		.text

size_of_choose_sprites		equ	230000
		.68000


choose_speed	equ	0

choose_ship:	sf	IN_GAME
		jsr	add_choose_backdrop	;draw backdrop
		jsr	shade_backdrop
		bsr	draw_grid
		jsr	NEW_OL
		jsr	add_choose_backdrop	;draw backdrop
		jsr	shade_backdrop
		bsr	draw_grid

		bsr	bring_back_on

		sf	zoom_size

		sf	choose_button_number

		bsr	initselect		;initalise Karls polygon stuff
		
		bsr	get_choose_tank_addr	;set addr of tank's shape
		
		bsr.s	zoom_in

.loop:		bsr	choose_a_button
		
		cmp.w	#0,d0
		beq.s	.exit
.change_ship:	move.w	d0,-(sp)
		bsr.s	zoom_out
		move.w	(sp)+,d0
		
		move.l	which_players_weapons,a6
		add.b	PLAYER_SHIP(A6),d0
		bpl.s	.posi
		addq	#3,d0
.posi:		cmp.b	#3,d0
		bne.s	.no_wrap
		subq	#3,d0
.no_wrap:	move.b	d0,PLAYER_SHIP(a6)
		
		bsr.s	get_choose_tank_addr
		
		bsr.s	zoom_in
		bra.s	.loop

.exit:		bsr.s	zoom_out
		
		bsr	take_back_off
		

		bsr	doneselect		;exit Karls stuff
		

		moveq	#0,d0
		move.l	which_players_weapons,a6
		move.b	PLAYER_SHIP(a6),d0	
		rts


zoom_in:	
		addq.b	#2,zoom_size
		
		bsr	draw_choose_screen
		
		cmp.b	#32,zoom_size
		bne.s	zoom_in
		rts

zoom_out:	moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
.zoom:		bsr	draw_choose_screen
		
		subq.b	#2,zoom_size
		cmp.b	#0,zoom_size
		bne.s	.zoom
		rts

get_choose_tank_addr:
		move.l	which_players_weapons,a6
		moveq	#0,d0
		move.b	PLAYER_SHIP(a6),d0	;get tank number
		lsl.b	#2,d0			;times 4 - longs
		lea	choose_ship_pointers,a6	;get ship addr
		move.l	(a6,d0.w),d0
		move.l	#selectcam,a6		;from camera get object
		move.l	ictarget(a6),a6
		move.l	d0,isanimbase(a6)	;set addr of the object
		rts	


choose_a_button:

		bsr.s	draw_choose_screen

		jsr	read_joypad
		
		move.l	joyedge1,d0

		move.b	choose_button_number,d1
		btst	#RIGHT_B,d0
		bne.s	.right_key
		btst	#LEFT_B,d0
		bne.s	.left_key
		btst	#UP_B,d0
		bne.s	.right_key
		btst	#DOWN_B,d0
		bne.s	.left_key
		btst	#FIRE_A,d0
		bne.s	.fire
		btst	#FIRE_B,d0
		bne.s	.fire
		btst	#FIRE_C,d0
		beq.s	choose_a_button
.fire:		moveq	#0,d0
		rts
.right_key:	moveq	#1,d0
		rts
.left_key:	moveq	#-1,d0
		rts




draw_choose_screen:
		jsr	NEW_OL
		jsr	switchab		;update the screens
		jsr	add_choose_backdrop	;draw backdrop
		move.l	rasterb,rasterd
		jsr	shade_backdrop
		bsr	draw_grid
		jsr	ADD_VIEWSCREEN		;add polygon playfield
		bsr	showselect		;draw tank
		bsr	add_back_anim1
		bsr.s	add_choose_overlay	;draw overlays
		bsr.s	show_select
		rts


STX	equ	(60-12+5)
STY	equ	(81-2)

shield_sprite_height	equ	16
shield_sprite_width	equ	128

add_choose_overlay:

		cmp.b	#8,zoom_size
		bge.s	.show
		rts
.show:		move.l	which_players_weapons,a6

		moveq	#0,d0
		move.b	PLAYER_SHIP(a6),d0
		lea	choose_icon_data,a6
		lsl.w	#2,d0
		move.l	(a6,d0.w),a6
		move.w	#4,-(sp)
.loop:		movem.w	(a6)+,d0/d1/d4
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20,d1
.ntsc:		moveq	#shield_sprite_width,d2
		moveq	#shield_sprite_height,d3
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		
		move.b	zoom_size,d7
		moveq	#32,d0
		jsr	scale_x_sprite
		
		move.b	zoom_size,d7
		jsr	scale_y_sprite
		
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp	
		rts



show_select:
		move.w	#131,d0
		moveq	#21,d1
		moveq	#21,d4
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20,d1
.ntsc:		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		rts		

	.data
choose_button_table:	
			;	x  ,y      ,s,s1,button number
			dc.w	188-20,155,48,0
			dc.w	201-20,155,49,1
			dc.w	217-20,155,16,2 ;was 05

TX1	EQU	86
TX2	EQU	86

TY1	EQU	63
TY2	EQU	80
TY3	EQU	97
TY4	EQU	114

choose_icon_data:	dc.l	.tank1,.tank2,.tank3

.tank1:		dc.w	TX1,TY1,36
			dc.w	TX2,TY2,39
			dc.w	TX2,TY3,42
			dc.w	TX2,TY4,45

.tank2:		dc.w	TX1,TY1,37
			dc.w	TX2,TY2,40
			dc.w	TX2,TY3,43
			dc.w	TX2,TY4,46

.tank3:		dc.w	TX1,TY1,38
			dc.w	TX2,TY2,41
			dc.w	TX2,TY3,44
			dc.w	TX2,TY4,47



choose_ship_pointers:	dc.l	full_lightanim
			dc.l	full_mediumanim
			dc.l	full_heavyanim	


		phrase
full_lightanim:		dc.l	full_lightload				
full_mediumanim:	dc.l	full_mediumload			
full_heavyanim:		dc.l	full_heavyload	


full_lightload:	incbin	"graphics/shapes/full/s_light.vdf"
full_mediumload:	incbin	"graphics/shapes/full/s_medium.vdf"
full_heavyload:	incbin	"graphics/shapes/full/s_heavy.vdf"

	


		.phrase


		bss

IN_GAME:		ds.b	01
zoom_size:		ds.b	01

choose_button_number:	ds.b	01
;;choose_ship_number:	ds.b	01
		phrase

