DEMO_K		equ	10
MAX_DEMO	equ	1

		.text


title_demo:	move.b	#DEMO_REPLAY,demo_mode
		jsr	round
		move.b	#DEMO_OFF,demo_mode
		rts


DEMO_START:	sf	exit_title
		cmp.b	#DEMO_RECORD,demo_mode
		beq	.demo_record
		cmp.b	#DEMO_REPLAY,demo_mode
		beq.s	.demo_replay
		cmp.b	#DEMO_RERUN,demo_mode
		beq.s	.no_wrap
		rts
.demo_replay:	move.w	level,save_level		;save the current level
		move.w	HOW_HARD,save_how_hard

		lea	demo_buffer,a1			;load in the script file
		lea	demo_name,a0
		jsr	load_file
		addq.b	#1,demo_index
		cmp.b	#"0"+MAX_DEMO,demo_index
		bne.s	.no_wrap
		move.b	#"0",demo_index
.no_wrap:	lea	demo_buffer,a6
		move.w	(a6)+,level			;retrieve level number
		move.w	(a6)+,HOW_HARD

		moveq	#WEAPON_SIZE-1,d0		;recreate the player
		lea	player1weapons,a5
.copy:		move.b	(a6)+,(a5)+
		dbf	d0,.copy
		
		move.l	joycur1,safe_cur1
		move.l	joyedge1,safe_edge1
		
		move.l	a6,d0
		addq	#1,d0
		and.b	#$fe,d0
		move.l	d0,a6
		move.l	(a6)+,joycur1			;point to keypad presses
		move.l	a6,demo_pointer

;create the tank
		move.l	#player1weapons,which_players_weapons	;point to player 1
		jsr	create_new_ship

		move.w	#GAME_LEVEL,d0
		jsr	load_level_graphics
		
		jsr	initrandom
		
		rts		

.demo_record:	jsr	initrandom
		lea	demo_buffer,a6
		move.w	level,(a6)+			;save level
		move.w	HOW_HARD,(a6)+

		moveq	#WEAPON_SIZE-1,d0		;save player info
		lea	player1weapons,a5
.save:		move.b	(a5)+,(a6)+
		dbf	d0,.save
		
		move.l	a6,d0				
		addq	#1,d0
		and.b	#$fe,d0
		move.l	d0,a6
		move.l	joycur1,d0
		and.l	#~(1<<KEY_0),d0
		move.l	d0,(a6)+
		move.l	a6,demo_pointer			;point to keypad presses
		rts	

DEMO_END:	
		cmp.b	#DEMO_REPLAY,demo_mode
		bne.s	.not_replay
		cmp.b	#$cd,exit_title
		seq	exit_title
		move.w	save_level,level
		move.w	save_how_hard,HOW_HARD
		bra.s	.not_record
.not_replay:	cmp.b	#DEMO_RECORD,demo_mode
		bne.s	.not_record
		move.l	demo_pointer,a0
		sub.l	#demo_buffer,a0
		move.l	a0,demo_length
.not_record:	move.b	#DEMO_OFF,demo_mode
		rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; Routines used for demo mode keypad reading/interpreting
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

joypad_record:
	jsr	scan_joypad
	move.l	demo_pointer,a6
	move.l	joycur1,d0
	move.l	d0,(a6)+
	move.l	a6,demo_pointer
	and.l	#1<<PAUSE,d0
	sne	exit_title
	rts


joypad_playback:
	move.l	joycur1,-(sp)			;read the joypad - if any keypress
	move.l	safe_cur1,joycur1		;then exit out of the titles
	move.l	safe_edge1,joyedge1
	jsr	scan_joypad
	move.l	joycur1,safe_cur1
	move.l	joyedge1,safe_edge1
	
	move.l	joycur1,d1			;quit out demo mode !!!
	move.l	d1,d2
	and.l	#(1<<KEY_0)|(1<<STAR)|(1<<HASH),d1
	eor.l	d1,d2
	tst.l	d2
	beq.s	.no_way
	move.b	#$cd,exit_title
.no_way:
	move.l	(sp)+,d0			;restore joycur1
	
	move.l	demo_pointer,a6	
	
	or.l	(a6)+,d1


	move.l	a6,demo_pointer
	move.l	#1<<PAUSE,d7
	and.l	d1,d7
	sne	d7
	move.l	d1,joycur1			;restore "taped" presses
	tst.b	exit_title
	bne.s	.no_change
	move.b	d7,exit_title
.no_change:
	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge1			;set new edge presses

	rts
 
replay_show:
     	cmp.b	#DEMO_REPLAY,demo_mode
	bne.s	.exit

	movem.l	d0-a6,-(sp)
	moveq	#1,d4
	moveq	#-44,d1
	add.w	screen_height,d1
	moveq	#50,d0
	lea	level_sprites,a0
	jsr	print_a_sprite_normal

	moveq	#32,d7
	move.l	#%10000,d0
	and.l	clock,d0
	beq.s	.small1
	moveq	#48,d7
.small1:
	move.w	d7,-(sp)
	moveq	#33,d0
	jsr	scale_x_sprite
		
	move.w	(sp)+,d7
	jsr	scale_y_sprite

	moveq	#1,d4
	moveq	#-44,d1
	add.w	screen_height,d1
	move.w	#320-50-44,d0
	lea	level_sprites,a0
	jsr	print_a_sprite_normal

	moveq	#32,d7
	move.l	#%10000,d0
	and.l	clock,d0
	bne.s	.small2
	moveq	#48,d7
.small2:
	move.w	d7,-(sp)
	moveq	#33,d0
	jsr	scale_x_sprite
		
	move.w	(sp)+,d7
	jsr	scale_y_sprite

	movem.l	(sp)+,d0-a6
.exit:	rts	




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	.data

demo_name:	dc.b	"DEMO"
demo_index:	dc.b	"0.DAT",0
		even
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		.bss
save_level:		ds.w	1
save_how_hard:		ds.w	1
demo_pointer:		ds.l	1
safe_cur1:		ds.l	1
safe_edge1:		ds.l	1
demo_length:		ds.l	1
demo_mode:		ds.b	1
		even
demo_buffer:		ds.b	1024*DEMO_K
