SIZE_OF_TITLE_PICTURE	EQU	320*200*2*2	;16 BIT IMAGE

	.text
find_sfx:
	lea	sfx_file_name,a0
	jsr	locate_file
	GET_FILE_OFFSET
	addq	#4,a0		;skip header
	move.l	a0,sfxadd
	rts

initialise_song_bank:
	lea	music_bank_name,a0
	jsr	locate_file
	GET_FILE_OFFSET
	move.l	a0,music_bank_addr
	rts




find_addons:
	lea	vdf_filename,a0
	jsr	locate_file
	GET_FILE_OFFSET
	rts

interleavescreen:
	move.l	rasterc,a0
	move.l	rasterc,a1
	move.l	#(rastersize*2)-8,d0		;size of piccy

	add.l	d0,a0
	lsl.l	#2,d0			;piccy * 4
	add.l	d0,a1

	move.l	#((rastersize*2)/8)-1,d0
.copyphrases:
	move.l	(a0),(a1)
	move.l	4(a0),4(a1)
	subq.l	#8,a0
	lea	-32(a1),a1
	dbf	d0,.copyphrases
	rts

load_title_music:
		lea	music_title_name,a0
		jmp	load_music

load_tunnel_music:
		lea	music_tunnel_name,a0
		jmp	load_music

load_shop_music:
		rts

load_hiscore_music:
		rts
		lea	music_hiscore_name,a0
		jmp	load_music

load_scoring_music:
		rts
		lea	music_scoring_name,a0
		jmp	load_music

load_mission_music:
		lea	music_shop_name,a0
		jmp	load_music


NO_LEVEL_TUNES	equ	4

load_level_music:
		moveq	#0,d0
		move.w	level,d0
		divu	#NO_LEVEL_TUNES,d0
		swap	d0
		lsl.w	#2,d0
		move.l	.table(pc,d0.w),a0
		jmp	load_music

.table:	dc.l	level_1_music
		dc.l	level_2_music
		dc.l	level_3_music
		dc.l	level_4_music


load_level:	move.w	level,d0
		lea	world_offsets,a0
		lsl.w	#2,d0
		move.l	(a0,d0.w),a0
		lea	load_world_area,a1
		jsr	load_file
;now relocate data
		move.l	a1,levelstart
		movem.l	(a1)+,d0-d1
		
		add.l	levelstart,d0
		add.l	levelstart,d1

		move.l	d0,arenadata
		move.l	d1,tunneldata

		jsr	relocatearena
		rts

relocatearena:	move.l	arenadata,a0		;set up room data
		move.l	(a0),a0
		add.l	levelstart,a0
		move.l	a0,arenaanims
		bsr	relocateanims
		rts

relocateanims:	move.l	(a0),d0			;relocate a list of anims
		beq.s	.done
		add.l	levelstart,d0
		move.l	d0,(a0)+
		bra.s	relocateanims
.done:
		rts

load_title_pic:
		lea	TITLE_FILE_NAME,a0
		lea	rasteradata,a1
		jsr	load_file
		rts

load_monitor_pic:
		lea	choose_back_name,a0
		move.l	rasterc,a1
		jsr	load_file
		bsr	interleavescreen
		rts



load_level_graphics:
		lea	sprite_offsets,a0
		lsl.w	#3,d0
		lea	(a0,d0.w),a5
		move.l	(a5)+,a0	;get pointer to filename.JHD
		jsr	locate_file
		GET_FILE_LENGTH
		lea	level_sprites,a1;must be PHRASE ALIGNED for JAGUAR
		move.l	a1,new_header
		move.l	d0,image_length1
		add.l	d0,d0
		add.l	d0,a1
		move.l	a1,start_of_image_1
		GET_FILE_OFFSET
		jsr	DECOMPRESSGPUPP
		jsr	waitgpu	   	;load in this data higher up
		
		jsr	convert_JHD

		move.l	(a5),a0		;then load in the sprite data
		jsr	locate_file	;above the header.
		GET_FILE_OFFSET
		move.l	start_of_image_1,a1
		jsr	DECOMPRESSGPUPP
		jsr	waitgpu
		
		rts

load_prepare_sprites:
		lea	sprite_offsets,a0
		lsl.w	#3,d0
		lea	(a0,d0.w),a5
		move.l	(a5)+,a0	;get pointer to filename.JHD
		jsr	locate_file
		GET_FILE_LENGTH
		lea	prepare_sprites,a1;must be PHRASE ALIGNED for JAGUAR
		move.l	a1,new_header
		move.l	d0,image_length1
		add.l	d0,d0
		add.l	d0,a1
		move.l	a1,start_of_image_1
		GET_FILE_OFFSET
		jsr	DECOMPRESSGPUPP
		jsr	waitgpu	   	;load in this data higher up
		
		jsr	convert_JHD

		move.l	(a5),a0		;then load in the sprite data
		jsr	locate_file	;above the header.
		GET_FILE_OFFSET
		move.l	start_of_image_1,a1
		jsr	DECOMPRESSGPUPP
		jsr	waitgpu
		
		rts




	.data
world_offsets:
		dc.l	lev1_filename
		dc.l	lev2_filename
		dc.l	lev3_filename
		dc.l	lev4_filename
		dc.l	lev5_filename
		dc.l	lev6_filename
		dc.l	lev7_filename
		dc.l	lev8_filename
		dc.l	lev9_filename
		dc.l	lev10_filename
		dc.l	lev11_filename
		dc.l	lev12_filename
		dc.l	lev13_filename
		dc.l	lev14_filename
		dc.l	lev15_filename
		dc.l	lev16_filename
		dc.l	lev17_filename
		dc.l	lev18_filename
		dc.l	lev19_filename
		dc.l	lev20_filename
		dc.l	lev21_filename



level:			dc.w	0
last_level:		dc.w	0

sprite_offsets:
		dc.l	lev1_spr_JHD,lev1_spr_JSP
		dc.l	lev2_spr_JHD,lev2_spr_JSP
		dc.l	lev3_spr_JHD,lev3_spr_JSP
		dc.l	lev4_spr_JHD,lev4_spr_JSP
		dc.l	lev5_spr_JHD,lev5_spr_JSP
		dc.l	lev6_spr_JHD,lev6_spr_JSP
		dc.l	lev7_spr_JHD,lev7_spr_JSP

vdf_filename:		dc.b	"VDF.BIN",0

lev1_filename:		dc.b	"WORLD1.DTA",0
lev2_filename:		dc.b	"WORLD2.DTA",0
lev3_filename:		dc.b	"WORLD3.DTA",0
lev4_filename:		dc.b	"WORLD4.DTA",0
lev5_filename:		dc.b	"WORLD5.DTA",0
lev6_filename:		dc.b	"WORLD6.DTA",0
lev7_filename:		dc.b	"WORLD7.DTA",0
lev8_filename:		dc.b	"WORLD8.DTA",0
lev9_filename:		dc.b	"WORLD9.DTA",0
lev10_filename:		dc.b	"WORLD10.DTA",0
lev11_filename:		dc.b	"WORLD11.DTA",0
lev12_filename:		dc.b	"WORLD12.DTA",0
lev13_filename:		dc.b	"WORLD13.DTA",0
lev14_filename:		dc.b	"WORLD14.DTA",0
lev15_filename:		dc.b	"WORLD15.DTA",0
lev16_filename:		dc.b	"WORLD16.DTA",0
lev17_filename:		dc.b	"WORLD17.DTA",0
lev18_filename:		dc.b	"WORLD18.DTA",0
lev19_filename:		dc.b	"WORLD19.DTA",0
lev20_filename:		dc.b	"WORLD20.DTA",0
lev21_filename:		dc.b	"WORLD21.DTA",0
		

lev1_spr_JHD:		dc.b	"SPRITE11.JHD",0
lev1_spr_JSP:		dc.b	"SPRITE11.JSP",0
lev2_spr_JHD:		dc.b	"FRONTEND.JHD",0
lev2_spr_JSP:		dc.b	"FRONTEND.JSP",0
lev3_spr_JHD:		dc.b	"OPTIONS.JHD",0
lev3_spr_JSP:		dc.b	"OPTIONS.JSP",0
lev4_spr_JHD:		dc.b	"TITLE.JHD",0
lev4_spr_JSP:		dc.b	"TITLE.JSP",0
lev5_spr_JHD:		dc.b	"HISCORE.JHD",0
lev5_spr_JSP:		dc.b	"HISCORE.JSP",0
lev6_spr_JHD:		dc.b	"LEVEL.JHD",0
lev6_spr_JSP:		dc.b	"LEVEL.JSP",0
lev7_spr_JHD:		dc.b	"SCORING.JHD",0
lev7_spr_JSP:		dc.b	"SCORING.JSP",0


choose_back_name:	dc.b	"SELECT.CRY",0
	

music_mission_name:	dc.b	"MISSION.SNG",0
music_scoring_name:	dc.b	"SCORING.SNG",0

music_bank_name:	dc.b	"MUSIC.DTA",0
music_title_name:	dc.b	"TITLE.SNG",0
music_shop_name:	dc.b	"SHOP.SNG",0
music_tunnel_name:	dc.b	"DATALINK.SNG",0
music_hiscore_name:	dc.b	"VICTORY.SNG",0
level_1_music:		dc.b	"LEVEL1.SNG",0
level_2_music:		dc.b	"LEVEL2.SNG",0
level_3_music:		dc.b	"LEVEL3.SNG",0
level_4_music:		dc.b	"LEVEL3.SNG",0
	



		even


	bss

		even
music_bank_addr:	ds.l	1
levelstart:		ds.l	1
arenadata:		ds.l	1
tunneldata:		ds.l	1
arenaanims:		ds.l	1
tunnelanims:		ds.l	1
	
	
