*************************** Control File For Game *************************

* Notes:
 
********************************* Equates *********************************

******************************* Code Section ******************************



		text
		.68000

********************************* Game Loop *******************************

game:		jsr	notes
		jsr	initshapes		;set up shape system
		jsr	initempties		;set up empty objects
		jsr	initworld		;set up empty world

.dogame:
		jsr	titles			;do the titles
		
		jsr	options_screen

	
		tst.b	restore_game
		bne	.start_game


;CHECK	load game stuff		
;CHECK		
;CHECK		
;CHECK		
;CHECK		
		tst.b	passcode_flag
		bne	.no_new_level
		
		tst.b	restore_game		
		bne.s	.start_at_level_x


.no_new_level:	bsr	install_weapons


		move.l	#player1weapons,which_players_weapons
		sf	IN_GAME
	 	jsr	choose_ship
		bra.s	.next_one
.start_at_level_x:
.start_game:
		move.w	restore_level,level
.next_one:	
		move.w	level,last_level	;we have not played any previous levels
		rept	2
		jsr	NEW_OL			;this was in mission.s but not now 
		jsr	add_choose_backdrop	;included so we need it here
		endr

		bsr	load_mission_stuff
.next_level:	

		jsr	shop
		jsr	create_new_ship
		
		DEMO_RECORD
		jsr	round			;do the current round
		DEMO_PLAYBACK
		tst.b	level_complete		; not correct
		beq.s	.died
		addq.w	#1,level		;do the next level
		
		cmp.w	#LAST_LEVEL,d0
		beq.s	.finale
		
		jsr	tunnel
		jsr	cls
		jsr	wait_vbl
		jsr	scoring_screen
		jsr	cls
		jsr	wait_vbl
		jsr	load_monitor_pic
		bsr	load_mission_stuff
		jsr	save_game_screen

		bra	.next_level	
	
.finale:

;do end of game stuff
		

.died:		jsr	hiscore_screen

		bra	.dogame			;repeat the whole thing

load_mission_stuff:
		move.l	#player1weapons,which_players_weapons
		move.b	#32,zoom_size
		sf	IN_GAME
		jsr	load_mission_music
		move.w	#FRONTEND_LEVEL,d0
		bsr	load_level_graphics
		
		lea	CLUT,a0
		lea	options_palette+2,a1
		moveq	#128-1,d2
.loop1:	move.l	(a1)+,(a0)+
		dbf	d2,.loop1
		rts		


install_weapons:

				
		lea	player1weapons,a6	;if new game the reset the scores
		lea	player2weapons,a5
		moveq	#WEAPON_SIZE-1,d0
.loop1:	sf	(a6,d0.w)
		sf	(a5,d0.w)
		dbf	d0,.loop1
	
		move.w	#3,PLAYER_LIVES(a6)
		move.w	#3,PLAYER_LIVES(a5)
		move.w	level,d0
		lsl.w	#2,d0
		lea	weapon_table,a0
		move.l	(a0,d0.w),a0

.loop2:	move.w	(a0)+,d0
		bmi.s	.exit
		move.w	(a0)+,d1
		move.b	d1,(a6,d0.w)
		move.b	d1,(a5,d0.w)
		bra.s	.loop2
.exit:		rts

*****************************************************************************************************************************
*****************************************************************************************************************************
*****************************************************************************************************************************
*****************************************************************************************************************************
*****************************************************************************************************************************


		.data

weapon_table:	dc.l	.level1
		dc.l	.level2
		dc.l	.level3
		dc.l	.level4
		dc.l	.level5
		dc.l	.level6
		dc.l	.level7
		dc.l	.level8
		dc.l	.level9
		dc.l	.level10
		dc.l	.level11
		dc.l	.level12
		dc.l	.level13
		dc.l	.level14
		dc.l	.level15
		dc.l	.level16
		dc.l	.level17
		dc.l	.level18
		dc.l	.level19
		dc.l	.level20
		dc.l	.level21


.level1:
		DC.W	WEAPON_LASER_L,1
		DC.W	-1
.level2:
.level3:
		DC.W	WEAPON_LASER_L,1
		DC.W	WEAPON_AUTO,1
		DC.W	WEAPON_RADAR,1
		DC.W	-1
.level4:	
.level5:
		DC.W	WEAPON_LASER_L,1
		DC.W	WEAPON_AUTO,1
		DC.W	WEAPON_RADAR,1
		DC.W	WEAPON_LAUNCHER_L,1
		DC.W	WEAPON_MISSILE_L_TYPE,2
		DC.W	WEAPON_MISSILE_L_NUMBER,2
		DC.W	-1
.level6:
		DC.W	WEAPON_LASER_L,1
		DC.W	WEAPON_AUTO,1
		DC.W	WEAPON_RADAR,1
		DC.W	WEAPON_LAUNCHER_L,1
		DC.W	WEAPON_MISSILE_L_TYPE,2
		DC.W	WEAPON_MISSILE_L_NUMBER,2
		DC.W	WEAPON_SHIELD,1
		DC.W	WEAPON_SHIELD_NUMBER,10
		DC.W	WEAPON_PLASMA,1
		DC.W	-1
.level7:
.level8:
.level9:	
.level10:	
.level11:	
.level12:	
.level13:	
.level14:	
		DC.W	WEAPON_LASER_L,1
		DC.W	WEAPON_AUTO,1
		DC.W	WEAPON_RADAR,2
		DC.W	WEAPON_LAUNCHER_L,1
		DC.W	WEAPON_MISSILE_L_TYPE,2
		DC.W	WEAPON_MISSILE_L_NUMBER,2
		DC.W	WEAPON_SHIELD,1
		DC.W	WEAPON_SHIELD_NUMBER,10
		DC.W	WEAPON_PLASMA,1
		DC.W	-1


.level15:	
.level16:	
.level17:	
.level18:	
.level19:	
.level20:	
.level21:	
		DC.W	WEAPON_LASER_L,1
		DC.W	WEAPON_AUTO,1
		DC.W	WEAPON_RADAR,2
		DC.W	WEAPON_LAUNCHER_L,1
		DC.W	WEAPON_MISSILE_L_TYPE,2
		DC.W	WEAPON_MISSILE_L_NUMBER,2
		DC.W	WEAPON_SHIELD,1
		DC.W	WEAPON_SHIELD_NUMBER,10
		DC.W	WEAPON_PLASMA,1
		DC.W	WEAPON_DRONE,1
		DC.W	-1
