NTSC_WINDOW_HEIGHT	equ	130
PAL_WINDOW_HEIGHT	equ	142


SCROLL_SPRITE	equ	39

HI_CURSOR	equ	55

HI_COLOUR0	equ	0<<3
HI_COLOUR1	equ	1<<3
HI_COLOUR2	equ	2<<3
HI_COLOUR3	equ	3<<3


Y_STEP		equ	20
H_L1		equ	53	
H_L2		equ	H_L1+Y_STEP
H_L3		equ	H_L2+Y_STEP
H_L4		equ	H_L3+Y_STEP

HI_NAME_X	equ	(320-(9*16))/2
HI_NAME_Y	equ	H_L4+((Y_STEP-5)*2)
HI_NAME_X_STEP	equ	16

HI_G_Y		equ	HI_NAME_Y+((Y_STEP-5)*2)

X_STEP		equ	30
H_C1		equ	28
H_C2		equ	H_C1+(X_STEP*1)
H_C3		equ	H_C1+(X_STEP*2)
H_C4		equ	H_C1+(X_STEP*3)
H_C5		equ	H_C1+(X_STEP*4)
H_C6		equ	H_C1+(X_STEP*5)
H_C7		equ	H_C1+(X_STEP*6)
H_C8		equ	H_C1+(X_STEP*7)
H_C9		equ	H_C1+(X_STEP*8)

	.text
hiscore_screen:
	lea	player1weapons,a0
	move.l	PLAYER_SCORE(a0),new_score

	move.l	new_score,d0
	bsr	BCD_2_LONG
	move.l	d0,d7
	lea	highscore_table,a0
	lea	9*4(a0),a1
.loop:	move.l	(a0)+,d0
	bsr	BCD_2_LONG
	sub.l	d7,d0
	bmi.s	.found_one
	cmp.l	a1,a0
	blt.s	.loop
	rts
.found_one:
	sf	hiscore_clear

	jsr	cls
	jsr	wait_vbl
	lea	CLUT,a0
	lea	options_palette+2,a1
	moveq	#128-1,d2
.loop1:move.l	(a1)+,(a0)+
	dbf	d2,.loop1

	jsr	load_hiscore_music
	move.w	#HISCORE_LEVEL,d0
	jsr	load_level_graphics
	jsr	load_monitor_pic
	jsr	init_hi_enter
	sf	hi_enter_exit
.wait:
	jsr	wait_vbl
	jsr	read_joypad
	jsr	draw_hi_enter
	jsr	move_hi_enter
	jsr	process_hi_enter
	tst.b	hi_enter_exit
	beq.s	.wait
	bsr	insert_hiscore_name	
    	jsr	create_eeprom_buffer
	sf	exit_title			;we are not in the titles now
	bra.s	show_hiscores_no_load

	
;----------------------------------------------------------------
;----------------------------------------------------------------
;----------------------------------------------------------------
	
	
	
show_hiscores:
	jsr	cls
	jsr	wait_vbl
	lea	CLUT,a0
	lea	options_palette+2,a1
	moveq	#128-1,d2
.loop1:move.l	(a1)+,(a0)+
	dbf	d2,.loop1
	
	move.w	#HISCORE_LEVEL,d0
	jsr	load_level_graphics
	jsr	load_monitor_pic
show_hiscores_no_load:
	move.w	#NTSC_WINDOW_HEIGHT,view_window_height
	moveq	#SCROLL_SPRITE,d0
	moveq	#0,d1
	move.w	view_window_height,d1
	lea	level_sprites,a0
	jsr	change_height_of_sprite
	bsr	draw_high_score_names
	clr.w	hi_score_y_pos
	sf	hi_enter_exit
.name:	jsr	title_press
	bsr.s	draw_hi_scroll
	jsr	wait_vbl
	jsr	wait_vbl
	tst.b	hi_enter_exit
	beq.s	.name
.quit:	jsr	cls
	jsr	wait_vbl
	rts

;----------------------------------------------------------------

draw_hi_scroll:
	jsr	NEW_OL
	jsr	add_choose_backdrop
	bsr	add_high_shadow_show
	

	moveq	#160-43,d0
	moveq	#21,d1
	moveq	#53,d4
	jsr	draw_shop_sprite
	
	moveq	#0,d0
	moveq	#50+12,d1
	moveq	#SCROLL_SPRITE,d4
	jsr	draw_shop_sprite
	move.w	#320/2,d0
	mulu	hi_score_y_pos,d0
	lsl.l	#8,d0
	add.l	d0,(a0)			;add offsets
	tst.b	exit_title
	bne.s	.yes
	addq.w	#1,hi_score_y_pos
	move.w	view_window_height,d0
	add.w	#320+(16*4),d0
	cmp.w	hi_score_y_pos,d0
	bne.s	.no
.yes:	st	hi_enter_exit
.no:	rts

;----------------------------------------------------------------

init_hi_enter:
	lea	hi_temp_name,a0
	lea	playername,a1
	moveq	#9-1,d0
.lp:	move.b	(a1)+,(a0)+			; all .'s
	dbf	d0,.lp
	sf	hi_enter_exit
	sf	hi_cursor_y
	sf	hi_cursor_x
	clr.w	hi_enter_char
	rts

;----------------------------------------------------------------

draw_hi_enter:
	jsr	NEW_OL
	jsr	add_choose_backdrop
	bsr	add_high_shadow
	jsr	hi_letters
	jsr	hi_high_light
	jsr	hi_show_name
	jsr	hi_greet
	rts
;----------------------------------------------------------------

hi_letters:
	lea	hi_letters_table,a6
	move.w	(a6)+,-(sp)
.loop:	movem.w	(a6)+,d0/d1/d4
	jsr	draw_hi_letter
	moveq	#HI_COLOUR0,d0
	jsr	add_colour_to_sprite
	subq.w	#1,(sp)
	bne.s	.loop
	addq	#2,sp
	rts
;----------------------------------------------------------------

hi_high_light:
	lea	hi_letters_table+2,a0
	moveq	#0,d4
	move.b	hi_cursor_x,d4
	mulu	#6,d4
	add.w	d4,a0
	moveq	#0,d4
	move.b	hi_cursor_y,d4
	mulu	#9*6,d4
	add.w	d4,a0
	moveq	#-3,d0
	moveq	#-3,d1
	add.w	(a0)+,d0
	add.w	(a0)+,d1
	move.w	(a0),hi_button
	move.w	#HI_CURSOR,d4
	jsr	draw_shop_sprite
	or.b	#%01000000,10(a0)	;make it RMW
	rts

;----------------------------------------------------------------

hi_greet:
	moveq	#160-43,d0
	moveq	#21,d1
	moveq	#53,d4
	jsr	draw_shop_sprite
	
	move.w	#((320-234)/2)+2,d0
	move.w	#HI_G_Y,d1
	moveq	#54,d4
	jsr	draw_shop_sprite
	moveq	#HI_COLOUR3,d0
	jmp	add_colour_to_sprite


;----------------------------------------------------------------

add_high_shadow_show:
	move.w	#$00e0,CLUT+(255*2)

	move.w	#(320-156)/2,d0
	move.w	#17,d1
	moveq	#60,d4
	jsr	display_option_sprite
	or.b	#%01000000,10(a0)	;make the sprite transparent
	move.w	#shadow_colour,d0
	jsr	add_colour_to_sprite

	move.w	#(320-282)/2,d0
	move.w	#50,d1
	moveq	#61,d4
	jsr	display_option_sprite
	or.b	#%01000000,10(a0)	;make the sprite transparent
	move.w	#shadow_colour,d0
	jsr	add_colour_to_sprite
	rts


add_high_shadow:
	move.w	#$00e0,CLUT+(255*2)

	move.w	#(320-156)/2,d0
	move.w	#17,d1
	moveq	#60,d4
	jsr	display_option_sprite
	or.b	#%01000000,10(a0)	;make the sprite transparent
	move.w	#shadow_colour,d0
	jsr	add_colour_to_sprite

	move.w	#(320-156)/2,d0
	move.w	#HI_NAME_Y-3,d1
	moveq	#60,d4
	jsr	display_option_sprite
	or.b	#%01000000,10(a0)	;make the sprite transparent
	move.w	#shadow_colour,d0
	jsr	add_colour_to_sprite
	rts




hi_show_name:
	lea	hi_temp_name,a6
	moveq	#0,d2
	move.w	#HI_NAME_X,d0
	move.w	#HI_NAME_Y,d1

.loop:	movem.w	d0-d2,-(sp)
	moveq	#0,d4
	move.b	(a6)+,d4
	jsr	draw_hi_letter
	movem.w	(sp),d0-d2
	moveq	#%1100,d0
	and.l	clock,d0
	beq.s	.no
	moveq	#HI_COLOUR1,d0
	cmp.b	hi_enter_char,d2
	beq.s	.hi
.no:	moveq	#HI_COLOUR2,d0
.hi:	jsr	add_colour_to_sprite
	movem.w	(sp)+,d0-d2
	addq	#1,d2
	add.w	#HI_NAME_X_STEP,d0
	cmp.b	#9,d2
	bne.s	.loop
	rts
;----------------------------------------------------------------

draw_hi_letter:
	lea	hi_letters_offset,a0
	moveq	#16,d7
	sub.b	(a0,d4.w),d7
	ext.w	d7
	asr.w	#1,d7
	add.w	d7,d0
	jmp	draw_shop_sprite
;----------------------------------------------------------------

move_hi_enter:
	move.l	joyedge1,d0
	move.l	#1<<LEFT_B,d1
	and.l	d0,d1
	beq.s	.no_left
	subq.b	#1,hi_cursor_x
	bpl.s	.no_left
	move.b	#8,hi_cursor_x
.no_left:
	move.l	#1<<RIGHT_B,d1
	and.l	d0,d1
	beq.s	.no_right
	addq.b	#1,hi_cursor_x
	cmp.b	#9,hi_cursor_x
	bne.s	.no_right
	sf	hi_cursor_x
.no_right:
	move.l	#1<<UP_B,d1
	and.l	d0,d1
	beq.s	.no_up
	subq.b	#1,hi_cursor_y
	bpl.s	.no_up
	move.b	#3,hi_cursor_y
.no_up:
	move.l	#1<<DOWN_B,d1
	and.l	d0,d1
	beq.s	.no_down
	addq.b	#1,hi_cursor_y
	cmp.b	#4,hi_cursor_y
	bne.s	.no_down
	sf	hi_cursor_y
.no_down:
	rts

;----------------------------------------------------------------

process_hi_enter:
	move.l	joyedge1,d0
	and.l	#(1<<FIRE_A)|(1<<FIRE_B)|(1<<FIRE_C),d0
	bne.s	.fire
	rts
.fire:	tst.b	hiscore_clear
	bne.s	.cleared_already

	cmp.w	#58,hi_button
	beq.s	.just_enter

	lea	hi_temp_name,a0
	moveq	#9-1,d0
.lppy:	move.b	#26,(a0)+
	dbf	d0,.lppy
.just_enter:
	st	hiscore_clear

.cleared_already:
	move.w	hi_button,d0
	cmp.w	#32,d0
	bgt.s	.special
	lea	hi_temp_name,a0
	moveq	#0,d1
	move.b	hi_enter_char,d1
	move.b	d0,(a0,d1.w)
	bra.s	.next
.special:
	cmp.b	#57,d0
	beq.s	.next
	cmp.b	#56,d0
	beq.s	.previous
	cmp.b	#59,d0
	beq.s	.clear_name
.cr:	st	hi_enter_exit
	rts
.clear_name:
	lea	hi_temp_name,a0
	moveq	#9-1,d0
.lp:	move.b	#26,(a0)+			; all .'s
	dbf	d0,.lp
	clr.w	hi_enter_char
	rts
.next:	addq.b	#1,hi_enter_char
	cmp.b	#9,hi_enter_char
	bne.s	.no_wrap
	sf	hi_enter_char
.no_wrap:
	rts
.previous:
	tst.b	hi_enter_char
	beq.s	.a_wrap
	subq.b	#1,hi_enter_char
	rts
.a_wrap:
	move.b	#8,hi_enter_char
	rts	

;----------------------------------------------------------------

BCD_2_LONG:
	movem.l	d1/d2,-(sp)
	move.l	d0,d2
	moveq	#0,d0
	move.w	#8,-(sp)
.loop:	rol.l	#4,d2
	moveq	#$f,d1
	and.l	d2,d1
	lsl.l	#1,d0	;times 2
	move.l	d0,-(sp)
	lsl.l	#2,d0	;times 8
	add.l	(sp)+,d0;8+2 = 10 times
	add.l	d1,d0
	subq.w	#1,(sp)
	bne.s	.loop
	addq	#2,sp
	movem.l	(sp)+,d1/d2
	rts


insert_hiscore_name:
	move.l	new_score,d0
	bsr	BCD_2_LONG
	move.l	d0,d7
	lea	highscore_table,a0
	moveq	#-1,d2
	lea	9*4(a0),a1	;end of the scores start of names
.loop:	addq	#1,d2		;0= top ,1=second etc..
	and	#0,ccr
	move.l	(a0)+,d0
	bsr	BCD_2_LONG
	sub.l	d7,d0
	bmi.s	.greater
	cmp.l	a1,a0		;do all the  names
	bne.s	.loop
	rts
.greater:	
	move.l	new_score,d0
	subq.l	#4,a0		;thats the score in place
.lp1:	move.l	(a0),d1
	exg.l	d0,d1  		;swap the number
	move.l	d1,(a0)+
	cmp.l	a0,a1
	bne.s	.lp1

	mulu	#9,d2		;point to the name in the file
	lea	-1(a1,d2.w),a0	;point to char before ( predecrement stuff is alter)
	
	lea	1+highscore_table_end,a1	;point just past end of table
	lea	-9(a1),a2			;to be copied from where
.lp2:	move.b	-(a2),-(a1)			;copy data
	cmp.l	a2,a0				;until all copied
	bne.s	.lp2
	addq	#1,a0
	lea	hi_temp_name,a1
	moveq	#9-1,d0
.lp3:	move.b	(a1)+,(a0)+
	dbf	d0,.lp3
	rts



;----------------------------------------------------------------

draw_high_score_names:
	lea	highscore_table,a0
	lea	name_table,a1
	moveq	#9-1,d7
.lp1:	addq	#5,a1			;skip the PAT command
	
	move.l	a1,a2
	moveq	#4-1,d6
.lp2:	moveq	#$f,d0
	move.b	(a0)+,d1		;BCD 2 digits
	and.b	d1,d0
	lsr.b	#4,d1
	add.b	#"0",d0
	add.b	#"0",d1
	move.b	d1,(a1)+
	move.b	d0,(a1)+
	dbf	d6,.lp2			;do all digits in score
	
	cmp.b	#"0",(a2)
	bne.s	.exit
	moveq	#7-1,d6
.lpa:	move.b	#" ",(a2)+
	cmp.b	#"0",(a2)
	bne.s	.exit
	dbf	d6,.lpa
.exit:
	dbf	d7,.lp1			;do all the scores



	moveq	#0,d0
	moveq	#9-1,d7
.lp3:	addq	#5,a1			;skip PAT command
	moveq	#9-1,d6
.lp4:	move.b	(a0)+,d0		;read the character
	move.b	.conv(pc,d0.w),(a1)+
	dbf	d6,.lp4
	dbf	d7,.lp3
	
	moveq	#SCROLL_SPRITE,d0
	lea	level_sprites,a0		;get addr of the sprite
	jsr	get_addr_sprite
	move.l	#WID320|PITCH1|PIXEL4|XADDPIX,d1;flags for the blitter
	lea	name_table,a6			;text to print
	move.l	#WID64|PIXEL4|PITCH1|XADDPIX,d2
	jsr	print_text_sprites		;so do it
	
	rts

.conv:	dc.b	"ABCDEFGHIJKLMNOPQRSTUVWXYZ .!0123"
	even

;----------------------------------------------------------------

convert_highscores:
	lea	copy_highscore_table,a0	;preserve the original
	lea	highscore_table,a1
	lea	highscore_table_end,a2
.lp:	move.b	(a0)+,(a1)+
	cmp.l	a1,a2
	bne.s	.lp
	lea	highscore_table,a0
	lea	9*4(a0),a0		;skip the scores
	move.w	#9*9,-(sp)
.loop:	move.b	(a0),d0
	sub.b	#"A",d0
	bpl.s	.valid
	add.b	#"A",d0
	moveq	#25,d1
	cmp.b	#" ",d0
	beq.s	.spa
	cmp.b	#".",d0
	beq.s	.dot
	cmp.b	#"!",d0
	beq.s	.ex
	cmp.b	#"1",d0
	beq.s	.one
	cmp.b	#"2",d0
	beq.s	.two
.three:addq	#1,d1
.two:	addq	#1,d1
.one:	addq	#1,d1
.ex:	addq	#1,d1
.dot:	addq	#1,d1
.spa:	addq	#1,d1
	move.b	d1,d0
.valid:
	move.b	d0,(a0)+
	subq.w	#1,(sp)
	bne.s	.loop
	addq	#2,sp
	rts

;----------------------------------------------------------------
	
	
	.data
hi_letters_table:
	dc.w	9*4
	dc.w	H_C1,H_L1,0	;a
	dc.w	H_C2,H_L1,1	;b
	dc.w	H_C3,H_L1,2	;c
	dc.w	H_C4,H_L1,3	;d
	dc.w	H_C5,H_L1,4	;e
	dc.w	H_C6,H_L1,5	;f
	dc.w	H_C7,H_L1,6	;g
	dc.w	H_C8,H_L1,7	;h
	dc.w	H_C9,H_L1,56	;previous

	dc.w	H_C1,H_L2,8	;i
	dc.w	H_C2,H_L2,9	;j
	dc.w	H_C3,H_L2,10	;k
	dc.w	H_C4,H_L2,11	;l
	dc.w	H_C5,H_L2,12	;m
	dc.w	H_C6,H_L2,13	;n
	dc.w	H_C7,H_L2,14	;o
	dc.w	H_C8,H_L2,15	;p
	dc.w	H_C9,H_L2,57	;next

	dc.w	H_C1,H_L3,16	;q
	dc.w	H_C2,H_L3,17	;r
	dc.w	H_C3,H_L3,18	;s
	dc.w	H_C4,H_L3,19	;t
	dc.w	H_C5,H_L3,20	;u
	dc.w	H_C6,H_L3,21	;v
	dc.w	H_C7,H_L3,22	;w
	dc.w	H_C8,H_L3,23	;x
	dc.w	H_C9,H_L3,59	;clear

	dc.w	H_C1,H_L4,24	;y
	dc.w	H_C2,H_L4,25	;z
	dc.w	H_C3,H_L4,26	;space
	dc.w	H_C4,H_L4,27	;!
	dc.w	H_C5,H_L4,28	;.
	dc.w	H_C6,H_L4,30	;1
	dc.w	H_C7,H_L4,31	;2
	dc.w	H_C8,H_L4,32	;3
	dc.w	H_C9,H_L4,58	;ok



hi_letters_offset:
	dc.b	14,12,10,12	;abcd
	dc.b	10,10,12,16	;efgh
	dc.b	04,08,14,10	;ijkl
	dc.b	16,12,14,10	;mnop
	dc.b	14,10,10,10	;qrst
	dc.b	12,14,16,12	;uvwx
	dc.b	12,12,06,08	;yz .
	dc.b	04,08,14,14	;!123
	dc.b	16,16,16,16
	dc.b	16,16,16,16
	dc.b	16,16,08,16	;.012
	dc.b	16,16,16,16	;3456
	dc.b	16,16,16,00	;789.

	dc.b	0,0,0,0
	dc.b	16,16,16,16
	dc.b	0,0,0,0
	dc.b	0,0,0,0



playername:
	;dc.b	"PLAYER1  "
	dc.b	15
	dc.b	11
	dc.b	0
	dc.b	24
	dc.b	4
	dc.b	17
	dc.b	30
	dc.b	26,26

	even


macro	HIGH_SCORE_STUFF
	even
	dc.l		$00090000	
	dc.l		$00080000	
	dc.l		$00070000	
	dc.l		$00060000	
	dc.l		$00050000	
	dc.l		$00040000	
	dc.l		$00030000	
	dc.l		$00020000	
	dc.l		$00010000	
	dc.b		"KARL WEST"
	dc.b		"A. SEED  "
	dc.b		"A. NOBLE "
	dc.b		"BILLY    "
	dc.b		"TEDDY T. "
	dc.b		"NORMSKI  "
	dc.b		"MAD FRED "
	dc.b		"BUN BOY  "
	dc.b		"KEV . AL "
endm
	even	
highscore_table:
	HIGH_SCORE_STUFF
highscore_table_end:
	dcb.b	9,0

copy_highscore_table:
	HIGH_SCORE_STUFF
copy_highscore_table_end:

name_table:				;used for displaying the highscores
		dc.b	PAT,0,130,0,20
		dc.b	"00000000"
		dc.b	PAT,0,130,0,60
		dc.b	"00000000"
		dc.b	PAT,0,130,0,100
		dc.b	"00000000"
		dc.b	PAT,0,130,0,140
		dc.b	"00000000"
		dc.b	PAT,0,130,0,180
		dc.b	"00000000"
		dc.b	PAT,0,130,0,220
		dc.b	"00000000"
		dc.b	PAT,0,130,1,260-256
		dc.b	"00000000"
		dc.b	PAT,0,130,1,300-256
		dc.b	"00000000"
		dc.b	PAT,0,130,1,340-256
		dc.b	"00000000"

		dc.b	PAT,0,50,0,00
		dc.b	"000000000"
		dc.b	PAT,0,50,0,40
		dc.b	"000000000"
		dc.b	PAT,0,50,0,80
		dc.b	"000000000"
		dc.b	PAT,0,50,0,120
		dc.b	"000000000"
		dc.b	PAT,0,50,0,160
		dc.b	"000000000"
		dc.b	PAT,0,50,0,200
		dc.b	"000000000"
		dc.b	PAT,0,50,0,240
		dc.b	"000000000"
		dc.b	PAT,0,50,1,280-256
		dc.b	"000000000"
		dc.b	PAT,0,50,1,320-256
		dc.b	"000000000"
		dc.b	PEND



		even
	.bss
view_window_height:	ds.w	1
new_score:		ds.l	1
hi_score_y_pos:	ds.w	1
hi_y:			ds.w	1
hi_button:		ds.w	1
hi_enter_char:		ds.w	1
hi_cursor_x:		ds.b	1
hi_cursor_y:		ds.b	1
hi_enter_exit:		ds.b	1
hi_temp_name:		ds.b	9
hiscore_clear:		ds.b	1
		even

                                                                                                                                                                                                               



