SHIELD_SHIFT	equ	3
************************** Head Up Display Routines ***********************
* Notes:
********************************** Equates ********************************

EXIT_TIME	 equ	150



SHIELD_COUNTER_SPRITE_0	equ	289
SHIELD_NUMBERS_SPRITE_0	equ	149


RADAR_WIDTH	equ	48
RADAR_HEIGHT	equ	42

chcentrex	equ	0			;offset from left
chcentrey	equ	0			;offset from top

energyx	equ	12			;offset from screen
energyy	equ	-28			;top left

ammox		equ	-12			;offset from screen
ammoy		equ	-28			;top right

*************************** Head Up Data Structures ***********************
CROSS_HAIR_SPRITE	equ	0

RADAR_NORM_SPRITE	equ	5
RADAR_RMW_SPRITE	equ	6

DAMAGE_SPRITE		equ	9
REGENERATE_SPRITE	equ	8


VIEWMODE1_SPRITE	equ	10
VIEWMODE2_SPRITE	equ	11
VIEWMODE3_SPRITE	equ	12
VIEWMODE4_SPRITE	equ	13
VIEWMODE5_SPRITE	equ	14
VIEWMODE6_SPRITE	equ	15

			
EXITOPEN_SPRITE	equ	402
DATAPOD_SPRITE		equ	403
DATABASE_SPRITE	equ	404
POWERUP_SPRITE		equ	405
ACCESSDENIED_SPRITE	equ	406
TELEPORTACTIVE_SPRITE	equ	407


MED_0_SCORE		equ	17
MED_0_LIVES		equ	119

Y_TOP			equ	10
Y_BOT			equ	20
Y_MID			equ	00

POWER_BAR_SPRITE	equ	133

X_RIGHT		equ	-10
X_LEFT			equ	10

LIVES_SPRITE		equ	119
SPECIAL_SPRITE		equ	(130-1)
NUMBERS_SPRITE		equ	149

******************************* Code Section ******************************

		text
		.68000

******************************** External HUD *****************************

externalhud:	move.l	ictarget(a0),a6
		move.w	iotimer2(a6),invincible
		jsr	waitgpu
		jsr	waitblitter
		jsr	display_hud_external
		lea	score_pos_external,a5
		bsr	display_scores
		;jsr	display_clock
		bsr	display_whats_left
		jsr	SHOW_HUD_MESSAGE
		st	radar_rmw_show
		jsr	displayradar
		jsr	display_mapper_sprite
		rts


******************************** HUD Routines *****************************


swap_hud_pointers:
		movem.l	d0-d7/a0,-(sp)
		lea	HUD_POINTERS,a0
		movem.l	(a0),d0-d5
		move.l	d0,d6
		move.l	d1,d7
		movem.l	d2-d7,(a0)
		movem.l	(sp)+,d0-d7/a0
		rts


****************************************************************************

display_whats_left:
		movem.l	d0-a6,-(sp)
		lea	whats_left_coords,a6

		movem.w	(a6)+,d0/d1/d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		movem.w	(a6)+,d0/d1
		move.w	databases_left,d4
		bsr	print_a_number

		movem.w	(a6)+,d0/d1/d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		movem.w	(a6)+,d0/d1
		move.w	pods_left,d4
		bsr	print_a_number
		
		movem.l	(sp)+,d0-a6
		rts


print_a_number:
		pea	(a6)
		ext.l	d4
		divu	#10,d4
		tst.w	d4
		beq.s	.less_than_10
		movem.l	d0/d1/d4,-(sp)
		add.w	#SCORE_DIGIT_SPRITES1,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		movem.l	(sp)+,d0/d1/d4
.less_than_10:
		addq	#8,d0
		swap	d4
		add.w	#SCORE_DIGIT_SPRITES1,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	(sp)+,a6
		rts



****************************************************************************
****************************************************************************

display_hud_external:	
		movem.l	d0-a6,-(sp)
		lea	player1weapons,a6		; pointer to the players data structure
		
	     if 0
		moveq	#Y_TOP+26,d0
		moveq	#11+2,d1
		cmp.b	#1,WEAPON_NUMBER(a6)
		bne.s	.not_plasma_gun
		addq	#1,d1
.not_plasma_gun:
		moveq	#J_LT,d2
		jsr	MAKE_JUMP_OBJECT
	endif
		lea	hud_external_sprite_data,a5
		
		jsr	ADD_EXTERNAL_SHIELD
		move.w	invincible,-(sp)
		clr.w	invincible
		jsr	ADD_EXTERNAL_WEAPON_STUFF
		move.w	(sp)+,invincible		

		movem.w	(a5)+,d0/d1/d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		movem.w	(a5)+,d0/d1/d4
		
		add.w	PLAYER_LIVES(a6),d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		movem.w	(a5)+,d0/d1/d4/d5
		move.w	(a1,d5.w),d3
		jsr	display_power
		clr.w	invincible		

		movem.w	(a5)+,d0/d1/d4/d5
		move.w	(a1,d5.w),d3
		jsr	display_power_digits

		movem.l	(sp)+,d0-a6
		rts


ADD_EXTERNAL_SHIELD:
		movem.l	d0-a4/a6,-(sp)
		move.l	ictarget(a0),a4
		moveq	#0,d4
		move.b	WEAPON_SHIELD_NUMBER(a6),d4
		bne.s	.have_shields
		tst.w	ioshield(a4)
		beq.s	.not_counting		
.have_shields:
		moveq	#0,d5
		move.w	ioshield(a4),d5
		beq.s	.not_counting

		move.w	#SHIELD_COUNTER_SPRITE_0,d4
		add.w	d5,d4
		bra.s	.counting

.not_counting:	add.w	#SHIELD_NUMBERS_SPRITE_0,d4
.counting:		
		movem.w	(a5)+,d0/d1
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip


		movem.w	(a5)+,d0/d1/d4		
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		
		movem.w	(a5)+,d0/d1
		tst.w	ioshield(a4)
		beq.s	.not_super
      		moveq	#1,d4
		and.w	ioshield(a4),d4
		add.w	#26,d4
		bra.s	.cont
.not_super:	move.l	ioweapons(a4),a4
		moveq	#0,d4
		move.b	WEAPON_SHIELD_TIMER(a4),d4
		asr.w	#SHIELD_SHIFT,d4
		neg.w	d4
		add.w	#25,d4
.cont:		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
	
		movem.l	(sp)+,d0-a4/a6
		rts



ADD_EXTERNAL_WEAPON_STUFF:
		moveq	#0,d0
		move.b	WEAPON_NUMBER(a6),d0
		asl.b	#2,d0
		ext.w	d0
		move.l	.mounting_routines+4(pc,d0.w),a4
		jsr	(a4)

		movem.w	(a5),d0/d1

		move.w	d3,-(sp)
		
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		move.w	(sp)+,d3
		movem.w	(a5),d0/d1
		add.w	#94-28,d0
		add.w	#9,d1
		jsr	display_power_digits
	
		cmp.b	#1,WEAPON_NUMBER(a6)
		bne.s	.not_plasma
		movem.w	(a5),d0/d1
		addq	#3,d0
		add.w	#9,d1
		moveq	#0,d3
		move.b	WEAPON_PLASMA_POWER(a6),d3
		moveq	#0,d4
		move.b	WEAPON_PLASMA(a6),d4
		mulu	#PLASMA_SCALER,d4
		jsr	display_power
.not_plasma:	addq	#4,a5
		rts



.mounting_routines:
		dc.l	external_nothing
		dc.l	external_lasers
		dc.l	external_plasma
		dc.l	external_missile_1
		dc.l	external_missile_2
		dc.l	external_combi


NOTHING_ICON		equ	266
LASER_ICON		equ	1+NOTHING_ICON
PLASMA_ICON		equ	1+LASER_ICON		
MISSILE_LEFT_ICON	equ	3+PLASMA_ICON
MISSILE_RIGHT_ICON	equ	3+MISSILE_LEFT_ICON	
MISSILE_MID_ICON	equ	3+MISSILE_RIGHT_ICON
COMBI_ICON		equ	3+MISSILE_MID_ICON	




external_nothing:
		moveq	#0,d3
		move.w	#NOTHING_ICON,d4
		rts
external_lasers:
		move.w	#LASER_ICON,d4
		moveq	#0,d3
		rts
external_plasma:
	     	moveq	#0,d3
		move.w	#PLASMA_ICON-1,d4
		move.b	WEAPON_PLASMA(a6),d3
		add.w	d3,d4
		move.b	WEAPON_PLASMA_POWER(a6),d3
		rts
external_missile_1:
		moveq	#0,d3
		add.b	WEAPON_MISSILE_L_NUMBER(a6),d3
		moveq	#0,d4
		move.b	WEAPON_MISSILE_L_TYPE(a6),d4
		cmp.b	#2,PLAYER_SHIP(a6)	;if heavy tank then display
		beq.s	.ok			; L else its the only one	
		add.w	#MISSILE_MID_ICON-1,d4
		rts
.ok:		add.w	#MISSILE_LEFT_ICON-1,d4
		rts
external_missile_2:
		moveq	#0,d3
		add.b	WEAPON_MISSILE_R_NUMBER(a6),d3
		moveq	#0,d4
		move.b	WEAPON_MISSILE_R_TYPE(a6),d4
		add.w	#MISSILE_RIGHT_ICON-1,d4
		rts

external_combi:
		moveq	#0,d3
		move.w	#COMBI_ICON-1,d4
		move.b	WEAPON_BACK(a6),d3
		add.w	d3,d4
		cmp.b	#4,d3
		bge.s	.mine_layer
		moveq	#0,d3
		rts
.mine_layer:	move.b	WEAPON_MINE(a6),d3
		rts

****************************************************************************
****************************************************************************
****************************************************************************
****************************************************************************



target_pulse_speed	equ	3
max_target_frame	equ	5

display_cross_hair:
		movem.l	d0-a6,-(sp)

		move.l	ictarget(a0),a1		;point to the player from camera
		move.l	ioweapons(a1),a1	;now the weapon structure

		lea	hud_sprites_cross,a5
		move.w	screen_height,d2
		sub.w	icgoy(a0),d2
		move.w	d2,d3
		sub.w	iccly(a0),d2
		sub.w	icchy(a0),d3	

		move.w	screen_height,d1
		sub.w	icgoy(a0),d1

		move.w	#320,d0
		sub.w	icgox(a0),d0

		add.w	(a5)+,d0
		add.w	(a5)+,d1
		
		add.w	CROSSX(a1),d0
		sub.w	CROSSY(a1),d1

		pea	(a0)
		move.w	(a5)+,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal
		move.l	(sp)+,a0



		move.w	screen_height,d2
		sub.w	icgoy(a0),d2
		move.w	d2,d3
		sub.w	iccly(a0),d2
		sub.w	icchy(a0),d3	

		move.w	screen_height,d1
		sub.w	icgoy(a0),d1

		move.w	#320,d0
		sub.w	icgox(a0),d0

		add.w	(a5)+,d0
		add.w	(a5)+,d1
		
		move.w	(a5)+,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal



		movem.l	(sp)+,d0-a6
		rts


***************************** Message for exit open **************************


display_exit_now_open:
		move.w	datapods,d0
		or.w	databases,d0
		bne.s	.quick_exit

		tst.b	exit_timer
		bne.s	.only_play_sfx_once

		moveq	#$30,d0
		jsr	MUS_HALT
		jsr	MUS_RESUME
		moveq	#SFX_SAY_EXIT_OPEN,d0
		jsr	sfxplay
.only_play_sfx_once:
		cmp.b	#EXIT_TIME,exit_timer
		beq.s	.no_display
		addq.b	#1,exit_timer

		nop
		;	print sprite here
	
.no_display:
		rts
.quick_exit:	sf	exit_timer
		rts



********************************* External Hud *******************************


display_scores:
		movem.l	(a5),d0/d1/a5
		jsr	DISPLAY_SCORE
		rts

		.data

*************************** Head Up Data Structures **************************


whats_left_coords:
		dc.w	10,30,3
		dc.w	10+70+2,30
		dc.w	320-(64+2+28),30,4
		dc.w	320-28,30



hud_external_sprite_data:
		dc.w	213,16				; shield x,y for number
		dc.w	194,10,131			; shield sprite
		dc.w	197,13				; shield icon
		dc.w	228,10				; weapon
		dc.w	011,10,118			; shield icon
		dc.w	095,10,LIVES_SPRITE		; lives x,y
		dc.w	029,19,playerENERGY,ioenergy	; energy bar power bar
		dc.w	012,19,playerENERGY,ioenergy	; energy bar numbers
		dc.w	228,10				; location for weapon number



YI_BOT	equ	7
hud_internal_sprite_data:
	

CROSS_HAIR_HEIGHT	equ	38
CROSS_HAIR_WIDTH	equ	54


FIXED_HAIR_HEIGHT	equ	23
FIXED_HAIR_WIDTH	equ	23

FIXED_HAIR_SPRITE	equ	2



hud_sprites_cross:
	dc.w	-(CROSS_HAIR_WIDTH/2),-(CROSS_HAIR_HEIGHT/2),CROSS_HAIR_SPRITE			;+
	dc.w	-(FIXED_HAIR_WIDTH/2),-(FIXED_HAIR_HEIGHT/2),FIXED_HAIR_SPRITE			;+
		
		
		
HUDTIMER:		dc.w	0
HUDMESSAGE:		dc.b	0
HUDFLASH:		dc.b	0
radar_rmw_show:	dc.b	0

		even
HUD_POINTERS:
		dc.l	HUD_PLYR1A,HUD_PLYR2A
		dc.l	HUD_PLYR1B,HUD_PLYR2B
		dc.l	HUD_PLYR1C,HUD_PLYR2C


score_pos_external:
score_pos_internal:
		dc.l	128,10,player1weapons









********************************* BSS Section ********************************

		.bss


exit_timer:	ds.b	1
	even
target_frame:	ds.w	1
target_period:	ds.w	1
invincible:	ds.w	1

player1weapons:
		ds.b	WEAPON_SIZE
		.even
player2weapons:
		ds.b	WEAPON_SIZE


		.phrase

HUD_PLYR1A:	ds.w	RADAR_WIDTH*RADAR_HEIGHT
HUD_PLYR1B:	ds.w	RADAR_WIDTH*RADAR_HEIGHT
HUD_PLYR1C:	ds.w	RADAR_WIDTH*RADAR_HEIGHT
		IF	TWO_PLAYERS
HUD_PLYR2A:	ds.w	RADAR_WIDTH*RADAR_HEIGHT
HUD_PLYR2B:	ds.w	RADAR_WIDTH*RADAR_HEIGHT
HUD_PLYR2C:	ds.w	RADAR_WIDTH*RADAR_HEIGHT
		ELSE
HUD_PLYR2A	equ	HUD_PLYR1A
HUD_PLYR2B	equ	HUD_PLYR1B
HUD_PLYR2C	equ	HUD_PLYR1C
		ENDIF
