;the map sprite is a 256 colour image - it only uses the top 32 colours
;the first of these is the background colour - the rest are used for the
;warps - which get highlighted once a warp has been used..


		.68000
		.text

SPRITE_MAP_X		equ	0
SPRITE_MAP_Y		equ	40

SPRITE_MAP_NUMBER	equ	401


;remember to load in the level sprites before you initalise the mapper

initalise_mapper:
		lea	mapper_space,a0
		moveq	#32-1,d0
		move.w	2+map_colour_table,d1
.loop:		move.w	d1,(a0)+
		dbf	d0,.loop
load_map_piccy:
		move.w	#SPRITE_MAP_NUMBER,d0	;find addr of the sprite
		lea	level_sprites,a0
		jsr	get_addr_sprite
		move.l	d0,a1			;addr to load in
		move.w	level,d0		;from the level number
		lsl.w	#2,d0
		lea	map_names,a0
		move.l	(a0,d0.w),a0		;point to correct file to load
		jmp	load_file		;guess what this does
		

do_mapper_palette:
		tst.b	mapper_on
		beq.s	.no
		
		movem.l	d0/d1/a0/a1,-(sp)

		lea	map_colour_table,a0
		lea	mapper_space,a1

		moveq	#1,d0
		add.w	mapper_index,d0			;*2 words
		add.w	d0,d0
		move.w	2(a0,d0.w),(a1,d0.w)	;copy the colour across

		lea	CLUT+((256-32)*2),a0
		moveq	#32-1,d1
.loop:		move.w	(a1)+,(a0)+
		dbf	d1,.loop
		
		lea	CLUT+((256-32)*2),a0
		moveq	#%1100,d1
		and.l	clock,d1
		bne.s	.pass
		move.w	2+map_colour_table,(a0,d0.w)
.pass:
		movem.l	(sp)+,d0/d1/a0/a1
.no:		rts


display_mapper_sprite:

		move.l	ictarget(a0),a1		;point to the player from camera
		move.l	ioweapons(a1),a1	;now the weapon structure


		tst.b	MAP_VISIBLE(a1)
		beq.s	.no
		
		movem.l	d0-a6,-(sp)
		move.w	#SPRITE_MAP_X,d0
		move.w	#SPRITE_MAP_Y,d1
		move.w	#SPRITE_MAP_NUMBER,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		
;to scale the map around its center use

		if 0		
		move.b	zoom_size,d7
		move.w	#320,d0
		jsr	scale_x_sprite
		
		move.b	zoom_size,d7
		jsr	scale_y_sprite
			
		endif		

		movem.l	(sp)+,d0-a6
.no:		rts




		.data


map_colour_table:
		incbin	"graphics/bitmaps/warp_pal.cpl"



map_names:	
		dc.l	.level01
		dc.l	.level02
		dc.l	.level03
		dc.l	.level04
		dc.l	.level05
		dc.l	.level06
		dc.l	.level07
		dc.l	.level08
		dc.l	.level09
		dc.l	.level10
		dc.l	.level11
		dc.l	.level12
		dc.l	.level13
		dc.l	.level14
		dc.l	.level15
		dc.l	.level16
		dc.l	.level17
		dc.l	.level18
		dc.l	.level19
		dc.l	.level20
		dc.l	.level21



.level01:	dc.b	"MAP01.JSP",0
.level02:	dc.b	"MAP02.JSP",0
.level03:	dc.b	"MAP03.JSP",0
.level04:	dc.b	"MAP04.JSP",0
.level05:	dc.b	"MAP05.JSP",0
.level06:	dc.b	"MAP06.JSP",0
.level07:	dc.b	"MAP07.JSP",0
.level08:	dc.b	"MAP08.JSP",0
.level09:	dc.b	"MAP09.JSP",0
.level10:	dc.b	"MAP10.JSP",0
.level11:	dc.b	"MAP11.JSP",0
.level12:	dc.b	"MAP12.JSP",0
.level13:	dc.b	"MAP13.JSP",0
.level14:	dc.b	"MAP14.JSP",0
.level15:	dc.b	"MAP15.JSP",0
.level16:	dc.b	"MAP16.JSP",0
.level17:	dc.b	"MAP17.JSP",0
.level18:	dc.b	"MAP18.JSP",0
.level19:	dc.b	"MAP19.JSP",0
.level20:	dc.b	"MAP20.JSP",0
.level21:	dc.b	"MAP21.JSP",0
		even

	.bss
mapper_space:	ds.w	32
mapper_index:	ds.w	1
mapper_on:	ds.b	1
		even
