OPTIONS_COLOUR9	equ	7<<3
OPTIONS_COLOUR10	equ	8<<3

MISSION_ICON_START	equ	230

		.68000
		.text

RMW_OFFSET	equ	128

VISIBLE_SIZE	equ	80
RMW_SPEED	equ	4

mission:	
		sf	mission_can_be_saved
		sf	mission_saved_before
		sf	mission_exit
		st	map_visible
		clr.w	rmw_value
		clr.w	mission_icon_selected
		clr.w	current_scroll_y   
		move.w	#3,max_mission_select	
		move.w	#RMW_SPEED,rmw_direction


		lea	level_sprites,a0
		move.w	#16+MISSION_ICON_START,d0
		jsr	get_addr_sprite
		move.l	d0,rmw_addr

		move.w	#0,CLUT+2+(RMW_OFFSET*2)

		lea	mission_text_table,a6
		move.w	level,d0
		lsl.w	#2,d0
		move.l	(a6,d0.w),a6
		move.l	rmw_addr,d0
		move.l	#WID320|PITCH1|PIXEL1|XADDPIX,d1
		jsr	print_text_routine

		clr.w	max_scroll_y
		move.w	#-(VISIBLE_SIZE-(2*font_height)),d0
		add.w	print_y_pos,d0
		bmi.s	.arghh
		move.w	d0,max_scroll_y
.arghh:


		move.b	passcode_flag,d0
		or.b	restore_game,d0
		bne.s	.no_can_do		;if last level = new level !!

		lea	mission_save_allowed,a6
		move.w	level,d0
		tst.b	(a6,d0.w)
		beq.s	.no_can_do

	    	st	mission_can_be_saved
		addq	#1,max_mission_select

.no_can_do:	sf	restore_game
		sf	passcode_flag

		jsr	initmap

		move.l	mapobject,a6
		move.l	#object_anim,isanimbase(a6)
		clr.l	isanimframe(a6)

		bsr.s	mission_wait
		
		jsr	donemap
		
		jsr	NEW_OL
		jsr	add_choose_backdrop	;draw backdrop
		jsr	add_save_game_sprite
	
		tst.b	mission_saved_before
		beq.s	.no_save_eeprom
		st	save_game
		jsr	create_eeprom_buffer
		sf	save_game
.no_save_eeprom:	
		rept	2
		jsr	NEW_OL
		jsr	add_choose_backdrop	;draw backdrop
		endr
		jsr	wait_vbl
		rts

add_save_game_sprite:
		tst.b	mission_saved_before
		beq.s	.no
		move.w	#266,d4
		move.w	#(320-152)/2,d0
		move.w	screen_height,d1
		sub.w	#34,d1
		asr.w	#1,d1
		bra	display_mission_icon
.no:		rts

mission_wait:		
.loop:		tst.b	mission_exit
		beq.s	.no_exit
		rts
.no_exit:	jsr	read_joypad
		bsr	display_mission_stuff
		bra.s	.loop
		rts

update_rmw_stuff:
		move.w	rmw_direction,d0
		beq.s	.quit

		move.w	rmw_value,d1
		
		muls	frames_past,d0
		
		add.w	d0,d1

		bmi.s	.over_flow1
		cmp.w	#127,d1
		bgt.s	.over_flow2
		move.w	d1,rmw_value
		bra.s	.exit
.over_flow1:	clr.w	rmw_direction
		clr.w	rmw_value
		bra.s	.exit
.over_flow2:	clr.w	rmw_direction
		move.w	#127,rmw_value
.exit:		moveq	#0,d0
		add.w	rmw_value,d0
		and.w	#$00ff,d0
		beq.s	.no_colour
		or.w	#$7400,d0
.no_colour:	move.w	d0,CLUT+(2*(1+RMW_OFFSET))
.quit:		rts		

display_mission_rmw:

		movem.l	d0-a6,-(sp)
		JSR	ADD_OL
		
		move.w	current_scroll_y,d4
		mulu	#40,d4
		add.l	rmw_addr,d4		;alter for y scrolling
		lsl.l	#8,d4


		moveq	#0,d5
		move.w	rmw_height,d5
		moveq	#11,d6
		lsl.l	d6,d5
		move.w	rmw_y,d6
		tst.b	PAL_TV
		beq.s	.ntsc
		addq	#8,d6
.ntsc:		add.w	d6,d6
		add.w	my_vdb,d6
		or.w	d6,d5
		lsl.l	#3,d5			;here endth the 1st phrase
		
		move.l	#%00000000000000001100000000000000|((RMW_OFFSET/2)<<6),d6
		move.l	#%01010000000101001000000000000000,d7

		movem.l	d4-d7,(a0)
		move.b	#Q_BMO,O_TYPE(A0)
		movem.l	(sp)+,d0-a6
		rts

display_mission_stuff:
		jsr	NEW_OL
		jsr	switchab		;update the screens
		jsr	add_choose_backdrop	;draw backdrop
		move.w	clock+2,-(sp)
		move.l	rasterb,rasterd
		
		tst.b	map_visible		
		beq.s	.no_show_vectors
		jsr	ADD_VIEWSCREEN		;add polygon playfield
.no_show_vectors:
		jsr	showmap
		jsr	display_mission
		move.w	clock+2,d0
		sub.w	(sp)+,d0
		move.w	d0,frames_past
		bsr.s	add_icons
		bsr	handle_icons
		bsr	update_rmw_stuff
		move.w	#59,rmw_y
		move.w	#VISIBLE_SIZE,rmw_height
		bsr	display_mission_rmw
		rts


add_icons:	lea	mission_icon_sprites,a6
		move.w	(a6)+,-(sp)
.loop:		movem.w	(a6)+,d0/d1/d4/d5
		move.w	d5,-(sp)
		bsr.s	display_mission_icon
		move.w	(sp)+,d5
		bsr.s	colour_mission_icon_sprite1
		subq.w	#1,(sp)
		bne.s	.loop
		
		tst.b	mission_can_be_saved
		beq.s	.no_can_do

		movem.w	(a6),d0/d1/d4/d5		;display if can save this level
		move.w	d5,-(sp)
		bsr.s	display_mission_icon
		move.w	(sp)+,d5
		bsr.s	colour_mission_icon_sprite1

.no_can_do:
		addq	#8,a6

		tst.w	max_scroll_y		; only display if text can scroll
		beq.s	.no_scroll_arrows


		move.w	#2,(sp)	
.loop2:	movem.l	(a6)+,d0/d1/d4
		bsr.s	display_mission_icon
		move.l	(a6)+,d5
		bsr.s	colour_mission_icon_sprite2
		subq.w	#1,(sp)
		bne.s	.loop2
.no_scroll_arrows:		
		addq	#2,sp
		rts



mission_pal_y	equ	20

display_mission_icon:
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#mission_pal_y,d1
.ntsc:		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		rts

colour_mission_icon_sprite1:
		moveq	#OPTIONS_COLOUR0,d0
		cmp.w	mission_icon_selected,d5
		bne.s	.not_high
		moveq	#%11000,d0
		and.l	clock,d0
		beq.s	.way
		moveq	#OPTIONS_COLOUR6,d0
		bra.s	.not_high
.way:		moveq	#OPTIONS_COLOUR1,d0
.not_high:	jmp	add_colour_to_sprite

colour_mission_icon_sprite2:
		move.l	joycur1,d0
		or.l	joycur2,d0
		and.l	d0,d5
		moveq	#OPTIONS_COLOUR9,d0
		tst.l	d5
		bne.s	.not_high
		moveq	#OPTIONS_COLOUR10,d0
.not_high:	jmp	add_colour_to_sprite

			
handle_icons:
		move.l	joycur1,d0
		or.l	joycur2,d0

		move.l	joyedge1,d1
		or.l	joyedge2,d1

		btst	#UP_B,d0
		beq.s	.not_move_up
		bsr	scroll_up
		bra.s	.pass_up_down
.not_move_up:	btst	#DOWN_B,d0
		beq.s	.pass_up_down
		bsr	scroll_down
.pass_up_down:	btst	#LEFT_B,d1
		beq.s	.not_left
		moveq	#SFX_LEFT_BLEEP,d0
		jsr	sfxplay
		bsr	icon_move_left
		bra.s	.no_side
.not_left:	btst	#RIGHT_B,d1
		beq.s	.no_side
		moveq	#SFX_RIGHT_BLEEP,d0
		jsr	sfxplay
		bsr	icon_move_right
.no_side:	bsr	fire_pressed
		beq.s	.no_fire
		cmp.w	#2,mission_icon_selected
		beq.s	.no_sfx
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
.no_sfx:	move.w	mission_icon_selected,d0
		eor.w	#1,mission_icon_selected
		cmp.w	#1,d0
		bne.s	.not_desc
		not.b	map_visible
		move.w	#RMW_SPEED,rmw_direction
		bra.s	.no_fire
.not_desc:	cmp.w	#0,d0
		bne.s	.not_map
		st	map_visible
		tst.w	rmw_direction
		beq.s	.steady
		neg.w	rmw_direction
		bra.s	.no_fire
.steady:	moveq	#-RMW_SPEED,d0
		tst.w	rmw_value
		bne.s	.fade_up
		neg.w	d0
.fade_up:	move.w	d0,rmw_direction
		bra.s	.no_fire
.not_map:	cmp.w	#3,d0
		seq	mission_saved_before
		st	mission_exit
.no_fire:	rts

scroll_up:	move.w	frames_past,d7
		add.w	d7,current_scroll_y
		move.w	current_scroll_y,d7
		cmp.w	max_scroll_y,d7
		blt.s	.no_move
		move.w	max_scroll_y,current_scroll_y
.no_move:	rts

scroll_down:	move.w	frames_past,d7
		sub.w	d7,current_scroll_y	
		bpl.s	.no_move
		clr.w	current_scroll_y
.no_move:	rts


icon_move_right:
		move.w	max_mission_select,d0
		addq.w	#1,mission_icon_selected
		cmp.w	mission_icon_selected,d0
		bne.s	.ok
		clr.w	mission_icon_selected
.ok:		rts

icon_move_left:
		subq.w	#1,mission_icon_selected
		bpl.s	.ok
	  	moveq	#-1,d0
		add.w	max_mission_select,d0
		move.w	d0,mission_icon_selected
.ok:		rts


display_mission:
		moveq	#101,d0
		moveq	#20,d1
		move.w	#0+MISSION_ICON_START,d4
		bsr.s	display_top_1

		move.w	#190,d0
		moveq	#20,d1
		moveq	#1,d4
		add.w	level,d4
		divu	#10,d4
		add.w	#6+MISSION_ICON_START,d4
		moveq	#-1,d5
		bsr.s	display_top_1
		
		move.w	#190+16,d0
		moveq	#20,d1
		moveq	#1,d4
		add.w	level,d4
		divu	#10,d4
		swap	d4
		add.w	#6+MISSION_ICON_START,d4
		moveq	#-1,d5
		bsr.s	display_top_1
		rts

display_top_1:
		lea	level_sprites,a0
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#dis_y+4,d1
.ntsc:		jmp	print_a_sprite_normal_no_clip

		.data


mission_save_allowed:
		dc.b	0,1,1,1,1	;01,02,03,04,05
		dc.b	1,1,1,1,1	;06,07,08,09,10
		dc.b	1,1,1,1,1	;11,12,13,14,15
		dc.b	1,1,1,1,1	;16,17,18,19,20

	
mission_text_table:
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all
	  	dc.l	.level_all

		if	0
		dc.l	.level_02
		dc.l	.level_03
		dc.l	.level_04
		dc.l	.level_05
		dc.l	.level_06
		dc.l	.level_07
		dc.l	.level_08
		dc.l	.level_09
		dc.l	.level_10
		dc.l	.level_11
		dc.l	.level_12
		dc.l	.level_13
		dc.l	.level_14
		dc.l	.level_15
		dc.l	.level_16
		dc.l	.level_17
		dc.l	.level_18
		dc.l	.level_19
		dc.l	.level_20
		endif

.level_all:
	dc.b	PAT,0,55,0,0
	dc.b	"RETRIEVAL:"
	dc.b	PAT,0,55,0,30
	dc.b	"Retrieve Data Pods.",PCR
	dc.b	"Destroy Data Bases.",PCR
	dc.b	"Then dock at DataLink port.",PEND

	if	0
.level_01:
	dc.b	PAT,0,55,0,0
	dc.b	"RETRIEVAL:"
	dc.b	PAT,0,55,0,30
	dc.b	"Retrieve Data Pods, destroy",PCR
	dc.b	"Databases, then dock at I/O",PCR
	dc.b	"port for weapons upgrade.",PEND
.level_02:
	dc.b	PAT,0,55,0,0
	dc.b	"SEEK AND DESTROY:"
	dc.b	PAT,0,55,0,30
	dc.b	"Locate and destroy Up-Link",PCR
	dc.b	"Data Generator that is",PCR
	dc.b	"giving Alpha Omega access",PCR
	dc.b	"to our transmissions.",PEND
.level_03:
	dc.b	PAT,0,55,0,0
	dc.b	"TRANSPORT:"
	dc.b	PAT,0,55,0,30
	dc.b	"Collect hostile Data Pod",PCR
	dc.b	"and transport to I/O port.",PCR
	dc.b	"Our system can then access",PCR
	dc.b	"the data it contains.",PEND
.level_04:
	dc.b	PAT,0,55,0,0
	dc.b	"DESTROY:"
	dc.b	PAT,0,55,0,30
	dc.b	"A Data Generator is",PCR
	dc.b	"preventing our probes",PCR
	dc.b	"accessing the net - you",PCR
	dc.b	"must destroy it!",PCR,PCR
	dc.b	"Warning : local matrix",PCR
	dc.b	"collapse may occur on",PCR
	dc.b	"destruction of Data",PCR
	dc.b	"Generator.",PEND
.level_05:
	dc.b	PAT,0,55,0,0
	dc.b	"RAID:"
	dc.b	PAT,0,55,0,30
	dc.b	"A hostile virus is being",PCR
	dc.b	"created in a Data Fortress",PCR
	dc.b	"hidden in this area. Destroy",PCR
	dc.b	"it at all cost.",PCR,PCR
	dc.b	"Warning : this area is",PCR
	dc.b	"heavily defended.",PEND
.level_06:
	dc.b	PAT,0,55,0,0
	dc.b	"RECOVER:"
	dc.b	PAT,0,55,0,30
	dc.b	"An intercepted Data Pod",PCR
	dc.b	"is being interrogated.",PCR
	dc.b	"You must locate and recover",PCR
	dc.b	"it within 90 seconds.",PEND
.level_07:
	dc.b	PAT,0,55,0,0
	dc.b	"LOCATE AND DESTROY:"
	dc.b	PAT,0,55,0,30
	dc.b	"Alpha Omega's I.C.E. is",PCR
	dc.b	"preventing the net's efforts",PCR
	dc.b	"to engage override circuits.",PCR
	dc.b	"Locate and destroy the A.I.",PCR
	dc.b	"Databases controlling the",PCR
	dc.b	"I.C.E. system.",PEND
.level_08:
	dc.b	PAT,0,55,0,0
	dc.b	"PROTECT:"
	dc.b	PAT,0,55,0,30
	dc.b	"Our probe is gathering data",PCR
	dc.b	"from a Data Fortress. It",PCR
	dc.b	"requires at least 90 seconds",PCR
	dc.b	"to complete it's download",PCR
	dc.b	"and transmission. Protect it",PCR
	dc.b	"at all costs.",PEND
.level_09:
.level_10:
.level_11:
.level_12:
.level_13:
.level_14:
.level_15:
.level_16:
.level_17:
.level_18:
.level_19:
.level_20:
	dc.b	PAT,0,60,0,4
	dc.b	"BRIEFING",PCR
	DC.B	"ESCORT DATA POD TO",PCR
	DC.B	"CO-ORDS U134",PCR
	DC.B	"DESTROY DATABASES",PCR
	DC.B	"CO-ORDS 71,47.29.40.1750",PCR
	DC.B	"ESCAPE VIA CONNECTOR",PCR
	DC.B	"GATE. DOCK AT I/O PORT",PCR
	DC.B	"ALPHA 7 FOR ADDITIONAL",PCR
	DC.B	"EQUIPMENT",PEND
	endif
	
	
		even
mission_icon_sprites:
		dc.w	3
		dc.w	050,167,02+MISSION_ICON_START,0
		dc.w	103,167,01+MISSION_ICON_START,1
		dc.w	150,167,03+MISSION_ICON_START,2
		
		dc.w	210,167,17+MISSION_ICON_START,3

		dc.l	263,159,4+MISSION_ICON_START,1<<UP_B
		dc.l	263,172,5+MISSION_ICON_START,1<<DOWN_B

		.phrase
object_anim:	dc.l	object_vdf


		
object_vdf:	incbin	"graphics\\shapes\\maps\\map1.vdf"
		even

		.bss

max_scroll_y:		ds.w	1
current_scroll_y:	ds.w	1
rmw_value:		ds.w	1
rmw_direction:		ds.w	1
frames_past:		ds.w	1
mission_icon_selected:	ds.w	1
rmw_addr:		ds.l	1
rmw_y:			ds.w	1
rmw_height:		ds.w	1
max_mission_select:	ds.w	1
mission_exit:		ds.b	1
map_visible:		ds.b	1
mission_can_be_saved:	ds.b	1
mission_saved_before:	ds.b	1
	even

