shadow_colour	equ	(127)
shadow_colour1	equ	(127-1)

mid_y	equ	20

SPA	EQU	6
SPB	EQU	7
SPC	EQU	8


IN_OUT_SPEED	equ	4

INVALID_PASSCODE_TIMER	equ	50*5

OPTIONS_COLOUR0	equ	1<<3
OPTIONS_COLOUR1	equ	0<<3
OPTIONS_COLOUR2	equ	2<<3
OPTIONS_COLOUR3	equ	3<<3
COLOUR_BOX		equ	4<<3
OPTIONS_COLOUR6	equ	5<<3

P_COL_0		equ	(6*16)
P_COL_1		equ	0+P_COL_0
P_COL_2		equ	0+P_COL_1
P_COL_3		equ	0+P_COL_2
P_COL_4		equ	0+P_COL_3
P_COL_5		equ	0+P_COL_4
P_COL_6		equ	0+P_COL_5
P_COL_7		equ	0+P_COL_6
P_COL_8		equ	0+P_COL_7
P_COL_9		equ	2+P_COL_8


FONT_WIDTH		equ	16
MAIN_MAX		equ	4
NUMBER_OF_CODE_OPTIONS	equ	2
MAX_PAD		equ	6
MAX_DIFFICULTY		equ	3
NUMBER_OF_OPTIONS	equ	5
MEGA_NUMBER_OF_OPTIONS	equ	3
NUMBER_OF_PAD_OPTIONS	equ	2
MAX_PASSCODE_LEN	equ	10

RESET_EEPROM_TIME	equ	50*5
RESET_EEPROM_X		equ	(320-258)/2
RESET_EEPROM_Y		equ	50

LEVEL_BUTX		equ	176


FONT_HEIGHT		equ	20

		.text

options_screen:
		bsr	cls
		jsr	wait_vbl

		lea	CLUT,a0
		lea	options_palette+2,a1
		moveq	#128-1,d2
.loop1:	move.l	(a1)+,(a0)+
		dbf	d2,.loop1

		move.w	#$00e0,CLUT+(255*2)

		move.w	#OPTIONS_LEVEL,d0
		bsr	load_level_graphics

		jsr	load_monitor_pic

		move.w	#MAX_PASSCODE_LEN-1,d3
		lea	passcodes+2,a5
		lea	passcode_string,a6
.clrpass:	move.b	(a5)+,d0
		sub.b	#"0",d0
		move.b	d0,(a6)+
		dbf	d3,.clrpass

		
		st	mega_menu
		clr.w	level
		clr.w	HOW_HARD  		; read from the eeprom
		clr.w	TEXTURES_ON
		clr.w	JOYPAD_CONFIG
	


		sf	restore_game
		sf	passcode_flag

		st	IN_OPTIONS
		clr.w	eeprom_show_timer	
		sf	write_eeprom_allowed
		sf	passcode_flag
		st	disable_reset
		sf	restore_game_flag
		clr.w	main_option
		sf	main_exit
		
		bsr	bring_back_on

main_loop:	jsr	wait_vbl
		jsr	read_joypad
		bsr	draw_main_screen
		bsr	main_cursor_up_down
		bsr	process_main_choice
		bsr	take_off_mega_menu

		tst.b	main_exit
		beq.s	main_loop


		bsr	take_back_off


		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	draw_grid
		JSR	NEW_OL
		sf	disable_reset
		sf	IN_OPTIONS
		rts


take_off_mega_menu:
		move.l	joycur1,d0
		move.l	#(1<<KEY_2)|(1<<KEY_8)|(1<<KEY_4)|(1<<KEY_6),d1
		and.l	d1,d0
		cmp.l	d1,d0
		bne.s	.exit
		sf	mega_menu
.exit:		rts




main_cursor_up_down:
		move.w	main_option,d1
		move.l	joyedge1,d0
		btst	#UP_B,d0
		bne.s	.up_pressed
		btst	#DOWN_B,d0
		bne.s	.down_pressed
		rts
.up_pressed:	
		moveq	#SFX_UP_BLEEP,d0
		moveq	#-1,d2
		moveq	#MAIN_MAX-1,d3
		moveq	#-1,d4
		bra.s	.cont
.down_pressed:	
		moveq	#SFX_DOWN_BLEEP,d0
		moveq	#MAIN_MAX,d2
		moveq	#0,d3
		moveq	#1,d4
.cont:		
		add.w	d4,d1
		cmp.w	d1,d2
		bne.s	.no_wrap
		move.w	d3,d1
.no_wrap:	move.w	d1,main_option
		jsr	sfxplay
		rts




process_main_choice:
		bsr	fire_pressed
		beq.s	.exit
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		move.w	main_option,d0
		mulu	#4,d0
		move.l	.table(pc,d0.w),a0
		
		tst.b	mega_menu
		beq.s	.normal
		cmp.l	#options_stuff,a0
	 	bne.s	.normal
		lea	mega_options_stuff,a0
.normal:	jmp	(a0)
.exit:		rts
.table:	dc.l	m_start_game
		dc.l	m_load_game
		dc.l	object_viewer
		dc.l	options_stuff

object_viewer:
		movem.l	d0-a6,-(sp)
		jsr	view_stuff
		movem.l	(sp)+,d0-a6
		rts



m_start_game:	sf	passcode_flag
		sf	restore_game
		st	main_exit
		rts

m_load_game:	tst.w	restore_level
		bne.s	.valid_load

		move.w	#200,-(sp)
.wait:		bsr	draw_invalid_load_screen
		jsr	wait_vbl
		jsr	read_joypad
		move.l	joyedge1,d0
		or.l	joyedge2,d0
		bne.s	.quit


		sub.w	#1,(sp)
		bne.s	.wait
.quit:		addq	#2,sp
		rts	

.valid_load:	sf	passcode_flag
		st	restore_game
		st	main_exit
		rts
	
options_stuff:	

		clr.w	entered_code
		clr.w	option_selected
		clr.w	exit_options		
		clr.w	entering_code
		clr.w	code_status
		clr.w	code_position
		clr.w	invalid_code

.loop:		
		jsr	wait_vbl
		jsr	read_joypad
		bsr	draw_options_screen
		bsr.s	move_cursor_up_down
		bsr	process_cursor_choice
		tst.w	exit_options
		beq.s	.loop
		rts

cls:
		rept	3
		jsr	NEW_OL
		endr
		rts

mega_options_stuff:	

		clr.w	entered_code
		clr.w	option_selected
		clr.w	exit_options		
		clr.w	entering_code
		clr.w	code_status
		clr.w	code_position
		clr.w	invalid_code

.loop:		
		jsr	wait_vbl
		jsr	read_joypad
		bsr	mega_draw_options_screen
		bsr.s	mega_move_cursor_up_down
		bsr	mega_process_cursor_choice
		tst.w	exit_options
		beq.s	.loop
		rts


;**************************************************************
;allow the player to move between the options on the screen

move_cursor_up_down:
		move.w	option_selected,d1
		move.l	joyedge1,d0
		btst	#UP_B,d0
		bne.s	.up_pressed
		btst	#DOWN_B,d0
		bne.s	.down_pressed
		rts
.up_pressed:	
		moveq	#SFX_UP_BLEEP,d0
		moveq	#-1,d2
		moveq	#NUMBER_OF_OPTIONS-1,d3
		moveq	#-1,d4
		bra.s	.cont
.down_pressed:	
		moveq	#SFX_DOWN_BLEEP,d0
		moveq	#NUMBER_OF_OPTIONS,d2
		moveq	#0,d3
		moveq	#1,d4
.cont:		
		add.w	d4,d1
		cmp.w	d1,d2
		bne.s	.no_wrap
		move.w	d3,d1
.no_wrap:	move.w	d1,option_selected
		jsr	sfxplay
		rts

mega_move_cursor_up_down:
		move.w	option_selected,d1
		move.l	joyedge1,d0
		btst	#UP_B,d0
		bne.s	.up_pressed
		btst	#DOWN_B,d0
		bne.s	.down_pressed
		rts
.up_pressed:	
		moveq	#SFX_UP_BLEEP,d0
		moveq	#-1,d2
		moveq	#MEGA_NUMBER_OF_OPTIONS-1,d3
		moveq	#-1,d4
		bra.s	.cont
.down_pressed:	
		moveq	#SFX_DOWN_BLEEP,d0
		moveq	#MEGA_NUMBER_OF_OPTIONS,d2
		moveq	#0,d3
		moveq	#1,d4
.cont:		
		add.w	d4,d1
		cmp.w	d1,d2
		bne.s	.no_wrap
		move.w	d3,d1
.no_wrap:	move.w	d1,option_selected
		jsr	sfxplay
		rts







;***********************************************************************


process_cursor_choice:
		move.w	option_selected,d0
		lsl.w	#2,d0
		move.l	.options(pc,d0.w),a0
		jmp	(a0)

.options:	
		dc.l	p_pad
		dc.l	p_difficulty
		dc.l	p_code
		dc.l	p_textures
		dc.l	p_start

		
mega_process_cursor_choice:
		move.w	option_selected,d0
		lsl.w	#2,d0
		move.l	.options(pc,d0.w),a0
		jmp	(a0)

.options:	
		dc.l	p_pad
		dc.l	p_difficulty
		dc.l	p_start



;***************************************************************************
; indicate to exit the titles screen and load in game for eeprom


p_restore:	
		bsr	fire_pressed
		beq.s	.exit
		st	restore_game_flag
		move.w	#-1,exit_options
.exit:		rts


p_textures:
		bsr	fire_pressed
		bne.s	.ok
		bsr	left_right
		beq.s	.exit
.ok:		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		eor.w	#1,TEXTURES_ON
.exit:		rts


;*************************************************************************
;wait for the player to press fire to start the game

p_start:	bsr	fire_pressed
		beq.s	.exit
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		move.w	#-1,exit_options
.exit:		rts

		
;*************************************************************************
;similar code to change in the games difficulty


p_difficulty:	bsr	fire_pressed
		bne.s	.yes
		rts

.yes:		
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		clr.w	pad_choice
		clr.w	pad_exit

.loop:		jsr	read_joypad
		bsr	how_hard_move
		bsr	how_hard_alter
		bsr	how_hard_show
		jsr	wait_vbl
		
		tst.b	how_hard_exit
		beq.s	.loop
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		rts

how_hard_move:	move.w	HOW_HARD,d1
		move.l	joyedge1,d0
		btst	#UP_B,d0
		bne.s	.up_pressed
		btst	#DOWN_B,d0
		bne.s	.down_pressed
		rts
.up_pressed:	
		moveq	#SFX_UP_BLEEP,d0
		moveq	#-1,d2
		moveq	#MAX_DIFFICULTY-1,d3
		moveq	#-1,d4
		bra.s	.cont
.down_pressed:	
		moveq	#SFX_DOWN_BLEEP,d0
		moveq	#MAX_DIFFICULTY,d2
		moveq	#0,d3
		moveq	#1,d4
.cont:		
		add.w	d4,d1
		cmp.w	d1,d2
		bne.s	.no_wrap
		move.w	d3,d1
.no_wrap:	move.w	d1,HOW_HARD
		jsr	sfxplay
		rts


how_hard_alter:
		bsr	fire_pressed
		sne	how_hard_exit
		rts





;*************************************************************************
;routine to check if fire has just been pressed

fire_pressed:	move.l	joyedge1,d0
		btst	#FIRE_A,d0
		bne.s	.good
		btst	#FIRE_B,d0
		bne.s	.good
		btst	#FIRE_C,d0
.good:		rts

left_right:	move.l	joyedge1,d0
		btst	#LEFT_B,d0
		bne.s	.good
		btst	#RIGHT_B,d0
.good:		rts



get_digit_pressed:
	move.l	joyedge1,d1		;get data from both pads 
	moveq	#0,d2
	moveq	#9-1,d0
.loop:	move.b	.pad_bits(pc,d0.w),d2
	btst	d2,d1
	bne.s	.exit
	dbf	d0,.loop
.exit:	rts

.pad_bits:	dc.b	KEY_1,KEY_2,KEY_3,KEY_4
		dc.b	KEY_5,KEY_6,KEY_7,KEY_8,KEY_9
	





;*************************************************************************
;routine to enter a passcode
;fire to select to enter passcode
;left-right move cursor
;numbers enter digits


p_code:	bsr	fire_pressed
		bne.s	.enter
		rts
.enter:	
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		clr.w	p_code_status
		clr.w	p_code_option
		clr.w	p_code_exit

.loop:		jsr	read_joypad
		bsr	p_code_move
		bsr	p_code_show
		bsr	p_code_do
		jsr	wait_vbl
		
		tst.b	p_code_exit
		beq.s	.loop
		rts


p_code_move:	move.w	p_code_option,d1
		move.l	joyedge1,d0
		btst	#UP_B,d0
		bne.s	.up_pressed
		btst	#DOWN_B,d0
		bne.s	.down_pressed
		rts
.up_pressed:	
		moveq	#SFX_UP_BLEEP,d0
		moveq	#-1,d2
		moveq	#NUMBER_OF_CODE_OPTIONS-1,d3
		moveq	#-1,d4
		bra.s	.cont
.down_pressed:	
		moveq	#SFX_DOWN_BLEEP,d0
		moveq	#NUMBER_OF_CODE_OPTIONS,d2
		moveq	#0,d3
		moveq	#1,d4
.cont:		
		add.w	d4,d1
		cmp.w	d1,d2
		bne.s	.no_wrap
		move.w	d3,d1
.no_wrap:	move.w	d1,p_code_option
		jsr	sfxplay
		rts





p_code_do:	cmp.w	#1,p_code_status
		beq.s	.valid
		bsr	fire_pressed
		beq.s	.exit
.valid:	move.w	p_code_option,d0
		lsl.w	#2,d0
		move.l	.table(pc,d0.w),a0
		jmp	(a0)
.exit:		rts
.table:	dc.l	p_code_enter
		dc.l	p_code_quit

p_code_quit:	bsr	fire_pressed
		beq.s	.no
		sf	restore_game_flag
		st	exit_options
		st	main_exit
		st	passcode_flag
		st	p_code_exit
.no:		rts

p_code_enter:	move.w	#1,p_code_status
		rts
		
		

enter_a_passcode:		
		move.w	code_position,d1
		move.l	joyedge1,d0
		btst	#RIGHT_B,d0
		bne.s	.right_pressed
		btst	#LEFT_B,d0
		beq.s	.not_left_or_right
.left_pressed:	
		moveq	#-1,d2
		moveq	#-1,d3
		moveq	#MAX_PASSCODE_LEN-1,d4
		moveq	#SFX_LEFT_BLEEP,d0
		bra.s	.check_for_wrap
.right_pressed:	
		moveq	#1,d2
		moveq	#MAX_PASSCODE_LEN,d3
		moveq	#0,d4
		moveq	#SFX_RIGHT_BLEEP,d0
.check_for_wrap:
		add.w	d2,d1
		cmp.w	d1,d3
		bne.s	.no_wrap
		move.w	d4,d1
.no_wrap:
		move.w	d1,code_position
		jsr	sfxplay
		rts
.not_left_or_right:
		bsr	get_digit_pressed
		tst.w	d0
		bmi.s	.exit
		addq.b	#1,d0
		lea	passcode_string,a0
		move.w	code_position,d1
		move.b	d0,(a0,d1.w)
		addq.w	#1,d1
		cmp.w	#MAX_PASSCODE_LEN,d1
		bne.s	.no_loop
		moveq	#0,d1
.no_loop:	move.w	d1,code_position
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
.exit:		rts




process_passcode:
		lea	passcodes,a6

		move.w	(a6)+,d0
		moveq	#0,d1

.loop:		cmp.w	d0,d1
		beq.s	.no_valid_passcode
		

		lea	passcode_string,a0
		move.l	a6,a5

		moveq	#MAX_PASSCODE_LEN-1,d5
.loop1:		moveq	#"0",d4
		add.b	(a0)+,d4
		cmp.b	(a5)+,d4
		bne.s	.fail
		dbf	d5,.loop1
		move.w	d1,level
		clr.w	invalid_code
		clr.w	p_code_status
		rts
.fail:		addq	#1,d1
		lea	MAX_PASSCODE_LEN(a6),a6
		bra.s	.loop
.no_valid_passcode:
		move.w	#2,p_code_status
		move.w	#INVALID_PASSCODE_TIMER,invalid_code
		rts




;**********************************************************************
;code to change joypad stuff
p_pad:		bsr	fire_pressed
		bne.s	.yes
		rts

.yes:		
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		clr.w	pad_choice
		clr.w	pad_exit

.loop:		jsr	read_joypad
		bsr	pad_change
		bsr	pad_quit
		bsr	pad_show
		jsr	wait_vbl
		
		tst.w	pad_exit
		beq.s	.loop
		rts

pad_quit:	bsr	fire_pressed
		beq.s	.no
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
		move.w	#-1,pad_exit
.no:		rts

pad_change:	move.l	joyedge1,d0
		btst	#RIGHT_B,d0
		bne.s	.right_pressed
		btst	#LEFT_B,d0
		bne.s	.left_pressed
		btst	#UP_B,d0
		bne.s	.right_pressed
		btst	#DOWN_B,d0
		beq.s	.exit
.left_pressed:	
		moveq	#-1,d2
		moveq	#-1,d3
		moveq	#MAX_PAD-1,d4
		moveq	#SFX_LEFT_BLEEP,d0
		bra.s	.check_for_wrap
.right_pressed:	
		moveq	#1,d2
		moveq	#MAX_PAD,d3
		moveq	#0,d4
		moveq	#SFX_RIGHT_BLEEP,d0
.check_for_wrap:
		move.w	JOYPAD_CONFIG,d1
		add.w	d2,d1
		cmp.w	d1,d3
		bne.s	.no_wrap
		move.w	d4,d1
.no_wrap:
		move.w	d1,JOYPAD_CONFIG
		jsr	sfxplay
.exit:		rts



pad_show:	jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_back_anim
		bsr	print_pad_text
		bsr	display_rest_eeprom
		rts


print_pad_text:

		lea	pad_fire_text,a0	
		bsr	show_pad_text

		lea	pad_select_text,a0
		bsr	show_pad_text

		lea	pad_special_text,a0
		bsr	show_pad_text

		bsr	display_pad_buttons
		rts



show_pad_text:	
		movem.w	(a0),d0/d1/d4/d5	;x,y,sp_no,index_no
		move.w	d5,-(sp)
		bsr	display_option_sprite
		move.w	(sp)+,d5
		bsr	colour_pad_item
		rts


display_pad_buttons:	
		lea	pad_buttons_table,a6
		move.w	JOYPAD_CONFIG,d0
		mulu	#3*2,d0
		add.w	d0,a6

		move.w	#LEVEL_BUTX,d0
		move.w	#64,d1
		move.w	(a6)+,d4
		bsr	display_option_sprite
		moveq	#-1,d5
		bsr	colour_pad_item

		move.w	#LEVEL_BUTX,d0
		move.w	#108,d1
		move.w	(a6)+,d4
		bsr	display_option_sprite
		moveq	#-1,d5
		bsr	colour_pad_item

		move.w	#LEVEL_BUTX,d0
		move.w	#152,d1
		move.w	(a6)+,d4
		bsr	display_option_sprite
		moveq	#-1,d5
		bsr	colour_pad_item

		
		move.w	#111,d0
		move.w	#21,d1
		moveq	#0,d4
		bsr	display_option_sprite
		moveq	#-2,d5
		bsr	colour_pad_item		     	;endure highlighted
		rts



print_p_code_status:
		move.w	p_code_status,d0
		lsl.w	#2,d0
		move.l	.table(pc,d0.w),a0
		jmp	(a0)
.table:	dc.l	normal_p_code
		dc.l	entering_p_code
		dc.l	invalid_p_code


invalid_p_code:
		subq.w	#1,invalid_code
		bne.s	.not_clear
		clr.w	level
		clr.w	p_code_status
.not_clear:	
		move.w	#93,d0
		move.w	#152,d1
		move.w	#23,d4
		moveq	#-1,d5
		bsr	cont_p_code_show
		rts

normal_p_code:
		move.w	#93-10,d0
		move.w	#152,d1
		move.w	#15,d4
		moveq	#-1,d5
		bsr	cont_p_code_show
		
		move.w	#93+80-10,d0
		move.w	#152,d1
		moveq	#1,d4
		add.w	level,d4
		divu	#10,d4
		add.w	#25,d4
		moveq	#-1,d5
		bsr	cont_p_code_show
		
		move.w	#93+80+16-10,d0
		move.w	#152,d1
		moveq	#1,d4
		add.w	level,d4
		divu	#10,d4
		swap	d4
		add.w	#25,d4
		moveq	#-1,d5
		bsr	cont_p_code_show
		rts

entering_p_code:
		bsr	enter_a_passcode
		bsr	display_passcode
		jsr	fire_pressed
		beq.s	.no
		jsr	read_joypad
		bsr	process_passcode
.no:		rts







;**********************************************************************
; blit a screen to rasterd
; print some text on that screen
; andy thing else - like ??


how_hard_show:
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_back_anim
		bsr	print_hard_text
		bsr	display_rest_eeprom
		rts

p_code_show:
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_back_anim
		bsr	print_p_code_text
		bsr	display_rest_eeprom
		bsr	print_p_code_status
		rts

		
draw_options_screen:
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_back_anim
		bsr	print_text
		bsr	display_rest_eeprom
		rts
mega_draw_options_screen:
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_back_anim
		bsr	mega_print_text
		bsr	display_rest_eeprom
		rts


draw_main_screen:
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_back_anim
		bsr	print_main_text
		bsr	display_rest_eeprom
		rts

draw_in_out_stuff:
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	draw_grid
		bsr	display_rest_eeprom
		rts

draw_invalid_load_screen:
		movem.l	d0-a6,-(sp)
		jsr	NEW_OL
		jsr	add_choose_backdrop
		bsr	add_no_save_shadow
		lea	main_menu,a6
		moveq	#-2,d5
		bsr	show_main_text_menu

		move.w	#(320-204)/2,d0
		move.w	screen_height,d1
		sub.w	#32,d1
		asr.w	#1,d1
		move.w	#74,d4

		bsr	display_option_sprite

		movem.l	(sp)+,d0-a6
		rts



print_text:	lea	options_menu,a6
		
		moveq	#-2,d5
		bsr	show_text_menu
		
		move.w	(a6)+,-(sp)
.loop:		bsr	show_text
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		movem.w	(a6)+,d0/d1/d4/d5
		add.w	TEXTURES_ON,d4
		bsr	cont_show
		rts

mega_print_text:
		lea	mega_options_menu,a6
		
		moveq	#-2,d5
		bsr	show_text_menu
		
		move.w	(a6)+,-(sp)
.loop:		bsr	show_text
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		rts
		
print_hard_text:
		lea	how_hard_menu,a6
		
		moveq	#-2,d5
		bsr	show_hard_text_menu
		
		move.w	(a6)+,-(sp)
.loop:		bsr	show_hard_text
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		rts
print_p_code_text:
		lea	p_code_menu_normal,a6
		
		moveq	#-2,d5
		bsr	show_p_code_text_menu
		
		move.w	(a6)+,-(sp)
.loop:		bsr	show_p_code_text
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		rts





print_main_text:
		lea	main_menu,a6
		
		moveq	#-2,d5
		bsr	show_main_text_menu
		
		move.w	(a6)+,-(sp)
.loop:		bsr	show_main_text
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		rts



show_text_menu:
		movem.w	(a6)+,d0/d1/d4
		bra.s	cont_show
show_text:	
		movem.w	(a6)+,d0/d1/d4/d5	;x,y,sp_no,index_no
cont_show:
		move.w	d5,-(sp)
		bsr	display_option_sprite
		move.w	(sp)+,d5
		bsr	colour_item
		rts

show_hard_text_menu:
		movem.w	(a6)+,d0/d1/d4
		bra.s	cont_hard_show
show_hard_text:	
		movem.w	(a6)+,d0/d1/d4/d5	;x,y,sp_no,index_no
cont_hard_show:		
		move.w	d5,-(sp)
		bsr	display_option_sprite
		move.w	(sp)+,d5
		bsr	colour_hard_item
		rts

show_main_text_menu:
		movem.w	(a6)+,d0/d1/d4
		bra.s	cont_main_show
show_main_text:	
		movem.w	(a6)+,d0/d1/d4/d5	;x,y,sp_no,index_no
cont_main_show:		
		move.w	d5,-(sp)
		bsr	display_option_sprite
		move.w	(sp)+,d5
		bsr	colour_main_item
		rts

show_p_code_text_menu:
		movem.w	(a6)+,d0/d1/d4
		bra.s	cont_p_code_show
show_p_code_text:	
		movem.w	(a6)+,d0/d1/d4/d5	;x,y,sp_no,index_no
cont_p_code_show:		
		move.w	d5,-(sp)
		bsr	display_option_sprite
		move.w	(sp)+,d5
		bsr	colour_p_code_item
		rts



display_rest_eeprom:
		tst.b	write_eeprom_allowed		;check if *#+OPTIONS
		beq.s	.exit			
		tst.w	eeprom_show_timer		;check if counting down
		bne	.no_double			;if so then no eeprom
		jsr	reset_eeprom			;reset
.no_double:	sf	write_eeprom_allowed		;clear flag and set timer
		move.w	#RESET_EEPROM_TIME,eeprom_show_timer
.exit:		tst.w	eeprom_show_timer
		bne.s	.go_on
		rts
.go_on:	subq.w	#1,eeprom_show_timer
		
		move.w	#RESET_EEPROM_X,d0		;print the sprite
		move.w	screen_height,d1		;only if time left
		sub.w	#RESET_EEPROM_Y,d1
		moveq	#24,d4
		bsr	display_option_sprite
		moveq	#OPTIONS_COLOUR2,d0
		jmp	add_colour_to_sprite


display_passcode:
		move.w	#94-10,d0
		move.w	#152,d1
		move.w	#MAX_PASSCODE_LEN-1,d3
		moveq	#0,d2
		lea	passcode_string,a6
.loop:		movem.w	d0/d1/d2/d3,-(sp)
		moveq	#25,d4
		add.b	(a6)+,d4
		bsr	display_option_sprite
		bsr	pass_item
		movem.w	(sp)+,d0/d1/d2/d3
		addq	#1,d2
		add.w	#16,d0
		dbf	d3,.loop
		rts

		
pass_item:	moveq	#OPTIONS_COLOUR1,d0
		cmp.w	code_position,d2
		bne.s	.not_current
		moveq	#OPTIONS_COLOUR2,d0
.not_current:	jmp	add_colour_to_sprite

colour_item:	cmp.w	#-2,d5
		beq.s	.way
		moveq	#OPTIONS_COLOUR0,d0
		cmp.w	option_selected,d5
		bne.s	.not_high
		moveq	#%11000,d0
		and.l	clock,d0
		beq.s	.way
		moveq	#OPTIONS_COLOUR6,d0
		bra.s	.not_high
.way:		moveq	#OPTIONS_COLOUR1,d0

.not_high:	jmp	add_colour_to_sprite

colour_hard_item:
		cmp.w	#-2,d5
		beq.s	.way
		moveq	#OPTIONS_COLOUR0,d0
		cmp.w	HOW_HARD,d5
		bne.s	.not_high
		moveq	#%11000,d0
		and.l	clock,d0
		beq.s	.way
		moveq	#OPTIONS_COLOUR6,d0
		bra.s	.not_high
.way:		moveq	#OPTIONS_COLOUR1,d0
.not_high:	jmp	add_colour_to_sprite

colour_main_item:
		cmp.w	#-2,d5
		beq.s	.way
		moveq	#OPTIONS_COLOUR0,d0
		cmp.w	main_option,d5
		bne.s	.not_high
		moveq	#%11000,d0
		and.l	clock,d0
		beq.s	.way
		moveq	#OPTIONS_COLOUR6,d0
		bra.s	.not_high
.way:		moveq	#OPTIONS_COLOUR1,d0
.not_high:	jmp	add_colour_to_sprite

colour_p_code_item:
		cmp.w	#-2,d5
		beq.s	.way
		moveq	#OPTIONS_COLOUR0,d0
		tst.w	d5
		bmi.s	.special
		cmp.w	p_code_option,d5
		bne.s	.not_high
		moveq	#%11000,d0
		and.l	clock,d0
		beq.s	.way
		moveq	#OPTIONS_COLOUR6,d0
		bra.s	.not_high
.way:		moveq	#OPTIONS_COLOUR1,d0
.not_high:	jmp	add_colour_to_sprite
.special:	move.l	#OPTIONS_COLOUR2,d0
		bra.s	.not_high

				
colour_pad_item:
		cmp.w	#-2,d5
		bne.s	.safe
		moveq	#OPTIONS_COLOUR1,d0
		bra.s	.not_high
.safe:		moveq	#OPTIONS_COLOUR0,d0
		tst.w	d5
		bmi.s	.col_3
		cmp.w	pad_choice,d5
		bne.s	.not_high
		moveq	#OPTIONS_COLOUR1,d0
		moveq	#%11000,d0
		and.l	clock,d0
		beq.s	.way
		moveq	#OPTIONS_COLOUR6,d0
.way:		bra.s	.not_high
.col_3:	moveq	#OPTIONS_COLOUR3,d0
.not_high:	jmp	add_colour_to_sprite
	
show_level_number:
		movem.w	d0/d1/d4,-(sp)
		divu	#10,d4
		add.w	#13,d4
		bsr	display_option_sprite
		moveq	#4,d5
		bsr	colour_item
		movem.w	(sp)+,d0/d1/d4
		addq	#8,d0
		divu	#10,d4
		swap	d4
		add.w	#13,d4
		bsr	display_option_sprite
		moveq	#4,d5
		bsr	colour_item
		rts



*************************************************************************************

anim_timer_1	equ	6
anim_frame_1	equ	10-1

anim_timer_2	equ	2
step_2		equ	8
anim_frame_2	equ	167


add_back_anim:
		bsr	draw_grid

		subq.w	#1,anim_1_timer
		bpl.s	.same_frame
		move.w	#anim_timer_1,anim_1_timer
		subq.w	#1,anim_1_frame
		bpl.s	.no_wrap
		move.w	#anim_frame_1,anim_1_frame
.no_wrap:
.same_frame:
		moveq	#85-10,d0
		moveq	#62,d1
		move.w	anim_1_frame,d4
		move.b	.tab(pc,d4.w),d4	
		add.w	#61,d4
		bsr	display_option_sprite
		moveq	#COLOUR_BOX,d0
		jsr	add_colour_to_sprite
		
		bsr.s	add_back_anim_strip
		rts
.tab:		dc.b	9,8,7,6,5,4,3,2,1,0



add_back_anim_strip:
		subq.w	#1,anim_2_timer
		bpl.s	.same_frame_2
		move.w	#anim_timer_2,anim_2_timer
		subq.w	#1,anim_2_frame
		bpl.s	.no_wrap_2
		add.w	#anim_frame_2,anim_2_frame
.no_wrap_2:
.same_frame_2:
		move.w	#220,d0
		moveq	#62,d1
		tst.b	PAL_TV
		beq.s	.ntsc
		moveq	#62+mid_y,d1
.ntsc:
		jsr	ADD_OL
		movem.l	dummy_2,d4/d5/d6/d7
		move.w	#anim_frame_2-1,d2
		sub.w	anim_2_frame,d2
		mulu	#step_2,d2
		add.l	d2,d4
		lsl.l	#8,d4
		add.w	d1,d1
		add.w	my_vdb,d1
		lsl.w	#3,d1
		or.w	d1,d5
		or.w	d0,d7
		movem.l	d4-d7,(a0)
		move.b	#Q_BMO,O_TYPE(a0)
		rts

add_back_anim1:
		subq.w	#1,anim_1_timer
		bpl.s	.same_frame
		move.w	#anim_timer_1,anim_1_timer
		subq.w	#1,anim_1_frame
		bpl.s	.no_wrap
		move.w	#anim_frame_1,anim_1_frame
.no_wrap:
.same_frame:
		moveq	#86,d0
		move.w	#144,d1
		move.w	anim_1_frame,d4
		move.b	.tab(pc,d4.w),d4	
		add.w	#61,d4
		bsr	display_option_sprite
		moveq	#COLOUR_BOX,d0
		jsr	add_colour_to_sprite
		
		subq.w	#1,anim_2_timer
		bpl.s	.same_frame_2
		move.w	#anim_timer_2,anim_2_timer
		subq.w	#1,anim_2_frame
		bpl.s	.no_wrap_2
		add.w	#anim_frame_2,anim_2_frame
.no_wrap_2:
.same_frame_2:

		bra	add_back_anim_strip
.tab:		dc.b	9,8,7,6,5,4,3,2,1,0

		move.w	#220,d0
		moveq	#62,d1
		tst.b	PAL_TV
		beq.s	.ntsc
		moveq	#mid_y+62,d1
.ntsc:
		jsr	ADD_OL
		movem.l	dummy_1,d4/d5/d6/d7
		move.w	#anim_frame_2-1,d2
		sub.w	anim_2_frame,d2
		mulu	#step_2,d2
		add.l	d2,d4
		lsl.l	#8,d4
		add.w	d1,d1
		add.w	my_vdb,d1
		lsl.w	#3,d1
		or.w	d1,d5
		or.w	d0,d7
		movem.l	d4-d7,(a0)
		move.b	#Q_BMO,O_TYPE(a0)
		rts


draw_grid2:	move.w	#(320-274)/2,d0
		move.w	#190-3,d1
		moveq	#80,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite


draw_grid1:	bsr	shade_backdrop1
		bra.s	grid_cont

draw_grid:	
		bsr	shade_backdrop
grid_cont:
		move.w	#9,anim_3_frame
		move.w	anim_3_frame,d0
		lsl.w	#3,d0
		movem.w	.offsets(pc,d0.w),d0/d1/d4/d5
		move.w	d5,-(sp)
		add.w	#51,d4
		bsr	display_option_sprite
		move.w	(sp)+,d0
		ext.l	d0
		jmp	add_colour_to_sprite
.offsets:
		dc.w	159,93,00,P_COL_0/2
		dc.w	155,85,01,P_COL_1/2
		dc.w	152,83,02,P_COL_2/2
		dc.w	151,81,03,P_COL_3/2
		dc.w	152,80,04,P_COL_4/2
		dc.w	142,73,05,P_COL_5/2
		dc.w	129,68,06,P_COL_6/2
		dc.w	115,63,07,P_COL_7/2
		dc.w	100,61,08,P_COL_8/2
		dc.w	(320-172)/2,61,09,P_COL_9/2


add_no_save_shadow:
		move.w	#(320-156)/2,d0
		move.w	#17,d1
		moveq	#77,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite
		
		
		
		
		move.w	#(320-224)/2,d0
		move.w	screen_height,d1
		sub.w	#62,d1
		asr.w	#1,d1
		move.w	#81,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite
		
		rts

take_back_off:
		rts
		moveq	#0,d0			;end_frame
		moveq	#10-1,d1		;start_frame
		moveq	#IN_OUT_SPEED,d2
		moveq	#-1,d3
		bra.s	move_grid
bring_back_on:	
		

		moveq	#71,d0
		lea	level_sprites,a0
		jsr	get_sprite_data
		
		and.l	#%11111111000000000011111111111111,d5
		moveq	#107,d0
		swap	d0
		ror.l	#2,d0
		or.l	d0,d5
		movem.l	d4-d7,dummy_2
		
		moveq	#71,d0
		lea	level_sprites,a0
		jsr	get_sprite_data
		
		and.l	#%11111111000000000011111111111111,d5
		moveq	#89,d0
		swap	d0
		ror.l	#2,d0
		or.l	d0,d5
		movem.l	d4-d7,dummy_1

		clr.w	anim_2_frame
		clr.w	anim_2_timer
		clr.w	anim_1_frame
		clr.w	anim_1_timer
		rts


		moveq	#10,d0		;end_frame
		moveq	#0,d1		
		moveq	#IN_OUT_SPEED,d2   
		moveq	#1,d3
move_grid:	
		move.w	d0,anim_3_last
		move.w	d1,anim_3_frame
		move.w	d2,anim_3_speed
		move.w	d2,anim_3_timer
		move.w	d3,anim_3_direction

.loop:		jsr	wait_vbl
		bsr	draw_in_out_stuff

		subq.w	#1,anim_3_timer
		bne.s	.loop
		move.w	anim_3_speed,anim_3_timer
		move.w	anim_3_direction,d0
		add.w	d0,anim_3_frame
		move.w	anim_3_frame,d1
		cmp.w	anim_3_last,d1
		bne.s	.loop
		sub.w	d0,anim_3_frame
		rts


display_option_sprite:
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20,d1
.ntsc:		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		rts


shade_backdrop:
		move.w	#(320-156)/2,d0
		move.w	#17,d1
		moveq	#77,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite

		move.w	#(320-194)/2,d0
		move.w	#52,d1
		moveq	#76,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite
		rts

shade_backdrop1:
		move.w	#(320-176)/2,d0
		move.w	#17,d1
		moveq	#78,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite

		move.w	#(320-194)/2,d0
		move.w	#52,d1
		moveq	#76,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite
		rts





		.data


main_menu:	dc.w	(320-48)/2,021,73
		dc.w	4
		dc.w	093-10,064,16,0
		dc.w	093-10,094,22,1
		dc.w	093-10,122,75,2
		dc.w	093-10,152,17,3


options_menu:	dc.w	(320-80)/2,021,17
		dc.w	5
		dc.w	094-10,064,00,0
		dc.w	093-10,086,09,1
		dc.w	093-10,108,13,2
		dc.w	093-10,130,18,3
		dc.w	093-10,152,73,4	;was 5
		dc.w	199-10,130,19,3

mega_options_menu:
		dc.w	(320-80)/2,021,17
		dc.w	3
		dc.w	094-10,064,00,0
		dc.w	093-10,108,09,1
		dc.w	093-10,152,73,2



how_hard_menu:	dc.w	(320-100)/2,021,09
		dc.w	3
		dc.w	093-10,064,10,0
		dc.w	093-10,108,11,1
		dc.w	093-10,152,12,2

p_code_menu_normal:
		dc.w	(320-134)/2,021,13
		dc.w	2
		dc.w	093-10,064,14,0
		dc.w	093-10,108,16,1

pad_fire_text:		dc.w	93-8,108,1,-1
pad_select_text:	dc.w	93-8,064,2,-1
pad_special_text:	dc.w	93-8,152,3,-1


options_palette:	incbin	"graphics\\bitmaps\\menus\\menu_pal.cpl"


passcodes:	dc.w	(passcodes_end-passcodes-2)/MAX_PASSCODE_LEN

		dc.b	"7171717171"	;1
		dc.b	"7272727272"	;2
		dc.b	"7373737373"	;3
		dc.b	"7474747474"	;4
		dc.b	"7575757575"	;5
		dc.b	"7676767676"	;6
		dc.b	"7777777777"	;7
		dc.b	"7878787878"	;8
		dc.b	"7979797979"	;9

		dc.b	"8181818181"	;10
		dc.b	"8282828282"	;11
		dc.b	"8383838383"	;12
		dc.b	"8484848484"	;13
		dc.b	"8585858585"	;14
		dc.b	"8686868686"	;15
		dc.b	"8787878787"	;16
		dc.b	"8888888888"	;17
		dc.b	"8989898989"	;18

		dc.b	"9191919191"	;19
		dc.b	"9292929292"	;20
		dc.b	"9393939393"	;21
passcodes_end:			   
		even

		.bss

passcode_string:	ds.b	MAX_PASSCODE_LEN
passcode_flag:		ds.b	1
restore_game_flag:	ds.b	1
how_hard_exit:		ds.b	1
main_exit:		ds.b	1
restore_game:		ds.b	1
IN_OPTIONS:		ds.b	1
mega_menu:		ds.b	1
		even

p_code_status:		ds.w	1
p_code_option:		ds.w	1
p_code_exit:		ds.w	1
main_option:		ds.w	1
invalid_code:		ds.w	1
eeprom_show_timer:	ds.w	1
option_selected:	ds.w	1
exit_options:		ds.w	1
HOW_HARD:		ds.w	1
TEXTURES_ON:		ds.w	1
code_status:		ds.w	1
entering_code:		ds.w	1
code_position:		ds.w	1
entered_code:		ds.w	1
pad_choice:		ds.w	1
pad_exit:		ds.w	1
anim_1_frame:		ds.w	1
anim_1_timer:		ds.w	1
anim_2_frame:		ds.w	1
anim_2_timer:		ds.w	1
			ds.b	32
dummy_1:		ds.b	32
dummy_2:		ds.b	32
anim_3_last:		ds.w	1
anim_3_frame:		ds.w	1
anim_3_speed:		ds.w	1
anim_3_timer:		ds.w	1
anim_3_direction:	ds.w	1

		phrase
