		.68000
		text

		
PSY	equ	(120-40)	

PAUSED_SPRITE		equ	7
PAUSED_SPRITE_WIDTH	equ	132
PAUSED_SPRITE_HEIGHT	equ	15
PAUSED_SPRITE_SHOP	equ	248

MUSIC_ON_ICON		equ	259
MUSIC_OFF_ICON		equ	260
SFX_ICON		equ	261
VOL_BAR		equ	262
VOL_SLIDER		equ	263
VOL_MARKER_LEFT	equ	264
VOL_MARKER_RIGHT	equ	265

PSPA	EQU	8
PSPB	EQU	9
PSPC	EQU	10

				   
PAUSE_STEP	equ	26
PAUSE_Y_0	equ	-(2*PAUSE_STEP)-(PAUSE_STEP/2)
PAUSE_Y_1	equ	-(1*PAUSE_STEP)-(PAUSE_STEP/2)
PAUSE_Y_2	equ	(0*PAUSE_STEP)-(PAUSE_STEP/2)
PAUSE_Y_3	equ	(1*PAUSE_STEP)-(PAUSE_STEP/2)
PAUSE_Y_4	equ	(2*PAUSE_STEP)-(PAUSE_STEP/2)

create_paused_sprites:
		sf	pause_control
		sf	pause_seen
		move.b	#1,pause_button

		move.w	screen_height,d0
		lsr.w	#1,d0
		add.w	#16,d0
		move.w	d0,pause_mid_point
	
		move.w	#(320-132)/2,d0
		move.w	#PAUSE_Y_0,d1
		add.w	pause_mid_point,d1
		
		move.w	#PAUSED_SPRITE,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	a0,addr_for_stop

		move.w	#(320-162)/2,d0
		move.w	#PAUSE_Y_2,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_BAR,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		move.w	#(320-162)/2,d0
		move.w	#PAUSE_Y_4,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_BAR,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		
		move.w	#(320-104)/2,d0
		move.w	#PAUSE_Y_3,d1
		add.w	pause_mid_point,d1
		move.w	#SFX_ICON,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip

		move.w	#(320-104)/2,d0
		move.w	#PAUSE_Y_1,d1
		add.w	pause_mid_point,d1
		move.w	#MUSIC_ON_ICON,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	a0,addr_of_music_icon		; music on / off  icon

		move.w	#(320-162)/2,d0
		move.w	#PAUSE_Y_2+1,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_SLIDER,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	a0,addr_of_music_slider

		move.w	#(320-162)/2,d0
		move.w	#PAUSE_Y_4+1,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_SLIDER,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	a0,addr_of_sfx_slider


		move.w	#(320-162)/2-20,d0
		move.w	#400,d1
		move.w	#VOL_MARKER_LEFT,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	a0,addr_of_sfx_maker_left

		move.w	#(320-162)/2-20,d0
		move.w	#400,d1
		move.w	#VOL_MARKER_RIGHT,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	a0,addr_of_sfx_maker_right

handle_paused_sprites:
		tst.b	pause_seen
		beq.s	.seen
		rts
.seen:		
		tst.b	pause_button
		beq.s	.nothing


		tst.b	pause_control
		bne	.handle_controls

		move.w	#PAUSE_Y_2,d1
		cmp.b	#1,pause_button
		beq.s	.music
		move.w	#PAUSE_Y_4,d1
.music:	add.w	pause_mid_point,d1
		move.w	d1,-(sp)

		move.w	#(320-162)/2-20,d0
		move.w	#VOL_MARKER_LEFT,d4
		lea	level_sprites,a0
		jsr	get_sprite_data_pause
		move.l	addr_of_sfx_maker_left,a0
		movem.l	d4-d7,(a0)

		move.w	#(320-162)/2+20+162-10,d0
		move.w	(sp)+,d1
		move.w	#VOL_MARKER_RIGHT,d4
		lea	level_sprites,a0
		jsr	get_sprite_data_pause
		move.l	addr_of_sfx_maker_right,a0
		movem.l	d4-d7,(a0)

.nothing:
		move.w	#(320-104)/2,d0
	  	move.w	#PAUSE_Y_1,d1
		add.w	pause_mid_point,d1

		move.w	#MUSIC_OFF_ICON,d4
		cmp.b	#-1,vol_mod
		beq.s	.off
		move.w	#MUSIC_ON_ICON,d4
.off:		lea	level_sprites,a0
		jsr	get_sprite_data_pause
		move.l	addr_of_music_icon,a0
		movem.l	d4-d7,(a0)

		move.w	#400,d0
		move.w	#PAUSE_Y_2+1,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_SLIDER,d4
		lea	level_sprites,a0
		jsr	get_sprite_data_pause
		move.l	addr_of_music_slider,a0
		movem.l	d4-d7,(a0)

		move.w	#640,d0
		cmp.b	#-1,vol_mod
		beq.s	.off1
		moveq	#0,d0
		move.b	vol_mod,d0
		move.b	.slide_table(pc,d0.w),d0
		add.w	#((320-162)/2)+1,d0
.off1:		move.w	#PAUSE_Y_2+1,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_SLIDER,d4
		lea	level_sprites,a0
		jsr	get_sprite_data_pause
		move.l	addr_of_music_slider,a0
		movem.l	d4-d7,(a0)
.handle_sfx:
		moveq	#0,d0
		move.b	vol_sfx,d0
		move.b	.slide_table(pc,d0.w),d0
		add.w	#((320-162)/2)+1,d0
		move.w	#PAUSE_Y_4+1,d1
		add.w	pause_mid_point,d1
		move.w	#VOL_SLIDER,d4
		lea	level_sprites,a0
		jsr	get_sprite_data_pause
		move.l	addr_of_sfx_slider,a0
		movem.l	d4-d7,(a0)
		bra	handle_sliders
.slide_table:	
acid	set	0
		rept	20
		dc.b	acid*10
acid	set	acid+1
		endr

		even
		

.handle_controls:
		move.l	addr_for_stop,a6
		lea	level_sprites,a0
		lea	pause_control_sprites,a5
		lea	pause_buttons_table,a4
		move.w	JOYPAD_CONFIG,d0
		mulu	#6,d0
		add.w	d0,a4

		move.w	(a5)+,-(sp)
.loop:		movem.w	(a5)+,d0/d1/d4
		bsr	add_pause_sprite
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp

		move.w	(a5)+,-(sp)
.loop1:	move.w	(a5)+,d0
		move.w	(a5)+,d1
		move.w	(a4)+,d4
		bsr	add_pause_sprite
		subq.w	#1,(sp)
		bne.s	.loop1
		addq	#2,sp

		clr.l	(a6)+ 			;add a stop object
		move.l	#4,(a6)+
		bsr	move_controls
		rts


add_pause_sprite:
	tst.b	PAL_TV
	beq.s	.ntsc
	add.w	#20,d1
.ntsc:	lsl.w	#5,d4				;index into table entry
	movem.l	(a0,d4.w),d4-d7
	lsl.l	#8,d4
	add.w	d1,d1
	add.w	my_vdb,d1
	lsl.w	#3,d1
	or.w	d1,d5				;and the y position
	or.w	d0,d7
	movem.l	d4/d5/d6/d7,(a6)
	move.b	#Q_BMO,O_TYPE(a6)		;indicate type of object
	lea	OBJ_SIZE(a6),a6
	rts

move_controls:	
		move.l	joyedge1,d0
		btst	#RIGHT_B,d0
		bne.s	.right_pressed
		btst	#LEFT_B,d0
		bne.s	.left_pressed
		btst	#UP_B,d0
		bne.s	.right_pressed
		btst	#DOWN_B,d0
		beq.s	.exit
.left_pressed:	
		moveq	#-1,d2
		moveq	#-1,d3
		moveq	#MAX_PAD-1,d4
		moveq	#SFX_LEFT_BLEEP,d0
		bra.s	.check_for_wrap
.right_pressed:	
		moveq	#1,d2
		moveq	#MAX_PAD,d3
		moveq	#0,d4
		moveq	#SFX_RIGHT_BLEEP,d0
.check_for_wrap:
		move.w	JOYPAD_CONFIG,d1
		add.w	d2,d1
		cmp.w	d1,d3
		bne.s	.no_wrap
		move.w	d4,d1
.no_wrap:
		move.w	d1,JOYPAD_CONFIG
		jsr	sfxplay
.exit:		rts




handle_sliders:
		move.l	#(1<<KEY_1)+(1<<KEY_3),d0
		and.l	joycur1,d0
		cmp.l	#(1<<KEY_1)+(1<<KEY_3),d0
		bne.s	.pause_still_on
		st	pause_seen
		move.l	addr_for_stop,a0
		clr.l	(a0)+
		move.l	#4,(a0)+
		rts
.pause_still_on:
		moveq	#%1,d0
		and.l	clock,d0
		beq.s	.wait
		bsr	handle_buttons
		cmp.b	#2,pause_button
		beq.s	handle_sfx
		cmp.b	#1,pause_button
		beq.s	handle_music
.wait:		rts
handle_sfx:	
		move.l	joycur1,d0
		move.l	#(1<<RIGHT_B),d2
		and.l	d0,d2
		bne.s	.move_slider_right
		move.l	#(1<<LEFT_B),d2
		and.l	d0,d2
		bne.s	.move_slider_left
		rts

.move_slider_right:				;increase value
		cmp.b	#MAX_SLIDER_VALUE,vol_sfx
		beq.s	.at_max_already
		addq.b	#1,vol_sfx
.at_max_already:
		bra.s	.set_new_volume_level

.move_slider_left:				;decrease value
		tst.b	vol_sfx
		beq.s	.at_minimum
		subq.b	#1,vol_sfx
.at_minimum:
.set_new_volume_level:
	
		moveq	#1,d1
	
		moveq	#0,d0				;get the volume for that specific value
		move.b	vol_sfx,d0
	
		lea	volume_table,a4
		move.b	(a4,d0.w),d0
	
		jsr	MUS_SET_VOLUME
.no_change:	rts

	
handle_music:	
		move.l	joycur1,d0
		move.l	#(1<<RIGHT_B),d2
		and.l	d0,d2
		bne.s	.move_slider_right
		move.l	#(1<<LEFT_B),d2
		and.l	d0,d2
		bne.s	.move_slider_left
		rts

.move_slider_right:				;increase value
		move.b	vol_mod,d0
		bpl.s	.music_was_not_off	
		beq.s	.music_was_not_off
		eor.b	#1,mustype						;change the state of the music
		sf	save_mod_level
		sf	vol_mod				;reset the volume back to 0 then 1st one is for sligh volume
		st	save_mod_level
		jsr	MUS_START_MOD
.music_was_not_off:
		cmp.b	#MAX_SLIDER_VALUE,vol_mod
		beq.s	.at_max_already
		addq.b	#1,vol_mod
.at_max_already:
		bra.s	.set_new_volume_level

.move_slider_left:				;decrease value
		moveq	#-1,d7
		cmp.b	vol_mod,d7
		beq.s	.at_minimum
		subq.b	#1,vol_mod
		cmp.b	vol_mod,d7
		bne.s	.music_not_turned_off

		eor.b	#1,mustype						;change the state of the music
		move.b	#1,save_mod_level
		jsr	MUS_STOP_MOD
	
.music_not_turned_off:
.at_minimum:
.set_new_volume_level:
	
		tst.b	vol_mod				;if -1 then music and no need to set volume
		bmi.s	.no_change
	
		moveq	#0,d1
		moveq	#0,d0				;get the volume for that specific value
		move.b	vol_mod,d0
		
		lea	volume_table,a4
		move.b	(a4,d0.w),d0
	
		jsr	MUS_SET_VOLUME
.no_change:	rts


handle_buttons:
		move.l	#(1<<OPTIONS),d0
		and.l	joycur1,d0
		beq.s	.no_control
		st	pause_control
		rts
.no_control:	move.l	joycur1,d0
		cmp.b	#1,pause_button
		beq.s	.skip_a
		move.l	#1<<FIRE_A,d1
		and.l	d0,d1
		bne.s	.handle_volumes
		move.l	#1<<UP_B,d1
		and.l	d0,d1
		bne.s	.handle_volumes
.skip_a:	
		cmp.b	#2,pause_button
		beq.s	.skip_b
		move.l	#1<<FIRE_B,d1
		and.l	d0,d1
		bne.s	.handle_sfx
		and.l	#1<<DOWN_B,d0
		bne.s	.handle_sfx
.skip_b:	rts
.handle_volumes:
		jsr	MUS_RESUME
		moveq	#$30,d0
		jsr	MUS_HALT
		move.b	#1,pause_button
		rts
.handle_sfx:
		jsr	MUS_RESUME
		moveq	#$0f,d0
		jsr	MUS_HALT
		move.b	#2,pause_button
		rts


handle_pause:	
		move.l	joyedge1,d0
		or.l	joyedge2,d0
		btst	#PAUSE,d0		;check for pause
		beq	.nopause
		st	paused
		sf	clock_on
		clr.l	joyedge1
		clr.l	joyedge2
		moveq	#$3f,d0
		jsr	MUS_HALT
		jsr	MUS_DISABLE_FX
		jsr	MUS_ENABLE_FX
		jsr	create_paused_sprites
		jsr	NEW_OL
.paused:	jsr	wait_vbl
		jsr	read_joypad
		jsr	handle_paused_sprites
		move.l	joyedge1,d0
		or.l	joyedge2,d0
		btst	#PAUSE,d0
		beq.s	.paused
		clr.l	joyedge1
		clr.l	joyedge2
		st	clock_on
		jsr	MUS_RESUME
		jsr	MUS_DISABLE_FX
		jsr	MUS_ENABLE_FX
		jsr	create_eeprom_buffer_pause
		bra.s	.cont
.nopause:	jsr	NEW_OL
.cont:		sf	paused
		rts

		data

pause_control_sprites:
		dc.w	4
		dc.w	(320-98)/2,0+PSY,11		;control
		dc.w	(320-102)/2,20+PSY,13		;fire
		dc.w	(320-102)/2,40+PSY,12		;select
		dc.w	(320-102)/2,60+PSY,14		;special
		
		dc.w	3
		dc.w	((320-102)/2)+88,20+PSY		
		dc.w	((320-102)/2)+88,40+PSY		
		dc.w	((320-102)/2)+88,60+PSY		










		bss

		even
pause_seen:		ds.b	1
pause_button:		ds.b	1
pause_control:		ds.b	1
		even
pause_mid_point:	ds.w	1

addr_for_stop:		ds.l	1

addr_of_music_slider:	ds.l	1
addr_of_music_icon:	ds.l	1

addr_of_sfx_maker_left:ds.l	1
addr_of_sfx_maker_right:ds.l	1
addr_of_sfx_slider:	ds.l	1

