SCORE_MULTIPLIER	equ	5
FRAMES_TO_WAIT		equ	100
macro	COUNT_IT
	moveq	#$0000000f,d1
	moveq	#$00000001,d7
	rept	8
	ror.l	#4,d1
	ror.l	#4,d7
	move.l	d0,d2
	and.l	d1,d2
	bne.s	.add_d7_to_score
	endr
	bra.s	.done
endm


macro	PCENT_LEFT	no,max,where
	move.w	\no,d1
	move.w	\max,d2
	neg.w	d1
	add.w	d2,d1
	lea	\where,a0
	bsr	padded_percent
endm

macro	PCENT_DONE	no,max,where
	move.w	\no,d1
	move.w	\max,d2
	lea	\where,a0
	bsr	padded_percent
endm


	.68000
	.text


	
add_fire_wait:
	tst.b	scoring_exit
	bne.s	.quit
.loop:	jsr	read_joypad
	jsr	wait_vbl
	jsr	fire_pressed	
	bne.s	.loop
.quit:	rts




	if 1



scoring_screen:


	move.w	#FRAMES_TO_WAIT,time_left

	clr.w	view_window_height

	lea	player1weapons,a6	;point to which player gets the points

	jsr	cls
	jsr	wait_vbl

	move.w	#SCORING_LEVEL,d0
	jsr	load_level_graphics

	lea	player1weapons,a6	;point to which player gets the points
	move.l	PLAYER_SCORE(a6),this_score

	move.w	maxdatapods,d0
	sub.w	datapods,d0
	move.w	d0,pods
	
	move.w	maxdatabases,d0
	sub.w	databases,d0
	move.w	d0,bases


	move.w	baddies,d2
	move.w	baddieskilled,d1

	tst.w	d2
	bne.s	.no_div_by_0
	moveq	#0,d0
	bra.s	.no_div
.no_div_by_0:
	moveq	#100,d0
	mulu	d1,d0
	divu	d2,d0
.no_div:	
	move.w	d0,killed	


	lea	CLUT,a0
	lea	options_palette+2,a1
	moveq	#128-1,d2
.loop1:move.l	(a1)+,(a0)+
	dbf	d2,.loop1

	jsr	initscorebackdrop

	
	clr.l	bonus_score


	bsr	calculate_score_stuff

	sf	scoring_exit
	sf	scoring_done
.loop:	
	jsr	read_joypad
	bsr	shop_scoring_data
	bsr	exit_quick
	bsr	move_numbers
	tst.b	scoring_done
	beq.s	.loop

	bsr	add_fire_wait
	
	jsr	donescorebackdrop
	rts



exit_quick:
	jsr	fire_pressed
	beq.s	.no_fire
	st	scoring_exit
.no_fire:
	tst.l	bonus_score
	bne.s	.counting_down
	subq.w	#1,time_left
	bne.s	.counting_down
	st	scoring_done
.counting_down:
	rts


calculate_score_stuff:

;pods
	move.w	#4,d0
	mulu	HOW_HARD,d0
	mulu	pods,d0
	bsr	long_to_bcd
	move.l	(a0),d0
	bsr	add_d0_to_bonus
	

;database
	move.w	#7,d0
	mulu	HOW_HARD,d0
	mulu	bases,d0
	bsr	long_to_bcd
	move.l	(a0),d0
	bsr	add_d0_to_bonus

;kills
	moveq	#0,d0
	move.w	killed,d0
	
	move.w	HOW_HARD,d1
	mulu	#2*5,d1
	pea	(a0)
	lea	score_hardness_table,a0
	movem.w	(a0,d1.w),d1-d5		; low mark . high mark . low mult
	cmp.w	d1,d0			; med mult . high mult
	bgt.s	.not_low
	move.w	d3,d1
	bra.s	.exit
.not_low:
	cmp.w	d2,d0
	bgt.s	.high
	move.w	d4,d1
	bra.s	.exit
.high:
	move.w	d5,d1
.exit:	move.l	(sp)+,a0
	mulu	d1,d0
	mulu	#SCORE_MULTIPLIER,d0
	bsr	long_to_bcd
	move.l	(a0),d0
	bsr	add_d0_to_bonus
	rts


long_to_bcd:
	lea	eight,a0
	move.l	d0,(a0)+
	divu	#10000,d0	; divide the words
	move.l	d0,-(sp)
	bsr.s	.top_word
	move.l	(sp)+,d0
	swap	d0
.top_word:
	clr.w	d0
	swap	d0
	divu	#100,d0
	move.w	d0,-(sp)
	swap	d0
	bsr.s	.byte
	move.w	(sp)+,d0
.byte:	swap	d0
	clr.w	d0
	swap	d0
	divu	#10,d0
	lsl.b	#4,d0
	move.w	d0,-(sp)
	swap	d0
	or.w	(sp)+,d0
	move.b	d0,-(a0)
	rts


add_d0_to_bonus:
	movem.l	a0/a1,-(sp)
	lea	4+bonus_score,a0
	move.l	sp,a1
	move.l	d0,-(sp)

	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	addq	#4,sp
	movem.l	(sp)+,a0/a1
	rts




move_numbers:
	move.l	bonus_score,d0
	beq	.done
.not_finished:
	COUNT_IT
	beq.s	.done
.add_d7_to_score:
	movem.l	a0/a1/a6,-(sp)
	
	lea	player1weapons,a6	;point to which player gets the points
	lea	PLAYER_SCORE+4(a6),a0	;update the score of the player
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	move.l	(a0),this_score

	lea	4+bonus_score,a0	;point to score
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	sbcd	-(a1),-(a0)		;subtract the 2 numbers together
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	addq.l	#8,sp			;realign the stack
	
	movem.l	(sp)+,a0/a1/a6
.done:	rts



shop_scoring_data:
	tst.b	scoring_exit
	beq.s	.show
	rts
.show:
	jsr	NEW_OL
	
	movem.l	d0-a6,-(sp)
	move.l	rasterb,rasterd
	jsr	showscorebackdrop
	jsr	ADD_VIEWSCREEN		;add polygon playfield
	movem.l	(sp)+,d0-a6
	jsr	switchabc		;switch screens

	
	lea	scoring_sprites,a6
	move.w	(a6)+,-(sp)
.loop:	movem.w	(a6)+,d0/d1/d4
	jsr	draw_shop_sprite
	subq.w	#1,(sp)
	bne.s	.loop
	addq	#2,sp
	
	move.w	(a6)+,-(sp)
.loop1:
	move.w	(a6)+,d0
	move.w	(a6)+,d1
	move.w	(a6)+,d7
	move.l	(a6)+,a0
	move.l	(a6)+,a1
	jsr	(a1)
	subq.w	#1,(sp)
	bne.s	.loop1
	addq	#2,sp
	rts



score_number:
	
	moveq	#0,d4
	move.w	(a0),d4

	lea	eight,a5

	divu	#100,d4
	add.b	#4,d4
	move.b	d4,(a5)
	clr.w	d4
	swap	d4
	divu	#10,d4
	add.b	#4,d4
	move.b	d4,1(a5)
	swap	d4
	add.b	#4,d4
	move.b	d4,2(a5)
	

	cmp.b	#4,(a5)
	bne.s	.nothing
	sf	(a5)
	cmp.b	#4,1(a5)
	bne.s	.nothing
	sf	1(a5)
.nothing:	
	
	move.w	d7,-(sp)
	mulu	#11,d7
	sub.w	d7,d0
	
.next_digit:	
	moveq	#0,d4
	move.b	(a5)+,d4
	bne.s	.not_skip_digit
	tst.w	(sp)
	bne.s	.skip_digit
.not_skip_digit:
	move.w	d0,-(sp)
	move.w	d1,-(sp)
	jsr	draw_shop_sprite
	move.w	(sp)+,d1
	move.w	(sp)+,d0
.skip_digit:
	add.w	#11,d0
	subq.w	#1,(sp)
	bne.s	.next_digit
	addq	#2,sp
	rts



score_new:
	lea	eight,a5
	lea	passed_it,a4
	move.l	(a0),(a4)

	moveq	#4-1,d6
.lp2:	moveq	#$f,d5
	move.b	(a4)+,d4		;BCD 2 digits
	and.b	d4,d5
	lsr.b	#4,d4
	addq	#4,d4
	addq	#4,d5
	move.b	d4,(a5)+
	move.b	d5,(a5)+
	dbf	d6,.lp2			;do all digits in score

	lea	eight,a5
	cmp.b	#4,(a5)
	bne.s	.nothing
	moveq	#7-1,d6
.lp:
	sf	(a5)+
	cmp.b	#4,(a5)
	bne.s	.nothing
	dbf	d6,.lp   
.nothing:	
	

	lea	eight,a5
	move.w	d7,-(sp)
	mulu	#11,d7
	sub.w	d7,d0
	
.next_digit:	
	moveq	#0,d4
	move.b	(a5)+,d4
	bne.s	.not_skip_digit
	tst.w	(sp)
	bne.s	.skip_digit
.not_skip_digit:
	move.w	d0,-(sp)
	move.w	d1,-(sp)
	jsr	draw_shop_sprite
	move.w	(sp)+,d1
	move.w	(sp)+,d0
.skip_digit:
	add.w	#11,d0
	subq.w	#1,(sp)
	bne.s	.next_digit
	addq	#2,sp
	rts




	
	.data

score_hardness_table:
.easy:		dc.w	30,60,04,06,08
.medium:	dc.w	40,70,05,07,09
.hard:		dc.w	50,80,06,08,10
tunnel_score_multiplier:
.easy:		dc.w	6
.medium:	dc.w	3
.hard:		dc.w	1
tunnel_hardness:
.easy:		dc.w	10
.medium:	dc.w	7
.hard:		dc.w	5

	
	
	
scoring_sprites:
	dc.w	6
	dc.w	020,020,0
	dc.w	020,050,1
	dc.w	020,080,2
	dc.w	290,080,15
	dc.w	020,170,14
	dc.w	020,200,3

	dc.w	5

	dc.w	290,020,3
	dc.l	pods,score_number

	dc.w	290,50,3
	dc.l	bases,score_number

	dc.w	290,80,3
	dc.l	killed,score_number

	
	dc.w	290,170,8
	dc.l	bonus_score,score_new

	
	dc.w	290,200,8
	dc.l	this_score,score_new





	.bss

pods:		ds.l	1
bases:		ds.l	1
killed:	ds.l	1
this_score:	ds.l	1
bonus_score:	ds.l	1

passed_it:	ds.b	8
eight:		ds.b	8
scoring_done:	ds.b	1

	even



		else



POINTS_PER_SECOND	equ	7
POINTS_PER_POD		equ	5

;returns d1 - 000->100

;****************************************************************************
;this screen is called after a tunnel sequence.
;it calculates the bonus's for each round.
;the bonus is dependant upon the difficultly and how well the player has done..
;****************************************************************************





scoring_screen:

	clr.w	view_window_height

	lea	player1weapons,a6	;point to which player gets the points
	
	moveq	#0,d0
	moveq	#MAX_ROOMS_AVAILABLE-1,d1
.counter:
	tst.b	PLAYER_ROOMS(a6,d1.w)
	beq.s	.no_add
	addq	#1,d0
.no_add:
	dbf	d1,.counter
	move.w	d0,rooms_visited

	jsr	cls
	jsr	wait_vbl

	pea	(a6)

	move.w	#HISCORE_LEVEL,d0
	jsr	load_level_graphics

	move.l	(sp)+,a6

	lea	CLUT,a0
	lea	options_palette+2,a1
	moveq	#128-1,d2
.loop1:move.l	(a1)+,(a0)+
	dbf	d2,.loop1

	movem.l	d0-a6,-(sp)
	jsr	initscorebackdrop
	movem.l	(sp)+,d0-a6

	sf	scoring_exit

	PCENT_DONE	rooms_visited,rooms_in_level,percentage_rooms_visited
	bsr	add_rooms_to_score		;scores from the level

	PCENT_DONE	baddies_killed,baddies_in_level,percentage_baddies_killed
	bsr	add_baddies_to_score

	bsr	add_time_tunnel			;scores and energy from tunnel
	bsr	add_pods_tunnel
	bsr	add_energy_tunnel

	bsr	add_fire_wait
	
	jsr	donescorebackdrop
	rts


add_energy_tunnel:
	moveq	#0,d0
	move.w	energy_left_in_tunnel,d0
	lea	tunnel_energy,a0
	divu	#100,d0
	add.b	#"0",d0
	move.b	d0,(a0)
	clr.w	d0
	swap	d0
	divu	#10,d0
	add.b	#"0",d0
	move.b	d0,1(a0)
	swap	d0
	add.b	#"0",d0
	move.b	d0,2(a0)
	move.w	energy_left_in_tunnel,d7
	move.w	HOW_HARD,d1
	add.w	d1,d1
	lea	tunnel_score_multiplier,a0
	move.w	(a0,d1.w),d0
	mulu	d7,d0
	move.l	d0,bonus_score
	lea	add_energy_left_tunnel,a0
	bra	count_bonus


add_time_tunnel:		
	lea	tunnel_secs,a0
	moveq	#0,d0
	move.w	seconds_in_tunnel,d0
	sub.w	minutes,d0
	move.w	d0,d7		;save the seconds
	divu	#10,d0
	add.l	#"0000",d0
	move.b	d0,(a0)
	swap	d0
	move.b	d0,1(a0)
	lea	tunnel_hardness,a0
	move.w	HOW_HARD,d0
	add.w	d0,d0
	mulu	(a0,d0.w),d7
	mulu	#POINTS_PER_SECOND,d7
	lea	add_tunnel_seconds_text,a0
	move.l	d7,bonus_score
	bra	count_score

add_pods_tunnel:
	lea	tunnel_pods,a0
	moveq	#0,d0
	move.w	pods_got_in_tunnel,d0
	move.w	d0,d7		;save the seconds
	divu	#10,d0
	add.l	#"0000",d0
	move.b	d0,(a0)
	swap	d0
	move.b	d0,1(a0)
	lea	tunnel_hardness,a0
	move.w	HOW_HARD,d0
	add.w	d0,d0
	mulu	(a0,d0.w),d7
	mulu	#POINTS_PER_POD,d7
	move.l	d7,bonus_score			;calc the bonus score
	lea	add_pods_collected_text,a0
	bra	count_bonus


	
add_rooms_to_score:
	lea	add_room_text,a0
	bra.s	process_score
add_baddies_to_score:
	lea	add_baddies_text,a0
process_score:
	bsr	get_score_to_add
	move.l	d0,bonus_score
count_score:
count_bonus:
	sf	process_exit
	move.l	a0,add_print_text
	move.w	#FRAMES_TO_WAIT,time_left
	lea	bonus_score+4,a0
	bsr	long_to_bcd
.loop:	
	jsr	read_joypad
	bsr	print_scoring_screen
	bsr.s	handle_processing
	bsr	update_bonus_score_stuff
	tst.b	process_exit
	beq.s	.loop
	rts


handle_processing:
	jsr	fire_pressed
	beq.s	.no_fire
	st	scoring_exit
.no_fire:
	tst.l	bonus_score
	bne.s	.counting_down
	subq.w	#1,time_left
	bne.s	.counting_down
	st	process_exit
.counting_down:
	rts

update_bonus_score_stuff:
	move.l	bonus_score,d0
	beq	.done
.not_finished:
	COUNT_IT
	beq.s	.done
.add_d7_to_score:
	movem.l	a0/a1,-(sp)
	
	lea	PLAYER_SCORE+4(a6),a0	;update the score of the player
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	lea	4+bonus_score,a0	;point to score
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	sbcd	-(a1),-(a0)		;subtract the 2 numbers together
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	addq.l	#8,sp			;realign the stack
	
	movem.l	(sp)+,a0/a1
.done:	rts

	move.l	bonus_score,d0
	beq	.done
.not_finished:
	COUNT_IT
	beq.s	.done
.add_d7_to_score:
	movem.l	a0/a1,-(sp)
	
	lea	PLAYER_SCORE+4(a6),a0	;update the score of the player
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	lea	4+bonus_score,a0	;point to score
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	sbcd	-(a1),-(a0)		;subtract the 2 numbers together
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	addq.l	#8,sp			;realign the stack
	
	movem.l	(sp)+,a0/a1
.done:	rts

	move.l	bonus_score,d0
	beq	.done
.not_finished:
	COUNT_IT
	beq.s	.done
.add_d7_to_score:
	movem.l	a0/a1,-(sp)
	
	lea	PLAYER_SCORE+4(a6),a0	;update the score of the player
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	lea	4+bonus_score,a0	;point to score
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	sbcd	-(a1),-(a0)		;subtract the 2 numbers together
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	addq.l	#8,sp			;realign the stack
	
	movem.l	(sp)+,a0/a1
.done:	rts

	move.l	bonus_score,d0
	beq	.done
.not_finished:
	COUNT_IT
	beq.s	.done
.add_d7_to_score:
	movem.l	a0/a1,-(sp)
	
	lea	PLAYER_SCORE+4(a6),a0	;update the score of the player
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	lea	4+bonus_score,a0	;point to score
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	sbcd	-(a1),-(a0)		;subtract the 2 numbers together
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	addq.l	#8,sp			;realign the stack
	
	movem.l	(sp)+,a0/a1
.done:	rts

	move.l	bonus_score,d0
	beq	.done
.not_finished:
	COUNT_IT
	beq.s	.done
.add_d7_to_score:
	movem.l	a0/a1,-(sp)
	
	lea	PLAYER_SCORE+4(a6),a0	;update the score of the player
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	abcd	-(a1),-(a0)		;add the 2 numbers together
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	abcd	-(a1),-(a0)
	
	lea	4+bonus_score,a0	;point to score
	move.l	sp,a1			;save pointer to value to be added
	move.l	d7,-(sp)		;save that value
	and	#~%10000,ccr		;clear the x flag
	sbcd	-(a1),-(a0)		;subtract the 2 numbers together
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	sbcd	-(a1),-(a0)
	addq.l	#8,sp			;realign the stack
	
	movem.l	(sp)+,a0/a1
.done:	rts

long_to_bcd:
	move.l	-4(a0),d0
	divu	#10000,d0	; divide the words
	move.l	d0,-(sp)
	bsr.s	.top_word
	move.l	(sp)+,d0
	swap	d0
.top_word:
	clr.w	d0
	swap	d0
	divu	#100,d0
	move.w	d0,-(sp)
	swap	d0
	bsr.s	.byte
	move.w	(sp)+,d0
.byte:	swap	d0
	clr.w	d0
	swap	d0
	divu	#10,d0
	lsl.b	#4,d0
	move.w	d0,-(sp)
	swap	d0
	or.w	(sp)+,d0
	move.b	d0,-(a0)
	rts

get_score_to_add:
	moveq	#0,d0
	move.w	d1,d0
	move.w	HOW_HARD,d1
	mulu	#2*5,d1
	pea	(a0)
	lea	score_hardness_table,a0
	movem.w	(a0,d1.w),d1-d5		; low mark . high mark . low mult
	cmp.w	d1,d0			; med mult . high mult
	bgt.s	.not_low
	move.w	d3,d1
	bra.s	.exit
.not_low:
	cmp.w	d2,d0
	bgt.s	.high
	move.w	d4,d1
	bra.s	.exit
.high:
	move.w	d5,d1
.exit:	move.l	(sp)+,a0
	mulu	d1,d0
	mulu	#SCORE_MULTIPLIER,d0
	rts


padded_percent:
	tst.w	d2
	bne.s	.no_div_by_0
	moveq	#0,d0
	bra.s	.no_div
.no_div_by_0:
	moveq	#100,d0
	mulu	d1,d0
	divu	d2,d0
	ext.l	d0
.no_div:	
	move.w	d0,d1
	divu	#100,d0
	add.b	#"0",d0
	move.b	d0,(a0)
	clr.w	d0
	swap	d0
	divu	#10,d0
	add.b	#"0",d0
	move.b	d0,1(a0)
	swap	d0
	add.b	#"0",d0
	move.b	d0,2(a0)
.exit:	rts


add_print_bonus:
	lea	bonus_text+4,a0
	move.l	bonus_score,d0
	rept	4
	moveq	#$f,d1
	and.l	d0,d1
	add.b	#"0",d1
	ror.l	#4,d0
	move.b	d1,-(a0)
	endr
	rts

print_scoring_screen:
	tst.b	scoring_exit
	beq.s	.display
	rts
.display:
	movem.l	d0-a6,-(sp)
	jsr	wait_vbl
	jsr	NEW_OL

	bsr	add_print_bonus
	bsr	add_score_text

	move.b	IN_GAME,atemp
	st	IN_GAME
	
	movem.l	d0-a6,-(sp)
	move.l	rasterb,rasterd
	jsr	showscorebackdrop
	jsr	ADD_VIEWSCREEN		;add polygon playfield
	movem.l	(sp)+,d0-a6

	move.b	IN_GAME,atemp



	bsr	get_sprite_number_for_page
	move.w	d0,-(sp)
	move.w	d0,d4
	moveq	#0,d0
	moveq	#30,d1
	tst.b	PAL_TV
	beq.s	.ntsc
	add.w	#20,d1
.ntsc:	lea	level_sprites,a0
	jsr	print_a_sprite_normal_no_clip
	
	move.w	(Sp)+,d0
	lea	level_sprites,a0
	jsr	get_addr_sprite
	
	bsr	cls_this_screen
	
	move.l	#PITCH1|PIXEL4|WID320|XADDPIX,d1
	
	lea	add_bonus_text,a6		;text to print
	movem.l	d0/d1,-(sp)
	jsr	print_text_sprites

	movem.l	(sp),d0/d1
	move.l	add_print_text,a6
	jsr	print_text_sprites

	movem.l	(sp)+,d0/d1
	lea	add_score_energy_text,a6
	jsr	print_text_sprites

	jsr	switchabc		;switch screens
	movem.l	(sp)+,d0-a6
	
	rts
	
get_sprite_number_for_page:
	moveq	#39,d0
	cmp.l	#rasteradata,rasterb
	beq.s	.exit
      	addq	#1,d0
	cmp.l	#rasterbdata,rasterb
	beq.s	.exit
	addq	#1,d0
.exit:	rts


cls_this_screen:		;entre with d0 pointing to the screen
	move.l	d0,-(sp)
	jsr	waitgpu
	jsr	waitblitter
	move.l	(sp)+,d0
	moveq.l	#0,d1
	move.l	d0,A1_BASE
	move.l	d1,A1_PIXEL
	move.l	#$00010000|((-160)&$ffff),A1_STEP
	move.l	#($00010000*200)+160,B_COUNT
	move.l	d1,B_PATD
	move.l	d1,B_PATD+4
	move.l	#PIXEL8|PITCH1|WID160|XADDPHR,A1_FLAGS
	move.l	#UPDA1|PATDSEL,B_CMD
	rts

add_score_text:
	move.l	PLAYER_SCORE(a6),d0
	lea	show_score+8,a0
	rept	8
	moveq	#$f,d1
	and.l	d0,d1
	add.b	#"0",d1
	move.b	d1,-(a0)
	ror.l	#4,d0
	endr
	rts



;**********************************************************************

	.data


;  Tables for the different difficulty settings.


;**********************************************************************

add_bonus_text:
		dc.b	PATY,0,120
		dc.b	PCEN,"YOU ARE AWARDED ",PCR,PCEN
bonus_text:	dc.b	"XXXX POINTS",PCR,PEND


add_score_energy_text:
		dc.b	PATY,0,170
		dc.b	PCEN,"SCORE . "
show_score:	dc.b	"XXXXXXXX",PCR,PEND

add_room_text:
		dc.b	PATY,0,0,PCEN
percentage_rooms_visited:
		dc.b	"xxx PERCENT OF THE",PCR
		dc.b	PCEN,"ROOMS WERE VISITED",PCR,PEND

add_baddies_text:
		dc.b	PATY,0,0,PCEN
percentage_baddies_killed:
		dc.b	"xxx PERCENT OF THE",PCR
		dc.b	PCEN,"ENEMIES WERE DESTROYED",PCR,PEND

		even


add_tunnel_seconds_text:
		dc.b	PATY,0,0
		dc.b	PCEN,"YOU SURVIVED "
tunnel_secs:	dc.b	"XX",PCR
		dc.b	PCEN,"SECONDS IN THE",PCR
		dc.b	PCEN,"DATALINK",PCR,PEND

add_pods_collected_text:
		dc.b	PATY,0,0,PCEN
		dc.b	"YOU COLLECTED "
tunnel_pods:	dc.b	"XX PODS",PCR
		dc.b	PCEN,"IN THE DATALINK",PCR,PEND


add_energy_left_tunnel:
		dc.b	PATY,0,0
		dc.b	PCEN,"YOU HAVE "
tunnel_energy:	dc.b	"XXX UNITS OF",PCR
		dc.b	PCEN,"ENERGY LEFT FROM",PCR
		dc.b	PCEN,"THE DATALINK",PCR,PEND

					
		even

;**********************************************************************

	;stuff from the level


rooms_visited:		dc.w	1
rooms_in_level		equ	rooms
	;stuff from the data tunnel

seconds_in_tunnel	equ	max_time_in_tunnel
pods_got_in_tunnel	equ	PODS

	.bss

bonus_score:		ds.l	1
add_print_text:	ds.l	1
atemp:			ds.b	1
process_exit:		ds.b	1
	even


	endif


	.bss	
time_left:		ds.w	1
energy_left_in_tunnel:	ds.w	1
scoring_exit:		ds.b	1

	even

baddies_killed		equ	baddieskilled
baddies_in_level	equ	baddies
pods_left		equ	datapods
pods_in_level		equ	maxdatapods
databases_left		equ	databases
databases_in_level	equ	maxdatabases
