SHOP_TEXT_SPRITE	equ	8

SPRITE_LASER_1		equ	0
SPRITE_LASER_2		equ	1
SPRITE_PLASMA_1	equ	2
SPRITE_PLASMA_2	equ	3
SPRITE_PLASMA_3	equ	4
SPRITE_LAUNCHER_1	equ	5
SPRITE_LAUNCHER_2	equ	6
SPRITE_LAUNCHER_3	equ	7

SPRITE_REAR_GUN_1	equ	11
SPRITE_REAR_GUN_2	equ	12
SPRITE_REAR_GUN_3	equ	13
SPRITE_MINE_LAYER_1	equ	14
SPRITE_MINE_LAYER_2	equ	15
SPRITE_MINE_LAYER_3	equ	16
SPRITE_SHIELD_1	equ	17
SPRITE_SHIELD_2	equ	18
SPRITE_SHIELD_3	equ	19
SPRITE_AUTOFIRE	equ	20
SPRITE_RADAR_1		equ	21
SPRITE_RADAR_2		equ	23
SPRITE_DRONE_1		equ	24
SPRITE_DRONE_2		equ	25

PULSE_START		equ	4
MAX_HELD		equ	30
SHOP_GOT		equ	2
COL_SHOP_GOT		equ	$00010001*$fff0

COLOUR_YELLOW		equ	0
COLOUR_GREEN		equ	1
COLOUR_RED		equ	$7fff7fff

LIGHT			equ	%000
MEDIUM			equ	%001
HEAVY			equ	%010

;			    	 fedcba9876543210
POS_1			equ	%0000000000000001
POS_2			equ	%0000000000000010
POS_3			equ	%0000000000000100
POS_4			equ	%0000000000001000
POS_5			equ	%0000000000010000
POS_6			equ	%0000000000100000
POS_B			equ	%0000000001000000
POS_C			equ	%0000000010000000
POS_D			equ	%0000000100000000
POS_E			equ	%0000001000000000
POS_F			equ	%0000010000000000
POS_AMMO		equ	%0000100000000000
POS_AMMO_NEEDED	equ	%0001000000000000


*********************************** Macros ***********************************

macro	shop_bcd	x_pos,y_pos,addr,colour,number
	dc.w		\x_pos,\y_pos
	dc.l		\addr,\colour
	dc.w		\number
endm


macro	SHOPPER	cost,sprite_number,weight,position,power,sprite_anim
	dc.l	\cost
	dc.w	\sprite_number
	dc.w	\weight
	dc.w	\position
	dc.w	\power
	dc.l	\sprite_anim
endm


	RSRESET
	RSL	SHOPPER_COST,1
	RSW	SHOPPER_SPRITE,1
	RSW	SHOPPER_WEIGHT,1
	RSW	SHOPPER_POSITION,1
	RSW	SHOPPER_POWER,1
	RSL	SHOPPER_ANIM,1
	RSW	shopping_item,0



macro	TENTRY	a
	dc.w	\a
	dc.b	SHOP_GOT,-1
	dc.l	-1
	dc.w	-1
endm
	

	RSRESET
	RSB	TABLE_INDEX,1
	RSB	TABLE_NUMBER,1
	RSW	TABLE_SPRITE,1
	RSW	TABLE_MOUNTING,1
	RSL	TABLE_ADDR,1
	RSB	TABLE_ENTRY,0

shopping_item0	equ	(shopping_item*0)
shopping_item1	equ	(shopping_item*1)
shopping_item2	equ	(shopping_item*2)
shopping_item3	equ	(shopping_item*3)
shopping_item4	equ	(shopping_item*4)
shopping_item5	equ	(shopping_item*5)

******************************** Code Section ********************************


		text
		.68000


shop:		jsr	load_shop_music
		move.b	#32,zoom_size

		clr.l	clock
		clr.w	button_selection
		clr.w	pulse_timer
		clr.w	mounting_number
		clr.w	weapon_number
		clr.w	shop_menu_bar
		sf	exit_shop
		sf	IN_GAME

		moveq	#0,d0
		move.l	which_players_weapons,a6
		move.b	PLAYER_SHIP(a6),d0
		lea	MOUNT_NUMBERS,a6
		add.w	d0,d0
		move.w	(a6,d0.w),number_of_stats


		bsr	get_addr_of_text
		bsr	create_new_ship
		move.l	#player1anim,mergedanim	
		jsr	initshop
		bsr	generate_new_weapons
		
		move.w	#$00e0,CLUT+(255*2)
		

		clr.w	weapon_number
.loop:		bsr	get_weapon_info
		bsr	shop_wait_while
		addq.w	#1,weapon_number
		move.w	allowed_weapons,d0
		cmp.w	weapon_number,d0

		bne.s	.no_wrap
		clr.w	weapon_number
.no_wrap:		
		tst.b	exit_shop
		beq.s	.loop

.exit:		
		jsr	doneshop
		move.l	which_players_weapons,a6
		sf	WEAPON_ACTIVE(a6)
		rts


shop_wait_while:
		move.w	#60,-(sp)
		
.loop:		jsr	read_joypad
		jsr	draw_shop_screen
		bsr	shop_action_fire
		tst.b	exit_shop
		bne.s	.exit
      		subq.w	#1,(sp)
		bne.s	.loop
.exit:		addq.l	#2,sp
		rts


;***************************************************************************
shop_action_fire:
		bsr	fire_pressed
		beq.s	.exit
		st	exit_shop
		moveq	#SFX_DIGIT_BLEEP,d0
		jsr	sfxplay
.exit:		rts

get_weapon_info:
		lea	weapon_got_table,a6  ;set the addr for the spinning logo
		move.w	weapon_number,d4
		mulu	#TABLE_ENTRY,d4
		add.l	d4,a6
		move.w	TABLE_MOUNTING(a6),d0
		move.l	TABLE_ADDR(a6),a6
		move.l	(a6),object_energy
		move.w	6(a6),object_weight
		move.w	8(a6),object_position
		move.w	10(a6),object_power	;ignore the BIG sprite number
		move.l	addonobject,a0
		move.l	12(a6),isanimbase(a0)
		
		moveq	#0,d1
		move.l	which_players_weapons,a0
		move.b	PLAYER_SHIP(a0),d1
		lsl.w	#2,d1
		lea	position_table,a0
		move.l	(a0,d1.w),a0
		mulu	#6,d0
		movem.w	(a0,d0.w),d0/d1/d2
		movem.w	d0-d2,mountx
		rts




;***************************************************************************
generate_new_weapons:
		move.l	which_players_weapons,a6
		clr.w	allowed_weapons
		lea	weapon_got_table,a5		;clear table out
		move.w	#(MAX_HELD*TABLE_ENTRY)-1,d0
.lp:		sf	(a5,d0.w)
		dbf	d0,.lp


gen_l_laser:	
		move.w	#0,mounting_number

got_l_laser_i:	move.w	#SPRITE_LASER_1,d0
		moveq	#WEAPON_LASER_L,d1
		moveq	#1,d2
		lea	laser_list+shopping_item0,a0
		bsr	got_it

got_l_laser_ii:
		move.w	#SPRITE_LASER_2,d0
		moveq	#WEAPON_LASER_L,d1
		moveq	#2,d2
		lea	laser_list+shopping_item1,a0
		bsr	got_it

		
gen_r_laser:	
		move.w	#1,mounting_number
		
got_r_laser_i:	move.w	#SPRITE_LASER_1,d0
		moveq	#WEAPON_LASER_R,d1
		moveq	#1,d2
		lea	laser_list+shopping_item0,a0
		bsr	got_it

got_r_laser_ii:
		move.w	#SPRITE_LASER_2,d0
		moveq	#WEAPON_LASER_R,d1
		moveq	#2,d2
		lea	laser_list+shopping_item1,a0
		bsr	got_it


gen_plasma:	
		move.w	#2,mounting_number

got_plasma_i:
		move.w	#SPRITE_PLASMA_1,d0
		moveq	#WEAPON_PLASMA,d1
		moveq	#1,d2
		lea	plasma_list+shopping_item0,a0
		bsr	got_it

got_plasma_ii:
		move.w	#SPRITE_PLASMA_2,d0
		moveq	#WEAPON_PLASMA,d1
		moveq	#2,d2
		lea	plasma_list+shopping_item1,a0
		bsr	got_it

got_plasma_iii:
		move.w	#SPRITE_PLASMA_3,d0
		moveq	#WEAPON_PLASMA,d1
		moveq	#3,d2
		lea	plasma_list+shopping_item2,a0
		bsr	got_it


gen_l_miss:	
		move.w	#3,mounting_number

got_l_launcher_i:
		move.w	#SPRITE_LAUNCHER_1,d0
		moveq	#WEAPON_LAUNCHER_L,d1
		moveq	#1,d2
		lea	launcher_list+shopping_item0,a0
		bsr	got_it


got_l_launcher_ii:
		move.w	#SPRITE_LAUNCHER_2,d0
		moveq	#WEAPON_LAUNCHER_L,d1
		moveq	#2,d2
		lea	launcher_list+shopping_item1,a0
		bsr	got_it

got_l_launcher_iii:
		move.w	#SPRITE_LAUNCHER_3,d0
		moveq	#WEAPON_LAUNCHER_L,d1
		moveq	#3,d2
		lea	launcher_list+shopping_item2,a0
		bsr	got_it


gen_r_miss:	
		move.w	#4,mounting_number


got_r_launcher_i:
		move.w	#SPRITE_LAUNCHER_1,d0
		moveq	#WEAPON_LAUNCHER_R,d1
		moveq	#1,d2
		lea	launcher_list+shopping_item0,a0
		bsr	got_it


got_r_launcher_ii:
		move.w	#SPRITE_LAUNCHER_2,d0
		moveq	#WEAPON_LAUNCHER_R,d1
		moveq	#2,d2
		lea	launcher_list+shopping_item1,a0
		bsr	got_it

got_r_launcher_iii:
		move.w	#SPRITE_LAUNCHER_3,d0
		moveq	#WEAPON_LAUNCHER_R,d1
		moveq	#3,d2
		lea	launcher_list+shopping_item2,a0
		bsr	got_it


gen_back:	
		move.w	#5,mounting_number

got_shield_i:
		move.w	#SPRITE_SHIELD_1,d0
		moveq	#WEAPON_SHIELD,d1
		moveq	#1,d2
		lea	shield_list+shopping_item0,a0
		bsr	got_it

got_shield_ii:
		move.w	#SPRITE_SHIELD_2,d0
		moveq	#WEAPON_SHIELD,d1
		moveq	#2,d2
		lea	shield_list+shopping_item1,a0
		bsr	got_it

got_shield_iii:
		move.w	#SPRITE_SHIELD_3,d0
		moveq	#WEAPON_SHIELD,d1
		moveq	#3,d2
		lea	shield_list+shopping_item2,a0
		bsr	got_it

got_rear_gun_i:
		move.w	#SPRITE_REAR_GUN_1,d0
		moveq	#WEAPON_BACK,d1
		moveq	#1,d2
		lea	turret_list+shopping_item0,a0
		bsr	got_it

got_rear_gun_ii:
		move.w	#SPRITE_REAR_GUN_2,d0
		moveq	#WEAPON_BACK,d1
		moveq	#2,d2
		lea	turret_list+shopping_item1,a0
		bsr	got_it

got_rear_gun_iii:
		move.w	#SPRITE_REAR_GUN_3,d0
		moveq	#WEAPON_BACK,d1
		moveq	#3,d2
		lea	turret_list+shopping_item2,a0
		bsr	got_it

got_mine_layer_i:
		move.w	#SPRITE_MINE_LAYER_1,d0
		moveq	#WEAPON_BACK,d1
		moveq	#4,d2
		lea	turret_list+shopping_item3,a0
		bsr	got_it



got_mine_layer_ii:
		move.w	#SPRITE_MINE_LAYER_2,d0
		moveq	#WEAPON_BACK,d1
		moveq	#5,d2
		lea	turret_list+shopping_item4,a0
		bsr	got_it


got_mine_layer_iii:
		move.w	#SPRITE_MINE_LAYER_3,d0
		moveq	#WEAPON_BACK,d1
		moveq	#6,d2
		lea	turret_list+shopping_item5,a0
		bsr	got_it

got_radar_i:
		move.w	#SPRITE_RADAR_1,d0
		moveq	#WEAPON_RADAR,d1
		moveq	#1,d2
		lea	radar_list+shopping_item0,a0
		bsr	got_it

got_radar_ii:
		move.w	#SPRITE_RADAR_2,d0
		moveq	#WEAPON_RADAR,d1
		moveq	#2,d2
		lea	radar_list+shopping_item1,a0
		bsr	got_it

got_drone_i:
		move.w	#SPRITE_DRONE_1,d0
		moveq	#WEAPON_DRONE,d1
		moveq	#1,d2
		lea	drone_list+shopping_item0,a0
		bsr	got_it

got_drone_ii:
		move.w	#SPRITE_DRONE_2,d0
		moveq	#WEAPON_DRONE,d1
		moveq	#2,d2
		lea	drone_list+shopping_item1,a0
		bsr	got_it

got_autofire:
		move.w	#SPRITE_AUTOFIRE,d0
		moveq	#WEAPON_AUTO,d1
		moveq	#1,d2
		lea	autoaim_list+shopping_item0,a0


got_it:	moveq	#0,d6		  	;if object is too heavy then
		move.b	PLAYER_SHIP(a6),d6	;then don not include it
		cmp.w	6(a0),d6
		blt.s	.no_way_heavy
		cmp.b	(a6,d1.w),d2
		bne.s	.not_got

		move.w	mounting_number,TABLE_MOUNTING(a5)
		move.w	d0,TABLE_SPRITE(a5)
		move.l	a0,TABLE_ADDR(a5)
		sf	TABLE_NUMBER(a5)
		move.b	#SHOP_GOT,TABLE_INDEX(a5)
		lea	TABLE_ENTRY(a5),a5
		addq.w	#1,allowed_weapons
.not_got:	
.no_way_heavy:	rts
		

;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************



;***************************************************************************


convert_mount:
		move.l	a6,-(sp)
		moveq	#0,d0
		move.l	which_players_weapons,a6
		move.b	PLAYER_SHIP(a6),d0
		lea	tank_mounting_tables,a6
		lsl.l	#2,d0
		move.l	(a6,d0.w),a6
		move.w	mounting_number,d0
		add.w	d0,d0
		move.w	(a6,d0.w),d0
		move.l	(sp)+,a6
		rts
;***************************************************************************
;***************************************************************************


draw_shop_screen:	
		jsr	NEW_OL
		jsr	switchab		;update the screens
		
		jsr	add_choose_backdrop
		
  		jsr	add_shop_boxes

		move.l	rasterb,rasterd
		jsr	showshop
		bsr	print_shop_text
		jsr	ADD_VIEWSCREEN		;add polygon playfield

		bsr	print_shop_instructions
		bsr	print_pulsing_cursor
		rts
	


;*****************************************************************************************************************************

YDIS		equ	10


SHOP_BORD	equ	5
SHOP_BORD1	equ	8

SHOP_BIG_X	equ	117	 
SHOP_BIG_Y	equ	(60+YDIS)

SHOP_ADDON_X	equ	20
SHOP_ADDON_Y	equ	(70+YDIS)



add_shop_boxes:
		moveq	#3,d4
		move.w	#SHOP_BIG_X-SHOP_BORD,d0
		move.w	#SHOP_BIG_Y-SHOP_BORD,d1
		bsr	draw_shop_sprite

		moveq	#10,d4
		move.w	#SHOP_ADDON_X-SHOP_BORD,d0
		move.w	#SHOP_ADDON_Y-SHOP_BORD1,d1
		bsr	draw_shop_sprite

		moveq	#1,d4			;now draw the title
		move.w	#(320-246)/2,d0
		move.w	#30-(36/2),d1
		bsr	draw_shop_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite

		moveq	#1,d4			;now draw the title
		move.w	#(320-246)/2,d0
		move.w	#200-(36/2),d1
		bsr	draw_shop_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite



		moveq	#2,d4
		move.w	#(320-210)/2,d0
		move.w	#30-(15/2),d1
		bra	draw_shop_sprite

print_shop_text:
		move.w	#SHOP_ADDON_X,shop_print_x
		move.w	#SHOP_ADDON_Y,shop_print_y
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20,shop_print_y
.ntsc:		lea	weapon_got_table,a0
		move.w	weapon_number,d0
		mulu	#TABLE_ENTRY,d0
		add.w	d0,a0
		moveq	#1,d0
		bsr.s	show_shop_text
		rts
					   
show_shop_text:
		move.l	a0,show_pointer
		move.w	d0,-(sp)		
.loop:		bsr	get_data
		bsr	print_data
		add.l	#TABLE_ENTRY,show_pointer
		addq.w	#7,shop_print_y
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		rts


get_data:	move.l	show_pointer,a0
		move.w	TABLE_SPRITE(a0),d0
		lea	shop_sprite_data,a6
		lsl.w	#3,d0
		add.w	d0,a6
		move.l	(a6)+,apos_yx
		move.l	(a6)+,awidth_yx

		move.l	#COL_SHOP_GOT,sprite_colour

		rts

DIGIT_X1	equ	76
DIGIT_X2	equ	DIGIT_X1+5

print_data:	
		jsr	waitgpu
		jsr	waitblitter
		move.l	rasterb,A1_BASE
		move.l	#WID320|PIXEL16|PITCH4|XADDPIX,A1_FLAGS
		move.l	#WID128|PIXEL1|PITCH1|XADDPIX,A2_FLAGS
		move.l	asprite_addr,A2_BASE
		move.l	sprite_colour,d0
		move.l	d0,B_PATD
		move.l	d0,B_PATD+4
		move.w	shop_print_y,d0		;print name tag
		swap	d0
		move.w	shop_print_x,d0
		move.l	d0,A1_PIXEL
		move.l	apos_yx,A2_PIXEL
		move.l	awidth_yx,d0
		move.l	d0,B_COUNT
		swap	d0
		move.w	#1,d0
		swap	d0
		neg.w	d0
		move.l	d0,A1_STEP
		move.l	d0,A2_STEP
		move.l	#BCOMPEN|PATDSEL|SRCEN|DSTEN|UPDA1|UPDA2|LFU_S,B_CMD

		rts

print_shop_instructions:

		lea	shop_help,a6
		move.l	rasterd,d0
		move.l	#PITCH4|PIXEL16|WID320|XADDPIX,d1
		jmp	print_text_routine




;*****************************************************************************************************************************

print_pulsing_cursor:
		addq.w	#1,pulse_timer
		cmp.w	#1,pulse_timer
		ble.s	.not_next_frame
		clr.w	pulse_timer		
		addq.w	#1,pulse_frame
.not_next_frame:
		moveq	#7,d0
		and.w	pulse_frame,d0
		moveq	#PULSE_START,d4
		add.b	.pulse_table(pc,d0.w),d4
		
		lea	tankcam,a0
		movem.w	icgox(a0),d0/d1
		neg.w	d1
		add.w	screen_height,d1
		subq.w	#8,d0
		subq.w	#8,d1	
		tst.b	PAL_TV
		beq.s	.ntsc
		sub.w	#20,d1
.ntsc:		jmp	draw_shop_sprite

.pulse_table:	dc.b	0,1,2,3,3,2,1,0
		    even

;*****************************************************************************************************************************


;*****************************************************************************************************************************



draw_shop_sprite:
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20,d1
.ntsc:
		lea	level_sprites,a0
		jmp	print_a_sprite_normal_no_clip
				

		

*****************************************************************************************************************************


create_new_ship:
		movem.l	d0-a6,-(sp)
		move.l	which_players_weapons,a6
		lea	player1tab,a5
		moveq	#0,d0
		move.b	PLAYER_SHIP(a6),d0
		
		move.l	d0,-(sp)
		addq	#1,d0
		lea	tank_basic_shapes,a4
		bsr	add_to_table
		move.l	(sp)+,d0
		
		lsl.l	#2,d0
		move.l	.table(pc,d0.w),a0
		jsr	(a0)

		lea	player1tab,a0
		lea	player1vdf,a1
		jsr	mergeshapes
		movem.l	(sp)+,d0-a6
		rts
.table:	dc.l	generate_light
		dc.l	generate_medium
		dc.l	generate_heavy


generate_light:
		moveq	#0,d0
		move.b	WEAPON_LASER_L(a6),d0
		beq.s	.no_laser
		lea	light_laser_table,a4
		bsr	add_to_table
.no_laser:	moveq	#0,d0
		move.b	WEAPON_PLASMA(a6),d0
		beq.s	.no_plasma
		lea	light_plasma_table,a4
		bsr	add_to_table
.no_plasma:	moveq	#0,d0
		move.b	WEAPON_LAUNCHER_L(a6),d0
		beq.s	.no_launcher
		lea	light_launcher_table,a4
		bsr	add_to_table
.no_launcher:	
		moveq	#0,d0
		move.b	WEAPON_MINE(a6),d0
		or.b	WEAPON_SHIELD(a6),d0
		or.b	WEAPON_RADAR(a6),d0
		or.b	WEAPON_BACK(a6),d0
		or.b	WEAPON_AUTO(a6),d0
		beq.s	.no_multi
		moveq	#1,d0
		lea	light_multi_table,a4
		bsr	add_to_table
.no_multi:
		clr.l	(a5)+
		rts

generate_medium:
		moveq	#0,d0
		move.b	WEAPON_LASER_L(a6),d0
		beq.s	.no_laser_l
		lea	medium_laser_l_table,a4
		bsr	add_to_table
.no_laser_l:	moveq	#0,d0
		move.b	WEAPON_LASER_R(a6),d0
		beq.s	.no_laser_r
		lea	medium_laser_r_table,a4
		bsr	add_to_table
.no_laser_r:	moveq	#0,d0
		move.b	WEAPON_PLASMA(a6),d0
		beq.s	.no_plasma
		lea	medium_plasma_table,a4
		bsr	add_to_table
.no_plasma:	moveq	#0,d0
		move.b	WEAPON_LAUNCHER_L(a6),d0
		beq.s	.no_launcher_l
		lea	medium_launcher_l_table,a4
		bsr	add_to_table
.no_launcher_l:moveq	#0,d0
		move.b	WEAPON_MINE(a6),d0
		or.b	WEAPON_SHIELD(a6),d0
		or.b	WEAPON_RADAR(a6),d0
		or.b	WEAPON_BACK(a6),d0
		or.b	WEAPON_AUTO(a6),d0
		beq.s	.no_multi
		moveq	#1,d0
		lea	medium_multi_table,a4
		bsr.s	add_to_table
.no_multi:
		clr.l	(a5)+
		rts
		   
generate_heavy:
		moveq	#0,d0
		move.b	WEAPON_LASER_L(a6),d0
		beq.s	.no_laser_l
		lea	heavy_laser_l_table,a4
		bsr.s	add_to_table
.no_laser_l:	moveq	#0,d0
		move.b	WEAPON_LASER_R(a6),d0
		beq.s	.no_laser_r
		lea	heavy_laser_r_table,a4
		bsr.s	add_to_table
.no_laser_r:	moveq	#0,d0
		move.b	WEAPON_PLASMA(a6),d0
		beq.s	.no_plasma
		lea	heavy_plasma_table,a4
		bsr.s	add_to_table
.no_plasma:	moveq	#0,d0
		move.b	WEAPON_LAUNCHER_L(a6),d0
		beq.s	.no_launcher_l
		lea	heavy_launcher_l_table,a4
		bsr.s	add_to_table
.no_launcher_l:
		moveq	#0,d0
		move.b	WEAPON_LAUNCHER_R(a6),d0
		beq.s	.no_launcher_r
		lea	heavy_launcher_r_table,a4
		bsr.s	add_to_table
.no_launcher_r:
		moveq	#0,d0
		move.b	WEAPON_MINE(a6),d0
		or.b	WEAPON_SHIELD(a6),d0
		or.b	WEAPON_RADAR(a6),d0
		or.b	WEAPON_BACK(a6),d0
		or.b	WEAPON_AUTO(a6),d0
		beq.s	.no_multi
		moveq	#1,d0
		lea	heavy_multi_table,a4
		bsr.s	add_to_table
.no_multi:
		clr.l	(a5)+
		rts


add_to_table:	lsl.w	#2,d0
		lea	-4(a4,d0.w),a4
		moveq	#0,d0
		move.l	(a4)+,(a5)+
		move.l	d0,(a5)+
		move.l	d0,(a5)+
		move.l	d0,(a5)+
		move.l	d0,(a5)+
		move.l	d0,(a5)+
		move.l	d0,(a5)+
		move.l	#playertankCODE,(a5)+
		rts

relocate_rom_vdf_files:
	jsr	find_addons
	lea	RELOCATED_ANIMS,a1
	move.l	a0,d0
	addq	#4,a0
.loop:	move.l	(a0)+,d1
	beq.s	.exit
	add.l	d0,d1
	move.l	d1,(a1)+
	bra.s	.loop
.exit:	rts


get_addr_of_text:
		lea	level_sprites,a0
		move.w	#SHOP_TEXT_SPRITE,d0
		jsr	get_addr_sprite
		move.l	d0,asprite_addr
		rts



******************************** Data Section ********************************

		data


shop_help:
	
		dc.b	PAT,0,(320-(16*8))/2,0,196,PPAL
		dc.b	"Press B to exit.",PCR
		dc.b	PEND

		even

shop_sprite_data:
		dc.w	0,0,5,72	;00
		dc.w	7,0,5,72	;01
		dc.w	14,0,5,72	;02
		dc.w	21,0,5,72	;03
		dc.w	28,0,5,72	;04
		dc.w	35,0,5,72	;05
		dc.w	42,0,5,72	;06
		dc.w	49,0,5,72	;07
		dc.w	56,0,5,72	;08
		dc.w	63,0,5,72	;09
		dc.w	70+0,0,5,72	;10
		dc.w	70+7,0,5,72	;11
		dc.w	70+14,0,5,72	;12
		dc.w	70+21,0,5,72	;13
		dc.w	70+28,0,5,72	;14
		dc.w	70+35,0,5,72	;15
		dc.w	70+42,0,5,72	;16
		dc.w	70+49,0,5,72	;17
		dc.w	70+56,0,5,72	;18
		dc.w	70+63,0,5,72	;19
		dc.w	140,0,5,72	;20
		dc.w	140+7,0,5,72	;21
		dc.w	140+14,0,5,72	;22
		dc.w	140+21,0,5,72	;23
		dc.w	140+28,0,5,72	;24
		dc.w	140+35,0,5,72	;25
					
		dc.w	200+54,0,6,96	;26
					
		
laser_list:	SHOPPER	$00012001,0,LIGHT,POS_1|POS_2,1,p_laser1anim
	    	SHOPPER	$00012002,0,LIGHT,POS_1|POS_2,2,p_laser2anim

plasma_list:	SHOPPER	$00003001,0,LIGHT,POS_3,1,p_plasma1anim
		SHOPPER	$00003002,0,MEDIUM,POS_3,2,p_plasma2anim
		SHOPPER	$00003003,0,HEAVY,POS_3,3,p_plasma3anim

launcher_list:	SHOPPER	$00014501,0,LIGHT,POS_4|POS_5|POS_AMMO_NEEDED,1,p_launcher1anim
		SHOPPER	$00014502,0,MEDIUM,POS_4|POS_5|POS_AMMO_NEEDED,2,p_launcher2anim
		SHOPPER	$00014503,0,HEAVY,POS_4|POS_5|POS_AMMO_NEEDED,3,p_launcher3anim

shield_list:  	SHOPPER	$00000601,0,LIGHT,POS_6|POS_E,1,p_shields1anim
		SHOPPER	$00000602,0,MEDIUM,POS_6|POS_E,2,p_shields2anim
		SHOPPER	$00000603,0,HEAVY,POS_6|POS_E,3,p_shields3anim

turret_list:  	SHOPPER	$00000601,0,LIGHT,POS_6|POS_D,1,p_reargun1anim
		SHOPPER	$00000602,0,MEDIUM,POS_6|POS_D,2,p_reargun2anim
		SHOPPER	$00000603,0,HEAVY,POS_6|POS_D,3,p_reargun3anim
		SHOPPER	$00010604,0,LIGHT,POS_6|POS_D|POS_AMMO_NEEDED,4,p_rearmine1anim
		SHOPPER	$00010605,0,MEDIUM,POS_6|POS_D|POS_AMMO_NEEDED,5,p_rearmine2anim
		SHOPPER	$00010606,0,HEAVY,POS_6|POS_D|POS_AMMO_NEEDED,6,p_rearmine3anim

radar_list:   	SHOPPER	$00000601,0,LIGHT,POS_6|POS_B,1,p_radar1anim
		SHOPPER	$00000602,0,LIGHT,POS_6|POS_B,2,p_radar2anim

drone_list:	SHOPPER	$00000601,0,LIGHT,POS_6|POS_C,1,p_drone1anim
		SHOPPER	$00000602,0,LIGHT,POS_6|POS_C,2,p_drone2anim

autoaim_list:	SHOPPER	$00099999,0,LIGHT,POS_6|POS_F,1,p_autotargetanim


end_of_shopping_list:

;****************** Montings specific to Tank *****************************

tank_mounting_tables:
		dc.l	light_mount
		dc.l	medium_mount
		dc.l	heavy_mount


;mounting number
; 0 = laser left  - or mid
; 1 = laser right
; 2 = cannon
; 3 = launcher left or mid
; 4 = launcher right
; 5 = rear mounting

light_mount:	dc.w	0,2,3,5
medium_mount:	dc.w	0,1,2,3,5
heavy_mount: 	dc.w	0,1,2,3,4,5
MOUNT_NUMBERS:	DC.W	4,5,6


;************************ VDF related Stuff ****************************

		.long

shop_base_table:
		dc.l	lightanim
		dc.l	mediumanim
		dc.l	heavyanim


;************ Mounting Positions *************************************
	  
			even
position_table:	dc.l	small_table,medium_table,heavy_table

small_table:	dc.w	-10,28,207
		dc.w	0,0,0
		dc.w	0,126,-105
		dc.w	-165,100,-100
		dc.w	0,0,0
		dc.w	0,0,-210
medium_table:	
		dc.w	-116,35,0
		dc.w	-20,20,260
		dc.w	-30,75,60
		dc.w	78,70,-90
		dc.w	0,0,0
		dc.w	0,20,-270
heavy_table:	
		dc.w	-107,66,155
		dc.w	107,66,155
		dc.w	0,144,-160
		dc.w	-109,120,-220
		dc.w	109,120,-220
		dc.w	0,40,-340

********************************** Variables *********************************



	.bss

object_energy:		ds.l	1
object_weight:		ds.w	1
object_position:	ds.w	1
object_power:		ds.w	1

mounting_number:	ds.w	1
mounting_energy:	ds.w	1


exit_shop:		ds.w	1
button_selection:	ds.w	1
bcd_table:		ds.b	8
pulse_frame:		ds.w	1
pulse_timer:		ds.w	1
mergedanim:		ds.l	1
which_players_weapons:	ds.l	1



number_of_stats:		ds.w	1
RELOCATED_ANIMS:		
light_laser_table:		ds.l	2
light_plasma_table:		ds.l	1
light_launcher_table:		ds.l	1
light_multi_table:		ds.l	1

medium_laser_r_table:		ds.l	2
medium_laser_l_table:		ds.l	2
medium_plasma_table:		ds.l	2
medium_launcher_l_table:	ds.l	2
medium_multi_table:		ds.l	1

heavy_laser_r_table:		ds.l	2
heavy_laser_l_table:		ds.l	2
heavy_plasma_table:		ds.l	3
heavy_launcher_r_table:	ds.l	3
heavy_launcher_l_table:	ds.l	3
heavy_multi_table:		ds.l	1

tank_basic_shapes:
lightanim:			ds.l	1
mediumanim:			ds.l	1
heavyanim:			ds.l	1

weapon_got_table:		ds.b	(MAX_HELD*TABLE_ENTRY)
shop_menu_bar:			ds.w	1
weapon_number:			ds.w	1
allowed_weapons:		ds.w	1
shop_print_x:			ds.w	1
shop_print_y:			ds.w	1


show_pointer:	ds.l	1
apos_yx:	ds.l	1
awidth_yx:	ds.l	1
asprite_addr:	ds.l	1
bpos_yx:	ds.l	1
bwidth_yx:	ds.l	1
cpos_yx:	ds.l	1
cwidth_yx:	ds.l	1
sprite_colour:	ds.l	1


