**************************** Dreadnought Titles ***************************

* Notes:

********************************* Equates *********************************

TITLE_HEIGHT	equ	100


******************************* Code Section ******************************

		text
		.68000

****************************** Title Routines *****************************

titles:
		jsr	cls
		jsr	wait_vbl
		move.w	#$2c1,VMODE
		
		jsr	load_title_music

		clr.w	logo_timer
		clr.w	logo_frame
		clr.w	plot_anim_timer_1
		clr.w	plot_anim_timer_2
		clr.w	plot_anim_frame_1
		clr.w	plot_anim_frame_2
		
		move.b	#DEMO_OFF,demo_mode

		sf	exit_title

		move.w	#$77ff,CLUT+2
		jsr	load_title_pic
		
		move.w	#TITLE_LEVEL,d0
		jsr	load_level_graphics
		
.main_loop:	

		move.w	#60*6,d7
		bsr	wait_full_copyright
		tst.b	exit_title
		bne	.exit

		jsr	cls
		jsr	wait_vbl
		move.w	#$6c1,VMODE

		bsr	load_monitor_pic

		bsr	title_plot
		tst.b	exit_title
		bne	.exit

		
		jsr	title_viewer
		tst.b	exit_title		;sprites
		bne	.exit

		jsr	cls
		jsr	wait_vbl
		bsr	title_demo		;this will trash all level
		tst.b	exit_title		;sprites
		bne	.exit

		jsr	cls
		jsr	wait_vbl
	
		jsr	load_title_music

		bsr	show_hiscores
		tst.b	exit_title
		bne.s	.exit

		
		move.w	#$2c1,VMODE

		move.w	#$77ff,CLUT+2
		jsr	load_title_pic
		move.w	#TITLE_LEVEL,d0
		jsr	load_level_graphics


		move.w	#60,d7
		bsr	wait_full
		tst.b	exit_title
		bne.s	.exit

		bsr	title_shrink
		tst.b	exit_title
		bne.s	.exit

		bsr	title_credits
		tst.b	exit_title
		bne.s	.exit


		bsr	title_expand
		tst.b	exit_title
		beq	.main_loop

		
.exit:		jsr	cls
		jsr	wait_vbl
		move.w	#$6c1,VMODE
		move.w	#320,screen_width
		rts


title_plot:	bsr	create_title_plot
		bsr	make_plot_sprite
		clr.w	scroll_plot_timer
		clr.w	plot_line
		sf	plot_shown
.loop:		jsr	NEW_OL
		lea	title_colours+2,a0
		lea	CLUT,a1
		move.w	#127,d0	
.lp:		move.l	(a0)+,(a1)+	;copy 8 colours
		dbf	d0,.lp
		jsr	add_choose_backdrop
		bsr.s	display_back_of_plot
		bsr	animate_plot_stuff
		bsr	scroll_plot
		jsr	wait_vbl
		bsr	title_press
		bne.s	.exit
		tst.b	plot_shown
		beq.s	.loop
.exit:		rts

display_back_of_plot:
		bsr	add_title_shade
		lea	plot_stuff,a6
		move.w	(a6)+,-(sp)
.loop:		movem.w	(a6)+,d0/d1/d4
		bsr	show_plot_sprite
		subq.w	#1,(sp)
		bne.s	.loop
		addq	#2,sp
		rts

add_title_shade:
		move.w	#$00e0,CLUT+(255*2)
		
		
		move.w	#(320-156)/2,d0
		move.w	#17,d1
		moveq	#78,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite

		move.w	#(320-256)/2,d0
		move.w	#52,d1
		moveq	#77,d4
		jsr	display_option_sprite
		or.b	#%01000000,10(a0)	;make the sprite transparent
		move.w	#shadow_colour,d0
		jsr	add_colour_to_sprite
		rts




first_plot_sprite	equ	68

plot_sprite_x_pos	equ	(47+1)
plot_sprite_y_pos	equ	(70+2+14)

make_plot_sprite:
		move.w	#first_plot_sprite,d0
		lea	level_sprites,a0
		jsr	get_sprite_data
		
		and.l	#%11111111000000000011111111111111,d5
		moveq	#107,d0
		swap	d0
		ror.l	#2,d0
		or.l	d0,d5
		or.w	#plot_sprite_x_pos,d7
		move.w	#plot_sprite_y_pos*2,d0
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20*2,d0
.ntsc:		add.w	my_vdb,d0
		lsl.w	#3,d0
		or.w	d0,d5
		movem.l	d4-d7,plot_sprite
		rts		
	



show_plot_sprite:
		tst.b	PAL_TV
		beq.s	.ntsc
		add.w	#20,d1
.ntsc:		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		moveq	#0<<3,d0
		jsr	add_colour_to_sprite
		rts


animate_plot_stuff:
		subq.w	#1,plot_anim_timer_1
		bpl.s	.no_1
		move.w	#plot_time1,plot_anim_timer_1
		subq.w	#1,plot_anim_frame_1
		bpl.s	.nowrap_1
		move.w	#plot_frame1,plot_anim_frame_1
.nowrap_1:
.no_1:		move.w	#214,d0
		move.w	#72+14,d1
		move.w	#FIRST_ANIM1,d4
		sub.w	plot_anim_frame_1,d4
		bsr	show_plot_sprite

		subq.w	#1,plot_anim_timer_2
		bpl.s	.no_2
		move.w	#plot_time2,plot_anim_timer_2
		subq.w	#1,plot_anim_frame_2
		bpl.s	.nowrap_2
		move.w	#plot_frame2,plot_anim_frame_2
.nowrap_2:
.no_2:		move.w	#214,d0
		move.w	#142+14,d1
		move.w	#FIRST_ANIM2,d4
		sub.w	plot_anim_frame_2,d4
		bra	show_plot_sprite

FIRST_ANIM1		equ	51
FIRST_ANIM2		equ	66

plot_frame1		equ	14
plot_frame2		equ	13

plot_time1		equ	6
plot_time2		equ	6

no_of_frames_to_read_plot_page		equ	600


plot_width	equ	(8*3)
MAX_PLOT_LINE	equ	(5*109)

scroll_plot:
		movem.l	plot_sprite,d4-d7
		move.w	plot_line,d0
		mulu	#plot_width,d0
		add.l	d0,d4
		lsl.l	#8,d4
		jsr	ADD_OL
		movem.l	d4-d7,(a0)
		move.b	#Q_BMO,O_TYPE(a0)
		moveq	#7<<3,d0
		jsr	add_colour_to_sprite
		
		subq.w	#1,scroll_plot_timer
		bpl.s	.no_add
		addq	#1,plot_line
.no_add:	cmp.w	#-109,scroll_plot_timer
		bne.s	.no_new_page
		move.w	#no_of_frames_to_read_plot_page,scroll_plot_timer
.no_new_page:	cmp.w	#MAX_PLOT_LINE,plot_line
		seq	plot_shown
		rts

wait_full:	move.w	#32,title_scale
.loop1:	jsr	NEW_OL
		jsr	ADD_TITLE_SCREEN
		bsr	animate_logo
		jsr	wait_vbl
		bsr	title_press
		bne.s	.exit
		dbf	d7,.loop1
.exit:		rts

wait_full_copyright:
		move.w	#32,title_scale
		move.w	d7,-(sp)
.loop1:	jsr	NEW_OL
		jsr	ADD_TITLE_SCREEN
		jsr	add_copyright_message
		bsr	animate_logo
		jsr	wait_vbl
		bsr	title_press
		bne.s	.exit
		subq.w	#1,(sp)
		bne.s	.loop1
.exit:		addq	#2,sp
		rts

add_copyright_message:
		moveq	#35,d0
		moveq	#-50,d1
		add.w	screen_height,d1
		move.w	#67,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		bset	#0,7(a0)
		move.b	#Q_SBMO,O_TYPE(A0)
		move.b	#64,23(a0)
		move.b	#32,22(a0)
		move.b	22(a0),21(a0)
		sub.l	#1<<14,4(a0)
		rts


title_shrink:	move.w	#32,title_scale
.in:		subq.w	#1,title_scale
		jsr	NEW_OL
		jsr	ADD_TITLE_SCREEN
		bsr	animate_logo
		jsr	wait_vbl
		bsr	title_press
		bne.s	.exit
		cmp.w	#16,title_scale
		bne.s	.in
.exit:		rts

title_expand:	move.w	#16,title_scale
.out:		addq.w	#1,title_scale
		jsr	NEW_OL
		jsr	ADD_TITLE_SCREEN
		bsr	animate_logo
		jsr	wait_vbl
		bsr.s	title_press
		bne.s	.exit
		cmp.w	#32,title_scale
		bne.s	.out
.exit:		rts







title_credits:
		move.w	screen_height,title_sprite_y
		move.w	#640,screen_width

.main:		jsr	NEW_OL
		jsr	ADD_TITLE_SCREEN
		subq.w	#1,title_sprite_y
		move.w	#320,d0
		move.w	title_sprite_y,d1
		moveq	#32,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal
		bsr.s	animate_logo
		
		jsr	wait_vbl
		bsr.s	title_press
		bne.s	.exit

		cmp.w	#-200,title_sprite_y
		bne.s	.main

.exit:		rts

title_press:	jsr	read_joypad
demo_press:	move.l	joyedge1,d0
		or.l	joyedge2,d0
		and.l	#~(1<<KEY_0),d0
		sne	exit_title
		rts


logo_time	equ	5
max_logo	equ	32

logo_x		equ	320-24-20
logo_y		equ	-43-20

animate_logo:	move.w	d7,-(sp)
		subq.w	#1,logo_timer
		bpl.s	.just_show
		add.w	#logo_time,logo_timer
		addq.w	#1,logo_frame
		cmp.w	#max_logo,logo_frame
		bne.s	.no_wrap
		clr.w	logo_frame
.no_wrap:	
.just_show:	move.w	#(logo_x)*2,d0
		move.w	#logo_y,d1
		add.w	screen_height,d1
		move.w	logo_frame,d4
		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip
		move.l	4(a0),d0
		sub.l	#%00000000000000000100000000000000,d0
		or.b	#1,d0
		move.l	d0,4(a0)
		move.b	#32*2,23(a0)
		move.b	#32,22(a0)
		move.b	#32,21(a0)
		move.b	#Q_SBMO,O_TYPE(a0)
		move.w	(sp)+,d7
		rts

create_title_plot:
		lea	level_sprites,a0
		move.w	#first_plot_sprite,d0
		jsr	get_addr_sprite
		lea	title_plot_text,a6
		move.l	#WID192|PITCH1|PIXEL1|XADDPIX,d1
		jsr	print_text_routine
		rts


******************************* Data Section ******************************

							  
title_colours:		incbin	"graphics\\bitmaps\\story\\story.cpl"

plot_stuff:		dc.w	4
			dc.w	(320-74)/2,021,33
			dc.w	045,050+14,34
			dc.w	045,069+14,35
			dc.w	212,069+14,36
		
title_plot_text:
	;dc.b	"*******************"
	dc.b	PAT,0,0,0,109
	dc.b	"After 20 years of",PCR
	dc.b	"development the",PCR
	dc.b	"Override mainframe,",PCR
	dc.b	"buried deep beneath",PCR
	dc.b	"the south polar",PCR
	dc.b	"icecap to aid it's",PCR
	dc.b	"supercooled",PCR
	dc.b	"megaframe brain,",PCR
	dc.b	"goes online exactly",PCR
	dc.b	"to schedule."

	;dc.b	"*******************"
	dc.b	PAT,0,0,0,109*2
	dc.b	"Designed to handle",PCR
	dc.b	"the increasingly",PCR
	dc.b	"complex world net",PCR
	dc.b	"called the I-WAY,",PCR
	dc.b	"it has many",PCR
	dc.b	"technological",PCR
	dc.b	"innovations giving",PCR
	dc.b	"it huge processing",PCR
	dc.b	"capacity. Mankind",PCR
	dc.b	"and society become",PCR
	dc.b	"totally dependent",PCR
	dc.b	"upon it."

	;dc.b	"*******************"
	dc.b	PAT,0,0,1,(3*109)-256
	dc.b	"Override operates",PCR
	dc.b	"for many years",PCR
	dc.b	"seemingly without",PCR
	dc.b	"problem. However",PCR
	dc.b	"it's DataBases",PCR
	dc.b	"mutate and begin",PCR
	dc.b	"creating virus",PCR
	dc.b	"programs that clog",PCR
	dc.b	"the I-WAY.",PCR

	;dc.b	"*******************"
	dc.b	PAT,0,0,1,(4*109)-256
	dc.b	"An anti-virus craft",PCR
	dc.b	"must enter the",PCR
	dc.b	"I-WAY and destroy",PCR
	dc.b	"the mutant",PCR
	dc.b	"databases. It must",PCR
	dc.b	"also remove the",PCR
	dc.b	"virus programs that",PCR
	dc.b	"are blocking the",PCR
	dc.b	"I-WAY.",PCR,PCR,PCR
	dc.b	"You are Mankind's",PCR
	dc.b	"only hope...."
	dc.b	PEND

	
		even

		.bss
exit_title:		ds.b	1
plot_shown:		ds.b	1
		even
title_scale:		ds.w	1
title_sprite_y:	ds.w	1
logo_timer:		ds.w	1
logo_frame:		ds.w	1
scroll_plot_timer:	ds.b	1

plot_anim_timer_1:	ds.w	1
plot_anim_timer_2:	ds.w	1
plot_anim_frame_1:	ds.w	1
plot_anim_frame_2:	ds.w	1
plot_line:		ds.w	1
plot_sprite:		ds.b	4*4
