
SPAN	equ	60*3

	.68000
	.text


view_stuff:
	sf	IN_GAME
	st.b	texturesoff

	move.b	#32,zoom_size
	jsr	add_choose_backdrop
	jsr	draw_grid1
	jsr	NEW_OL
	jsr	add_choose_backdrop
	jsr	draw_grid1

	clr.w	object_number

	jsr	initviewer

.loop:
	bsr	load_image
.inner:

	bsr	show_image


	jsr	read_joypad
	move.l	joyedge1,d0
	
	btst	#RIGHT_B,d0
	bne.s	.right
	
	btst	#LEFT_B,d0
	bne.s	.left
	
	btst	#FIRE_A,d0
	bne.s	.exit
	btst	#FIRE_B,d0
	bne.s	.exit
	btst	#FIRE_C,d0
	beq	.inner
.exit:	jsr	doneviewer
	rts
.right:
	addq.w	#1,object_number
	cmp.w	#MAX_OBJECT,object_number
	bne.s	.loop
	clr.w	object_number
	bra.s	.loop
.left:	subq.w	#1,object_number
	bpl.s	.loop
	move.w	#MAX_OBJECT-1,object_number
	bra.s	.loop



load_image:
	moveq	#16,d0
	mulu.w	object_number,d0
	lea	view_table,a0
	add.w	d0,a0
	addq.l	#2,a0
	move.w	(a0)+,viewercam+icdist
	move.l	viewerobj,a1
	move.l	(a0)+,isycoord(a1)
	move.l	(a0)+,objectanim
	move.l	(a0)+,objecttext
	rts

show_image:
	jsr	NEW_OL
	jsr	switchab		;update the screens
	jsr	add_choose_backdrop
	
	moveq	#75,d4
	move.w	#(320-150)/2,d0
	moveq	#21,d1
	jsr	display_option_sprite
	moveq	#OPTIONS_COLOUR1,d0
	jsr	add_colour_to_sprite

	jsr	draw_grid2
	move.l	rasterb,rasterd
	jsr	ADD_VIEWSCREEN		;add polygon playfield
	jsr	showviewer
	
	move.l	objecttext,a6
	move.l	rasterd,d0
	move.l	#PITCH4|PIXEL16|WID320|XADDPIX,d1
	jsr	print_text_routine


	rts




title_viewer:

	move.b	#32,zoom_size
	rept	3
	jsr	NEW_OL
	jsr	add_choose_backdrop
	endr
	jsr	wait_vbl

	lea	CLUT,a0
	lea	options_palette+2,a1
	moveq	#128-1,d2
.loop1:move.l	(a1)+,(a0)+
	dbf	d2,.loop1

	move.w	#$00e0,CLUT+(255*2)
	sf	IN_GAME
	st.b	texturesoff

	move.w	#OPTIONS_LEVEL,d0
	bsr	load_level_graphics




	clr.w	object_number

	jsr	initviewer

.loop:
	bsr	load_title_image

	move.w	#SPAN,-(sp)
.inner:
	bsr	title_press
	bne.s	.quick_exit
	bsr	show_title_image
	subq.w	#1,(sp)
	bne.s	.inner
	addq.l	#2,sp
	addq	#1,object_number
	cmp.w	#MAX_TITLE_OBJECT,object_number
	beq.s	.exit
	bra.s	.loop
.quick_exit:
	addq	#2,sp      
.exit:	jsr	doneviewer
	rts

load_title_image:
	moveq	#16,d0
	mulu.w	object_number,d0
	lea	title_view_table,a0
	add.w	d0,a0
	addq	#2,a0
	move.w	(a0)+,viewercam+icdist
	move.l	viewerobj,a1
	move.l	(a0)+,isycoord(a1)
	move.l	(a0)+,objectanim
	move.l	(a0)+,objecttext
	rts

show_title_image:
	jsr	NEW_OL
	jsr	switchab		;update the screens
	jsr	add_choose_backdrop
	
	moveq	#79,d4
	move.w	#(320-104)/2,d0
	moveq	#21,d1
	jsr	display_option_sprite
	moveq	#OPTIONS_COLOUR1,d0
	jsr	add_colour_to_sprite


	jsr	draw_grid2
	move.l	rasterb,rasterd
	jsr	ADD_VIEWSCREEN		;add polygon playfield
	jsr	showviewer
	
	move.l	objecttext,a6
	move.l	rasterd,d0
	move.l	#PITCH4|PIXEL16|WID320|XADDPIX,d1
	jsr	print_text_routine

	rts




	.data
		even

view_table:	
		dc.l	1200,360-100,tank1vdf,tank1desc
		dc.l	1600,400-100,tank2vdf,tank2desc
		dc.l	1500,280-100,tank3vdf,tank3desc
		dc.l	1200,330-100,tank4vdf,tank4desc
		dc.l	1600,400-100,tank5vdf,tank5desc
		dc.l	1500,300-100,launcher1vdf,launcher1desc
		dc.l	1500,400-100,launcher2vdf,launcher2desc
		dc.l	1500,300-100,launcher3vdf,launcher3desc
		dc.l	1000,360-100,mobile1vdf,mobile1desc
		dc.l	1000,300-100,mobile2vdf,mobile2desc
		dc.l	800,300-100,trundlervdf,trundlerdesc
		dc.l	1300,420-100,phaservdf,phaserdesc
		dc.l	900,320-100,bombervdf,bomberdesc
		dc.l	900,300-100,dropshipvdf,dropshipdesc
		dc.l	1100,390-100,droptankvdf,droptankdesc
		dc.l	1700,550-100,wholegunvdf,guntowerdesc
		dc.l	1100,370-100,straightvdf,straightdesc
		dc.l	1100,400-100,layervdf,layerdesc
		dc.l	500,330-100,resminevdf,resminedesc
		dc.l	500,330-100,bouncer3vdf,bouncerdesc
view_table_end:
		

title_view_table:
		dc.l	4000,200-100,exitopenvdf,exitondesc
		dc.l	800,330-100,datapodvdf,datapoddesc
		dc.l	2500,250-100,databasevdf,databasedesc
		
title_view_table_end:




MAX_OBJECT		equ	(view_table_end-view_table)/16
MAX_TITLE_OBJECT	equ	(title_view_table_end-title_view_table)/16



tank1desc:    	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Opal Tank",PCR
		dc.b	"Speed:     58% Aggression: 80%",PCR
		dc.b	"Firepower: 68%  Shielding: 60%",PCR
		dc.b	PEND				

tank2desc:    	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Gemstone Tank",PCR
		dc.b	"Speed:     66% Aggression: 84%",PCR
		dc.b	"Firepower: 72%  Shielding: 71%",PCR
		dc.b	PEND

tank3desc:    	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Crystal Tank",PCR
		dc.b	"Speed:     75% Aggression: 88%",PCR
		dc.b	"Firepower: 82%  Shielding: 84%",PCR
		dc.b	PEND

tank4desc:    	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Diamond Tank",PCR
		dc.b	"Speed:     83% Aggression: 93%",PCR
		dc.b	"Firepower: 89%  Shielding: 92%",PCR
		dc.b	PEND

tank5desc:    	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Emerald Tank",PCR
		dc.b	"Speed:     97% Aggression: 95%",PCR
		dc.b	"Firepower: 94%  Shielding: 97%",PCR
		dc.b	PEND

launcher1desc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Tiger Launcher",PCR
		dc.b	"Speed:     00% Aggression: 69%",PCR
		dc.b	"Firepower: 57%  Shielding: 48%",PCR
		dc.b	PEND

launcher2desc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Lion Launcher",PCR
		dc.b	"Speed:     00% Aggression: 73%",PCR
		dc.b	"Firepower: 69%  Shielding: 56%",PCR
		dc.b	PEND

launcher3desc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Panther Launcher",PCR
		dc.b	"Speed:     00% Aggression: 77%",PCR
		dc.b	"Firepower: 84%  Shielding: 62%",PCR
		dc.b	PEND

mobile1desc: 	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Alpha Mobile Launcher",PCR
		dc.b	"Speed:     68% Aggression: 78%",PCR
		dc.b	"Firepower: 67%  Shielding: 68%",PCR
		dc.b	PEND

mobile2desc: 	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Beta Mobile Launcher",PCR
		dc.b	"Speed:     83% Aggression: 86%",PCR
		dc.b	"Firepower: 89%  Shielding: 75%",PCR
		dc.b	PEND

trundlerdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Trundler",PCR
		dc.b	"Speed:     69% Aggression: 89%",PCR
		dc.b	"Firepower: 98%  Shielding: 88%",PCR
		dc.b	PEND

phaserdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Tau Phase Shifter",PCR
		dc.b	"Speed:     49% Aggression: 76%",PCR
		dc.b	"Firepower: 00%  Shielding: 37%",PCR
		dc.b	PEND

bomberdesc:  	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Lancaster Bomber",PCR
		dc.b	"Speed:     89% Aggression: 59%",PCR
		dc.b	"Firepower: 58%  Shielding: 68%",PCR
		dc.b	PEND

dropshipdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Wellington Dropship",PCR
		dc.b	"Speed:     86% Aggression: 63%",PCR
		dc.b	"Firepower: 00%  Shielding: 72%",PCR
		dc.b	PEND

droptankdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Wellington Droptank",PCR
		dc.b	"Speed:     57% Aggression: 89%",PCR
		dc.b	"Firepower: 67%  Shielding: 74%",PCR
		dc.b	PEND

guntowerdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Nuclear Gun Tower",PCR
		dc.b	"Speed:     00% Aggression: 94%",PCR
		dc.b	"Firepower: 79%  Shielding: 58%",PCR
		dc.b	PEND

straightdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Tomcat Homer",PCR
		dc.b	"Speed:     78% Aggression: 63%",PCR
		dc.b	"Firepower: 00%  Shielding: 46%",PCR
		dc.b	PEND

layerdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Tomahawk Mine Layer",PCR
		dc.b	"Speed:     46% Aggression: 85%",PCR
		dc.b	"Firepower: 48%  Shielding: 59%",PCR
		dc.b	PEND

resminedesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Patriot Mine",PCR
		dc.b	"Speed:     00% Aggression: 00%",PCR
		dc.b	"Firepower: 00%  Shielding: 99%",PCR
		dc.b	PEND

bouncerdesc:	dc.b	PAT,0,40,0,190,PPAL
		dc.b	"Craft: Bouncing Wallis",PCR
		dc.b	"Speed:     36% Aggression: 30%",PCR
		dc.b	"Firepower: 00%  Shielding: 37%",PCR
		dc.b	PEND


exitondesc:	dc.b	PAT,0,67,0,190,PPAL
		dc.b	"Enter the DataLink when",PCR
		dc.b	"a node is clear of viruses."
		dc.b	PEND

datapoddesc:	dc.b	PAT,0,67,0,190,PPAL
		dc.b	"Collect DataPods to remove",PCR
		dc.b	"existing virus programs."
		dc.b	PEND

databasedesc:	dc.b	PAT,0,60,0,190,PPAL
		dc.b	"Destroy Mutant DataBases to",PCR
		dc.b	"stop more viruses appearing."
		dc.b	PEND


		even


	.bss

object_number:		ds.w	1
objecttext:		ds.l	1


