***************************** Bomber Control File ****************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

******************* Bomber Waiting And Scanning For Targets ******************

dobomberwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	bombercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodebomber

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)		;look for a target
		bne.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dobomberlineup,ido(a0)	;we have a target!
.done:
		rts

********************* Bomber Lining Up Behind It's Target ********************

dobomberlineup:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	doobjcoll		;deal with collisions
		bsr	bombercollide
		tst.w	ioenergy(a0)
		ble	explodebomber

		bsr	confirmtarget		;target still available?
		beq.s	.losttarget		;no...
		bsr	flatrotatetotarget  	;rotate towards the target
		bsr	flatmoveobject	    	;and move towards the target
		bsr	maintainheight		;and maintain height

		move.l	iotarget(a0),a1		;control the bomber's speed
		move.w	iszx(a0),d0		;based on distance to
		move.w	iszz(a0),d2		;drop point
		ext.l	d0
		ext.l	d2
		asr.l	#4,d0
		asr.l	#4,d2
		neg.l	d0
		neg.l	d2
		add.l	isxcoord(a1),d0
		add.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		muls	d0,d0
		muls	d2,d2
		add.l	d2,d0
		cmp.l	#800*800,d0
		ble.s	.attack
.speedup:
		addq.w	#8,iozspeed(a0)
		cmp.w	#200,iozspeed(a0)
		ble.s	.done
		move.w	#200,iozspeed(a0)
.done:
		rts
.attack:
		move.l	#dobomberattack,ido(a0)	;attack the target
		rts
.losttarget:
		move.l	#dobomberwait,ido(a0)	;reaquire target
		rts

***************** Bomber Flying Over Target And Bombing It *******************

dobomberattack:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done
	
		bsr	doobjcoll		;deal with collisions
		bsr	bombercollide
		tst.w	ioenergy(a0)
		ble	explodebomber

		bsr	flatmoveobject		;move towards target
		bsr	maintainheight		;maintain height above target

		move.l	iotarget(a0),a1		;drop a carefully aimed
		move.w	iszx(a0),d0		;bomb at the target
		move.w	iszz(a0),d2
		ext.l	d0
		ext.l	d2
		asr.l	#4,d0
		asr.l	#4,d2
		neg.l	d0
		neg.l	d2
		add.l	isxcoord(a1),d0
		add.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		muls	d0,d0
		muls	d2,d2
		add.l	d2,d0
		cmp.l	#800*800,d0
		bge.s	.slowdown
.speedup:
		addq.w	#8,iozspeed(a0)		;if within attack distance
		cmp.w	#200,iozspeed(a0)	;speed up and drop a bomb
		ble.s	.notfast
		move.w	#200,iozspeed(a0)
.notfast:
		subq.w	#1,iotimer2(a0)
		bge.s	.done
		move.w	#2,iotimer2(a0)

		tst.w	iotimer1(a0)
		bne.s	.bounce
.drop:
		bsr	createbomb
		bra.s	.done
.bounce:
		bsr	createbouncebomb
.done:
		rts
.slowdown:
		subq.w	#4,iozspeed(a0)		;if outside attack distance
		cmp.w	#30,iozspeed(a0)	;slow down and start
		bge.s	.notslow		;new attack
		move.w	#30,iozspeed(a0)
		move.l	#dobomberwait,ido(a0)
.notslow:
		rts

***************************** Bomber Subroutines *****************************

bombercollide:	tst.l	iocollcode(a0)
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodebomber:	move.l	#dosmallbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makebomber:	bsr	getempty		;make a bomber object

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#longrange,iorange(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dobomberwait,ido(a1)
		move.l	#bomberanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#bomberTYPE,iotype(a1)
		move.w	#bomberENERGY,ioenergy(a1)
		move.w	#bomberDAMAGE,iodamage(a1)

		jsr	random			;this is so they don't
		and.w	#31,d0			;all look for targets
		addq.w	#1,d0			;on the same update
		move.w	d0,iotimer(a1)
		move.w	index,d0
		and.w	#1,d0
		move.w	d0,iotimer1(a1)
		move.w	#1,iotimer2(a1)

		move.w	#0,iobarrelx(a1)
		move.w	#-200,iobarrely(a1)
		move.w	#0,iobarrelz(a1)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

********************************* Animations *********************************

		phrase
bomberanim:	dc.l	bombervdf

********************************** VDF Files *********************************

bombervdf:	incbin	"graphics\\shapes\\enemies\\bomber.vdf"


