***************************** Bomb Control Routines **************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

******************************* Update Routines ******************************

dobomb:		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	doobjcoll

		tst.l	iocollfloor(a0)
		bne	explodebomb
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		cmp.w	#bomberCODE,d0
		beq.s	.nocollide
		cmp.w	#bombCODE,d0
		bne	explodebomb
.nocollide:

		movem.w	ioxspeed(a0),d0-d2
		move.w	d0,d3
		move.w	d2,d4
		asr.w	#3,d3
		asr.w	#3,d4
		sub.w	d3,d0
		sub.w	d4,d2
		sub.w	#gravity,d1
		cmp.w	#-terminalv,d1
		bge.s	.ysok
		move.w	#-terminalv,d1
.ysok:
		movem.w	d0-d2,ioxspeed(a0)
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
.done:
		rts

dobouncebomb:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		subq.w	#1,iotimer(a0)
		beq	explodebomb

		bsr	doobjcoll

		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		cmp.w	#bomberCODE,d0
		beq.s	.nocollide
		cmp.w	#bombCODE,d0
		bne.s	explodebomb
.nocollide:

		movem.w	ioxspeed(a0),d0-d2
		move.w	d0,d3
		move.w	d2,d4
		asr.w	#4,d3
		asr.w	#4,d4
		sub.w	d3,d0
		sub.w	d4,d2
		move.l	iocollfloor(a0),d3
		beq.s	.nobounce
		clr.l	iocollfloor(a0)
		add.l	d3,isycoord(a0)
		neg.w	d1
		move.w	d1,d3
		asr.w	#3,d3
		sub.w	d3,d1
.nobounce:
		sub.w	#gravity,d1
		cmp.w	#-terminalv,d1
		bge.s	.ysok
		move.w	#-terminalv,d1
.ysok:
		movem.w	d0-d2,ioxspeed(a0)
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)

		move.w	ioxspeed(a0),d0		;spin the bomb around
		move.w	iozspeed(a0),d1
		muls	d0,d0
		muls	d1,d1
		add.l	d1,d0
		bsr	root
		add.w	d0,d0
		neg.w	d0
		add.w	#2048,d0
		move.w	d0,xangle
		lea	isxx(a0),a6
		bsr	matrotx
.done:
		rts

******************************* Bomb Subroutines *****************************

explodebomb:	bsr	random			;random x rotate
		and.w	#2047,d0
		move.w	d0,xangle
		lea	isxx(a0),a6
		bsr	matrotx

		bsr	random			;random y rotate
		and.w	#2047,d0
		move.w	d0,yangle
		lea	isxx(a0),a6
		bsr	matroty

		bsr	random			;random z rotate
		and.w	#2047,d0
		move.w	d0,zangle
		lea	isxx(a0),a6
		bsr	matrotz

		move.l	#dosmallbang,ido(a0)
		rts

******************************* Object Generators ****************************

createbomb:	bsr	getempty		;create a bomb object
		beq.s	.none

		move.l	#dobomb,ido(a1)
		move.l	#bombanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		moveq.l	#0,d0
		bsr	movetobarrel

		move.w	d6,d0			;inherits the speed
		move.w	a2,d1			;of the parent
		move.w	iozspeed(a0),d7
		muls	d7,d0
		muls	d7,d1
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		swap	d0
		swap	d1
		move.w	d0,ioxspeed(a1)
		clr.w	ioyspeed(a1)
		move.w	d1,iozspeed(a1)

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#bombTYPE,iotype(a1)
		move.w	#bombDAMAGE,iodamage(a1)
.none:
		rts

createbouncebomb:
		bsr	getempty		;create a bouncing bomb object
		beq.s	.none

		move.l	#dobouncebomb,ido(a1)
		move.l	#bouncebombanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		moveq.l	#0,d0
		bsr	movetobarrel

		move.w	d6,d0			;inherits the speed
		move.w	a2,d1			;of the parent
		move.w	iozspeed(a0),d7
		muls	d7,d0
		muls	d7,d1
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		swap	d0
		swap	d1
		move.w	d0,ioxspeed(a1)
		clr.w	ioyspeed(a1)
		move.w	d1,iozspeed(a1)

		move.w	#50,iotimer(a1)
		move.w	#2048-100,ioxrot(a1)

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#bombTYPE,iotype(a1)
		move.w	#bombDAMAGE,iodamage(a1)
.none:
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
bombanim:	dc.l	bombvdf

		phrase
bouncebombanim:	dc.l	bouncebombvdf

********************************** VDF Files *********************************

bombvdf:	dc.w	bombc-bombvdf

bombs:		dc.w	105

		dc.w	10

		dc.w	0,-100,0,0,0,0			;0
		dc.w	-25,-75,-25,0,0,0		;1
		dc.w	25,-75,-25,0,0,0		;2
		dc.w	-25,-75,25,0,0,0		;3
		dc.w	25,-75,25,0,0,0			;4
		dc.w	-25,-50,-25,0,0,0		;5
		dc.w	25,-50,-25,0,0,0		;6
		dc.w	-25,-50,25,0,0,0		;7
		dc.w	25,-50,25,0,0,0			;8
		dc.w	0,0,0,0,0,0			;9

		dc.w	12

		dc.w	$4034,3,1,0,2	;2,0,1
		dc.w	$4035,3,2,0,4	;4,0,2
		dc.w	$4034,3,4,0,3	;3,0,4
		dc.w	$4035,3,3,0,1	;1,0,3

		dc.w	$4033,4,1,2,6,5	;5,6,2,1
		dc.w	$4034,4,2,4,8,6	;6,8,4,2
		dc.w	$4033,4,4,3,7,8	;8,7,3,4
		dc.w	$4034,4,3,1,5,7	;7,5,1,3

		dc.w	$4031,3,6,9,5	;5,9,6
		dc.w	$4032,3,8,9,6	;6,9,8
		dc.w	$4031,3,7,9,8	;8,9,7
		dc.w	$4032,3,5,9,7	;7,9,5

bombc:		dc.w	105

		dc.w	1

		dc.w	-25,-100,-25
		dc.w	50,100,50
		dc.w	static+bombCODE


bouncebombvdf:	dc.w	bouncebombc-bouncebombvdf

bouncebombs:	dc.w	200

		dc.w	24

		dc.w	0,-80,40,0,0,0		;0
		dc.w	0,-80,-40,0,0,0		;1
		dc.w	0,80,40,0,0,0		;2
		dc.w	0,80,-40,0,0,0		;3
		dc.w	0,-40,80,0,0,0		;4
		dc.w	0,-40,-80,0,0,0		;5
		dc.w	0,40,80,0,0,0		;6
		dc.w	0,40,-80,0,0,0		;7

		dc.w	40,-40,20,0,0,0		;8
		dc.w	40,-40,-20,0,0,0	;9
		dc.w	40,40,20,0,0,0		;10
		dc.w	40,40,-20,0,0,0		;11
		dc.w	40,-20,40,0,0,0		;12
		dc.w	40,-20,-40,0,0,0	;13
		dc.w	40,20,40,0,0,0		;14
		dc.w	40,20,-40,0,0,0		;15

		dc.w	-40,-40,20,0,0,0	;16
		dc.w	-40,-40,-20,0,0,0	;17
		dc.w	-40,40,20,0,0,0		;18
		dc.w	-40,40,-20,0,0,0	;19
		dc.w	-40,-20,40,0,0,0	;20
		dc.w	-40,-20,-40,0,0,0	;21
		dc.w	-40,20,40,0,0,0		;22
		dc.w	-40,20,-40,0,0,0	;23

		dc.w	18

		dc.w	$4033,4,18,19,3,2	;2,3,19,18	;left side
		dc.w	$4033,4,23,21,5,7	;7,5,21,23
		dc.w	$4033,4,17,16,0,1	;1,0,16,17
		dc.w	$4033,4,20,22,6,4	;4,6,22,20
		dc.w	$4035,4,19,23,7,3	;3,7,23,19
		dc.w	$4035,4,21,17,1,5	;5,1,17,21
		dc.w	$4035,4,16,20,4,0	;0,4,20,16
		dc.w	$4035,4,22,18,2,6	;6,2,18,22
		dc.w	$4031,8,22,20,16,17,21,23,19,18	;18,19,23,21,17,16,20,22

		dc.w	$4033,4,11,10,2,3	;3,2,10,11	;right side
		dc.w	$4033,4,13,15,7,5	;5,7,15,13
		dc.w	$4033,4,8,9,1,0		;0,1,9,8
		dc.w	$4033,4,14,12,4,6	;6,4,12,14
		dc.w	$4035,4,15,11,3,7	;7,3,11,15
		dc.w	$4035,4,9,13,5,1	;1,5,13,9
		dc.w	$4035,4,12,8,0,4	;4,0,8,12
		dc.w	$4035,4,10,14,6,2	;2,6,14,10
		dc.w	$4031,8,15,13,9,8,12,14,10,11	;11,10,14,12,8,9,13,15

bouncebombc:	dc.w	200

		dc.w	1

		dc.w	-40,-40,-40
		dc.w	80,80,80
		dc.w	static+bombCODE

