*************************** Bouncer Control Routines *************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

******************* Bouncer Waiting For A Target To Get Close ****************

dobouncer1wait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	bouncercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodebouncer

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)
		bgt.s	.done
		move.w	#longaidelay,iotimer(a0)

		bsr	rangetarget    		;wait until a target gets close
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dobouncer1boing,ido(a0)	;set the bouncer bouncing

		bsr	randombounce
.done:
		rts

*************************** Bouncer Bouncing Around **************************

dobouncer1boing:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		bsr	doobjcoll		;deal with collisions
		bsr	bouncercollide
		tst.w	ioenergy(a0)
		ble	explodebouncer

		move.l	iocollfloor(a0),d1	;check for hitting the floor
		beq.s	.bouncing
		clr.l	iocollfloor(a0)
		add.l	d1,isycoord(a0)
		neg.w	ioyspeed(a0)
		sub.w	#gravity,ioyspeed(a0)	;decay bounce and check for
		cmp.w	#2*gravity,ioyspeed(a0)	;bounce again
		bgt.s	.bouncing

		bsr	confirmtarget		;only bounce again if
		beq	.losttarget		;the target is still close

		jsr	random			;usually bounce at random
		and.w	#3,d0			;but every now and then
		beq.s	.attarget		;bounce towards the target
		bsr	randombounce
		bra.s	.bouncing
.attarget:
		move.l	iotarget(a0),a1
		move.l	isxcoord(a1),d0
		move.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		asr.l	#6,d0
		moveq.l	#terminalv,d1
		asr.l	#6,d2
		movem.w	d0-d2,ioxspeed(a0)
.bouncing:
		move.l	isanimframe(a0),d0
		addq.l	#1,d0
		cmp.l	#22,d0
		blt.s	.animok
		moveq.l	#0,d0
.animok:
		move.l	d0,isanimframe(a0)

		movem.w	ioxspeed(a0),d0-d2	;add on gravity
		sub.w	#gravity,d1
		cmp.w	#-terminalv,d1
		bge.s	.notfast
		move.w	#-terminalv,d1
.notfast:
		movem.w	d0-d2,ioxspeed(a0)	;update position
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	isxcoord(a0),d0
		add.l	isycoord(a0),d1
		add.l	iszcoord(a0),d2

		cmp.l	iominx(a0),d0		;clip position to boundaries
		bge.s	.xnotlow		;and ricochet off
		move.l	iominx(a0),d0
		neg.w	ioxspeed(a0)
		bra.s	.xnothigh
.xnotlow:
		cmp.l	iomaxx(a0),d0
		ble.s	.xnothigh
		move.l	iomaxx(a0),d0
		neg.w	ioxspeed(a0)
.xnothigh:
		cmp.l	iominz(a0),d2
		bge.s	.znotlow
		move.l	iominz(a0),d2
		neg.w	iozspeed(a0)
		bra.s	.znothigh
.znotlow:
		cmp.l	iomaxz(a0),d2
		ble.s	.znothigh
		move.l	iomaxz(a0),d2
		neg.w	iozspeed(a0)
.znothigh:
		movem.l	d0-d2,isxcoord(a0)
.done:
		rts
.losttarget:
		move.l	#dobouncer1wait,ido(a0)
		rts

******************* Bouncer Waiting For A Target To Get Close ****************

dobouncer2wait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	bouncercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodebouncer

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)
		bgt.s	.done
		move.w	#longaidelay,iotimer(a0)

		bsr	rangetarget    		;wait until a target gets close
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dobouncer2boing,ido(a0)	;set the bouncer bouncing

		bsr	randombounce
.done:
		rts

*************************** Bouncer Bouncing Around **************************

dobouncer2boing:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		bsr	doobjcoll		;deal with collisions
		bsr	bouncercollide
		tst.w	ioenergy(a0)
		ble	explodebouncer

		bsr	rotatetotarget
		subq.w	#1,iotimer2(a0)
		bpl.s	.noshoot
		move.w	#20,iotimer2(a0)
		bsr	createenemyfrontlaser1
.noshoot:

		move.l	iocollfloor(a0),d1	;check for hitting the floor
		beq.s	.bouncing
		clr.l	iocollfloor(a0)
		add.l	d1,isycoord(a0)
		neg.w	ioyspeed(a0)
		sub.w	#gravity,ioyspeed(a0)	;decay bounce and check for
		cmp.w	#2*gravity,ioyspeed(a0)	;bounce again
		bgt.s	.bouncing

		bsr	confirmtarget		;only bounce again if
		beq	.losttarget		;the target is still close

		jsr	random			;usually bounce at random
		and.w	#3,d0			;but every now and then
		beq.s	.attarget		;bounce towards the target
		bsr	randombounce
		bra.s	.bouncing
.attarget:
		move.l	iotarget(a0),a1
		move.l	isxcoord(a1),d0
		move.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		asr.l	#6,d0
		moveq.l	#terminalv,d1
		asr.l	#6,d2
		movem.w	d0-d2,ioxspeed(a0)
.bouncing:
		move.l	isanimframe(a0),d0
		addq.l	#1,d0
		cmp.l	#22,d0
		blt.s	.animok
		moveq.l	#0,d0
.animok:
		move.l	d0,isanimframe(a0)

		movem.w	ioxspeed(a0),d0-d2	;add on gravity
		sub.w	#gravity,d1
		cmp.w	#-terminalv,d1
		bge.s	.notfast
		move.w	#-terminalv,d1
.notfast:
		movem.w	d0-d2,ioxspeed(a0)	;update position
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	isxcoord(a0),d0
		add.l	isycoord(a0),d1
		add.l	iszcoord(a0),d2

		cmp.l	iominx(a0),d0		;clip position to boundaries
		bge.s	.xnotlow		;and ricochet off
		move.l	iominx(a0),d0
		neg.w	ioxspeed(a0)
		bra.s	.xnothigh
.xnotlow:
		cmp.l	iomaxx(a0),d0
		ble.s	.xnothigh
		move.l	iomaxx(a0),d0
		neg.w	ioxspeed(a0)
.xnothigh:
		cmp.l	iominz(a0),d2
		bge.s	.znotlow
		move.l	iominz(a0),d2
		neg.w	iozspeed(a0)
		bra.s	.znothigh
.znotlow:
		cmp.l	iomaxz(a0),d2
		ble.s	.znothigh
		move.l	iomaxz(a0),d2
		neg.w	iozspeed(a0)
.znothigh:
		movem.l	d0-d2,isxcoord(a0)
.done:
		rts
.losttarget:
		move.l	#dobouncer2wait,ido(a0)
		rts

***************************** Bouncer Subroutines ****************************

bouncercollide:	tst.l	iocollcode(a0)
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

randombounce:	jsr	random
		move.w	d0,d2
		swap	d0
		move.l	#$7fff,d3
		and.l	d3,d0
		and.l	d3,d2
		move.w	#350,d3
		divu	d3,d0
		divu	d3,d2
		swap	d0
		swap	d2
		asr.w	d3
		sub.w	d3,d0
		sub.w	d3,d2
		moveq.l	#terminalv,d1
		movem.w	d0-d2,ioxspeed(a0)
		rts

explodebouncer:	move.l	#dosmallbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makebouncer:	bsr	getempty		;make a bouncer

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)

		move.l	#midrange,iorange(a1)

		sub.l	d0,d3			;get a random position
		sub.l	d2,d5			;inside the boundary
		move.l	d0,-(sp)
		jsr	random
		move.l	d0,d7
		move.l	(sp)+,d0

		and.l	#$00f800f8,d7
		move.w	d7,d6
		swap	d7
		mulu	d6,d3
		mulu	d7,d5
		asr.l	#8,d3
		asr.l	#8,d5
		add.l	d3,d0
		add.l	d5,d2
		movem.l	d0-d2,isxcoord(a1)

		move.l	#bounceranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#bouncerTYPE,iotype(a1)
		move.w	#bouncerENERGY,ioenergy(a1)
		move.w	#bouncerDAMAGE,iodamage(a1)

		jsr	random			;ai timer
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		addq.w	#1,baddies

		move.l	index,d0
		cmp.l	#1,d0
		beq.s	.type2
.type1:
		move.l	#dobouncer1wait,ido(a1)
		rts
.type2:
		move.l	#dobouncer2wait,ido(a1)

		move.w	#20,iotimer2(a1)	;shooting timer

		move.w	#0,iobarrelx(a1)
		move.w	#0,iobarrely(a1)
		move.w	#100,iobarrelz(a1)
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
bounceranim:	dc.l	bouncer3vdf	;0
		dc.l	bouncer4vdf	;1
		dc.l	bouncer5vdf	;2
		dc.l	bouncer5vdf	;3
		dc.l	bouncer4vdf	;4
		dc.l	bouncer3vdf	;5
		dc.l	bouncer2vdf	;6
		dc.l	bouncer1vdf	;7
		dc.l	bouncer1vdf	;8
		dc.l	bouncer2vdf	;9
		dc.l	bouncer3vdf	;10
		dc.l	bouncer4vdf	;11
		dc.l	bouncer5vdf	;12
		dc.l	bouncer5vdf	;13
		dc.l	bouncer4vdf	;14
		dc.l	bouncer3vdf	;15
		dc.l	bouncer2vdf	;16
		dc.l	bouncer1vdf	;17
		dc.l	bouncer1vdf	;18
		dc.l	bouncer2vdf	;19
		dc.l	bouncer3vdf	;20
		dc.l	bouncer3vdf	;21

********************************* VDF Files **********************************

bouncer1vdf:	incbin	"graphics\\shapes\\enemies\\bounce01.vdf"
bouncer2vdf:	incbin	"graphics\\shapes\\enemies\\bounce02.vdf"
bouncer3vdf:	incbin	"graphics\\shapes\\enemies\\bounce03.vdf"
bouncer4vdf:	incbin	"graphics\\shapes\\enemies\\bounce04.vdf"
bouncer5vdf:	incbin	"graphics\\shapes\\enemies\\bounce05.vdf"

