****************************** Drone Control File ****************************

* Notes:


********************************* Code Section *******************************

		text
		.68000

********************************* Player Drone *******************************

dodrone:	move.l	iotarget(a0),a1		;move into position
		movem.l	isxcoord(a1),d0-d2	;above my owner
		add.l	#dronealtitude,d1
		tst.w	iowarped(a1)
		beq.s	.nowarp
		sub.l	isxcoord(a0),d0
		sub.l	isycoord(a0),d1
		sub.l	iszcoord(a0),d2
		asr.l	#2,d0
		asr.l	#2,d1
		asr.l	#2,d2
		add.l	isxcoord(a0),d0
		add.l	isycoord(a0),d1
		add.l	iszcoord(a0),d2
.nowarp:
		movem.l	d0-d2,isxcoord(a0)

		move.w	#enemyCLASS,d0
		move.w	d0,d1
		bsr	closestobject
		move.l	a1,d0
		beq.s	.notarget

		move.l	isxcoord(a1),d0		;make sure the target is
		sub.l	isxcoord(a0),d0		;close enough to bother with
		bpl.s	.xpos
		neg.l	d0
.xpos:
		cmp.l	#10000,d0
		bge.s	.notarget

		move.l	isycoord(a1),d0
		sub.l	isycoord(a0),d0
		bpl.s	.ypos
		neg.l	d0
.ypos:
		cmp.l	#10000,d0
		bge.s	.notarget

		move.l	iszcoord(a1),d0
		sub.l	iszcoord(a0),d0
		bpl.s	.zpos
		neg.l	d0
.zpos:
		cmp.l	#10000,d0
		bge.s	.notarget

		move.l	iotarget(a0),-(sp)	;yes, it's a valid target
		move.l	a1,iotarget(a0)
		bsr	rotatetotarget
		move.l	(sp)+,iotarget(a0)

		subq.w	#1,iotimer(a0)		;shoot at it now and then
		bpl.s	.notarget
		move.w	#10,iotimer(a0)
		bsr	createdronefrontlasers
.notarget:
		bsr	doobjcoll		;deal with collisions
		tst.l	iocollcode(a0)
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,iodamage(a0)
		bpl.s	.nocollide

		move.l	#dosmallbang,ido(a0)
.nocollide:
		rts

****************************** Object Generators *****************************

createdrone:	movem.l	d0-d7/a0-a6,-(sp)

		lea	world,a2		;first check to see if
		move.w	#droneTYPE,d0		;a drone object already
		move.l	ifirst(a2),d7		;exists for this player
		beq.s	.empty
.finddrone:
		move.l	d7,a2

		cmp.w	iotype(a2),d0		;must be a drone
		bne.s	.next			;belonging to this player
		cmp.l	iotarget(a2),a0
		bne.s	.next

		move.l	ioweapons(a0),a1   	;reset the drone's firepower
		moveq.l	#0,d0			;as the drone's new mark
		move.b	WEAPON_DRONE(a1),d0
		move.w	d0,iopower(a2)
		bra	.done
.next:
		move.l	inext(a2),d7
		bne.s	.finddrone
.empty:
		move.l	ioweapons(a0),a1
		moveq.l	#0,d0
		move.b	WEAPON_DRONE(a1),d0
		beq	.done
		move.w	d0,iopower(a0)

		bsr	getempty		;create a new player drone
		beq.s	.done

		move.l	#dodrone,ido(a1)
		move.l	#droneanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d1-d7/a2-a3
		movem.w	d1-d7/a2-a3,isxx(a1)

		move.w	#0,iobarrelx(a0)
		move.w	#dronealtitude,iobarrely(a0)
		move.w	#0,iobarrelz(a0)
		moveq.l	#0,d0
		bsr	movetobarrel

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#droneTYPE,iotype(a1)
		move.w	#droneENERGY,ioenergy(a1)
		move.w	#droneDAMAGE,iodamage(a1)

		move.w	#0,iobarrelx(a1)
		move.w	#0,iobarrely(a1)
		move.w	#200,iobarrelz(a1)
		move.w	iopower(a0),iopower(a1)

		move.w	#10,iotimer(a1)

		move.l	a0,iotarget(a1)		;the player that I belong to
.done:
		movem.l	(sp)+,d0-d7/a0-a6
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

********************************* Animations *********************************

		phrase

droneanim:	dc.l	dronevdf

********************************** VDF Files *********************************

dronevdf:	incbin	"graphics\\shapes\\addons\\drone.vdf"

