***************************** Dropship Control File **************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

******************* Dropship Waiting And Scanning For Targets ****************

dodropshipwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	dropshipcollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodedropship

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)		;look for a target
		bne.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dodropshiplineup,ido(a0)	;we have a target!
.done:
		rts

********************* Bomber Lining Up Behind It's Target ********************

dodropshiplineup:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		jsr	doobjcoll		;deal with collisions
		bsr	dropshipcollide
		tst.w	ioenergy(a0)
		ble	explodedropship

		bsr	confirmtarget		;target still available?
		beq.s	.losttarget		;no...
		bsr	flatrotatetotarget  	;rotate towards the target
		bsr	flatmoveobject	    	;and move towards the target
		bsr	maintainheight		;maintain height above target

		move.l	iotarget(a0),a1		;control the dropship's speed
		move.w	iszx(a0),d0		;based on distance to
		move.w	iszz(a0),d2		;drop zone
		ext.l	d0
		ext.l	d2
		asr.l	#4,d0
		asr.l	#4,d2
		neg.l	d0
		neg.l	d2
		add.l	isxcoord(a1),d0
		add.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		muls	d0,d0
		muls	d2,d2
		add.l	d2,d0
		cmp.l	#800*800,d0
		ble.s	.attack
.speedup:
		addq.w	#8,iozspeed(a0)
		cmp.w	#200,iozspeed(a0)
		ble.s	.done
		move.w	#200,iozspeed(a0)
.done:
		rts
.attack:
		move.l	#dodropshipattack,ido(a0)	;attack the target
		rts
.losttarget:
		move.l	#dodropshipwait,ido(a0)	;reaquire target
		rts

**************** Dropship Flying Over Target And Dropping Tank ***************

dodropshipattack:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		jsr	doobjcoll		;deal with collisions
		bsr.s	dropshipcollide
		tst.w	ioenergy(a0)
		ble	explodedropship

		bsr	flatmoveobject		;move towards target
		bsr	maintainheight		;maintain height above target

		move.l	iotarget(a0),a1		;find drop zone
		move.l	isxcoord(a1),d0
		move.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		muls	d0,d0
		muls	d2,d2
		add.l	d2,d0
		cmp.l	#800*800,d0
		bge.s	.slowdown
.speedup:
		addq.w	#8,iozspeed(a0)		;if within attack distance
		cmp.w	#200,iozspeed(a0)	;speed up and drop an enemy
		ble.s	.notfast
		move.w	#200,iozspeed(a0)
.notfast:
		tst.w	iotimer2(a0)
		bne.s	.done
		move.w	#1,iotimer2(a0)
		bsr	createdroptank
.done:
		rts
.slowdown:
		subq.w	#4,iozspeed(a0)		;if outside attack distance
		cmp.w	#30,iozspeed(a0)	;slow down and start
		bge.s	.notslow		;new attack
		move.w	#30,iozspeed(a0)
		move.l	#dodropshipwait,ido(a0)
		clr.w	iotimer2(a0)
.notslow:
		rts

***************************** Dropship Subroutines ***************************

dropshipcollide:
		tst.l	iocollcode(a0)
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodedropship:
		move.l	#dosmallbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makedropship:	bsr	getempty		;make a dropship object

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#longrange,iorange(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dodropshipwait,ido(a1)
		move.l	#dropshipanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#dropshipTYPE,iotype(a1)
		move.w	#dropshipENERGY,ioenergy(a1)
		move.w	#dropshipDAMAGE,iodamage(a1)

		jsr	random			;this is so they don't
		and.w	#31,d0			;all look for targets
		addq.w	#1,d0			;on the same update
		move.w	d0,iotimer(a1)

		clr.w	enemiesdropped

		move.w	#0,iobarrelx(a1)
		move.w	#-200,iobarrely(a1)
		move.w	#-200,iobarrelz(a1)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

		even

enemiesavailable:
		dc.w	1

********************************* Animations *********************************

		phrase
dropshipanim:	dc.l	dropshipvdf

********************************** VDF Files *********************************

dropshipvdf:	incbin	"graphics\\shapes\\enemies\\dropship.vdf"

********************************* BSS Section ********************************

		bss

********************************** Variables *********************************

		even

enemiesdropped:	ds.w	1


