*************************** End Boss Control Routines ************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

************************* Player Update For End Boss *************************

dobossplayer:	bsr	aimcursor
		bsr	shootpod
		bsr	checkdoneit
		rts

aimcursor:	move.l	iocontroller(a0),a1
		move.l	(a1),d7

		movem.w	ioxspeed(a0),d0-d1

		btst	#LEFT_B,d7
		beq.s	.noleft
		subq.w	#4,d0
		cmp.w	#-15,d0
		bge.s	.noright
		move.w	#-15,d0
		bra.s	.noright
.noleft:
		btst	#RIGHT_B,d7
		beq.s	.noright
		addq.w	#4,d0
		cmp.w	#15,d0
		ble.s	.noright
		move.w	#15,d0
.noright:
		btst	#UP_B,d7
		beq.s	.noup
		addq.w	#4,d1
		cmp.w	#15,d1
		ble.s	.nodown
		move.w	#15,d1
		bra.s	.nodown
.noup:
		btst	#DOWN_B,d7
		beq.s	.nodown
		subq.w	#4,d1
		cmp.w	#-15,d1
		bge.s	.nodown
		move.w	#-15,d1
.nodown:
		tst.w	d0
		beq.s	.xok
		bmi.s	.xneg
.xpos:
		subq.w	#2,d0
		bge.s	.xok
		moveq.l	#0,d0
		bra.s	.xok
.xneg:
		addq.w	#2,d0
		ble.s	.xok
		moveq.l	#0,d0
.xok:
		tst.w	d1
		beq.s	.yok
		bmi.s	.yneg
.ypos:
		subq.w	#2,d1
		bge.s	.yok
		moveq.l	#0,d1
		bra.s	.yok
.yneg:
		addq.w	#2,d1
		ble.s	.yok
		moveq.l	#0,d1
.yok:
		movem.w	d0-d1,ioxspeed(a0)

		move.l	ioweapons(a0),a1
		add.w	CROSSX(a1),d0
		add.w	CROSSY(a1),d1
		cmp.w	#-130,d0
		bge.s	.xnotlow
		move.w	#-130,d0
		bra.s	.xnothigh
.xnotlow:
		cmp.w	#130,d0
		ble.s	.xnothigh
		move.w	#130,d0
.xnothigh:
		cmp.w	#-60,d1
		bge.s	.ynotlow
		move.w	#-60,d1
		bra.s	.ynothigh
.ynotlow:
		cmp.w	#60,d1
		ble.s	.ynothigh
		move.w	#60,d1
.ynothigh:
		movem.w	d0-d1,CROSSX(a1)
		rts

shootpod:	tst.w	iotimer(a0)
		bne.s	.cantshoot

		tst.w	bossammo
		ble.s	.noshoot

		move.l	iocontroller(a0),a1
		move.l	(a1),d7

		btst	#FIRE_B,d7
		beq.s	.noshoot

		bsr	createbossdatapod
		move.w	#10,iotimer(a0)
.noshoot:
		rts
.cantshoot:
		subq.w	#1,iotimer(a0)
		rts

checkdoneit:	tst.w	dataports
		bgt.s	.notyet
		bsr	scaleit
.notyet:
		rts

******************************** Object Updates ******************************

dobossdatapod:	subq.w	#1,iotimer(a0)		;should we kill the pod?
		ble.s	.killit

		bsr	doobjcoll

		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)

		cmp.w	#dataportCODE,d0
		beq.s	.onein
		move.l	#dosmallbang,ido(a0)
.nocollide:
		movem.l	isxcoord(a0),d0-d2	;move the pod
		movem.w	ioxspeed(a0),d3-d5
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2
		movem.l	d0-d2,isxcoord(a0)

		movem.w	ioxangle(a0),d0-d2	;spin the pod
		move.w	#2047,d3
		add.w	ioxrot(a0),d0
		add.w	ioyrot(a0),d1
		add.w	iozrot(a0),d2
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		jsr	anglematrix
		rts
.onein:
		moveq.l	#SFX_COLLECT,d7
		jsr	ADD_SFX

		move.l	iocollobj(a0),a1
		subq.w	#1,ioenergy(a1)
		move.w	#4,ioshield(a1)
.killit:
		bsr	killobject		;kill the bugger
		rts

****************************** Data Port Update ******************************
******************************* Pretty Cryptic *******************************

dodataport:	tst.w	ioxspeed(a0)		;should we animate the jaws?
		beq.s	.waiting
.animating:
		move.l	isanimframe(a0),d0	;animate the jaws
		move.w	ioxspeed(a0),d1
		ext.l	d1
		add.l	d1,d0
		move.l	d0,isanimframe(a0)
		beq.s	.waitagain
		cmp.l	#3,d0
		beq.s	.waitagain
		bra.s	.done
.waitagain:
		clr.w	ioxspeed(a0)		;jaws are open/closed
		tst.l	isanimframe(a0)
		bne.s	.opened
.closed:
		move.w	#20,iotimer(a0)		;stay closed for 20 frames
		bra.s	.done
.opened:
		move.w	#80,iotimer(a0)		;stay open for 80 frames
		bra.s	.done
.waiting:
		tst.w	ioshield(a0)
		beq.s	.yeswait
		subq.w	#1,ioshield(a0)
		clr.w	iotimer(a0)
		bra.s	.chomping
.yeswait:
		tst.w	ioenergy(a0)		;is it full?
		ble	.gotone

		subq.w	#1,iotimer(a0)		;wait to animate
		bpl.s	.done
.chomping:
		tst.l	isanimframe(a0)
		beq.s	.open
.close:
		move.w	#-1,ioxspeed(a0)	;animate closed
		bra.s	.done
.open:
		move.w	#1,ioxspeed(a0)		;animate open
.done:

		move.w	ioyrot(a0),d0		;bob up and down
		cmp.w	ioxrot(a0),d0
		beq.s	.ok
		blt.s	.up
.down:
		subq.w	#2,d0
		cmp.w	ioxrot(a0),d0
		bgt.s	.ok
		move.w	ioxrot(a0),d0
		bra.s	.ok
.up:
		addq.w	#2,d0
		cmp.w	ioxrot(a0),d0
		blt.s	.ok
		move.w	ioxrot(a0),d0
.ok:
		move.w	d0,ioyrot(a0)
		add.w	ioyangle(a0),d0
		and.w	#2047,d0
		move.w	d0,ioyangle(a0)
		bsr	sincos
		muls	#900,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		ext.l	d0
		add.l	iominx(a0),d0
		move.l	d0,isycoord(a0)
		rts
.gotone:
		move.l	#dobigbang,ido(a0)	;blow up when full
		subq.w	#1,dataports
		bgt.s	.notyet
		clr.w	gameoverscale
.notyet:
		rts

****************************** Creation Routines *****************************

createbossdatapod:
		bsr	getempty
		beq	.none

		bsr	random
		move.l	d0,d1
		move.w	d0,d2
		swap	d1
		bsr	random
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		jsr	anglematrix

		bsr	random
		move.l	d0,d1
		move.w	d0,d2
		swap	d1
		bsr	random
		move.w	#127,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		asr.w	d3
		sub.w	d3,d0
		sub.w	d3,d1
		sub.w	d3,d2
		movem.w	d0-d2,ioxrot(a1)

		move.l	#dobossdatapod,ido(a1)
		move.l	#datapodanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#datapodTYPE,iotype(a1)
		move.w	#datapodDAMAGE,iodamage(a1)
		move.w	#datapodENERGY,ioenergy(a1)

		move.l	ioweapons(a0),a2
		movem.w	CROSSX(a2),d0-d1
		move.l	#256,d2
		muls	#6,d0
		muls	#6,d1
		muls	#6,d2
		asr.w	#2,d0
		asr.w	#2,d1
		asr.w	#2,d2
		movem.w	d0-d2,ioxspeed(a1)

		add.l	isxcoord(a0),d0
		add.l	isycoord(a0),d1
		add.l	iszcoord(a0),d2
		add.l	#camheight,d1
		add.l	#200,d2
		movem.l	d0-d2,isxcoord(a1)

		move.w	#150,iotimer(a1)

		moveq.l	#SFX_PLAYER_LASER,d7
		jsr	ADD_SFX
.none:
		rts

makedataport:	bsr	getempty		;make data port

		movem.l	position,d0-d2
		add.l	#100,d1
		movem.l	d0-d2,isxcoord(a1)
		move.l	d1,iominx(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#dodataport,ido(a1)
		move.l	#dataportanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#powerupCLASS,ioclass(a1)
		move.w	#powerupTYPE,iotype(a1)
		move.w	#powerupDAMAGE,iodamage(a1)

		move.w	#3,ioenergy(a1)
		clr.w	ioshield(a1)

		clr.w	ioyangle(a1)
		clr.w	ioyrot(a1)

		bsr	random
		and.w	#15,d0
		add.w	#20,d0
		move.w	d0,ioxrot(a1)

		clr.w	ioxspeed(a1)

		jsr	random
		and.w	#31,d0
		add.w	#80,d0
		move.w	d0,iotimer(a1)

		addq.w	#1,dataports
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

dataports:	dc.w	0
bossammo:	dc.w	100

********************************* Animations *********************************

		phrase
dataportanim:	dc.l	dataport1vdf
		dc.l	dataport2vdf
		dc.l	dataport3vdf
		dc.l	dataport4vdf

********************************* VDF Files **********************************

dataport1vdf:	   	incbin	"graphics\\shapes\\world21\\catch1.vdf"
dataport2vdf:	   	incbin	"graphics\\shapes\\world21\\catch2.vdf"
dataport3vdf:	   	incbin	"graphics\\shapes\\world21\\catch3.vdf"
dataport4vdf:	   	incbin	"graphics\\shapes\\world21\\catch4.vdf"

