******************************* NetWar Equates *******************************

* Notes:

***************************** Structure Equates ******************************

******************************** Item Structure ******************************

iparent			equ	0			;parent item
iprev			equ	iparent+4		;previous item
inext			equ	iprev+4			;next item
ifirst			equ	inext+4			;first child item
ilast			equ	ifirst+4		;last child item
ido			equ	ilast+4			;item update routine
idraw			equ	ido+4			;item draw routine

itemlen			equ	idraw+4

******************************* Shape Structure ******************************

isanimbase		equ	itemlen			;animation bases for simple,med,complex models
isanimframe		equ	isanimbase+4
isxcoord		equ	isanimframe+4		;coordinates
isycoord		equ	isxcoord+4
iszcoord		equ	isycoord+4
isxrotated		equ	iszcoord+4		;rotated coordinates
isyrotated		equ	isxrotated+4
iszrotated		equ	isyrotated+4
isxx			equ	iszrotated+4		;orientation
isxy			equ	isxx+2
isxz			equ	isxy+2
isyx			equ	isxz+2
isyy			equ	isyx+2
isyz			equ	isyy+2
iszx			equ	isyz+2
iszy			equ	iszx+2
iszz			equ	iszy+2
isblowup		equ	iszz+2			;blow up factor
isrezz			equ	isblowup+2		;rezz factor
isonscreen		equ	isrezz+2		;flag object when onscreen

ishapelen		equ	isonscreen+2		;must be long word boundary

***************************** Collision Structure ****************************

iocollcode		equ	ishapelen 		;code after collision
iocollobj		equ	iocollcode+4		;object collided with
iocollfloor		equ	iocollobj+4		;floor collision code

icollidelen		equ	iocollfloor+4

******************************* Object Structure *****************************

ioclass			equ	icollidelen		;object class
iotype			equ	ioclass+2		;object type
ioenergy		equ	iotype+2		;object's energy
ioshield		equ	ioenergy+2		;object's shield
iodamage		equ	ioshield+2		;damage caused to others
iocontroller		equ	iodamage+2		;pointer to controller data
ioxangle		equ	iocontroller+4 		;object angles
ioyangle		equ	ioxangle+2
iozangle		equ	ioyangle+2
ioxrot			equ	iozangle+2    		;object rotations
ioyrot			equ	ioxrot+2
iozrot			equ	ioyrot+2
ioxspeed		equ	iozrot+2		;object speeds
ioyspeed		equ	ioxspeed+2
iozspeed		equ	ioyspeed+2
ioweapons		equ	iozspeed+2		;weapon structure pointer
iobarrelx		equ	ioweapons+4		;gun barrel x
iobarrely		equ	iobarrelx+2		;gun barrel y
iobarrelz		equ	iobarrely+2		;gun barrel z
iopower			equ	iobarrelz+2		;weapon power
iotimer			equ	iopower+2		;some timers
iotimer1		equ	iotimer+2
iotimer2		equ	iotimer1+2
iotarget		equ	iotimer2+2		;target object pointer
iorange			equ	iotarget+4		;range for target aquisition
iominx			equ	iorange+4		;boundaries for movement
iominy			equ	iominx+4
iominz			equ	iominy+4
iomaxx			equ	iominz+4
iomaxy			equ	iomaxx+4
iomaxz			equ	iomaxy+4
ioswitch		equ	iomaxz+4		;activating switch
iodestination		equ	ioswitch+2		;which destination
iowarped		equ	iodestination+2		;flag for warping

iobjectlen		equ	iowarped+2

****************************** Camera Structure ******************************

iccontroller		equ	itemlen	    		;controller pointer
icxcoord		equ	iccontroller+4		;camera coordinates
icycoord		equ	icxcoord+4
iczcoord		equ	icycoord+4
icxx			equ	iczcoord+4		;camera orientation
icxy			equ	icxx+2
icxz			equ	icxy+2
icyx			equ	icxz+2
icyy			equ	icyx+2
icyz			equ	icyy+2
iczx			equ	icyz+2
iczy			equ	iczx+2
iczz			equ	iczy+2
ictarget		equ	iczz+2			;pointer to target object
icxangle		equ	ictarget+4		;camera angles
icyangle		equ	icxangle+2
iczangle		equ	icyangle+2
icxrot			equ	iczangle+2		;camera rotations
icyrot			equ	icxrot+2
iczrot			equ	icyrot+2
icdist			equ	iczrot+2		;camera distance from target
iczoom			equ	icdist+2		;camera distance zoom
icclx			equ	iczoom+2		;camera window
iccly			equ	icclx+2
icchx			equ	iccly+2
icchy			equ	icchx+2
icgox			equ	icchy+2
icgoy			equ	icgox+2

icamlen			equ	icgoy+2

******************************* Control Equates ******************************

****************************** Object Class Codes ****************************

arenaCLASS		equ	1
enemyCLASS  		equ	2
explodeCLASS		equ	3
featureCLASS		equ	4
miscellaneousCLASS	equ	5
playerCLASS		equ	6
powerupCLASS		equ	7
weaponCLASS		equ	8

****************************** Object Type Codes *****************************

roomTYPE		equ	000	;arena types
playerTYPE		equ	001	;player types
explodeTYPE		equ	002

bombTYPE		equ	100	;weapon types
laserTYPE		equ	101
mineTYPE		equ	102
missileTYPE		equ	103
plasmaTYPE		equ	104
droneTYPE		equ	105

powerupTYPE		equ	200	;powerup types

exitTYPE  		equ	300	;feature types
datapodTYPE  		equ	301
databaseTYPE 		equ	302
doorTYPE		equ	303
platformTYPE		equ	304
switchTYPE		equ	305
springTYPE		equ	306
attractTYPE		equ	307
repellTYPE		equ	308
warpTYPE		equ	309
prismTYPE		equ	310
distorterTYPE		equ	311
panelTYPE		equ	312
columnTYPE		equ	313
barrierTYPE		equ	314
spikesTYPE		equ	315
keyTYPE			equ	315

tank1TYPE		equ	400	;enemy types
tank2TYPE		equ	401
tank3TYPE		equ	402
tank4TYPE		equ	403
tank5TYPE		equ	404
launcher1TYPE 		equ	405
launcher2TYPE 		equ	406
launcher3TYPE 		equ	407
mobile1TYPE 		equ	408
mobile2TYPE 		equ	409
layerTYPE		equ	410
gunTYPE   		equ	411
guardTYPE   		equ	412
bomberTYPE  		equ	413
bouncerTYPE		equ	414
fragmentTYPE		equ	415
phaserTYPE   		equ	416
straightTYPE 		equ	417
spiralTYPE   		equ	418
trundlerTYPE 		equ	419
radarTYPE    		equ	420
dropshipTYPE 		equ	421
resmineTYPE 		equ	422
droptankTYPE		equ	423

flyerTYPE		equ	500
bonusTYPE		equ	501
obstacleTYPE		equ	502

******************************** Object Energies *****************************

playerENERGY		equ	999
flyerENERGY		equ	999

droneENERGY		equ	1000

datapodENERGY 		equ	100
databaseENERGY 		equ	100

tank1ENERGY		equ	100
tank2ENERGY		equ	120
tank3ENERGY		equ	140
tank4ENERGY		equ	160
tank5ENERGY		equ	180
launcher1ENERGY		equ	100
launcher2ENERGY		equ	120
launcher3ENERGY		equ	140
mobile1ENERGY 		equ	100
mobile2ENERGY 		equ	150
layerENERGY		equ	100
gunENERGY 		equ	200
guardENERGY   		equ	200
bomberENERGY  		equ	100
bouncerENERGY		equ	50
fragmentENERGY		equ	50
phaserENERGY		equ	300
straightENERGY 		equ	50
spiralENERGY 		equ	50
trundlerENERGY 		equ	200
radarENERGY  		equ	200
dropshipENERGY		equ	100
resmineENERGY		equ	50
droptankENERGY		equ	100

********************************* Object Damages *****************************

roomDAMAGE		equ	0

playerDAMAGE		equ	0

bombDAMAGE		equ	15
laserDAMAGE		equ	10
mineDAMAGE		equ	25
missileDAMAGE		equ	15
plasmaDAMAGE		equ	25
droneDAMAGE		equ	5

powerupDAMAGE		equ	0

exitDAMAGE		equ	0
datapodDAMAGE		equ	0
databaseDAMAGE		equ	0
doorDAMAGE		equ	0
platformDAMAGE		equ	0
switchDAMAGE		equ	0
keyDAMAGE		equ	0
springDAMAGE		equ	0
attractDAMAGE		equ	0
repellDAMAGE		equ	0
warpDAMAGE		equ	0
prismDAMAGE		equ	0
distorterDAMAGE		equ	0
panelDAMAGE		equ	0
columnDAMAGE		equ	0
barrierDAMAGE		equ	30
spikesDAMAGE		equ	100

tank1DAMAGE		equ	5
tank2DAMAGE		equ	5
tank3DAMAGE		equ	5
tank4DAMAGE		equ	5
tank5DAMAGE		equ	5
launcher1DAMAGE		equ	5
launcher2DAMAGE		equ	5
launcher3DAMAGE		equ	5
mobile1DAMAGE 		equ	5
mobile2DAMAGE 		equ	5
layerDAMAGE		equ	5
gunDAMAGE 		equ	5
guardDAMAGE   		equ	5
bomberDAMAGE  		equ	5
bouncerDAMAGE		equ	5
fragmentDAMAGE		equ	5
phaserDAMAGE		equ	5
straightDAMAGE 		equ	5
spiralDAMAGE 		equ	5
trundlerDAMAGE 		equ	5
radarDAMAGE  		equ	5
dropshipDAMAGE		equ	5
resmineDAMAGE		equ	5
droptankDAMAGE		equ	5

******************************* Make Object Tags *****************************

madelistTAG   		equ	-1	;made all objects

makeplayer1TAG 		equ	0	;player objects
makeplayer2TAG 		equ	1

makelaser1tag		equ	2	;powerup objects
makelaser2tag		equ	3
makeplasma1tag		equ	4
makeplasma2tag		equ	5
makeplasma3tag		equ	6
makelauncher1tag	equ	7
makelauncher2tag	equ	8
makelauncher3tag	equ	9
makeshields1tag		equ	10
makeshields2tag		equ	11
makeshields3tag		equ	12
makereargun1tag		equ	13
makereargun2tag		equ	14
makereargun3tag		equ	15
makerearmine1tag	equ	16
makerearmine2tag	equ	17
makerearmine3tag	equ	18
makeautotag		equ	19
makeradar1tag		equ	20
makeradar2tag		equ	21
makedrone1tag		equ	22
makedrone2tag		equ	23
makelifetag		equ	24
makeenergytag		equ	25

makedestinationTAG	equ	26	;feature objects
makeexitTAG 		equ	27
makedatapodTAG 		equ	28
makedatabaseTAG 	equ	29
makelprismTAG  		equ	30
makerprismTAG  		equ	31
maketimedswitchTAG 	equ	32
maketripswitchTAG 	equ	33
makeswitchTAG  		equ	34
makekeyTAG  		equ	35
makedoorTAG		equ	36
makespringTAG  		equ	37
makerepellorTAG 	equ	38
makeattractorTAG	equ	39
makeplatformTAG    	equ	40
makewarpTAG   		equ	41
makedistorterTAG	equ	42
makefloorpanelTAG	equ	43
makecolumnTAG		equ	44
maketimedbarrierTAG	equ	45
makebarrierTAG		equ	46
makespikesTAG		equ	47

maketankTAG		equ	48	;enemy objects
makelauncherTAG		equ	49
makemobileTAG		equ	50
makelayerTAG		equ	51
makegunTAG   		equ	52
makeguardTAG   		equ	53
makebomberTAG  		equ	54
makebouncerTAG		equ	55
makefragmentorTAG	equ	56
makephaserTAG		equ	57
makehomerTAG		equ	58
maketrundlerTAG		equ	59
makeradarTAG		equ	60
makedropshipTAG		equ	61
makeresmineTAG		equ	62

makedataporttag		equ	63

*************************** Collision Detection Codes ************************

collidemask		equ	$ffff>>6	;to mask out coding bits

typebits		equ	13		;top three bits are box type codes for my mapper
solidbit		equ	12		;sets a collision box as solid
staticbit		equ	11		;sets a collision box as immovable
floorbit		equ	10		;sets a collision box as a floor

objectbox		equ	7		;sets an object box
facingbox     		equ	6		;sets a facing box
switchbox     		equ	5		;sets a switch box
destinationbox		equ	4		;sets a destination box
indexbox		equ	3		;sets an index box
volumebox		equ	2		;sets a volume box
panningcambox		equ	1		;sets a panning camera box
collisionbox		equ	0		;sets a normal collision box

objecttype		equ	7<<typebits
facingtype		equ	6<<typebits
switchtype		equ	5<<typebits
destinationtype		equ	4<<typebits
indextype		equ	3<<typebits
volumetype		equ	2<<typebits
panningcamtype		equ	1<<typebits
collisiontype		equ	0<<typebits

solid			equ	1<<solidbit
static			equ	1<<staticbit
floor			equ	1<<floorbit

stopCODE		equ	001
playerCODE		equ	002
explodeCODE		equ	003

powerupCODE		equ	100

bombCODE		equ	200
laserCODE		equ	201
mineCODE		equ	202
missileCODE		equ	203
plasmaCODE		equ	204
droneCODE		equ	205
shieldCODE		equ	206

exitCODE		equ	300
datapodCODE		equ	301
databaseCODE		equ	302
attractCODE		equ	303
doorCODE		equ	304
distorterCODE		equ	305
lprismCODE		equ	306
platformCODE		equ	307
repellCODE		equ	308
rprismCODE		equ	309
tripswitchCODE		equ	310
springCODE		equ	311
warpCODE		equ	312
panelCODE		equ	stopCODE
columnCODE		equ	stopCODE
barrierCODE		equ	313
spikesCODE		equ	314
keyCODE			equ	315

tankCODE		equ	400
launcherCODE		equ	401
mobileCODE		equ	402
layerCODE		equ	403
gunCODE			equ	404
guardCODE		equ	405
bomberCODE		equ	406
bouncerCODE		equ	407
fragmentCODE		equ	408
phaserCODE		equ	409
straightCODE		equ	410
spiralCODE		equ	411
trundlerCODE		equ	412
radarCODE		equ	413
dropshipCODE		equ	414
resmineCODE		equ	415
droptankCODE		equ	416

flyerCODE		equ	500
bonusCODE		equ	501
obstacleCODE		equ	502

dataportCODE		equ	600

playertankCODE		equ	solid+playerCODE

******************************* Camera Equates *******************************

camsize			equ	200	   	;camera size,used in arena volumes
camheight		equ	200		;height of viewpoint above object

mincamdist		equ	400
maxcamdist		equ	2000
midcamdist		equ	mincamdist+((maxcamdist-mincamdist)/2)

camxangle		equ	2048-32
camyangle		equ	0
camzangle		equ	0

cameramessagetime	equ	60*1

maxpanningcams		equ	100
maxvolumes		equ	150

cockpitcam		equ	1
floatingcam		equ	2
fixedcam		equ	3
closefixedcam		equ	4
panningcam		equ	5

*********************************** AI Equates *******************************

longrange		equ	7000		;distance for long range enemies
midrange		equ	5000		;distance for medium range enemies
shortrange		equ	2000		;distance for short range enemies

longaidelay		equ	12		;long delay for ai
midaidelay		equ	8		;medium delay for ai
shortaidelay		equ	2		;short delay for ai

****************************** Miscellaneous Equates *************************

maxplayers		equ	2		;maximum players
maxammo			equ	100		;maximum ammo
maxempties		equ	200		;maximum objects
maxswitches		equ	50		;maximum switches per level
maxdestinations		equ	50		;maximum warp destinations

gravity			equ	9	  	;gravitational constant
terminalv		equ	10*gravity	;terminal velocity
doorspeed		equ	30		;for sliding doors

horizonz		equ	100000		;distance of horizon

roomspacing		equ	200000
gridsize		equ	10
minespacing		equ	300
laserspacing		equ	50

dronealtitude		equ	400		;distance above player

explosionsize		equ	400		;size of explosion bitmap

immortaltime		equ	200
