*************************** Explosion Control Routines ***********************

******************************** Code Section ********************************

		text
		.68000

****************************** A Tiny Explosion ******************************

dotinybang:	moveq.l	#SFX_SMALL_EXPLOSION,d7
		jsr	ADD_SFX

		move.l	#dotinybang2,ido(a0)
		move.w	#-2,isblowup(a0)
		move.w	#explodeCLASS,ioclass(a0)
		;move.w	#explodeTYPE,iotype(a0)
dotinybang2:
		subq.w	#3,isblowup(a0)
		cmp.w	#-8*2,isblowup(a0)
		blt	killobject
		rts

****************************** A Small Explosion *****************************

dosmallbang:	moveq.l	#SFX_SMALL_EXPLOSION,d7
		jsr	ADD_SFX

		move.l	#dosmallbang2,ido(a0)
		move.w	#-20,isblowup(a0)
		move.w	#explodeCLASS,ioclass(a0)
		;move.w	#explodeTYPE,iotype(a0)
		bsr	createfirehere
dosmallbang2:
		sub.w	#20,isblowup(a0)
		cmp.w	#-25*16,isblowup(a0)
		blt	killobject
		rts

******************************* A Big Explosion ******************************

dobigbang:	move.l	#dobigbang2,ido(a0)	;going.....
		clr.w	isblowup(a0)
		move.w	#explodeCLASS,ioclass(a0)
		;move.w	#explodeTYPE,iotype(a0)
		move.w	#1,iotimer(a0)
		move.w	#3,iotimer1(a0)

dobigbang2:	subq.w	#2,isblowup(a0)		;going....
		subq.w	#1,iotimer(a0)
		bne.s	.notyet
		jsr	random
		and.w	#3,d0
		add.w	#2,d0
		move.w	d0,iotimer(a0)

		subq.w	#1,iotimer1(a0)
		bne.s	.chain
		move.l	#dobigbang3,ido(a0)
		moveq.l	#SFX_BIG_EXPLOSION,d7
		jsr	ADD_SFX

		bsr	createfirehere
		rts
.chain:
		moveq.l	#SFX_SMALL_EXPLOSION,d7
		jsr	ADD_SFX

		bsr	createfireclose
.notyet:
		rts

dobigbang3:	sub.w	#70,isblowup(a0)	;gone!
		cmp.w	#-30*50,isblowup(a0)
		blt	killobject
		rts

****************************** A Small Explosion *****************************

dotunnelbang:	move.l	#dotunnelbang2,ido(a0)
		move.w	#-20,isblowup(a0)
		move.w	#explodeCLASS,ioclass(a0)
		;move.w	#explodeTYPE,iotype(a0)

		moveq.l	#SFX_SMALL_EXPLOSION,d7
		jsr	ADD_SFX
dotunnelbang2:
		sub.w	#16,isblowup(a0)
		cmp.w	#-25*16,isblowup(a0)
		blt	killobject
		rts

***************************** A Player Explosion *****************************

doplayerbang:	move.l	ioweapons(a0),a1
		subq.w	#1,PLAYER_LIVES(a1)	;show game over when no lives left
		bgt.s	.notgameover
		clr.w	gameoverscale

		moveq.l	#SAY_GAME_OVER,d7
		jsr	ADD_SFX
.notgameover:
		move.l	#doplayerbang2,ido(a0)	;going.....
		clr.w	isblowup(a0)
		move.w	#explodeCLASS,ioclass(a0)
		;move.w	#explodeTYPE,iotype(a0)
		move.w	#1,iotimer(a0)
		move.w	#3,iotimer1(a0)
		move.w	#-1,ioenergy(a0)

doplayerbang2:	
		subq.w	#2,isblowup(a0)		;going....
		subq.w	#1,iotimer(a0)
		bne.s	.notyet
		jsr	random
		and.w	#3,d0
		add.w	#2,d0
		move.w	d0,iotimer(a0)

		subq.w	#1,iotimer1(a0)
		bne.s	.chain
		move.l	#doplayerbang3,ido(a0)
		moveq.l	#SFX_BIG_EXPLOSION,d7
		jsr	ADD_SFX

		bsr	createfirehere
		rts
.chain:
		moveq.l	#SFX_SMALL_EXPLOSION,d7
		jsr	ADD_SFX

		jsr	createfireclose
.notyet:
		rts

doplayerbang3:	bsr.s	scaleit
		sub.w	#50,isblowup(a0)	;gone!
		cmp.w	#-52*50,isblowup(a0)
		bge.s	.notyet
		move.l	#doplayerregen,ido(a0)
		move.w	#playerCLASS,ioclass(a0)
		move.w	#playerTYPE,iotype(a0)
		move.w	#-52*50,isblowup(a0)
		move.w	#0,ioenergy(a0)
.notyet:
		rts

scaleit:	tst.w	gameoverscale
		bmi.s	.scaleok
		addq.w	#1,gameoverscale
.scaleok:
		rts

****************************** A Flyer Explosion *****************************

doflyerbang:	move.l	#doflyerbang2,ido(a0)	;going.....
		clr.w	isblowup(a0)
		move.w	#explodeCLASS,ioclass(a0)
		;move.w	#explodeTYPE,iotype(a0)
		move.w	#1,iotimer(a0)
		move.w	#3,iotimer1(a0)

doflyerbang2:	bsr	tunnelslowdown
		subq.w	#1,isblowup(a0)		;going....
		subq.w	#1,iotimer(a0)
		bne.s	.notyet
		jsr	random
		and.w	#3,d0
		add.w	#15,d0
		move.w	d0,iotimer(a0)

		subq.w	#1,iotimer1(a0)
		bne.s	.chain
		move.l	#doflyerbang3,ido(a0)
		bsr	createfirehere
		rts
.chain:
		bsr.s	createfireclose
.notyet:
		rts

doflyerbang3:	bsr	tunnelslowdown
		sub.w	#52,isblowup(a0)	;gone!
		cmp.w	#-52*5,isblowup(a0)
		bge.s	.notyet
		move.w	isrezz(a0),d0
		sub.w	#512,d0
		bgt.s	.ok
		moveq.l	#0,d0
		st.b	tunnel_exit
.ok:
		move.w	d0,isrezz(a0)
.notyet:
		rts

tunnelslowdown:	move.w	iozspeed(a0),d0
		asr.w	d0
		sub.w	d0,iozspeed(a0)
		bpl.s	.speedok
		clr.w	iozspeed(a0)
.speedok:
		rts

******************************* Fire Expanding *******************************

dofire: 	subq.w	#3,isblowup(a0)		;blow the fire apart
		cmp.w	#-18*3,isblowup(a0)
		blt	killobject
		rts

******************************* Object Generators ****************************

createfireclose:
		bsr	getempty		;make some fire close
		beq.s	.none			;to object a0's position

		move.l	#dofire,ido(a1)
		move.l	#fireanim,isanimbase(a1)
		jsr	random
		and.l	#3,d0
		move.l	d0,isanimframe(a1)

		jsr	random			;to randomise the offsets
		move.l	d0,d1
		move.l	d0,d2			;bits 0-7 for x
		swap	d1			;bits 16-23 for y
		rol.l	#8,d2			;bits 24-31 for z

		move.l	#$1f0,d3
		and.l	d3,d0
		and.l	d3,d1
		and.l	d3,d2
		lsr.l	d3
		sub.l	d3,d0
		sub.l	d3,d1
		sub.l	d3,d2

		add.l	isxcoord(a0),d0		;add object's position
		add.l	isycoord(a0),d1
		add.l	iszcoord(a0),d2
		movem.l	d0-d2,isxcoord(a1)

		jsr	random
		move.w	d0,d2
		moveq.l	#0,d1
		and.w	#2047,d0
		and.w	#2047,d2
		lea	isxx(a1),a6
		bsr	anglematrix

		move.w	#explodeCLASS,ioclass(a1)
		move.w	#explodeTYPE,iotype(a1)
.none:
		rts

createfirehere:	bsr	getempty		;make some fire at
		beq.s	.none			;object a0's position

		move.l	#dofire,ido(a1)
		move.l	#fireanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.l	isxcoord(a0),d0-d2
		movem.l	d0-d2,isxcoord(a1)

		jsr	random
		move.w	d0,d2
		moveq.l	#0,d1
		and.w	#2047,d0
		and.w	#2047,d2
		lea	isxx(a1),a6
		bsr	anglematrix

		move.w	#explodeCLASS,ioclass(a1)
		move.w	#explodeTYPE,iotype(a0)
.none:
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
fireanim:	dc.l	fire1vdf
		dc.l	fire2vdf
		dc.l	fire3vdf
		dc.l	fire4vdf

********************************** VDF Files *********************************

fire1vdf:	incbin	"graphics\\shapes\\fire\\fire1.vdf"
fire2vdf:	incbin	"graphics\\shapes\\fire\\fire2.vdf"
fire3vdf:	incbin	"graphics\\shapes\\fire\\fire3.vdf"
fire4vdf:	incbin	"graphics\\shapes\\fire\\fire4.vdf"

fire5vdf:	dc.w	fire5c-fire5vdf

fire5s:		dc.w	175

		dc.w	14

		dc.w	0,-100,0,0,0,0			;0

		dc.w	-100,-50,0,0,0,0		;1
		dc.w	-50,-50,-86,0,0,0		;2
		dc.w	50,-50,-86,0,0,0		;3
		dc.w	100,-50,0,0,0,0			;4
		dc.w	50,-50,86,0,0,0			;5
		dc.w	-50,-50,86,0,0,0		;6

		dc.w	-100,50,0,0,0,0			;7
		dc.w	-50,50,-86,0,0,0		;8
		dc.w	50,50,-86,0,0,0			;9
		dc.w	100,50,0,0,0,0			;10
		dc.w	50,50,86,0,0,0			;11
		dc.w	-50,50,86,0,0,0			;12

		dc.w	0,100,0,0,0,0			;13

		dc.w	18

		dc.w	$0101,3,0,2,1	;1,2,0
		dc.w	$0100,3,0,3,2	;2,3,0
		dc.w	$0100,3,0,4,3	;3,4,0
		dc.w	$0101,3,0,5,4	;4,5,0
		dc.w	$0101,3,0,6,5	;5,6,0
		dc.w	$0100,3,0,1,6	;6,1,0

		dc.w	$0101,4,1,2,8,7	;7,8,2,1
		dc.w	$0101,4,2,3,9,8	;8,9,3,2
		dc.w	$0101,4,3,4,10,9	;9,10,4,3
		dc.w	$0100,4,4,5,11,10	;10,11,5,4
		dc.w	$0100,4,5,6,12,11	;11,12,6,5
		dc.w	$0100,4,6,1,7,12	;12,7,1,6

		dc.w	$0100,3,13,11,12	;12,11,13
		dc.w	$0101,3,13,10,11	;11,10,13
		dc.w	$0100,3,13,9,10		;10,9,13
		dc.w	$0101,3,13,8,9		;9,8,13
		dc.w	$0100,3,13,7,8		;8,7,13
		dc.w	$0101,3,13,12,7		;7,12,13

fire5c:		dc.w	175

		dc.w	1

		dc.w	-100,-100,-100
		dc.w	200,200,200
		dc.w	static+explodeCODE


fire6vdf:	dc.w	fire6c-fire6vdf

fire6s:		dc.w	250

		dc.w	4

		dc.w	-50,-30,-50,0,0,0	;0
		dc.w	50,-30,-50,0,0,0	;1
		dc.w	0,-30,50,0,0,0		;2
		dc.w	0,30,0,0,0,0		;3

		dc.w	4

		dc.w	$0101,3,3,0,1
		dc.w	$0100,3,3,1,2
		dc.w	$0101,3,3,2,0
		dc.w	$0100,3,2,1,0

fire6c:		dc.w	250

		dc.w	1

		dc.w	-100,-75,-100
		dc.w	200,150,200
		dc.w	static+explodeCODE

