******************************* Feature Updates ******************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

******************************** Feature Updates *****************************

doexitdoors1:	move.w	ioxangle(a0),d0		;open the doors so the
		add.w	#40,d0			;player can be driven out
		and.w	#2047,d0
		cmp.w	#1024+512,d0
		ble.s	.opening
		move.w	#1024+512,d0

		move.l	#doexitdoors2,ido(a0)
.opening:
		move.w	d0,ioxangle(a0)

		bsr	sincos
		asr.w	d0
		add.w	#8192,d0
		move.w	d0,isrezz(a0)
		rts

doexitdoors2:	move.w	ioxangle(a0),d0
		sub.w	#40,d0
		and.w	#2047,d0
		cmp.w	#512,d0
		bge.s	.closing
		sf.b	ignoreexit
		move.l	#doexitdoors3,ido(a0)
		clr.l	isanimframe(a0)
		move.w	#512,d0
.closing:
		move.w	d0,ioxangle(a0)

		bsr	sincos
		asr.w	d0
		add.w	#8192,d0
		move.w	d0,isrezz(a0)
		rts
.waiting:
		subq.w	#1,iotimer(a0)
		rts

doexitdoors3:	move.l	joycur1,d0
		btst	#STAR,d0
		beq.s	.no
		clr.w	datapods
		clr.w	databases
.no:

		move.w	datapods,d0		;open the doors when
		or.w	databases,d0		;mission is complete
		bne.s	.stayclosed
.open:
		move.w	ioxangle(a0),d0
		add.w	#40,d0
		and.w	#2047,d0
		cmp.w	#1024+512,d0
		ble.s	.opening

		move.b	#EXITOPENMESSAGE,HUDMESSAGE
		move.w	#100,HUDTIMER
		st	HUDFLASH

		moveq.l	#SFX_SAY_EXIT_OPEN,d7
		jsr	ADD_SFX

		bsr	killobject
		rts
.opening:
		move.w	d0,ioxangle(a0)

		bsr	sincos
		asr.w	d0
		add.w	#8192,d0
		move.w	d0,isrezz(a0)
.stayclosed:
		rts

doexitbeam:	move.l	isanimframe(a0),d0
		addq.l	#1,d0
		and.l	#7,d0
		move.l	d0,isanimframe(a0)
		rts

*********************************** Data Pod *********************************

dodatapodfall:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		bsr	doobjcoll

		move.l	iocollfloor(a0),d0	;invert vertical speed
		beq.s	.yok			;if we hit the floor
		clr.l	iocollfloor(a0)
		add.l	d0,isycoord(a0)
		neg.w	ioyspeed(a0)
		asr.w	ioyspeed(a0)
		cmp.w	#15,ioyspeed(a0)
		bgt.s	.yok
		move.l	#dodatapod,ido(a0)
.yok:
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)

		cmp.w	#playerCODE,d0		;allow player to collect pods
		bne.s	.nocollide
		move.w	#2000,iotimer(a0)	;set the data pod derezzing
.nocollide:
		move.w	isrezz(a0),d0
		sub.w	iotimer(a0),d0
		bpl.s	.stillon
		subq.w	#1,datapods
		move.l	#$1000,d7
		jsr	ADD_TO_SCORE
		bsr	killobject
		bra.s	.done
.stillon:
		move.w	d0,isrezz(a0)

		movem.w	ioxrot(a0),d0-d2
		add.w	ioxangle(a0),d0
		add.w	ioyangle(a0),d1
		add.w	iozangle(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix

		movem.w	ioxspeed(a0),d0-d2
		move.l	d0,d3
		move.l	d2,d5
		asr.l	#2,d3
		asr.l	#2,d5
		sub.l	d3,d0
		sub.l	d5,d2
		sub.l	#gravity,d1
		cmp.l	#-terminalv,d1
		bge.s	.ysok
		move.l	#-terminalv,d1
.ysok:
		movem.w	d0-d2,ioxspeed(a0)
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
.done:
		rts

dodatapod:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		bsr	doobjcoll

		move.l	iocollfloor(a0),d0	;push out of the floor
		beq.s	.yok
		clr.l	iocollfloor(a0)
		add.l	d0,isycoord(a0)
.yok:

		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)

		cmp.w	#playerCODE,d0		;allow player to collect pods
		bne.s	.nocollide

		tst.w	iotimer(a0)
		bne.s	.nocollide

		move.w	#2000,iotimer(a0)	;set the data pod derezzing
		moveq.l	#SFX_COLLECT,d7
		jsr	ADD_SFX

		move.b	#DATAPODMESSAGE,HUDMESSAGE
		move.w	#cameramessagetime,HUDTIMER
		sf.b	HUDFLASH
.nocollide:
		move.w	isrezz(a0),d0
		sub.w	iotimer(a0),d0
		bpl.s	.stillon
		subq.w	#1,datapods
		move.l	#$1000,d7
		jsr	ADD_TO_SCORE
		bsr	killobject
		bra.s	.done
.stillon:
		move.w	d0,isrezz(a0)

		movem.w	ioxrot(a0),d0-d2
		add.w	ioxangle(a0),d0
		add.w	ioyangle(a0),d1
		add.w	iozangle(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
.done:
		rts

*********************************** Data Base ********************************

dodatabase:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		movem.w	ioxrot(a0),d0-d2
		add.w	ioxangle(a0),d0
		add.w	ioyangle(a0),d1
		add.w	iozangle(a0),d2
		and.w	#2047,d0
		and.w	#2047,d1
		and.w	#2047,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		jsr	anglematrix

		move.l	iocollcode(a0),d0
		beq.s	.done
		clr.l	iocollcode(a0)

		move.l	iocollobj(a0),a1	;apply damage and if too much
		move.w	iodamage(a1),d0		;then blow up
		sub.w	d0,ioenergy(a0)
		bpl.s	.done

		bsr	createdatapod		;spew out data pods
		bsr	createdatapod
		bsr	createdatapod

		move.l	#dosmallbang,ido(a0)
		subq.w	#1,databases
		move.l	#$2000,d7
		jsr	ADD_TO_SCORE

		move.b	#DATABASEMESSAGE,HUDMESSAGE
		move.w	#cameramessagetime,HUDTIMER
		sf.b	HUDFLASH
.done:
		rts

********************************* All Doors **********************************

dodoor:		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	readswitch
		beq.s	.inactive

		bsr	rangetarget		;if a player is near open door
		move.l	isanimframe(a0),d0	;otherwise close door
		move.l	a1,d1
		beq.s	.close
.open:
		addq.l	#1,d0
		cmp.l	#8,d0
		ble.s	.ok
		moveq.l	#8,d0
		bra.s	.ok
.close:
		subq.l	#1,d0
		bpl.s	.ok
		moveq.l	#0,d0
.ok:
		move.l	d0,isanimframe(a0)
		rts
.inactive:
		subq.l	#1,isanimframe(a0)	;close the door
		bpl.s	.done			;when inactive
		clr.l	isanimframe(a0)
.done:
		rts

****************************** Various Platforms *****************************

doplatform:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		bsr	readswitch		;if the switch is on
		beq.s	.off			;speed up rotation
		move.w	ioyrot(a0),d0		;if off
		addq.w	#1,d0			;slow down rotation
		cmp.w	#15,d0
		ble.s	.yrotok
		moveq.l	#15,d0
.yrotok:
		move.w	d0,ioyrot(a0)
		bra.s	.setposition
.off:
		tst.w	ioyrot(a0)
		beq.s	.done
		subq.w	#1,ioyrot(a0)
.setposition:
		move.w	ioyangle(a0),d0		;position platform
		add.w	ioyrot(a0),d0		;if moving
		and.w	#2047,d0
		move.w	d0,ioyangle(a0)
		bsr	sincos
		move.w	d0,d3
		movem.l	iomaxx(a0),d0-d2
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	iominx(a0),d0
		add.l	iominy(a0),d1
		add.l	iominz(a0),d2
		move.l	d0,d3
		move.l	d0,d4
		move.l	d0,d5
		sub.l	isxcoord(a0),d3
		sub.l	isycoord(a0),d4
		sub.l	iszcoord(a0),d5
		movem.l	d0-d2,isxcoord(a0)
		movem.w	d0-d2,ioxspeed(a0)
.done:
		rts

*********************************** Springs **********************************

dospring:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	readswitch		;set the spring's state
		beq.s	.off			;using it's switch

		subq.w	#1,iotimer(a0)
		bpl.s	.done
		move.w	#1,iotimer(a0)

		move.l	isanimframe(a0),d0
		addq.l	#1,d0
		cmp.l	#4,d0
		blt.s	.ok
		moveq.l	#0,d0
.ok:
		move.l	d0,isanimframe(a0)
		rts
.off:
		move.l	#0,isanimframe(a0)
.done:
		rts

********************************** Switches **********************************

dotimedswitch:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		move.l	iocollcode(a0),d0	;has anything hit the switch?
		beq.s	.done
		clr.l	iocollcode(a0)

		cmp.w	#laserCODE,d0
		beq.s	.shot
		cmp.w	#missileCODE,d0
		beq.s	.shot
		cmp.w	#plasmaCODE,d0
		bne.s	.done
.shot:
		move.l	#dotimedon,ido(a0)	;turn the switch on for a bit
		move.l	#1,isanimframe(a0)
		move.w	#150,iotimer(a0)
		bsr	switchon
.done:
		rts

dotimedon:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)
		bne.s	.done
		move.l	#dotimedswitch,ido(a0)
		clr.l	isanimframe(a0)
		clr.l	iocollcode(a0)
		bsr	switchoff
.done:
		rts

doswitch:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		move.l	iocollcode(a0),d0	;has anything hit the switch?
		beq.s	.done
		clr.l	iocollcode(a0)

		cmp.w	#laserCODE,d0
		beq.s	.shot
		cmp.w	#missileCODE,d0
		beq.s	.shot
		cmp.w	#plasmaCODE,d0
		bne.s	.done
.shot:
		move.l	isanimframe(a0),d0	;toggle the switch
		eor.b	#1,d0
		move.l	d0,isanimframe(a0)
		bsr	switchtoggle
.done:
		rts

dotripswitch:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	readswitch		;has anything else
		bne.s	.showtripped		;tripped the switch?

		move.l	iocollcode(a0),d0	;do I need to
		beq.s	.done			;trip the switch?
		clr.l	iocollcode(a0)

		cmp.w	#playerCODE,d0
		beq.s	.tripped
.done:
		rts
.tripped:
		bsr	switchon		;turn the switch on
		rts
.showtripped:
		move.l	#1,isanimframe(a0)	;use the tripped graphic
		rts

dokey:		tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		bsr	doobjcoll
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)

		cmp.w	#playerCODE,d0		;allow player to collect pods
		bne.s	.nocollide
		move.w	#2000,iotimer(a0)	;set the key derezzing
		bsr	switchon		;turn on it's switch
.nocollide:
		move.w	isrezz(a0),d0
		sub.w	iotimer(a0),d0
		bpl.s	.stillon
		bsr	killobject
		bra.s	.done
.stillon:
		move.w	d0,isrezz(a0)

		movem.w	ioxrot(a0),d0-d2
		add.w	ioxangle(a0),d0
		add.w	ioyangle(a0),d1
		add.w	iozangle(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
.done:
		rts

************************************ Warp ************************************

dowarp:		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	readswitch		;get switches status
		beq.s	.warpoff		;and set warp on or off

		subq.w	#1,iotimer(a0)
		bpl.s	.done
		move.w	#2,iotimer(a0)

		move.l	isanimframe(a0),d0
		eor.l	#1,d0
		move.l	d0,isanimframe(a0)
		rts
.warpoff:
		move.l	#0,isanimframe(a0)
.done:
		rts

*********************************** Prisms ***********************************

dorprism:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		move.w	#-60,d0
		subq.w	#1,ioyrot(a0)
		cmp.w	ioyrot(a0),d0
		ble.s	.spin
		move.w	d0,ioyrot(a0)
		bra.s	.spin
.off:
		tst.w	ioyrot(a0)
		beq.s	.done
		addq.w	#1,ioyrot(a0)
.spin:
		movem.w	ioxangle(a0),d0-d2
		add.w	ioyrot(a0),d1
		and.w	#2047,d1
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
.done:
		rts

dolprism:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		move.w	#60,d0
		addq.w	#1,ioyrot(a0)
		cmp.w	ioyrot(a0),d0
		bge.s	.spin
		move.w	d0,ioyrot(a0)
		bra.s	.spin
.off:
		tst.w	ioyrot(a0)
		beq.s	.done
		subq.w	#1,ioyrot(a0)
.spin:
		movem.w	ioxangle(a0),d0-d2
		add.w	ioyrot(a0),d1
		and.w	#2047,d1
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
.done:
		rts

dobarrier:	tst.w	isonscreen(a0)
		beq.s	.done

		move.l	isanimframe(a0),d0
		addq.l	#1,d0
		cmp.l	#19,d0
		blt.s	.ok
		moveq.l	#1,d0
.ok:
		move.l	d0,isanimframe(a0)
.done:
		rts

dotimedbarrieroff:
		tst.w	isonscreen(a0)
		beq.s	.done

		subq.w	#1,iotimer(a0)
		bpl.s	.done
		move.w	#100,iotimer(a0)
		move.l	#dotimedbarrieron,ido(a0)
.done:
		rts

dotimedbarrieron:
		tst.w	isonscreen(a0)
		beq.s	.done

		subq.w	#1,iotimer(a0)
		bpl.s	.stillon
		move.w	#20,iotimer(a0)
		move.l	#0,isanimframe(a0)
		move.l	#dotimedbarrieroff,ido(a0)
.done:
		rts
.stillon:
		move.l	isanimframe(a0),d0
		addq.l	#1,d0
		cmp.l	#19,d0
		blt.s	.ok
		moveq.l	#1,d0
.ok:
		move.l	d0,isanimframe(a0)
		rts

dodistorter:	move.w	ioyrot(a0),d3
		subq.w	#1,d3
		cmp.w	#5,d0
		bgt.s	.ok
		bsr	random
		and.w	#127,d0
		add.w	#50,d0
		move.w	d0,d3
.ok:
		move.w	d3,ioyrot(a0)
		bsr	flatrotateobject
		movem.w	iszx(a0),d0-d2
		asr.w	#6,d0
		moveq.l	#0,d1
		asr.w	#6,d2
		movem.w	d0-d2,ioxspeed(a0)
		rts

***************************** Feature Subroutines ****************************

readswitch:	lea	switchtab,a6		;read a switches state
		move.w	ioswitch(a0),d0
		move.b	0(a6,d0.w),d0
		rts

switchon:	lea	switchtab,a6		;turn a switch on
		move.w	ioswitch(a0),d0
		st.b	0(a6,d0.w)
		rts

switchoff:	lea	switchtab,a6		;turn a switch off
		move.w	ioswitch(a0),d0
		sf.b	0(a6,d0.w)
		rts

switchtoggle:	lea	switchtab,a6		;toggle a switch on/off
		move.w	ioswitch(a0),d0
		not.b	0(a6,d0.w)
		rts

getdestination:	move.w	iodestination(a0),d0	;get a warp's destination
		lea	destinationtab,a1
		add.w	d0,d0
		add.w	d0,d0
		add.w	d0,a1
		add.w	d0,d0
		add.w	d0,a1
		movem.l	(a1),d0-d2
		rts

****************************** Object Generators *****************************

createexitbeam:	bsr	getempty

		movem.l	isxcoord(a0),d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#doexitbeam,ido(a1)
		move.l	#exitbeamanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#exitTYPE,iotype(a1)
		move.w	#exitDAMAGE,iodamage(a1)
		rts

createexitdoors:
		bsr	getempty

		movem.l	isxcoord(a0),d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#doexitdoors1,ido(a1)
		move.l	#exitdoorsanim,isanimbase(a1)
		move.l	#1,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#exitTYPE,iotype(a1)
		move.w	#exitDAMAGE,iodamage(a1)

		move.w	#512,ioxangle(a1)

		st.b	ignoreexit
		rts

createdatapod:	bsr	getempty
		beq	.nopod

		move.l	#dodatapodfall,ido(a1)
		move.l	#datapodanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#datapodTYPE,iotype(a1)
		move.w	#datapodDAMAGE,iodamage(a1)
		move.w	#datapodENERGY,ioenergy(a1)

		move.w	#16,ioxrot(a1)
		move.w	#34,ioyrot(a1)
		move.w	#5,iozrot(a1)

		move.w	#16384,isrezz(a1)
		move.w	#0,iotimer(a1)

		bsr	random
		move.w	d0,d2
		bsr	random
		move.w	d0,d1
		swap	d0
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		bsr	anglematrix

		bsr	random
		move.w	d0,d2
		swap	d0
		and.l	#$7f0,d0
		and.l	#$7f0,d2
		sub.l	#$3f8,d0
		sub.l	#$3f8,d2
		move.w	#100,d1
		movem.w	d0-d2,ioxspeed(a1)

		movem.l	isxcoord(a0),d0-d2
		movem.l	d0-d2,isxcoord(a1)

		addq.w	#1,datapods
		addq.w	#1,maxdatapods
.nopod:
		rts

makedestination:
		move.w	destination,d3

		movem.l	position,d0-d2
		lea	destinationtab,a1
		add.w	d3,d3
		add.w	d3,d3
		add.w	d3,a1
		add.w	d3,d3
		add.w	d3,a1
		movem.l	d0-d2,(a1)
		rts

makeexit:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#donowt,ido(a1)
		move.l	#exitanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#exitTYPE,iotype(a1)
		move.w	#exitDAMAGE,iodamage(a1)

		move.l	a1,a0

		bsr	createexitdoors
		bsr	createexitbeam

		jsr	realmakeplayer1
		rts

makedatapod:	bsr	getempty

		movem.l	position,d0-d2
		add.l	datapodheight,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)

		move.l	#dodatapod,ido(a1)
		move.l	#datapodanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#datapodTYPE,iotype(a1)
		move.w	#datapodDAMAGE,iodamage(a1)
		move.w	#datapodENERGY,ioenergy(a1)

		clr.w	ioxspeed(a1)
		clr.w	ioyspeed(a1)
		clr.w	iozspeed(a1)

		move.w	#16,ioxrot(a1)
		move.w	#34,ioyrot(a1)
		move.w	#5,iozrot(a1)

		move.w	#16384,isrezz(a1)
		move.w	#0,iotimer(a1)

		addq.w	#1,datapods
		addq.w	#1,maxdatapods
		rts

makedatabase:	bsr	getempty

		movem.l	position,d0-d2
		add.l	databaseheight,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)

		move.l	#dodatabase,ido(a1)
		move.l	#databaseanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#databaseTYPE,iotype(a1)
		move.w	#databaseDAMAGE,iodamage(a1)
		move.w	#databaseENERGY,ioenergy(a1)

		move.w	#0,ioxrot(a1)
		move.w	#15,ioyrot(a1)
		move.w	#0,iozrot(a1)

		addq.w	#1,databases
		addq.w	#1,maxdatabases
		rts

makedoor:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dodoor,ido(a1)
		move.l	#door1anim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.l	#2000,iorange(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#doorTYPE,iotype(a1)
		move.w	#doorDAMAGE,iodamage(a1)
		rts

makeplatform:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		sub.l	d0,d3
		sub.l	d1,d4
		sub.l	d2,d5
		asr.l	d3
		asr.l	d4
		asr.l	d5

		cmp.l	d3,d5
		bgt.s	.zmove
.xmove:
		moveq.l	#0,d5
		bra.s	.ok
.zmove:
		moveq.l	#0,d3
.ok:
		movem.l	position,d0-d2
		movem.l	d0-d5,iominx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#doplatform,ido(a1)
		move.l	#platformanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		clr.w	ioyrot(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#platformDAMAGE,iodamage(a1)
		move.w	#platformTYPE,iotype(a1)
		rts

makespring:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dospring,ido(a1)
		move.l	#springanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#springTYPE,iotype(a1)
		move.w	#springDAMAGE,iodamage(a1)

		move.w	#1,iotimer(a1)
		rts

makeattractor:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#donowt,ido(a1)
		move.l	#attractanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	iszx(a1),d0-d2
		moveq.l	#8,d3
		asr.l	d3,d0
		asr.l	d3,d1
		asr.l	d3,d2
		movem.w	d0-d2,ioxspeed(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#attractTYPE,iotype(a1)
		move.w	#attractDAMAGE,iodamage(a1)
		rts

makerepellor:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#donowt,ido(a1)
		move.l	#repellanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	iszx(a1),d0-d2
		moveq.l	#7,d3
		asr.l	d3,d0
		asr.l	d3,d1
		asr.l	d3,d2
		movem.w	d0-d2,ioxspeed(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#repellTYPE,iotype(a1)
		move.w	#repellDAMAGE,iodamage(a1)
		rts

makewarp:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)
		move.w	destination,iodestination(a1)
		move.l	index,d0
		move.w	d0,ioxspeed(a1)

		move.l	#dowarp,ido(a1)
		move.l	#warpanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#warpTYPE,iotype(a1)
		move.w	#warpDAMAGE,iodamage(a1)

		move.w	#2,iotimer(a1)
		rts

makerprism:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)
		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)

		move.l	#dorprism,ido(a1)
		move.l	#rprismanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#prismTYPE,iotype(a1)
		move.w	#prismDAMAGE,iodamage(a1)

		clr.w	ioyrot(a1)
		rts

makelprism:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)
		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)

		move.l	#dolprism,ido(a1)
		move.l	#lprismanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#prismTYPE,iotype(a1)
		move.w	#prismDAMAGE,iodamage(a1)

		clr.w	ioyrot(a1)
		rts

maketimedswitch:
		bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dotimedswitch,ido(a1)
		move.l	#switchanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#switchTYPE,iotype(a1)
		move.w	#switchDAMAGE,iodamage(a1)
		rts

maketripswitch:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dotripswitch,ido(a1)
		move.l	#tripswitchanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#switchTYPE,iotype(a1)
		move.w	#switchDAMAGE,iodamage(a1)
		rts

makeswitch:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#doswitch,ido(a1)
		move.l	#switchanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#switchTYPE,iotype(a1)
		move.w	#switchDAMAGE,iodamage(a1)
		rts

makekey:	bsr	getempty

		movem.l	position,d0-d2
		add.l	keyheight,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)

		move.l	#dokey,ido(a1)
		move.l	#keyanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#keyTYPE,iotype(a1)
		move.w	#keyDAMAGE,iodamage(a1)

		move.w	#16,ioxrot(a1)
		move.w	#34,ioyrot(a1)
		move.w	#5,iozrot(a1)

		move.w	#16384,isrezz(a1)
		move.w	#0,iotimer(a1)
		rts

makedistorter:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#dodistorter,ido(a1)
		move.l	#distortanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#distorterTYPE,iotype(a1)
		move.w	#distorterDAMAGE,iodamage(a1)

		move.w	#10,ioyrot(a1)
		rts

makefloorpanel:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#donowt,ido(a1)
		move.l	#panelanim,isanimbase(a1)
		move.l	index,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#panelTYPE,iotype(a1)
		move.w	#panelDAMAGE,iodamage(a1)
		rts

makecolumn:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#donowt,ido(a1)
		move.l	#columnanim,isanimbase(a1)
		move.l	index,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#columnTYPE,iotype(a1)
		move.w	#columnDAMAGE,iodamage(a1)

		move.w	switch,ioswitch(a1)
		rts

maketimedbarrier:
		bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dotimedbarrieroff,ido(a1)
		move.l	#barrieranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#barrierTYPE,iotype(a1)
		move.w	#barrierDAMAGE,iodamage(a1)

		move.w	#20,iotimer(a1)
		rts

makebarrier:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dobarrier,ido(a1)
		move.l	#barrieranim,isanimbase(a1)
		move.l	index,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#barrierTYPE,iotype(a1)
		move.w	#barrierDAMAGE,iodamage(a1)
		rts

makespikes:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#donowt,ido(a1)
		move.l	#spikesanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#featureCLASS,ioclass(a1)
		move.w	#spikesTYPE,iotype(a1)
		move.w	#spikesDAMAGE,iodamage(a1)
		rts

clearswitches:	lea	switchtab,a6
		move.w	#maxswitches-1,d7
.clear:
		sf.b	(a6)+
		dbf	d7,.clear
		st.b	switchtab		;switch zero always active
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************
 
		phrase

exitanim:   	dc.l	exitopenvdf

exitdoorsanim:	dc.l	exitd1vdf
		dc.l	exitd2vdf

exitbeamanim:  	dc.l	exit1vdf
		dc.l	exit2vdf
		dc.l	exit3vdf
		dc.l	exit4vdf
		dc.l	exit5vdf
		dc.l	exit6vdf
		dc.l	exit7vdf
		dc.l	exit8vdf

datapodanim:   	dc.l	datapodvdf

databaseanim:  	dc.l	databasevdf

platformanim:  	dc.l	platformvdf

switchanim:  	dc.l	switchoffvdf
	       	dc.l	switchonvdf

tripswitchanim:	dc.l	tripswitchoffvdf
		dc.l	tripswitchonvdf

keyanim:	dc.l	keyvdf

springanim:  	dc.l	spring1vdf
		dc.l	spring2vdf
		dc.l	spring3vdf
		dc.l	spring4vdf

attractanim: 	dc.l	attractvdf

repellanim:	dc.l	repellvdf

warpanim:   	dc.l	warp1vdf
		dc.l	warp2vdf

rprismanim:  	dc.l	rprismvdf

lprismanim:	dc.l	lprismvdf

door1anim:	dc.l	door1vdf
		dc.l	door2vdf
		dc.l	door3vdf
		dc.l	door4vdf
		dc.l	door5vdf
		dc.l	door6vdf
		dc.l	door7vdf
		dc.l	door8vdf
		dc.l	door9vdf

panelanim:	dc.l	panel0vdf
		dc.l	panel1vdf
		dc.l	panel2vdf

columnanim:	dc.l	column1vdf
		dc.l	column2vdf

barrieranim:	dc.l	barrier0vdf	;0	off frame

		dc.l	barrier1vdf	;1	on frames
		dc.l	barrier4vdf	;2
		dc.l	barrier6vdf	;3
		dc.l	barrier2vdf	;4
		dc.l	barrier5vdf	;5
		dc.l	barrier4vdf	;6
		dc.l	barrier3vdf	;7
		dc.l	barrier6vdf	;8
		dc.l	barrier1vdf	;9
		dc.l	barrier3vdf	;10
		dc.l	barrier4vdf	;11
		dc.l	barrier2vdf	;12
		dc.l	barrier5vdf	;13
		dc.l	barrier2vdf	;14
		dc.l	barrier1vdf	;15
		dc.l	barrier5vdf	;16
		dc.l	barrier6vdf	;17
		dc.l	barrier3vdf	;18

spikesanim:	dc.l	spikesvdf

distortanim:	dc.l	distortvdf

********************************* VDF Files **********************************

exitopenvdf:	incbin	"graphics\\shapes\\features\\exiton.vdf"

exitd1vdf:	incbin	"graphics\\shapes\\features\\exitd1.vdf"
exitd2vdf:	incbin	"graphics\\shapes\\features\\exitd2.vdf"

exit1vdf:	incbin	"graphics\\shapes\\features\\exit1.vdf"
exit2vdf:	incbin	"graphics\\shapes\\features\\exit2.vdf"
exit3vdf:	incbin	"graphics\\shapes\\features\\exit3.vdf"
exit4vdf:	incbin	"graphics\\shapes\\features\\exit4.vdf"
exit5vdf:	incbin	"graphics\\shapes\\features\\exit5.vdf"
exit6vdf:	incbin	"graphics\\shapes\\features\\exit6.vdf"
exit7vdf:	incbin	"graphics\\shapes\\features\\exit7.vdf"
exit8vdf:	incbin	"graphics\\shapes\\features\\exit8.vdf"

door1vdf:	incbin	"graphics\\shapes\\features\\door1.vdf"
door2vdf:	incbin	"graphics\\shapes\\features\\door2.vdf"
door3vdf:	incbin	"graphics\\shapes\\features\\door3.vdf"
door4vdf:	incbin	"graphics\\shapes\\features\\door4.vdf"
door5vdf:	incbin	"graphics\\shapes\\features\\door5.vdf"
door6vdf:	incbin	"graphics\\shapes\\features\\door6.vdf"
door7vdf:	incbin	"graphics\\shapes\\features\\door7.vdf"
door8vdf:	incbin	"graphics\\shapes\\features\\door8.vdf"
door9vdf:	incbin	"graphics\\shapes\\features\\door9.vdf"

datapodvdf:	incbin	"graphics\\shapes\\features\\datapod.vdf"
databasevdf:	incbin	"graphics\\shapes\\features\\database.vdf"

keyvdf:		incbin	"graphics\\shapes\\features\\key.vdf"

platformvdf:	dc.w	platformc-platformvdf

platforms:	dc.w	600

		dc.w	16

		dc.w	-400,-100,-400,0,0,0		;0
		dc.w	400,-100,-400,0,0,0		;1
		dc.w	-400,-100,400,0,0,0		;2
		dc.w	400,-100,400,0,0,0		;3

		dc.w	-400,0,-400,0,0,0		;4
		dc.w	400,0,-400,0,0,0		;5
		dc.w	-400,0,400,0,0,0		;6
		dc.w	400,0,400,0,0,0			;7

		dc.w	-200,-150,-200,0,0,0		;8
		dc.w	200,-150,-200,0,0,0		;9
		dc.w	-200,-150,200,0,0,0		;10
		dc.w	200,-150,200,0,0,0		;11

		dc.w	-160,-200,-160,0,0,0		;12
		dc.w	160,-200,-160,0,0,0		;13
		dc.w	-160,-200,160,0,0,0		;14
		dc.w	160,-200,160,0,0,0		;15

		dc.w	14

		dc.w	$403f,4,0,1,5,4	;4,5,1,0
		dc.w	$404f,4,1,3,7,5	;5,7,3,1
		dc.w	$403f,4,3,2,6,7	;7,6,2,3
		dc.w	$404f,4,2,0,4,6	;6,4,0,2

		dc.w	$404f,4,8,9,1,0	;0,1,9,8
		dc.w	$403f,4,9,11,3,1	;1,3,11,9
		dc.w	$404f,4,11,10,2,3	;3,2,10,11
		dc.w	$403f,4,10,8,0,2	;2,0,8,10

		dc.w	$403f,4,12,13,9,8	;8,9,13,12
		dc.w	$404f,4,13,15,11,9	;9,11,15,13
		dc.w	$403f,4,15,14,10,11	;11,10,14,15
		dc.w	$404f,4,14,12,8,10	;10,8,12,14

		dc.w	$402f,4,4,5,7,6	;6,7,5,4
		dc.w	$4100,4,14,15,13,12	;12,13,15,14

platformc:	dc.w	600

		dc.w	2

		dc.w	-400,-400,-400
		dc.w	800,400,800
		dc.w	floor

		dc.w	-400,-10,-400
		dc.w	800,20,800
		dc.w	platformCODE

spring1vdf:	dc.w	0

spring1s:	dc.w	660

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3

		dc.w	-200,0,-200,0,0,0		;4
		dc.w	200,0,-200,0,0,0		;5
		dc.w	-200,0,200,0,0,0		;6
		dc.w	200,0,200,0,0,0			;7

		dc.w	5

		dc.w	$8014,4,0,1,5,4	;4,5,1,0
		dc.w	$8014,4,1,3,7,5	;5,7,3,1
		dc.w	$8014,4,3,2,6,7	;7,6,2,3
		dc.w	$8014,4,2,0,4,6	;6,4,0,2

		dc.w	$8015,4,4,5,7,6	;6,7,5,4

spring2vdf:	dc.w	spring2c-spring2vdf

spring2s:	dc.w	660

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3

		dc.w	-200,53,-200,0,0,0		;4
		dc.w	200,53,-200,0,0,0		;5
		dc.w	-200,53,200,0,0,0		;6
		dc.w	200,53,200,0,0,0		;7

		dc.w	5

		dc.w	$8014,4,0,1,5,4	;4,5,1,0
		dc.w	$8014,4,1,3,7,5	;5,7,3,1
		dc.w	$8014,4,3,2,6,7	;7,6,2,3
		dc.w	$8014,4,2,0,4,6	;6,4,0,2

		dc.w	$8015,4,4,5,7,6	;6,7,5,4

spring2c:	dc.w	330

		dc.w	1

		dc.w	-400,-40,-400
		dc.w	800,200,800
		dc.w	static+springCODE

spring3vdf:	dc.w	spring3c-spring3vdf

spring3s:	dc.w	660

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3

		dc.w	-200,106,-200,0,0,0		;4
		dc.w	200,106,-200,0,0,0		;5
		dc.w	-200,106,200,0,0,0		;6
		dc.w	200,106,200,0,0,0		;7

		dc.w	5

		dc.w	$8014,4,0,1,5,4	;4,5,1,0
		dc.w	$8014,4,1,3,7,5	;5,7,3,1
		dc.w	$8014,4,3,2,6,7	;7,6,2,3
		dc.w	$8014,4,2,0,4,6	;6,4,0,2

		dc.w	$8015,4,4,5,7,6	;6,7,5,4

spring3c:	dc.w	660

		dc.w	1

		dc.w	-400,-40,-400
		dc.w	800,200,800
		dc.w	static+springCODE

spring4vdf:	dc.w	spring4c-spring4vdf

spring4s:	dc.w	660

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3

		dc.w	-200,160,-200,0,0,0		;4
		dc.w	200,160,-200,0,0,0		;5
		dc.w	-200,160,200,0,0,0		;6
		dc.w	200,160,200,0,0,0		;7

		dc.w	5

		dc.w	$8014,4,0,1,5,4	;4,5,1,0
		dc.w	$8014,4,1,3,7,5	;5,7,3,1
		dc.w	$8014,4,3,2,6,7	;7,6,2,3
		dc.w	$8014,4,2,0,4,6	;6,4,0,2

		dc.w	$8015,4,4,5,7,6	;6,7,5,4

spring4c:	dc.w	660

		dc.w	1

		dc.w	-400,-40,-400
		dc.w	800,200,800
		dc.w	static+springCODE

attractvdf:	dc.w	attractc-attractvdf

attracts:	dc.w	410

		dc.w	24

		dc.w	-75,0,-50,0,0,0			;0
		dc.w	75,0,-50,0,0,0			;1
		dc.w	-50,0,0,0,0,0			;2
		dc.w	50,0,0,0,0,0			;3
		dc.w	-250,0,25,0,0,0			;4
		dc.w	250,0,25,0,0,0			;5
		dc.w	-150,0,50,0,0,0			;6
		dc.w	150,0,50,0,0,0			;7
		dc.w	-250,0,300,0,0,0		;8
		dc.w	250,0,300,0,0,0			;9
		dc.w	-150,0,300,0,0,0		;10
		dc.w	150,0,300,0,0,0			;11

		dc.w	-75,100,-50,0,0,0		;12
		dc.w	75,100,-50,0,0,0		;13
		dc.w	-50,100,0,0,0,0			;14
		dc.w	50,100,0,0,0,0			;15
		dc.w	-250,100,25,0,0,0		;16
		dc.w	250,100,25,0,0,0		;17
		dc.w	-150,100,50,0,0,0		;18
		dc.w	150,100,50,0,0,0		;19
		dc.w	-250,100,300,0,0,0		;20
		dc.w	250,100,300,0,0,0		;21
		dc.w	-150,100,300,0,0,0		;22
		dc.w	150,100,300,0,0,0		;23

		dc.w	17

		dc.w	$40f0,4,16,18,22,20	;20,22,18,16
		dc.w	$40f0,4,19,17,21,23	;23,21,17,19
		dc.w	$40f0,4,12,14,18,16	;16,18,14,12
		dc.w	$40f0,4,15,13,17,19	;19,17,13,15
		dc.w	$40f0,4,12,13,15,14	;14,15,13,12

		dc.w	$40f2,4,0,1,13,12	;12,13,1,0
		dc.w	$40f2,4,3,2,14,15	;15,14,2,3
		dc.w	$4102,4,10,8,20,22	;22,20,8,10
		dc.w	$4102,4,9,11,23,21	;21,23,11,9

		dc.w	$40f4,4,8,4,16,20	;20,16,4,8
		dc.w	$40f4,4,5,9,21,17	;17,21,9,5
		dc.w	$40f4,4,6,10,22,18	;18,22,10,6
		dc.w	$40f4,4,11,7,19,23	;23,19,7,11

		dc.w	$40f6,4,4,0,12,16	;16,12,0,4
		dc.w	$40f6,4,1,5,17,13	;13,17,5,1
		dc.w	$40f6,4,2,6,18,14	;14,18,6,2
		dc.w	$40f6,4,7,3,15,19	;19,15,3,7

attractc:	dc.w	6100

		dc.w	4

		dc.w	-250,0,-50
		dc.w	400,100,100
		dc.w	solid+static+stopCODE

		dc.w	-250,0,-50
		dc.w	100,100,350
		dc.w	solid+static+stopCODE

		dc.w	150,0,-50
		dc.w	100,100,350
		dc.w	solid+static+stopCODE

		dc.w	-250,-10,1000
		dc.w	400,110,5000
		dc.w	static+attractCODE

repellvdf:	dc.w	repellc-repellvdf

repells:	dc.w	300

		dc.w	20

		dc.w	-200,0,-200,0,0,0		;0
		dc.w	200,0,-200,0,0,0		;1
		dc.w	-200,0,0,0,0,0			;2
		dc.w	200,0,0,0,0,0			;3

		dc.w	-200,20,-200,0,0,0		;4
		dc.w	200,20,-200,0,0,0		;5
		dc.w	-200,20,0,0,0,0			;6
		dc.w	200,20,0,0,0,0			;7

		dc.w	-200,40,50,0,0,0		;8
		dc.w	200,40,50,0,0,0			;9
		dc.w	-200,40,200,0,0,0		;10
		dc.w	200,40,200,0,0,0		;11

		dc.w	-200,100,0,0,0,0		;12
		dc.w	200,100,0,0,0,0			;13
		dc.w	-200,100,200,0,0,0		;14
		dc.w	200,100,200,0,0,0		;15

		dc.w	-160,60,150,0,0,0		;16
		dc.w	160,60,150,0,0,0		;17
		dc.w	-160,80,150,0,0,0		;18
		dc.w	160,80,150,0,0,0		;19

		dc.w	17

		dc.w	$8017,4,0,1,5,4
		dc.w	$8017,4,3,2,6,7
		dc.w	$8017,4,1,3,7,5
		dc.w	$8017,4,2,0,4,6

		dc.w	$8017,4,4,5,13,12
		dc.w	$8017,4,7,6,8,9
		dc.w	$8017,4,7,9,13,5
		dc.w	$8017,4,8,6,4,12

		dc.w	$8017,4,12,13,15,14
		dc.w	$8017,4,9,8,10,11
		dc.w	$8017,4,9,11,15,13
		dc.w	$8017,4,10,8,12,14

		dc.w	$8017,4,19,18,14,15
		dc.w	$8017,4,16,17,11,10
		dc.w	$8017,4,17,19,15,11
		dc.w	$8017,4,18,16,10,14

		dc.w	$8017,4,17,16,18,19

repellc:	dc.w	1050

		dc.w	2

		dc.w	-200,0,-200
		dc.w	400,100,400
		dc.w	solid+static+stopCODE

		dc.w	-200,0,100
		dc.w	400,400,1000
		dc.w	static+repellCODE

warp1vdf:	dc.w	warp1c-warp1vdf

warp1s:		dc.w	720

		dc.w	8

		dc.w	-300,0,-300,0,0,0		;0
		dc.w	300,0,-300,0,0,0		;1
		dc.w	-300,0,300,0,0,0		;2
		dc.w	300,0,300,0,0,0			;3
		dc.w	0,30,-150,0,0,0			;4
		dc.w	0,30,150,0,0,0			;5
		dc.w	-150,30,0,0,0,0			;6
		dc.w	150,30,0,0,0,0			;7

		dc.w	9


		dc.w	$4000,3,1,4,0
		dc.w	$4000,3,3,7,1
		dc.w	$4000,3,2,5,3
		dc.w	$4000,3,0,6,2
		dc.w	$4001,3,4,1,7
		dc.w	$4001,3,7,3,5
		dc.w	$4001,3,5,2,6
		dc.w	$4001,3,6,0,4
		dc.w	$4002,4,4,7,5,6

warp1c:		dc.w	720

		dc.w	4

		dc.w	-300,-20,-300
		dc.w	300,120,300
		dc.w	solid+static+stopCODE

		dc.w	0,-20,-300
		dc.w	300,120,300
		dc.w	solid+static+stopCODE

		dc.w	-300,-20,0
		dc.w	300,120,300
		dc.w	solid+static+stopCODE

		dc.w	0,-20,0
		dc.w	300,120,300
		dc.w	solid+static+stopCODE

warp2vdf:	dc.w	warp2c-warp2vdf

warp2s:		dc.w	720

		dc.w	8

		dc.w	-300,0,-300,0,0,0		;0
		dc.w	300,0,-300,0,0,0		;1
		dc.w	-300,0,300,0,0,0		;2
		dc.w	300,0,300,0,0,0			;3
		dc.w	0,30,-150,0,0,0			;4
		dc.w	0,30,150,0,0,0			;5
		dc.w	-150,30,0,0,0,0			;6
		dc.w	150,30,0,0,0,0			;7

		dc.w	9

		dc.w	$4000,3,1,4,0
		dc.w	$4000,3,3,7,1
		dc.w	$4000,3,2,5,3
		dc.w	$4000,3,0,6,2
		dc.w	$4100,3,4,1,7
		dc.w	$4100,3,7,3,5
		dc.w	$4100,3,5,2,6
		dc.w	$4100,3,6,0,4
		dc.w	$4002,4,4,7,5,6

warp2c:		dc.w	720

		dc.w	4

		dc.w	-300,-20,-300
		dc.w	300,120,300
		dc.w	solid+static+warpCODE

		dc.w	0,-20,-300
		dc.w	300,120,300
		dc.w	solid+static+warpCODE

		dc.w	-300,-20,0
		dc.w	300,120,300
		dc.w	solid+static+warpCODE

		dc.w	0,-20,0
		dc.w	300,120,300
		dc.w	solid+static+warpCODE

rprismvdf:	dc.w	rprismc-rprismvdf

rprisms:	dc.w	340

		dc.w	24

		dc.w	-50,0,-100,0,0,0		;0
		dc.w	50,0,-100,0,0,0			;1
		dc.w	-50,0,100,0,0,0			;2
		dc.w	50,0,100,0,0,0			;3
		dc.w	-100,0,-50,0,0,0		;4
		dc.w	100,0,-50,0,0,0			;5
		dc.w	-100,0,50,0,0,0			;6
		dc.w	100,0,50,0,0,0			;7

		dc.w	-50,300,-100,0,0,0		;8
		dc.w	50,300,-100,0,0,0		;9
		dc.w	-50,300,100,0,0,0		;10
		dc.w	50,300,100,0,0,0		;11
		dc.w	-100,300,-50,0,0,0		;12
		dc.w	100,300,-50,0,0,0		;13
		dc.w	-100,300,50,0,0,0		;14
		dc.w	100,300,50,0,0,0		;15

		dc.w	-30,250,-60,0,0,0		;16
		dc.w	30,250,-60,0,0,0		;17
		dc.w	-30,250,60,0,0,0		;18
		dc.w	30,250,60,0,0,0			;19
		dc.w	-60,250,-30,0,0,0		;20
		dc.w	60,250,-30,0,0,0		;21
		dc.w	-60,250,30,0,0,0		;22
		dc.w	60,250,30,0,0,0			;23

		dc.w	17

		dc.w	$408a,4,0,1,9,8	;8,9,1,0
		dc.w	$408f,4,1,5,13,9	;9,13,5,1
		dc.w	$408a,4,5,7,15,13	;13,15,7,5
		dc.w	$408f,4,7,3,11,15	;15,11,3,7
		dc.w	$408a,4,3,2,10,11	;11,10,2,3
		dc.w	$408f,4,2,6,14,10	;10,14,6,2
		dc.w	$408a,4,6,4,12,14	;14,12,4,6
		dc.w	$408f,4,4,0,8,12	;12,8,0,4

		dc.w	$40bf,4,8,9,17,16	;16,17,9,8
		dc.w	$40ba,4,9,13,21,17	;17,21,13,9
		dc.w	$40bf,4,13,15,23,21	;21,23,15,13
		dc.w	$40ba,4,15,11,19,23	;23,19,11,15
		dc.w	$40bf,4,11,10,18,19	;19,18,10,11
		dc.w	$40ba,4,10,14,22,18	;18,22,14,10
		dc.w	$40bf,4,14,12,20,22	;22,20,12,14
		dc.w	$40ba,4,12,8,16,20	;20,16,8,12

		dc.w	$40f0,8,22,20,16,17,21,23,19,18	;18,19,23,21,17,16,20,22

rprismc:	dc.w	340

		dc.w	1

		dc.w	-100,0,-100
		dc.w	200,300,200
		dc.w	solid+static+rprismCODE

lprismvdf:	dc.w	lprismc-lprismvdf

lprisms:	dc.w	340

		dc.w	24

		dc.w	-50,0,-100,0,0,0		;0
		dc.w	50,0,-100,0,0,0			;1
		dc.w	-50,0,100,0,0,0			;2
		dc.w	50,0,100,0,0,0			;3
		dc.w	-100,0,-50,0,0,0		;4
		dc.w	100,0,-50,0,0,0			;5
		dc.w	-100,0,50,0,0,0			;6
		dc.w	100,0,50,0,0,0			;7

		dc.w	-50,300,-100,0,0,0		;8
		dc.w	50,300,-100,0,0,0		;9
		dc.w	-50,300,100,0,0,0		;10
		dc.w	50,300,100,0,0,0		;11
		dc.w	-100,300,-50,0,0,0		;12
		dc.w	100,300,-50,0,0,0		;13
		dc.w	-100,300,50,0,0,0		;14
		dc.w	100,300,50,0,0,0		;15

		dc.w	-30,250,-60,0,0,0		;16
		dc.w	30,250,-60,0,0,0		;17
		dc.w	-30,250,60,0,0,0		;18
		dc.w	30,250,60,0,0,0			;19
		dc.w	-60,250,-30,0,0,0		;20
		dc.w	60,250,-30,0,0,0		;21
		dc.w	-60,250,30,0,0,0		;22
		dc.w	60,250,30,0,0,0			;23

		dc.w	17

		dc.w	$408a,4,0,1,9,8	;8,9,1,0
		dc.w	$408f,4,1,5,13,9	;9,13,5,1
		dc.w	$408a,4,5,7,15,13	;13,15,7,5
		dc.w	$408f,4,7,3,11,15	;15,11,3,7
		dc.w	$408a,4,3,2,10,11	;11,10,2,3
		dc.w	$408f,4,2,6,14,10	;10,14,6,2
		dc.w	$408a,4,6,4,12,14	;14,12,4,6
		dc.w	$408f,4,4,0,8,12	;12,8,0,4

		dc.w	$40bf,4,8,9,17,16	;16,17,9,8
		dc.w	$40ba,4,9,13,21,17	;17,21,13,9
		dc.w	$40bf,4,13,15,23,21	;21,23,15,13
		dc.w	$40ba,4,15,11,19,23	;23,19,11,15
		dc.w	$40bf,4,11,10,18,19	;19,18,10,11
		dc.w	$40ba,4,10,14,22,18	;18,22,14,10
		dc.w	$40bf,4,14,12,20,22	;22,20,12,14
		dc.w	$40ba,4,12,8,16,20	;20,16,8,12

		dc.w	$40f0,8,22,20,16,17,21,23,19,18	;18,19,23,21,17,16,20,22

lprismc:	dc.w	340

		dc.w	1

		dc.w	-100,0,-100
		dc.w	200,300,200
		dc.w	solid+static+lprismCODE

oldswitchoffvdf:	dc.w	oldswitchoffc-oldswitchoffvdf

oldswitchoffs:	dc.w	370

		dc.w	40

		dc.w	-70,0,-70,0,0,0			;0
		dc.w	70,0,-70,0,0,0			;1
		dc.w	-70,0,70,0,0,0			;2
		dc.w	70,0,70,0,0,0			;3
		dc.w	-70,300,-70,0,0,0		;4
		dc.w	70,300,-70,0,0,0		;5
		dc.w	-70,300,70,0,0,0		;6
		dc.w	70,300,70,0,0,0			;7

		dc.w	-50,30,-70,0,0,0		;8
		dc.w	50,30,-70,0,0,0			;9
		dc.w	-50,270,-70,0,0,0		;10
		dc.w	50,270,-70,0,0,0		;11
		dc.w	-50,30,-150,0,0,0		;12
		dc.w	50,30,-150,0,0,0		;13
		dc.w	-50,270,-150,0,0,0		;14
		dc.w	50,270,-150,0,0,0		;15

		dc.w	70,30,-50,0,0,0			;16
		dc.w	70,30,50,0,0,0			;17
		dc.w	70,270,-50,0,0,0		;18
		dc.w	70,270,50,0,0,0			;19
		dc.w	150,30,-50,0,0,0		;20
		dc.w	150,30,50,0,0,0			;21
		dc.w	150,270,-50,0,0,0		;22
		dc.w	150,270,50,0,0,0		;23

		dc.w	-70,30,50,0,0,0			;24
		dc.w	-70,30,-50,0,0,0		;25
		dc.w	-70,270,50,0,0,0		;26
		dc.w	-70,270,-50,0,0,0		;27
		dc.w	-150,30,50,0,0,0		;28
		dc.w	-150,30,-50,0,0,0		;29
		dc.w	-150,270,50,0,0,0		;30
		dc.w	-150,270,-50,0,0,0		;31

		dc.w	50,30,70,0,0,0			;32
		dc.w	-50,30,70,0,0,0			;33
		dc.w	50,270,70,0,0,0			;34
		dc.w	-50,270,70,0,0,0		;35
		dc.w	50,30,150,0,0,0			;36
		dc.w	-50,30,150,0,0,0		;37
		dc.w	50,270,150,0,0,0		;38
		dc.w	-50,270,150,0,0,0		;39

		dc.w	26

		dc.w	$40fa,4,14,15,11,10	;10,11,15,14
		dc.w	$40fb,4,13,12,8,9	;9,8,12,13
		dc.w	$40fd,4,12,14,10,8	;8,10,14,12
		dc.w	$40fc,4,15,13,9,11	;11,9,13,15
		dc.w	$8014,4,12,13,15,14	;14,15,13,12

		dc.w	$40fa,4,22,23,19,18	;18,19,23,22
		dc.w	$40fb,4,21,20,16,17	;17,16,20,21
		dc.w	$40fc,4,23,21,17,19	;19,17,21,23
		dc.w	$40fd,4,20,22,18,16	;16,18,22,20
		dc.w	$8014,4,20,21,23,22	;22,23,21,20

		dc.w	$40fa,4,30,31,27,26	;26,27,31,30
		dc.w	$40fb,4,29,28,24,25	;25,24,28,29
		dc.w	$40fc,4,31,29,25,27	;27,25,29,31
		dc.w	$40fd,4,28,30,26,24	;24,26,30,28
		dc.w	$8014,4,28,29,31,30	;30,31,29,28

		dc.w	$40fa,4,38,39,35,34	;34,35,39,38
		dc.w	$40fb,4,37,36,32,33	;33,32,36,37
		dc.w	$40fc,4,39,37,33,35	;35,33,37,39
		dc.w	$40fd,4,36,38,34,32	;32,34,38,36
		dc.w	$8014,4,36,37,39,38	;38,39,37,36

		dc.w	$40f0,4,4,5,7,6	;6,7,5,4
		dc.w	$40f0,4,2,3,1,0	;0,1,3,2
		dc.w	$40f1,4,0,1,5,4	;4,5,1,0
		dc.w	$40f1,4,3,2,6,7	;7,6,2,3
		dc.w	$40f2,4,1,3,7,5	;5,7,3,1
		dc.w	$40f2,4,2,0,4,6	;6,4,0,2

oldswitchoffc:	dc.w	500

		dc.w	2

		dc.w	-70,0,-150
		dc.w	140,300,300
		dc.w	solid+static+stopCODE

		dc.w	-150,0,-70
		dc.w	300,300,140
		dc.w	solid+static+stopCODE

oldswitchonvdf:	dc.w	oldswitchonc-oldswitchonvdf

oldswitchons:	dc.w	320

		dc.w	40

		dc.w	-70,0,-70,0,0,0			;0
		dc.w	70,0,-70,0,0,0			;1
		dc.w	-70,0,70,0,0,0			;2
		dc.w	70,0,70,0,0,0			;3
		dc.w	-70,300,-70,0,0,0		;4
		dc.w	70,300,-70,0,0,0		;5
		dc.w	-70,300,70,0,0,0		;6
		dc.w	70,300,70,0,0,0			;7

		dc.w	-50,30,-70,0,0,0		;8
		dc.w	50,30,-70,0,0,0			;9
		dc.w	-50,270,-70,0,0,0		;10
		dc.w	50,270,-70,0,0,0		;11
		dc.w	-50,30,-80,0,0,0		;12
		dc.w	50,30,-80,0,0,0			;13
		dc.w	-50,270,-80,0,0,0		;14
		dc.w	50,270,-80,0,0,0		;15

		dc.w	70,30,-50,0,0,0			;16
		dc.w	70,30,50,0,0,0			;17
		dc.w	70,270,-50,0,0,0		;18
		dc.w	70,270,50,0,0,0			;19
		dc.w	80,30,-50,0,0,0			;20
		dc.w	80,30,50,0,0,0			;21
		dc.w	80,270,-50,0,0,0		;22
		dc.w	80,270,50,0,0,0			;23

		dc.w	-70,30,50,0,0,0			;24
		dc.w	-70,30,-50,0,0,0		;25
		dc.w	-70,270,50,0,0,0		;26
		dc.w	-70,270,-50,0,0,0		;27
		dc.w	-80,30,50,0,0,0			;28
		dc.w	-80,30,-50,0,0,0		;29
		dc.w	-80,270,50,0,0,0		;30
		dc.w	-80,270,-50,0,0,0		;31

		dc.w	50,30,70,0,0,0			;32
		dc.w	-50,30,70,0,0,0			;33
		dc.w	50,270,70,0,0,0			;34
		dc.w	-50,270,70,0,0,0		;35
		dc.w	50,30,80,0,0,0			;36
		dc.w	-50,30,80,0,0,0			;37
		dc.w	50,270,80,0,0,0			;38
		dc.w	-50,270,80,0,0,0		;39

		dc.w	26

		dc.w	$40fa,4,14,15,11,10	;10,11,15,14
		dc.w	$40fb,4,13,12,8,9	;9,8,12,13
		dc.w	$40fd,4,12,14,10,8	;8,10,14,12
		dc.w	$40fc,4,15,13,9,11	;11,9,13,15
		dc.w	$8014,4,12,13,15,14	;14,15,13,12

		dc.w	$40fa,4,22,23,19,18	;18,19,23,22
		dc.w	$40fb,4,21,20,16,17	;17,16,20,21
		dc.w	$40fc,4,23,21,17,19	;19,17,21,23
		dc.w	$40fd,4,20,22,18,16	;16,18,22,20
		dc.w	$8014,4,20,21,23,22	;22,23,21,20

		dc.w	$40fa,4,30,31,27,26	;26,27,31,30
		dc.w	$40fb,4,29,28,24,25	;25,24,28,29
		dc.w	$40fc,4,31,29,25,27	;27,25,29,31
		dc.w	$40fd,4,28,30,26,24	;24,26,30,28
		dc.w	$8014,4,28,29,31,30	;30,31,29,28

		dc.w	$40fa,4,38,39,35,34	;34,35,39,38
		dc.w	$40fb,4,37,36,32,33	;33,32,36,37
		dc.w	$40fc,4,39,37,33,35	;35,33,37,39
		dc.w	$40fd,4,36,38,34,32	;32,34,38,36
		dc.w	$8014,4,36,37,39,38	;38,39,37,36

		dc.w	$40f0,4,4,5,7,6	;6,7,5,4
		dc.w	$40f0,4,2,3,1,0	;0,1,3,2
		dc.w	$40f1,4,0,1,5,4	;4,5,1,0
		dc.w	$40f1,4,3,2,6,7	;7,6,2,3
		dc.w	$40f2,4,1,3,7,5	;5,7,3,1
		dc.w	$40f2,4,2,0,4,6	;6,4,0,2

oldswitchonc:	dc.w	500

		dc.w	1

		dc.w	-80,0,-80
		dc.w	160,300,160
		dc.w	solid+static+stopCODE

tripswitchoffvdf:
		dc.w	tripswitchoffc-tripswitchoffvdf

tripswitchoffs:	dc.w	1010

		dc.w	6

		dc.w	-1000,0,-100,0,0,0		;0
		dc.w	-1000,0,100,0,0,0		;1
		dc.w	-900,50,0,0,0,0			;3
		dc.w	1000,0,-100,0,0,0		;4
		dc.w	1000,0,100,0,0,0		;5
		dc.w	900,50,0,0,0,0			;6

		dc.w	4

		dc.w	$102,4,0,3,5,2	;2,5,3,0
		dc.w	$102,4,4,1,2,5	;5,2,1,4
		dc.w	$102,3,2,1,0	;0,1,2
		dc.w	$102,3,5,3,4	;4,3,5

tripswitchoffc:	dc.w	1010

		dc.w	1

		dc.w	-1000,-10,-100
		dc.w	2000,200,200
		dc.w	static+tripswitchCODE

tripswitchonvdf:
		dc.w	tripswitchonc-tripswitchonvdf

tripswitchons:	dc.w	1010

		dc.w	6

		dc.w	-1000,0,-100,0,0,0		;0
		dc.w	-1000,0,100,0,0,0		;1
		dc.w	-900,50,0,0,0,0			;3
		dc.w	1000,0,-100,0,0,0		;4
		dc.w	1000,0,100,0,0,0  		;5
		dc.w	900,50,0,0,0,0			;6

		dc.w	4

		dc.w	$101,4,0,3,5,2	;2,5,3,0
		dc.w	$101,4,4,1,2,5	;5,2,1,4
		dc.w	$101,3,2,1,0	;0,1,2
		dc.w	$101,3,5,3,4	;4,3,5

tripswitchonc:	dc.w	1010

		dc.w	1

		dc.w	-1000,-10,-100
		dc.w	2000,200,200
		dc.w	static+tripswitchCODE

panel0vdf:	dc.w	panel0c-panel0vdf

panel0s:	dc.w	1000

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3
		dc.w	-300,130,-300,0,0,0		;4
		dc.w	300,130,-300,0,0,0		;5
		dc.w	-300,130,300,0,0,0		;6
		dc.w	300,130,300,0,0,0		;7

		dc.w	5

		dc.w	$8044,4,0,1,5,4	;4,5,1,0
		dc.w	$8044,4,1,3,7,5	;5,7,3,1
		dc.w	$8044,4,3,2,6,7	;7,6,2,3
		dc.w	$8044,4,2,0,4,6	;6,4,0,2

		dc.w	$8044,4,4,5,7,6	;6,7,5,4

panel0c:	dc.w	1000

		dc.w	1

		dc.w	-400,0,-400
		dc.w	800,130,800
		dc.w	solid+static+panelCODE

panel1vdf:	dc.w	panel1c-panel1vdf

panel1s:	dc.w	1000

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3
		dc.w	-300,130,-300,0,0,0		;4
		dc.w	300,130,-300,0,0,0		;5
		dc.w	-300,130,300,0,0,0		;6
		dc.w	300,130,300,0,0,0		;7

		dc.w	5

		dc.w	$8046,4,0,1,5,4	;4,5,1,0
		dc.w	$8046,4,1,3,7,5	;5,7,3,1
		dc.w	$8046,4,3,2,6,7	;7,6,2,3
		dc.w	$8046,4,2,0,4,6	;6,4,0,2

		dc.w	$8046,4,4,5,7,6	;6,7,5,4

panel1c:	dc.w	1000

		dc.w	1

		dc.w	-400,0,-400
		dc.w	800,130,800
		dc.w	solid+static+panelCODE

panel2vdf:	dc.w	panel2c-panel2vdf

panel2s:	dc.w	1000

		dc.w	8

		dc.w	-400,0,-400,0,0,0		;0
		dc.w	400,0,-400,0,0,0		;1
		dc.w	-400,0,400,0,0,0		;2
		dc.w	400,0,400,0,0,0			;3
		dc.w	-300,130,-300,0,0,0		;4
		dc.w	300,130,-300,0,0,0		;5
		dc.w	-300,130,300,0,0,0		;6
		dc.w	300,130,300,0,0,0		;7

		dc.w	5

		dc.w	$8048,4,0,1,5,4	;4,5,1,0
		dc.w	$8048,4,1,3,7,5	;5,7,3,1
		dc.w	$8048,4,3,2,6,7	;7,6,2,3
		dc.w	$8048,4,2,0,4,6	;6,4,0,2

		dc.w	$8048,4,4,5,7,6	;6,7,5,4

panel2c:	dc.w	1000

		dc.w	1

		dc.w	-400,0,-400
		dc.w	800,130,800
		dc.w	solid+static+panelCODE

column1vdf:	dc.w	column1c-column1vdf

column1s:	dc.w	1230

		dc.w	17

		dc.w	-500,0,-500,0,0,0		;0
		dc.w	500,0,-500,0,0,0		;1
		dc.w	-500,0,500,0,0,0		;2
		dc.w	500,0,500,0,0,0			;3

		dc.w	-400,300,-400,0,0,0		;4
		dc.w	400,300,-400,0,0,0		;5
		dc.w	-400,300,400,0,0,0		;6
		dc.w	400,300,400,0,0,0		;7

		dc.w	0,0,-500,0,0,0			;8
		dc.w	0,0,500,0,0,0			;9
		dc.w	-500,0,0,0,0,0			;10
		dc.w	500,0,0,0,0,0			;11

		dc.w	0,600,-200,0,0,0		;12
		dc.w	0,600,200,0,0,0			;13
		dc.w	-200,600,0,0,0,0		;14
		dc.w	200,600,0,0,0,0			;15

		dc.w	0,800,0,0,0,0			;16

		dc.w	24

		dc.w	$4080,3,0,8,4
		dc.w	$4085,3,8,1,5
		dc.w	$4080,3,1,11,5
		dc.w	$4085,3,11,3,7
		dc.w	$4080,3,3,9,7
		dc.w	$4085,3,9,2,6
		dc.w	$4080,3,2,10,6
		dc.w	$4085,3,10,0,4

		dc.w	$8020,3,8,5,4
		dc.w	$8020,3,11,7,5
		dc.w	$8020,3,9,6,7
		dc.w	$8020,3,10,4,6

		dc.w	$8020,3,12,4,5
		dc.w	$8020,3,15,5,7
		dc.w	$8020,3,13,7,6
		dc.w	$8020,3,14,6,4

		dc.w	$4080,3,16,4,12
		dc.w	$4085,3,16,12,5
		dc.w	$4080,3,16,5,15
		dc.w	$4085,3,16,15,7
		dc.w	$4080,3,16,7,13
		dc.w	$4085,3,16,13,6
		dc.w	$4080,3,16,6,14
		dc.w	$4085,3,16,14,4

column1c:	dc.w	1230

		dc.w	1

		dc.w	-500,0,-500
		dc.w	1000,1000,1000
		dc.w	solid+static+columnCODE

column2vdf:	incbin	"graphics\\shapes\\features\\column2.vdf"

barrier0vdf:	incbin	"graphics\\shapes\\features\\barrier0.vdf"
barrier1vdf:	incbin	"graphics\\shapes\\features\\barrier1.vdf"
barrier2vdf:	incbin	"graphics\\shapes\\features\\barrier2.vdf"
barrier3vdf:	incbin	"graphics\\shapes\\features\\barrier3.vdf"
barrier4vdf:	incbin	"graphics\\shapes\\features\\barrier4.vdf"
barrier5vdf:	incbin	"graphics\\shapes\\features\\barrier5.vdf"
barrier6vdf:	incbin	"graphics\\shapes\\features\\barrier6.vdf"

spikesvdf:	incbin	"graphics\\shapes\\features\\spikes.vdf"

distortvdf:	incbin	"graphics\\shapes\\features\\distort.vdf"

switchoffvdf:	incbin	"graphics\\shapes\\features\\swtchoff.vdf"
switchonvdf:	incbin	"graphics\\shapes\\features\\swtchon.vdf"

******************************** BSS Section *********************************

		bss

********************************* Variables **********************************

		even

datapodheight:	ds.l	1
databaseheight:	ds.l	1
doorheight:	ds.l	1
keyheight:	ds.l	1

maxdatapods:	ds.w	1		;number of data pods generated
maxdatabases:	ds.w	1		;number of data bases generated

datapods:	ds.w	1		;number of data pods active
databases:	ds.w	1		;number of data bases active

ignoreexit:	ds.b	1
exit_on:	ds.b	1

******************************** Switch Table ********************************

switchtab:	ds.b	maxswitches

***************************** Destinations Table *****************************

		phrase
destinationtab:	ds.b	maxdestinations*12
