************************** Fragment Control Routines *************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

************************ Fragment Waiting For A Target ***********************

dofragmentwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	fragmentcollide		;deal with collisions
		tst.w	ioenergy(a0)
	 	ble	explodefragment

		bsr	flatrotateobject

		subq.w	#1,iotimer(a0)		;look for a target
		bne.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dofragmentsplit,ido(a0)
		move.w	#200,iozspeed(a0)
.done:
		rts

**************************** Fragment Splitting Up ***************************

dofragmentsplit:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		sub.w	#15,iozspeed(a0)
		ble.s	.attack

		bsr	doobjcoll		;deal with collisions
		bsr.s	fragmentcollide
		tst.w	ioenergy(a0)
		ble	explodefragment

		bsr.s	movefragment
.done:
		rts
.attack:
		move.l	#dofragmentattack,ido(a0)
		move.w	#0,iozspeed(a0)
		move.w	#50,iotimer(a0)
		rts

************************* Fragment Homing In On Player ***********************

dofragmentattack:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)		;self destruct after a bit
		ble.s	explodefragment

		bsr	doobjcoll		;deal with collisions
		bsr.s	fragmentcollide
		tst.w	ioenergy(a0)
		ble.s	explodefragment

		move.w	iozspeed(a0),d0		;accelerate the fragment
		add.w	#20,d0			;to it's top speed
		cmp.w	#100,d0
		ble.s	.speedok
		move.w	#100,d0
.speedok:
		move.w	d0,iozspeed(a0)

		bsr	flatrotatetotarget
		bsr.s	movefragment
.done:
		rts

**************************** Fragmentor Subroutines **************************

fragmentcollide:
		tst.l	iocollcode(a0)		;check collisions
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

movefragment:	movem.w	iszx(a0),d0-d2 		;move the fragment
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
		rts

explodefragment:
		move.l	#dobigbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makefragmentor:	move.w	#0,fragmentangle	;make three fragments
		move.l	a0,-(sp)		;for our fragmentor
		bsr.s	makefragment

		move.w	#682,fragmentangle
		move.l	(sp),a0
		bsr.s	makefragment

		move.w	#2048-682,fragmentangle
		move.l	(sp)+,a0
		bsr.s	makefragment
		rts

makefragment:	bsr	getempty		;make fragmentor fragments

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#shortrange,iorange(a1)

		move.w	switch,ioswitch(a1)

		move.w	fragmentangle,yangle
		lea	isxx(a1),a6
		bsr	matroty

		move.l	fragmentheight,d0
		add.l	d0,isycoord(a1)

		move.l	#dofragmentwait,ido(a1)
		move.l	#fragmentanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#fragmentTYPE,iotype(a1)
		move.w	#fragmentENERGY,ioenergy(a1)
		move.w	#fragmentDAMAGE,iodamage(a1)

		jsr	random
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		move.w	#50,ioyrot(a1)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************
 
		phrase
fragmentanim:	dc.l	fragmentvdf

********************************* VDF Files **********************************

fragmentvdf:	incbin	"graphics\\shapes\\enemies\\frgmntr.vdf"

******************************** BSS Section *********************************

		bss

********************************* Variables **********************************

		even

fragmentheight:
		ds.l	1
fragmentangle:	ds.w	1
