***************************** Front End Routines *****************************

* Notes:

* All these routines interface with Seedy's code
* so if there are any problems
* I'll just blame him - HAH!

********************************* Code Section *******************************

		text
		.68000

*************************** Object Viewer Init,Show,Done *********************

initviewer:	bsr	clearworld
		bsr	getempty

		move.l	a1,viewerobj

		lea	viewercam,a2
		move.l	a1,ictarget(a2)

		tst.b	PAL_TV
		beq.s	.ntsc
.pal:
		movem.l	.palwindow,d0-d2
		bra.s	.setwindow
.ntsc:
		movem.l	.ntscwindow,d0-d2
.setwindow:
		movem.l	d0-d2,icclx(a2)

		move.l	#dospin,ido(a1)
		move.l	#objectanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.l	#0,isxcoord(a1)
		move.l	#100,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.w	#0,ioxangle(a1)
		move.w	#0,ioyangle(a1)
		move.w	#0,iozangle(a1)

		move.w	#0,ioxrot(a1)
		move.w	#20,ioyrot(a1)
		move.w	#0,iozrot(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)
		rts

.palwindow:	dc.w	-160,-140
		dc.w	160,140
		dc.w	160,140

.ntscwindow:	dc.w	-160,-120
		dc.w	160,120
		dc.w	160,120

showviewer:	move.l	rasterd,a0		;clear raster
		moveq.l	#0,d7
		jsr	clearraster

		move.l	rasterz,a0		;clear zbuffer
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0		;update the world
		bsr	doitem

		lea	viewercameras,a0 	;update the cameras
		bsr	doitem

		jsr	waitgpu			;wait for cameras
		jsr	waitblitter
		rts

doneviewer:	bsr	clearworld
		rts

**************************** Select Tank Init,Show,Done **********************

initselect:	bsr	clearworld		;set up the tank
		bsr	getempty

		lea	selectcam,a2
		move.l	a1,ictarget(a2)

		tst.b	PAL_TV
		beq.s	.ntsc
.pal:
		movem.l	.palwindow,d0-d2
		bra.s	.setwindow
.ntsc:
		movem.l	.ntscwindow,d0-d2
.setwindow:
		movem.l	d0-d2,icclx(a2)

		move.l	#dospin,ido(a1)
		move.l	#0,isanimframe(a1)

		move.l	#0,isxcoord(a1)
		move.l	#100,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.w	#0,ioxangle(a1)
		move.w	#0,ioyangle(a1)
		move.w	#0,iozangle(a1)

		move.w	#0,ioxrot(a1)
		move.w	#20,ioyrot(a1)
		move.w	#0,iozrot(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)
		rts

.palwindow:	dc.w	-160,-140
		dc.w	160,140
		dc.w	160,140

.ntscwindow:	dc.w	-160,-120
		dc.w	160,120
		dc.w	160,120

showselect:	move.l	rasterd,a0		;clear raster
		moveq.l	#0,d7
		jsr	clearraster

		move.l	rasterz,a0		;clear zbuffer
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0		;update the world
		bsr	doitem

		lea	selectcameras,a0 	;update the cameras
		bsr	doitem

		jsr	waitgpu			;wait for cameras
		jsr	waitblitter
		rts

doneselect:	bsr	clearworld
		rts

***************************** Shop Init,Show,Done ****************************

initshop:	bsr	clearworld
		bsr.s	inittank		;set up tank object
		bsr	initaddon		;set up add on object

		lea	ntscshopwindows,a0	;set the camera windows
		tst.b	PAL_TV
		beq.s	.ntsc
		lea	palshopwindows,a0
.ntsc:
		movem.l	(a0)+,d0-d5
		movem.l	d0-d2,tankwindow
		movem.l	d3-d5,addonwindow
		rts

inittank:	bsr	getempty
		move.l	a1,tankobject

		lea	tankcam,a2
		move.l	a1,ictarget(a2)

		move.l	#donowt,ido(a1)
		move.l	mergedanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.l	#20000,isxcoord(a1)
		move.l	#100,isycoord(a1)
		move.l	#0,iszcoord(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	mountx,d3-d5
		lea	tankcam+icxx,a6
		bsr	pointmatrix
		rts

initaddon:	bsr	getempty
		move.l	a1,addonobject

		lea	addoncam,a2
		move.l	a1,ictarget(a2)

		move.l	#dospin,ido(a1)
		move.l	#missileanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.l	#0,isxcoord(a1)
		move.l	#100,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.w	#0,ioxangle(a1)
		move.w	#0,ioyangle(a1)
		move.w	#0,iozangle(a1)

		move.w	#0,ioxrot(a1)
		move.w	#15,ioyrot(a1)
		move.w	#0,iozrot(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)
		rts

showshop:	move.l	rasterd,a0		;clear raster
		moveq.l	#0,d7
		jsr	clearraster

		move.l	rasterz,a0		;clear zbuffer
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0		;update the world
		bsr	doitem

		lea	shopcameras,a0	 	;update the cameras
		bsr	doitem
		jsr	waitgpu
		jsr	waitblitter
		rts

doneshop:	bsr	clearworld
		rts

******************************* Map Init,Show,Done ***************************

initmap:	bsr	clearworld		;set up the map shape
		bsr	getempty
		move.l	a1,mapobject

		lea	mapcam,a2
		move.l	a1,ictarget(a2)

		move.l	#dospin,ido(a1)
		move.l	#0,isanimframe(a1)

		move.l	#0,isxcoord(a1)
		move.l	#100,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.w	#0,ioxangle(a1)
		move.w	#0,ioyangle(a1)
		move.w	#0,iozangle(a1)

		move.w	#0,ioxrot(a1)
		move.w	#20,ioyrot(a1)
		move.w	#0,iozrot(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)
		rts

showmap:	move.l	rasterd,a0		;clear raster
		moveq.l	#0,d7
		jsr	clearraster

		move.l	rasterz,a0		;clear zbuffer
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0		;update the world
		bsr	doitem

		lea	mapcameras,a0	 	;update the cameras
		bsr	doitem

		jsr	waitgpu			;wait for cameras
		jsr	waitblitter
		rts

donemap:	bsr	clearworld
		rts
	
************************ Score Backdrop Init,Show,Done ***********************

initscorebackdrop:
		bsr	clearworld		;set up the map shape

		bsr	makehangar
		bsr	makerings
		bsr	makescoreflyer

makehangar:	bsr	getempty

		lea	scorebackdropcam,a2
		move.l	a1,ictarget(a2)

		tst.b	PAL_TV
		beq.s	.ntsc
.pal:
		movem.l	.palwindow,d0-d2
		bra.s	.setwindow
.ntsc:
		movem.l	.ntscwindow,d0-d2
.setwindow:
		movem.l	d0-d2,icclx(a2)

		move.l	#dospin,ido(a1)
		move.l	#hangaranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.l	#0,isxcoord(a1)
		move.l	#0,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.w	#0,ioxangle(a1)
		move.w	#0,ioyangle(a1)
		move.w	#0,iozangle(a1)

		move.w	#0,ioxrot(a1)
		move.w	#-10,ioyrot(a1)
		move.w	#0,iozrot(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)
		rts

.palwindow:	dc.w	-160,-140
		dc.w	160,140
		dc.w	160,140

.ntscwindow:	dc.w	-160,-120
		dc.w	160,120
		dc.w	160,120

makerings:	bsr	getempty

		lea	scorebackdropcam,a2
		move.l	a1,ictarget(a2)

		move.l	#dospin,ido(a1)
		move.l	#ringsanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.l	#0,isxcoord(a1)
		move.l	#0,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.w	#0,ioxangle(a1)
		move.w	#0,ioyangle(a1)
		move.w	#0,iozangle(a1)

		move.w	#30,ioxrot(a1)
		move.w	#40,ioyrot(a1)
		move.w	#50,iozrot(a1)

		movem.w	frontmat,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		clr.w	isblowup(a1)
		move.w	#playerTYPE,iotype(a1)
		rts

makescoreflyer:	bsr	getempty
		bsr	clearangles

		move.l	#0,isxcoord(a1)
		move.l	#0,isycoord(a1)
		move.l	#0,iszcoord(a1)

		move.l	#dospin,ido(a1)
		move.l	#flyeranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#playerTYPE,iotype(a1)

		move.w	#0,ioxrot(a1)
		move.w	#20,ioyrot(a1)
		move.w	#0,iozrot(a1)
		rts

showscorebackdrop:
		move.l	rasterd,a0		;clear raster
		moveq.l	#0,d7
		jsr	clearraster

		move.l	rasterz,a0		;clear zbuffer
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0		;update the world
		bsr	doitem

		lea	scorebackdropcameras,a0	;update the cameras
		bsr	doitem

		jsr	waitgpu			;wait for cameras
		jsr	waitblitter
		rts

donescorebackdrop:
		bsr	clearworld
		rts
	
******************************** Object Routines *****************************

********************************* Spin An Object *****************************

dospin:		movem.w	ioxangle(a0),d0-d2
		movem.w	ioxrot(a0),d3-d5
		add.w	d3,d0
		add.w	d4,d1
		add.w	d5,d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
		rts

******************************** Camera Routines *****************************

******************************** Fixed Camera ********************************

doviewercam:	lea	icxx(a0),a6		;calculate the camera's
		movem.w	icxangle(a0),d0-d2	;orientation matrix
		bsr	anglematrix

		movem.w	iczx(a0),d3-d5		;calculate the camera's
		move.w	icdist(a0),d6		;desired position
		neg.w	d6
		muls	d6,d3
		muls	d6,d4
		muls	d6,d5
		add.l	d3,d3
		add.l	d3,d3
		add.l	d4,d4
		add.l	d4,d4
		add.l	d5,d5
		add.l	d5,d5
		swap	d3
		swap	d4
		swap	d5
		ext.l	d3
		ext.l	d4
		ext.l	d5
		add.l	#camheight,d4
		movem.l	d3-d5,icxcoord(a0)	;save new position

		bsr	showview		;display camera
		rts

********************************* Zooming Camera *****************************

dozoomingcam:	movem.w	icxangle(a0),d0-d2	;update the camera angles
		add.w	icxrot(a0),d0
		add.w	icyrot(a0),d1
		add.w	iczrot(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,icxangle(a0)

		lea	icxx(a0),a6		;calculate the camera's
		movem.w	icxangle(a0),d0-d2	;orientation matrix
		bsr	anglematrix

		movem.w	iczx(a0),d0-d2		;set the camera's position
		move.w	icdist(a0),d3
		neg.w	d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		move.l	ictarget(a0),a1
		add.l	isxcoord(a1),d0
		add.l	isycoord(a1),d1
		add.l	iszcoord(a1),d2
		movem.l	d0-d2,icxcoord(a0)	;save new position

		bsr	showview		;display camera
		rts

***************************** Tank Mounting Camera ***************************

domountcam:	movem.w	mountx,d0-d2		;get position of mount
		bsr	makeunitvec
		neg.w	d0			;get z vector from
		neg.w	d1			;mount to object
		neg.w	d2
		movem.w	iczx(a0),d3-d5		;get current orientation
		sub.w	d3,d0			;get rotation vector
		sub.w	d4,d1
		sub.w	d5,d2

		move.w	d0,d7			;if the rotation vector
		muls	d7,d7			;is small then we're close
		move.w	d1,d6			;enough to just look
		muls	d6,d6			;straight through the mount
		add.l	d6,d7			;position
		move.w	d2,d6
		muls	d6,d6
		add.l	d6,d7
		cmp.l	#200*200,d7
		ble.s	.closeenough

		asr.w	#3,d0
		asr.w	#3,d1
		asr.w	#3,d2
.closeenough:
		add.w	d0,d3			;add rotation vector to z vector
		add.w	d1,d4
		add.w	d2,d5
		ext.l	d3
		ext.l	d4
		ext.l	d5
		move.l	d3,d0
		move.l	d4,d1
		move.l	d5,d2
		moveq.l	#0,d3			;point in new direction
		moveq.l	#0,d4
		moveq.l	#0,d5
		lea	icxx(a0),a6
		bsr	pointmatrix

		movem.w	iczx(a0),d0-d2		;set the camera's position
		move.w	icdist(a0),d3
		neg.w	d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		move.l	ictarget(a0),a1
		add.l	isxcoord(a1),d0
		add.l	isycoord(a1),d1
		add.l	iszcoord(a1),d2
		movem.l	d0-d2,icxcoord(a0)	;save new position

		bsr	showview		;display camera
		rts

******************************** Data Section ********************************

		data

****************************** Window Definitions ****************************

		even


palshopwindows:
		dc.w	-88,-45			;tank window - pal
		dc.w	89,45
		dc.w	SHOP_BIG_X-SHOP_BORD+94
		dc.w	260-(SHOP_BIG_Y-SHOP_BORD+48)
		
		dc.w	-43,-35			;addon window - pal
		dc.w	43,35
		dc.w	SHOP_ADDON_X-SHOP_BORD+46
		dc.w	260-(SHOP_ADDON_Y-SHOP_BORD1+8)

ntscshopwindows:
		dc.w	-88,-45			;tank window - pal
		dc.w	89,45
		dc.w	SHOP_BIG_X-SHOP_BORD+94
		dc.w	240-(SHOP_BIG_Y-SHOP_BORD+48)
		
		dc.w	-43,-35			;addon window - pal
		dc.w	43,35
		dc.w	SHOP_ADDON_X-SHOP_BORD+46
		dc.w	240-(SHOP_ADDON_Y-SHOP_BORD1+38)

***************************** Select Tank Cameras ****************************

		phrase
viewercameras:	dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	viewercam,viewercam	;first,last
		dc.l	dolist,donowt		;do,draw

		phrase
viewercam:	dc.l	viewercameras		;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	doviewercam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
		dc.l	0			;target
		dc.w	2048-200,256,0		;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	7000,0			;distance,zoom
viewerwindow:	dc.w	-160,-120		;clx,cly	botleft
		dc.w	160,120			;chx,chy	topright
		dc.w	160,120			;gox,goy	midpoint

***************************** Select Tank Cameras ****************************

		phrase
selectcameras:	dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	selectcam,selectcam	;first,last
		dc.l	dolist,donowt		;do,draw

		phrase
selectcam:	dc.l	selectcameras		;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	dozoomingcam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
		dc.l	0			;target
		dc.w	2048-200,256,0		;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	1500,0			;distance,zoom
selectwindow:	dc.w	-160,-120		;clx,cly	botleft
		dc.w	160,120			;chx,chy	topright
		dc.w	160,120			;gox,goy	midpoint

******************************** Shop Cameras ********************************

		phrase
shopcameras:	dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	tankcam,addoncam	;first,last
		dc.l	dolist,donowt		;do,draw

		phrase
tankcam:	dc.l	shopcameras		;parent
		dc.l	0,addoncam		;previous,next
		dc.l	0,0			;first,last
		dc.l	domountcam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
		dc.l	0			;target
		dc.w	0,0,0			;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	1500,0			;distance,zoom
tankwindow:	dc.w	0,0			;clx,cly	botleft
		dc.w	0,0			;chx,chy	topright
		dc.w	0,0			;gox,goy	midpoint

		phrase
addoncam:	dc.l	shopcameras		;parent
		dc.l	tankcam,0		;previous,next
		dc.l	0,0			;first,last
		dc.l	dozoomingcam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
		dc.l	0			;target
		dc.w	2048-200,256,0		;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	600,0			;distance,zoom
addonwindow:	dc.w	0,0			;clx,cly	botleft
		dc.w	0,0			;chx,chy	topright
		dc.w	0,0			;gox,goy	midpoint

**************************** Rotating Map Cameras ****************************

		phrase
mapcameras:	dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	mapcam,mapcam		;first,last
		dc.l	dolist,donowt		;do,draw

		phrase
mapcam:		dc.l	mapcameras		;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	dozoomingcam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
		dc.l	0			;target
		dc.w	2048-200,256,0		;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	4000,0			;distance,zoom
mapwindow:	dc.w	-160,-150		;clx,cly	botleft
		dc.w	160,90			;chx,chy	topright
		dc.w	160,150			;gox,goy	midpoint

*************************** Score Backdrop Cameras ***************************

		phrase
scorebackdropcameras:
		dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	scorebackdropcam,scorebackdropcam	;first,last
		dc.l	dolist,donowt		;do,draw

		phrase
scorebackdropcam:
		dc.l	scorebackdropcameras	;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	dozoomingcam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
		dc.l	0			;target
		dc.w	0,0,0			;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	3000,0			;distance,zoom
		dc.w	-160,-120		;clx,cly	botleft
		dc.w	160,120			;chx,chy	topright
		dc.w	160,120			;gox,goy	midpoint

		phrase
hangaranim:	dc.l	hangarvdf
ringsanim:	dc.l	ringsvdf

hangarvdf:	incbin	"graphics\\shapes\\full\\hangar.vdf"
ringsvdf:	incbin	"graphics\\shapes\\full\\rings.vdf"

********************************* BSS Section ********************************

		bss

******************************* Object Pointers ******************************

		even

tankobject:	ds.l	1
addonobject:	ds.l	1

mapobject:	ds.l	1
viewerobj:	ds.l	1

mountx:		ds.w	1
mounty:		ds.w	1
mountz:		ds.w	1

		.phrase
objectanim:	ds.l	1

