**************************** Gun Control Routines ****************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

*********************** Gun Tower Waiting For A Target ***********************

dogunwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	guncollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodegun

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0) 		;look for a target
		bne.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dogunattack,ido(a0)
.done:
		rts

************************ Gun Tower Shooting At Target ************************

dogunattack:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	guncollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble.s	explodegun

		bsr	confirmtarget 		;look at target
		beq.s	.losttarget
		bsr	rotatetotarget

		subq.w	#1,iotimer2(a0)		;shoot every now and then
		bne.s	.done
		jsr	random
		and.w	#3,d0
		add.w	#12,d0
		move.w	d0,iotimer2(a0)
		bsr	createenemyfrontlaser1
.done:
		rts
.losttarget:
		move.l	#dogunwait,ido(a0)
		rts

******************************** Gun Subroutines *****************************

guncollide:	move.l	a0,a1
		bsr.s	.partcollide
		move.l	inext(a0),a1
.partcollide:
		tst.l	iocollcode(a1)
		beq.s	.nocollide
		clr.l	iocollcode(a1)
		move.l	iocollobj(a1),a2
		move.w	iodamage(a2),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodegun:	move.l	inext(a0),a1
		move.l	#dobigbang,ido(a0)
		move.l	#dobigbang,ido(a1)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makegun:	bsr	getempty		;make gun objects
		bsr	getempty

		movem.l	position,d0-d2
		add.l	guntowerheight,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#midrange,iorange(a1)

		move.l	#dogunwait,ido(a1)
		move.l	#gunturretanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#gunTYPE,iotype(a1)
		move.w	#gunENERGY,ioenergy(a1)
		move.w	#gunDAMAGE,iodamage(a1)

		jsr	random
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)
		move.w	#1,iotimer2(a1)

		move.w	#0,iobarrelx(a1)
		move.w	#50,iobarrely(a1)
		move.w	#350,iobarrelz(a1)

		move.l	inext(a1),a2
		movem.l	isxcoord(a1),d0-d2
		movem.l	d0-d2,isxcoord(a2)
		movem.w	isxx(a1),d0-d7/a3
		movem.w	d0-d7/a3,isxx(a2)

		move.l	#donowt,ido(a2)
		move.l	#guntoweranim,isanimbase(a2)
		move.l	#0,isanimframe(a2)

		move.w	#enemyCLASS,ioclass(a2)
		move.w	#gunTYPE,iotype(a2)
		move.w	#gunENERGY,ioenergy(a2)
		move.w	#gunDAMAGE,iodamage(a1)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************
 
		phrase
guntoweranim:	dc.l	guntowervdf
gunturretanim:	dc.l	gunturretvdf

********************************* VDF Files **********************************

guntowervdf:	dc.w	guntowerc-guntowervdf

guntowers:	dc.w	575

		dc.w	13

		dc.w	-130,-500,-200,0,0,0		;0
		dc.w	130,-500,-200,0,0,0		;1
		dc.w	-130,-500,200,0,0,0		;2
		dc.w	130,-500,200,0,0,0		;3
		dc.w	-130,-500,-60,0,0,0		;4
		dc.w	130,-500,-60,0,0,0		;5
		dc.w	-130,-500,60,0,0,0		;6
		dc.w	130,-500,60,0,0,0		;7

		dc.w	-200,-500,-40,0,0,0		;8
		dc.w	200,-500,-40,0,0,0		;9
		dc.w	-200,-500,40,0,0,0		;10
		dc.w	200,-500,40,0,0,0		;11
		dc.w	0,0,0,0,0,0			;12

		dc.w	10

		dc.w	$401e,5,2,12,0,4,6
		dc.w	$8002,3,12,10,8
		dc.w	$401c,3,0,12,8
		dc.w	$401c,3,10,12,2

		dc.w	$401e,5,1,12,3,7,5
		dc.w	$8002,3,12,9,11
		dc.w	$401c,3,9,12,1
		dc.w	$401c,3,3,12,11

		dc.w	$8002,3,12,4,5
		dc.w	$8002,3,12,7,6

guntowerc:	dc.w	575

		dc.w	1

		dc.w	-200,-500,-200
		dc.w	400,500,400
		dc.w	solid+static+gunCODE

gunturretvdf:	dc.w	gunturretc-gunturretvdf

gunturrets:	dc.w	380

		dc.w	13

		dc.w	-50,0,-100,0,0,0		;0
		dc.w	50,0,-100,0,0,0			;1
		dc.w	-50,0,100,0,0,0			;2
		dc.w	50,0,100,0,0,0			;3
		dc.w	-50,100,-100,0,0,0		;4
		dc.w	50,100,-100,0,0,0		;5
		dc.w	-50,100,100,0,0,0		;6
		dc.w	50,100,100,0,0,0		;7

		dc.w	-200,50,-70,0,0,0		;8
		dc.w	200,50,-70,0,0,0		;9
		dc.w	-200,50,70,0,0,0		;10
		dc.w	200,50,70,0,0,0			;11

		dc.w	0,50,300,0,0,0			;12

		dc.w	15

		dc.w	$4037,3,6,7,12
		dc.w	$4037,3,3,2,12
		dc.w	$4038,3,7,3,12
		dc.w	$4038,3,2,6,12

		dc.w	$4037,3,0,4,8
		dc.w	$4037,3,5,1,9
		dc.w	$8003,3,6,2,10
		dc.w	$8004,3,3,7,11

		dc.w	$4038,4,10,8,4,6
		dc.w	$4038,4,9,11,7,5
		dc.w	$4038,4,8,10,2,0
		dc.w	$4038,4,11,9,1,3

		dc.w	$4039,4,4,5,7,6
		dc.w	$4039,4,1,0,2,3
		dc.w	$4102,4,0,1,5,4

gunturretc:	dc.w	380

		dc.w	2

		dc.w	-200,0,-100
		dc.w	200,100,400
		dc.w	solid+static+gunCODE

		dc.w	-50,0,-100
		dc.w	100,100,400
		dc.w	solid+static+gunCODE

******************** This shape is used in the object viewer *****************
********************** It has the tower and turret combined ******************

wholegunvdf:	dc.w	0

wholeguns:	dc.w	2000

		dc.w	26

		dc.w	-130,-500,-200,0,0,0		;0	tower points
		dc.w	130,-500,-200,0,0,0		;1
		dc.w	-130,-500,200,0,0,0		;2
		dc.w	130,-500,200,0,0,0		;3
		dc.w	-130,-500,-60,0,0,0		;4
		dc.w	130,-500,-60,0,0,0		;5
		dc.w	-130,-500,60,0,0,0		;6
		dc.w	130,-500,60,0,0,0		;7
		dc.w	-200,-500,-40,0,0,0		;8
		dc.w	200,-500,-40,0,0,0		;9
		dc.w	-200,-500,40,0,0,0		;10
		dc.w	200,-500,40,0,0,0		;11
		dc.w	0,0,0,0,0,0			;12

		dc.w	-50,0,-100,0,0,0		;13	turret points
		dc.w	50,0,-100,0,0,0			;14
		dc.w	-50,0,100,0,0,0			;15
		dc.w	50,0,100,0,0,0			;16
		dc.w	-50,100,-100,0,0,0		;17
		dc.w	50,100,-100,0,0,0		;18
		dc.w	-50,100,100,0,0,0		;19
		dc.w	50,100,100,0,0,0		;20
		dc.w	-200,50,-70,0,0,0		;21
		dc.w	200,50,-70,0,0,0		;22
		dc.w	-200,50,70,0,0,0		;23
		dc.w	200,50,70,0,0,0			;24
		dc.w	0,50,300,0,0,0			;25

		dc.w	25

		dc.w	$401e,5,2,12,0,4,6		;tower polygons
		dc.w	$8002,3,12,10,8
		dc.w	$401c,3,0,12,8
		dc.w	$401c,3,10,12,2
		dc.w	$401e,5,1,12,3,7,5
		dc.w	$8002,3,12,9,11
		dc.w	$401c,3,9,12,1
		dc.w	$401c,3,3,12,11
		dc.w	$8002,3,12,4,5
		dc.w	$8002,3,12,7,6

		dc.w	$4037,3,19,20,25		;turret polygons
		dc.w	$4037,3,16,15,25
		dc.w	$4038,3,20,16,25
		dc.w	$4038,3,15,19,25
		dc.w	$4037,3,13,17,21
		dc.w	$4037,3,18,14,22
		dc.w	$8003,3,19,15,23
		dc.w	$8004,3,16,20,24
		dc.w	$4038,4,23,21,17,19
		dc.w	$4038,4,22,24,20,18
		dc.w	$4038,4,21,23,15,13
		dc.w	$4038,4,24,22,14,16
		dc.w	$4039,4,17,18,20,19
		dc.w	$4039,4,14,13,15,16
		dc.w	$4102,4,13,14,18,17

********************************* BSS Section ********************************

	bss

********************************** Variables *********************************

	even

guntowerheight:	ds.l	1
