************************ Homing Enemy Control Routines ***********************

* Notes:

********************************* Code Section *******************************

		text
		.68000

************************** Straight Line Homer Routines **********************

dostraightwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	readswitch
		beq.s	.done

		bsr.s	homercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble.s	explodehomer

		subq.w	#1,iotimer2(a0)		;try to find a target
		bpl.s	.done
		move.w	#shortaidelay,iotimer2(a0)

		bsr	closesttarget		;may not be any targets
		move.l	a1,iotarget(a0)		;left to shoot!
		beq.s	.done
		move.l	#dostraighthome,ido(a0)	;we have a target!
.done:
		rts

dostraighthome:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	doobjcoll		;deal with collisions
		bsr.s	homercollide
		tst.w	ioenergy(a0)
		ble.s	explodehomer

		bsr	confirmtarget 		;reaquire target if needed
		beq.s	.losttarget
		bsr	flatrotatetotarget	;point at the target
		bsr.s	movehomer		;and fly towards it
.done:
		rts
.losttarget:
		move.l	#dostraightwait,ido(a0)
		rts

******************************* Homer Subroutines ****************************

homercollide:	move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		cmp.w	#repellCODE,d0
		beq.s	.nocollide
		cmp.w	#attractCODE,d0
		beq.s	.nocollide
		move.w	#-1,ioenergy(a0)
.nocollide:
		rts

explodehomer:	move.l	#dosmallbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

movehomer:	move.w	iozspeed(a0),d0		;accelerate the homer
		add.w	#20,d0			;to it's top speed
		cmp.w	#150,d0
		ble.s	.speedok
		move.w	#150,d0
.speedok:
		move.w	d0,iozspeed(a0)

		movem.w	iszx(a0),d0-d2 		;move the homer
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
		rts

******************************* Object Generators ****************************

makehomer:	bsr	getempty		;make a homer object

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.w	#60,iotimer(a1)
		move.w	#1,iotimer2(a1)
		move.w	#0,iozspeed(a1)

		move.l	#10000,iorange(a1)

		addq.w	#1,baddies

		move.l	index,d0
		cmp.l	#1,d0
		beq.s	.type2
.type1:
		move.l	straightheight,d0
		add.l	d0,isycoord(a1)

		move.l	#dostraightwait,ido(a1)
		move.l	#straightanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#straightTYPE,iotype(a1)
		move.w	#straightENERGY,ioenergy(a1)
		move.w	#straightDAMAGE,iodamage(a1)
		rts
.type2:
		illegal				;should be a spiral homer
		rts				;bit extraneous now though

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
straightanim:	dc.l	straightvdf

spiralanim:	dc.l	spiralvdf

********************************** VDF Files *********************************

straightvdf:	incbin	"graphics\\shapes\\enemies\\homer.vdf"
spiralvdf:	incbin	"graphics\\shapes\\enemies\\homer.vdf"

********************************* BSS Section ********************************

		bss

********************************* Variables **********************************

		even

straightheight:	ds.l	1
spiralheight:	ds.l	1
