******************************** Horizon Code ********************************

* Notes:

*********************************** Macros ***********************************

macro		pers1
		asl.l	#persp,\1
		asl.l	#persp,\2
		add.l	#1<<persp,\3
		cmp.l	\4,\3
		ble.s	.shrunk\~
.shrink\~:
		asr.l	#2,\1
		asr.l	#2,\2
		asr.l	#2,\3
		cmp.l	\4,\3
		bgt.s	.shrink\~
.shrunk\~:
		divs	\3,\1
		divs	\3,\2
		endm

********************************* Code Section *******************************

		text
		.68000

*************************** Calculate Horizon Polygons ***********************

horizon:	move.l	viewxz,d0		;zvector
		move.l	viewyz,d1
		move.l	viewzz,d2
		move.l	d0,a3
		move.l	d1,a4
		move.l	d2,a5
		move.l	viewxx,d3		;xvector
		move.l	viewyx,d4
		move.l	viewzx,d5
		move.l	groundcolour,d7

		sub.l	d3,d0
		sub.l	d4,d1
		sub.l	d5,d2
		bpl.s	.pos1
		neg.l	d0
		neg.l	d1
		neg.l	d2
		swap	d7
.pos1:
		asr.l	d3
		asr.l	d4
		asr.l	d5
		add.l	a3,d3
		add.l	a4,d4
		add.l	a5,d5
		bpl.s	.pos2
		neg.l	d3
		neg.l	d4
		neg.l	d5
		swap	d7
.pos2:
		move.l	#16384,d6
		pers1	d0,d1,d2,d6
		pers1	d3,d4,d5,d6
		ext.l	d0
		ext.l	d1
		ext.l	d3
		ext.l	d4

		move.l	d3,d5
		sub.l	d0,d5
		bpl.s	.pos3
		neg.l	d5
.pos3:
		move.l	d4,d6
		sub.l	d1,d6
		bpl.s	.pos4
		neg.l	d6
.pos4:
		cmp.l	d5,d6
		bgt	.vertically
.horizontally:
		cmp.l	d0,d3
		bge.s	.right
		exg	d0,d3
		exg	d1,d4
		swap	d7
.right:
		move.l	d3,d5
		move.l	d4,d6
		sub.l	d0,d5
		sub.l	d1,d6
		move.l	d1,d4
		move.l	clx,d1
		move.l	chx,d3
		sub.l	d0,d1
		sub.l	d0,d3
		muls	d6,d1
		muls	d6,d3
		divs	d5,d1
		divs	d5,d3
		ext.l	d1
		ext.l	d3
		add.l	d4,d1
		add.l	d4,d3
		move.l	clx,d0
		move.l	chx,d2

		bsr	calcis

		cmp.w	skycolour,d7
		beq.s	.skyfirst1
		bsr	drawbottom
		bsr	drawsun
		bsr	drawtop
		rts
.skyfirst1:
		bsr	drawtop
		bsr	drawsun
		bsr	drawbottom
		rts
.vertically:
		cmp.l	d1,d4
		bge.s	.up
		exg	d0,d3
		exg	d1,d4
		swap	d7
.up:
		move.l	d3,d5
		move.l	d4,d6
		sub.l	d0,d5
		sub.l	d1,d6
		move.l	d0,d4
		move.l	cly,d0
		move.l	chy,d2
		sub.l	d1,d0
		sub.l	d1,d2
		muls	d5,d0
		muls	d5,d2
		divs	d6,d0
		divs	d6,d2
		ext.l	d0
		ext.l	d2
		add.l	d4,d0
		add.l	d4,d2
		move.l	cly,d1
		move.l	chy,d3

		bsr	calcis

		cmp.w	skycolour,d7
		beq.s	.skyfirst2
		bsr	drawright
		bsr	drawsun
		bsr	drawleft
		rts
.skyfirst2:
		bsr	drawleft
		bsr	drawsun
		bsr	drawright
		rts

drawtop:	cmp.l	chy,d1
		bge.s	.top2
		cmp.l	chy,d3
		bge	.top3

		move.l	#4,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	clx,(a6)+
		move.l	chy,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uli,(a6)+
		move.l	chx,(a6)+
		move.l	chy,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uri,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		bra.s	.donetop
.top2:
		cmp.l	chy,d3
		bge.s	.donetop

		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uli,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		bra.s	.donetop
.top3:
		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d0,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uli,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
.donetop:
		rts

drawbottom:	swap	d7
		cmp.l	cly,d1
		blt.s	.bottom2
		cmp.l	cly,d3
		blt	.bottom3

		move.l	#4,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	chx,(a6)+
		move.l	cly,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lri,(a6)+
		move.l	clx,(a6)+
		move.l	cly,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lli,(a6)+
		bra.s	.donebottom
.bottom2:
		cmp.l	cly,d3
		blt.s	.donebottom

		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lli,(a6)+
		bra.s	.donebottom
.bottom3:
		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d0,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lri,(a6)+
.donebottom:
		swap	d7
		rts

drawleft:	cmp.l	clx,d0
		blt.s	.left2
		cmp.l	clx,d2
		blt	.left3

		move.l	#4,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	clx,(a6)+
		move.l	cly,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lli,(a6)+
		move.l	clx,(a6)+
		move.l	chy,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uli,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		bra.s	.doneleft
.left2:
		cmp.l	clx,d2
		blt.s	.doneleft

		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d0,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uli,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		bra.s	.doneleft
.left3:
		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lli,(a6)+
.doneleft:
		rts

drawright:	swap	d7
		cmp.l	chx,d0
		bge.s	.right2
		cmp.l	chx,d2
		bge	.right3

		move.l	#4,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	chx,(a6)+
		move.l	chy,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uri,(a6)+
		move.l	chx,(a6)+
		move.l	cly,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lri,(a6)+
		bra.s	.doneright
.right2:
		cmp.l	chx,d2
		bge.s	.doneright

		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d0,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	uri,(a6)+
		bra.s	.doneright
.right3:
		move.l	#3,(a6)+
		move.w	d7,(a6)+
		move.w	d7,(a6)+

		move.l	d0,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d3,(a6)+
		move.l	#horizonz,(a6)+
		move.l	#$e7,(a6)+
		move.l	d2,(a6)+
		move.l	d1,(a6)+
		move.l	#horizonz,(a6)+
		move.l	lri,(a6)+
.doneright:
		swap	d7
		rts

drawsun:	rts
		tst.w	suncolour
		bmi.s	.done
		movem.w	viewyx,d4-d6		;get position vector
		asr.w	#2,d4
		asr.w	#2,d5
		asr.w	#2,d6
		add.w	viewzx,d4
		add.w	viewzy,d5
		add.w	viewzz,d6
		bmi.s	.done			;is it behind us?
		ext.l	d4
		ext.l	d5
		ext.l	d6
		lea	32767.w,a0
		pers1	d4,d5,d6,a0		;get screen position
;		lea	graphicsdata,a0
		move.w	#100,-(a0)		;draw it
		movem.w	d4-d5,-(a0)
		move.w	suncolour,-(a0)
		movem.l	d0-d3/d7,-(sp)
;		jsr	circle
		movem.l	(sp)+,d0-d3/d7
.done:
		rts

calcis:		rts
		movem.l	d0-d3,-(sp)

		move.l	d0,d4			;save these for later
		move.l	d1,d5

		sub.l	d0,d2			;find normal vector
		sub.l	d1,d3			;from horizon vector
		neg.l	d2
		exg.l	d2,d3

		move.l	d2,d0			;make normal vector
		move.l	d3,d1			;into a unit vector
		muls	d0,d0
		muls	d1,d1
		add.l	d1,d0
		bsr	root
		move.l	#16384,d1
		divu	d0,d1
		muls	d1,d2
		muls	d1,d3
		add.l	d2,d2
		add.l	d2,d2
		add.l	d3,d3
		add.l	d3,d3
		swap	d2
		swap	d3

		movem.l	clx,d0-d1		;calc intensity for
		sub.l	d4,d0			;lower left corner
		sub.l	d5,d1
		muls	d2,d0
		muls	d3,d1
		add.l	d1,d0
		bpl.s	.pos1
		neg.l	d0
.pos1:
		asr.l	#8,d0
		neg.w	d0
		add.l	#$98,d0
		move.l	d0,lli

		move.l	chx,d0			;calc intensity for
		move.l	cly,d1			;lower right corner
		sub.l	d4,d0
		sub.l	d5,d1
		muls	d2,d0
		muls	d3,d1
		add.l	d1,d0
		bpl.s	.pos2
		neg.l	d0
.pos2:
		asr.l	#8,d0
		neg.l	d0
		add.l	#$98,d0
		move.l	d0,lri

		move.l	clx,d0			;calc intensity for
		move.l	chy,d1			;upper left corner
		sub.l	d4,d0
		sub.l	d5,d1
		muls	d2,d0
		muls	d3,d1
		add.l	d1,d0
		bpl.s	.pos3
		neg.l	d0
.pos3:
		asr.l	#8,d0
		neg.l	d0
		add.l	#$98,d0
		move.l	d0,uli

		move.l	chx,d0			;calc intensity for
		move.l	chy,d1			;upper right corner
		sub.l	d4,d0
		sub.l	d5,d1
		muls	d2,d0
		muls	d3,d1
		add.l	d1,d0
		bpl.s	.pos4
		neg.l	d0
.pos4:
		asr.l	#8,d0
		neg.l	d0
		add.l	#$98,d0
		move.l	d0,uri

		movem.l	(sp)+,d0-d3
		rts

******************************* Data Section ******************************

		data

******************************** Variables ********************************

groundcolour:	dc.w	$0a
skycolour:	dc.w	$b7
suncolour:	dc.w	-1

lli:		dc.l	$18		;intensities for screen corners
lri:		dc.l	$18
uli:		dc.l	$18
uri:		dc.l	$18

******************************* BSS Section *******************************

	bss

************************** Horizon Polygon Buffer *************************

		phrase
hbuffer:	ds.b	4*4*8*4
