********************************** Item Code *********************************

* Notes:
* a0 = current item
* a1 = new item
* a2 = parent item

* The dolist and drawlist routines save the next item pointer on the
* stack so that an item can delete itself. If this is not done then
* the list routines get the wrong next item.

******************************** Code Section ********************************

		text
		.68000

******************************** Item Routines *******************************

doitem:		move.l	ido(a0),a6
		jsr	(a6)
		rts

;drawitem:	move.l	idraw(a0),a6
;		jsr	(a6)
;		rts

dolist:		move.l	a0,-(sp)
		move.l	ifirst(a0),d0
		beq.s	.empty
.doitems:
		move.l	d0,a0
		move.l	inext(a0),-(sp)
		move.l	ido(a0),a6
		jsr	(a6)
		move.l	(sp)+,d0
		bne.s	.doitems
.empty:
		move.l	(sp)+,a0
		rts

;drawlist:	move.l	a0,-(sp)
;		move.l	ifirst(a0),d0
;		beq.s	.empty
;.drawitems:
;		move.l	d0,a0
;		move.l	inext(a0),-(sp)
;		move.l	idraw(a0),a6
;		jsr	(a6)
;		move.l	(sp)+,d0
;		bne.s	.drawitems
;.empty:
;		move.l	(sp)+,a0
;		rts

dofirst:	move.l	a0,-(sp)
		move.l	ifirst(a0),d0
		beq.s	.empty
		move.l	d0,a0
		move.l	ido(a0),a6
		jsr	(a6)
.empty:
		move.l	(sp)+,a0
		rts

;drawfirst:	move.l	a0,-(sp)
;		move.l	ifirst(a0),d0
;		beq.s	.empty
;		move.l	d0,a0
;		move.l	idraw(a0),a6
;		jsr	(a6)
;.empty:
;		move.l	(sp)+,a0
;		rts

iaddfirst:	movem.l	d7/a6,-(sp)
		move.l	ifirst(a2),d7		;add item a1 at the
		beq.s	.empty			;start of list a2
		move.l	a1,ifirst(a2)
		move.l	d7,a6
		move.l	a6,inext(a1)
		clr.l	iprev(a1)
		move.l	a1,iprev(a6)
		move.l	a2,iparent(a1)
		movem.l	(sp)+,d7/a6
		rts
.empty:
		move.l	a1,ifirst(a2)
		move.l	a1,ilast(a2)
		move.l	a2,iparent(a1)
		clr.l	iprev(a1)
		clr.l	inext(a1)
		movem.l	(sp)+,d7/a6
		rts

iaddlast:	movem.l	d7/a6,-(sp)
		move.l	ilast(a2),d7		;add item a1 at the
		beq.s	.empty			;end of list a2
		move.l	a1,ilast(a2)
		move.l	d7,a6
		clr.l	inext(a1)
		move.l	a1,inext(a6)
		move.l	a6,iprev(a1)
		move.l	a2,iparent(a1)
		movem.l	(sp)+,d7/a6
		rts
.empty:
		move.l	a1,ifirst(a2)
		move.l	a1,ilast(a2)
		move.l	a2,iparent(a1)
		clr.l	iprev(a1)
		clr.l	inext(a1)
		movem.l	(sp)+,d7/a6
		rts

iaddbefore:	movem.l	d7/a6,-(sp)
		move.l	iprev(a0),d7		;add item a1
		beq.s	.first			;before item a0
		move.l	d7,a6
		move.l	inext(a6),inext(a1)
		move.l	a1,inext(a6)
		move.l	a1,iprev(a0)
		move.l	a6,iprev(a1)
		move.l	iparent(a0),a6
		move.l	a6,iparent(a1)
		movem.l	(sp)+,d7/a6
		rts
.first:
		move.l	iparent(a0),a6
		move.l	a6,iparent(a1)
		move.l	a1,ifirst(a6)
		move.l	a0,inext(a1)
		move.l	a1,iprev(a0)
		clr.l	iprev(a1)
		movem.l	(sp)+,d7/a6
		rts

iaddafter:	movem.l	d7/a6,-(sp)
		move.l	inext(a0),d7		;add item a1
		beq.s	.last			;after item a0
		move.l	d7,a6
		move.l	inext(a6),inext(a1)
		move.l	a1,inext(a6)
		move.l	a1,iprev(a0)
		move.l	a6,iprev(a1)
		move.l	iparent(a0),a6
		move.l	a6,iparent(a1)
		movem.l	(sp)+,d7/a6
		rts
.last:
		move.l	iparent(a0),a6
		move.l	a6,iparent(a1)
		move.l	a1,ilast(a6)
		move.l	a1,inext(a0)
		clr.l	inext(a1)
		move.l	a0,iprev(a1)
		movem.l	(sp)+,d7/a6
		rts

iremove:	movem.l	d6-d7/a5-a6,-(sp)
		move.l	iprev(a1),d6		;remove item a1
		beq.s	.first			;from list a2
		move.l	inext(a1),d7
		beq.s	.last
		move.l	d6,a5
		move.l	d7,a6
		move.l	a6,inext(a5)
		move.l	a5,iprev(a6)
		movem.l	(sp)+,d6-d7/a5-a6
		rts
.first:
		move.l	inext(a1),d6
		beq.s	.only
		move.l	d6,a6
		move.l	a6,ifirst(a2)
		clr.l	iprev(a6)
		movem.l	(sp)+,d6-d7/a5-a6
		rts
.last:
		move.l	iprev(a1),a6
		move.l	a6,ilast(a2)
		clr.l	inext(a6)
		movem.l	(sp)+,d6-d7/a5-a6
		rts
.only:
		clr.l	ifirst(a2)
		clr.l	ilast(a2)
		movem.l	(sp)+,d6-d7/a5-a6
		rts
