****************************** Laser Control File ****************************

* Notes:


********************************* Code Section *******************************

		text
		.68000

********************************* Player Laser *******************************

doplayerlaser:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		subq.w	#1,iotimer(a0)		;has the laser been
		bmi	killobject		;on long enough?

		bsr	doobjcoll		;deal with collisions

		tst.l	iocollfloor(a0)
		bne	.tiny

		move.l	iocollcode(a0),d0
		beq	.movelaser
		clr.l	iocollcode(a0)

		cmp.w	#stopCODE,d0		;stops
		beq.s	.tiny
		cmp.w	#warpCODE,d0		;warps
		beq.s	.small
		cmp.w	#rprismCODE,d0		;right prisms
		beq.s	.rprism
		cmp.w	#lprismCODE,d0		;left prisms
		beq.s	.lprism
		cmp.w	#barrierCODE,d0		;energy barriers
		beq.s	.movelaser
		cmp.w	#tripswitchCODE,d0	;trip switches
		beq.s	.movelaser
		cmp.w	#laserCODE,d0		;other lasers
		beq.s	.movelaser
		cmp.w	#plasmaCODE,d0		;plasmas
		beq.s	.movelaser

; add to player's score here

		bra.s	.small
.rprism:
		movem.w	isxx(a0),d0-d7/a1	;spin the laser
		neg.w	d0			;right by 90 degrees
		neg.w	d3
		neg.w	d6
		exg.l	d0,d2
		exg.l	d3,d5
		exg.l	d6,a1
		movem.w	d0-d7/a1,isxx(a0)
		bra.s	.movelaser
.lprism:
		movem.w	isxx(a0),d0-d7/a1	;spin the laser
		exg.l	d0,d2			;left by 90 degrees
		exg.l	d3,d5
		exg.l	d6,a1
		neg.w	d0
		neg.w	d3
		neg.w	d6
		movem.w	d0-d7/a1,isxx(a0)
		bra.s	.movelaser
.tiny:
		move.l	#dotinybang,ido(a0)
		bra.s	.done
.small:
		move.l	#dosmallbang,ido(a0)
		bra.s	.done
.movelaser:
		movem.w	iszx(a0),d0-d2		;move the laser
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
.done:
		rts

********************************** Enemy Laser *******************************

doenemylaser:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		subq.w	#1,iotimer(a0)		;has the laser been
		bmi	killobject		;on long enough?

		bsr	doobjcoll		;deal with collisions

		tst.l	iocollfloor(a0)
		bne	.tiny

		move.l	iocollcode(a0),d0
		beq	.movelaser
		clr.l	iocollcode(a0)

		cmp.w	#stopCODE,d0		;stops
		beq.s	.small
		cmp.w	#warpCODE,d0		;warps
		beq.s	.small
		cmp.w	#repellCODE,d0		;repellors
		beq.s	.movelaser
		cmp.w	#attractCODE,d0		;attractors
		beq.s	.movelaser
		cmp.w	#rprismCODE,d0		;right prisms
		beq.s	.rprism
		cmp.w	#lprismCODE,d0		;left prisms
		beq.s	.lprism
		cmp.w	#barrierCODE,d0		;energy barriers
		beq.s	.movelaser
		cmp.w	#tripswitchCODE,d0	;trip switches
		beq.s	.movelaser
		cmp.w	#laserCODE,d0		;other lasers
		beq.s	.movelaser
		cmp.w	#plasmaCODE,d0		;plasmas
		beq.s	.movelaser
		bra.s	.small
.rprism:
		movem.w	isxx(a0),d0-d7/a1	;spin the laser
		neg.w	d0			;right by 90 degrees
		neg.w	d3
		neg.w	d6
		exg.l	d0,d2
		exg.l	d3,d5
		exg.l	d6,a1
		movem.w	d0-d7/a1,isxx(a0)
		bra.s	.movelaser
.lprism:
		movem.w	isxx(a0),d0-d7/a1	;spin the laser
		exg.l	d0,d2			;left by 90 degrees
		exg.l	d3,d5
		exg.l	d6,a1
		neg.w	d0
		neg.w	d3
		neg.w	d6
		movem.w	d0-d7/a1,isxx(a0)
		bra.s	.movelaser
.tiny:
		move.l	#dotinybang,ido(a0)
		bra.s	.done
.small:
		move.l	#dosmallbang,ido(a0)
		bra.s	.done
.movelaser:
		movem.w	iszx(a0),d0-d2		;move the laser
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
.done:
		rts

****************************** Object Generators *****************************

******************************** Player Lasers *******************************

createdronefrontlasers:
		move.w	iopower(a0),d0		;create forward facing lasers
		subq.w	#1,d0
		move.w	d0,d1
		muls	#-(laserspacing/2),d1

		move.l	ioweapons(a0),a1
		and.w	#2047,d3
.lasers:
		and.w	#2047,d1
		movem.w	d0-d1,-(sp)
		move.w	d1,yangle
		bsr	createplayerlaser
		movem.w	(sp)+,d0-d1
		add.w	#laserspacing,d1
		dbf	d0,.lasers

		moveq.l	#SFX_PLAYER_LASER,d7
		jsr	ADD_SFX
		rts

createplayerfrontlasers:
		movem.w	isxx(a0),d0-d7/a2	;fools the lasers into following
		movem.w	d0-d7/a2,-(sp)		;the aim matrix and not
		move.l	ioweapons(a0),a1	;the player's matrix
		movem.w	AIMMATRIX(a1),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a0)

		move.w	iopower(a0),d0		;create forward facing lasers
		subq.w	#1,d0
		move.w	d0,d1
		muls	#-(laserspacing/2),d1

		move.l	ioweapons(a0),a1
		and.w	#2047,d3
.lasers:
		and.w	#2047,d1
		movem.w	d0-d1,-(sp)
		move.w	d1,yangle
		bsr	createplayerlaser
		movem.w	(sp)+,d0-d1
		add.w	#laserspacing,d1
		dbf	d0,.lasers

		movem.w	(sp)+,d0-d7/a2		;restore player's matrix
		movem.w	d0-d7/a2,isxx(a0)

		moveq.l	#SFX_PLAYER_LASER,d7
		jsr	ADD_SFX
		rts

createplayerrearlasers:
		move.w	iopower(a0),d0		;create rearward facing lasers
		subq.w	#1,d0
		move.w	d0,d1
		muls	#-(laserspacing/2),d1
		add.w	#1024,d1
.lasers:
		and.w	#2047,d1
		movem.w	d0-d1,-(sp)
		move.w	d1,yangle
		bsr	createplayerlaser
		movem.w	(sp)+,d0-d1
		add.w	#laserspacing,d1
		dbf	d0,.lasers

		moveq.l	#SFX_PLAYER_LASER,d7
		jsr	ADD_SFX
		rts

createplayerlaser:
		bsr	getempty		;create a player laser
		beq.s	.none

		move.l	#doplayerlaser,ido(a1)
		move.l	#plaseranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d1-d7/a2-a3
		movem.w	d1-d7/a2-a3,isxx(a1)
		lea	isxx(a1),a6
		bsr	matroty

		move.w	#200,d0
		bsr	movetobarrel

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#laserTYPE,iotype(a1)
		move.w	#laserDAMAGE,iodamage(a1)

		move.w	#20,iotimer(a1)
		move.w	#400,iozspeed(a1)

		clr.w	iotimer2(a1)
.none:
		rts

******************************** Enemy Lasers ********************************

createenemyfrontlaser1:
		move.w	#0,yangle		;one forward facing laser
		bsr	createenemylaser

		moveq.l	#SFX_ENEMY_TANK_LASER,d7
		jsr	ADD_SFX
		rts

createenemyfrontlaser3:
		move.w	#2048-100,yangle	;three forward facing lasers
		bsr	createenemylaser
		move.w	#0,yangle
		bsr	createenemylaser
		move.w	#100,yangle
		bsr	createenemylaser

		moveq.l	#SFX_ENEMY_TANK_LASER,d7
		jsr	ADD_SFX
		rts

createenemylaser:
		bsr	getempty		;create an enemy laser
		beq.s	.none

		move.l	#doenemylaser,ido(a1)
		move.l	#elaseranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d1-d7/a2-a3
		movem.w	d1-d7/a2-a3,isxx(a1)
		lea	isxx(a1),a6
		bsr	matroty

		move.w	#200,d0
		bsr	movetobarrel

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#laserTYPE,iotype(a1)
		move.w	#laserDAMAGE,iodamage(a1)

		move.w	#5000/400,iotimer(a1)
		move.w	#400,iozspeed(a1)
.none:
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

********************************* Animations *********************************

		phrase

plaseranim:	dc.l	plaservdf

elaseranim:	dc.l	elaservdf

********************************** VDF Files *********************************

plaservdf:	dc.w	plaserc-plaservdf

plasershape:	dc.w	350

		dc.w	6

		dc.w	0,0,-200,0,0,0			;0
		dc.w	0,0,200,0,0,0			;1
		dc.w	-15,0,100,0,0,0			;2
		dc.w	15,0,100,0,0,0			;3
		dc.w	0,-15,100,0,0,0			;4
		dc.w	0,15,100,0,0,0			;5

		dc.w	8

		dc.w	$0100,3,3,5,0	;0,5,3
		dc.w	$0100,3,4,3,0	;0,3,4
		dc.w	$0100,3,2,4,0	;0,4,2
		dc.w	$0100,3,5,2,0	;0,2,5
		dc.w	$0100,3,5,3,1	;1,3,5
		dc.w	$0100,3,3,4,1	;1,4,3
		dc.w	$0100,3,4,2,1	;1,2,4
		dc.w	$0100,3,2,5,1	;1,5,2

plaserc:	dc.w	350

		dc.w	4

		dc.w	-15,-15,-200
		dc.w	30,30,100
		dc.w	laserCODE

		dc.w	-15,-15,-100
		dc.w	30,30,100
		dc.w	laserCODE

		dc.w	-15,-15,0
		dc.w	30,30,100
		dc.w	laserCODE

		dc.w	-15,-15,100
		dc.w	30,30,100
		dc.w	laserCODE

elaservdf:	dc.w	elaserc-elaservdf

elasershape:	dc.w	350

		dc.w	6

		dc.w	0,0,-200,0,0,0			;0
		dc.w	0,0,200,0,0,0			;1
		dc.w	-25,0,100,0,0,0			;2
		dc.w	25,0,100,0,0,0			;3
		dc.w	0,-25,100,0,0,0			;4
		dc.w	0,25,100,0,0,0			;5

		dc.w	8

		dc.w	$0101,3,3,5,0	;0,5,3
		dc.w	$0101,3,4,3,0	;0,3,4
		dc.w	$0101,3,2,4,0	;0,4,2
		dc.w	$0101,3,5,2,0	;0,2,5
		dc.w	$0101,3,5,3,1	;1,3,5
		dc.w	$0101,3,3,4,1	;1,4,3
		dc.w	$0101,3,4,2,1	;1,2,4
		dc.w	$0101,3,2,5,1	;1,5,2

elaserc:	dc.w	350

		dc.w	4

		dc.w	-25,-25,-200
		dc.w	50,50,100
		dc.w	laserCODE

		dc.w	-25,-25,-100
		dc.w	50,50,100
		dc.w	laserCODE

		dc.w	-25,-25,0
		dc.w	50,50,100
		dc.w	laserCODE

		dc.w	-25,-25,100
		dc.w	50,50,100
		dc.w	laserCODE

