********************** Missile Launcher Control Routines *********************

* Notes:

******************************** Code Section ********************************

		text
		.68000

********************** Auto Launcher Waiting For A Target ********************

doautolauncherwait:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	launchercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodelauncher

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0) 		;look for a target
		bpl.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#doautolauncherattack,ido(a0)
.done:
		rts

******************* Auto Launcher Firing Missiles At Target ******************

doautolauncherattack:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	launchercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodelauncher

		bsr	confirmtarget 		;look at target
		beq.s	.losttarget
		bsr	flatrotatetotarget

		subq.w	#1,iotimer2(a0)		;shoot every now and then
		bpl.s	.done
		move.w	#100,iotimer2(a0)

		bsr	createmissile
		neg.w	iobarrelx(a0)
.done:
		rts
.losttarget:
		move.l	#doautolauncherwait,ido(a0)
		rts

***************** Radar Launcher Attacking Any Radar Targets *****************

doradarlauncher:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	launchercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble.s	explodelauncher

		bsr	readswitch
		beq.s	.done

		move.l	#radarTYPE,d0		;get the closest radar
		bsr	closesttype		;if there is one
		move.l	a1,d0
		beq.s	.done

		move.l	iotarget(a1),iotarget(a0)	;get the radar's target
		beq.s	.done

		bsr	flatrotatetotarget

		subq.w	#1,iotimer2(a0)		;shoot every now and then
		bpl.s	.done
		move.w	#100,iotimer2(a0)

		bsr	createmissile
		neg.w	iobarrelx(a0)
.done:
		rts

***************************** Launcher Subroutines ***************************

launchercollide:
		move.l	iocollcode(a0),d0	;check collisions on turret
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodelauncher:
		move.l	#dobigbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makelauncher:	bsr	getempty

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#midrange,iorange(a1)

		move.w	switch,ioswitch(a1)

		jsr	random
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		move.w	#1,iotimer2(a1)

		addq.w	#1,baddies

		move.l	index,d0
		cmp.l	#2,d0
		beq	.type3
		cmp.l	#1,d0
		beq	.type2
.type1:
		move.l	launcher1height,d0
		add.l	d0,isycoord(a1)

		move.l	#doautolauncherwait,ido(a1)
		move.l	#launcher1anim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#launcher1TYPE,iotype(a1)
		move.w	#launcher1ENERGY,ioenergy(a1)
		move.w	#launcher1DAMAGE,iodamage(a1)

		move.w	#125,iobarrelx(a1)
		move.w	#25,iobarrely(a1)
		move.w	#350,iobarrelz(a1)
		rts
.type2:
		move.l	launcher2height,d0
		add.l	d0,isycoord(a1)

		move.l	#doautolauncherwait,ido(a1)
		move.l	#launcher2anim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#launcher2TYPE,iotype(a1)
		move.w	#launcher2ENERGY,ioenergy(a1)
		move.w	#launcher2DAMAGE,iodamage(a1)

		move.w	#130,iobarrelx(a1)
		move.w	#50,iobarrely(a1)
		move.w	#225,iobarrelz(a1)
		rts
.type3:
		move.l	launcher3height,d0
		add.l	d0,isycoord(a1)

		move.l	#doradarlauncher,ido(a1)
		move.l	#launcher3anim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#launcher3TYPE,iotype(a1)
		move.w	#launcher3ENERGY,ioenergy(a1)
		move.w	#launcher3DAMAGE,iodamage(a1)

		move.w	#125,iobarrelx(a1)
		move.w	#25,iobarrely(a1)
		move.w	#350,iobarrelz(a1)
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************
 
		phrase
launcher1anim:	dc.l	launcher1vdf
launcher2anim:	dc.l	launcher2vdf
launcher3anim:	dc.l	launcher3vdf

********************************* VDF Files **********************************

launcher1vdf:	incbin	"graphics\\shapes\\enemies\\launch01.vdf"
launcher2vdf:	incbin	"graphics\\shapes\\enemies\\launch02.vdf"
launcher3vdf:	incbin	"graphics\\shapes\\enemies\\launch03.vdf"

********************************* BSS Section ********************************

		bss

********************************* Variables **********************************

		even

launcher1height:	ds.l	1
launcher2height:	ds.l	1
launcher3height:	ds.l	1
