************************* Mine Layer Control Routines ************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

**************** Mine Layer Waiting For A Target To Get Close ****************

dolayerwait:	tst.w	isonscreen(a0)
		beq.s	.done

		bsr	layercollide
		tst.w	ioenergy(a0)
		ble	explodelayer

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)
		bgt.s	.done
		move.w	#longaidelay,iotimer(a0)

		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dolayerattack,ido(a0)
		clr.w	iozspeed(a0)
		move.w	#110,ioyrot(a0)
		move.w	#8,iotimer(a0)
.done:
		rts

**************************** Mine Layer Laying Mines *************************

dolayerattack:	tst.w	isonscreen(a0)
		beq.s	.done

		bsr	doobjcoll
		bsr.s	layercollide
		tst.w	ioenergy(a0)
		ble.s	explodelayer

		subq.w	#1,ioyrot(a0)
		ble.s	.losttarget

		move.w	iozspeed(a0),d0
		addq.w	#1,d0
		cmp.w	#110,d0
		ble.s	.speedok
		move.w	#110,d0
.speedok:
		move.w	d0,iozspeed(a0)

		bsr	flatrotateobject
		bsr	flatmoveobject

		subq.w	#1,iotimer(a0)
		bgt.s	.done
		move.w	#12,iotimer(a0)
		bsr	createmine
.done:
		rts
.losttarget:
		move.l	#dolayerwait,ido(a0)
		rts

****************************** Layer Subroutines *****************************

layercollide:	move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		cmp.w	#mineCODE,d0
		beq.s	.nocollide
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodelayer:	move.l	#dosmallbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makelayer:	bsr	getempty		;make mine layer

		movem.l	position,d0-d2
		add.l	layerheight,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dolayerwait,ido(a1)
		move.l	#layeranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)

		move.l	#longrange,iorange(a1)	;set attack range

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#layerTYPE,iotype(a1)
		move.w	#layerENERGY,ioenergy(a1)
		move.w	#layerDAMAGE,iodamage(a1)

		jsr	random			;this is so they don't
		and.w	#31,d0			;all look for targets
		addq.w	#1,d0			;on the same update
		move.w	d0,iotimer(a1)

		move.w	#1,iotimer2(a1)		;mine dropping delay

		move.w	#100,iozspeed(a1)

		move.w	#0,iobarrelx(a1)
		move.w	#200,iobarrely(a1)
		move.w	#-200,iobarrelz(a1)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
layeranim:	dc.l	layervdf

********************************* VDF Files **********************************

layervdf: 	incbin	"graphics\\shapes\\enemies\\minelayr.vdf"

******************************** BSS Section *********************************

		bss

********************************* Variables **********************************

		even

layerheight:	ds.l	1



