***************************** Mine Control Routines **************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

******************************* Update Routines ******************************

dominefall:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	doobjcoll

		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		cmp.w	#layerCODE,d0
		beq.s	.nocollide
		cmp.w	#playerCODE,d0
		beq	explodemine
.nocollide:
		move.l	iocollfloor(a0),d1	;invert vertical speed
		beq.s	.yok			;if we hit the floor
		clr.l	iocollfloor(a0)
		add.l	d1,isycoord(a0)
		neg.w	ioyspeed(a0)
		asr.w	ioyspeed(a0)
		cmp.w	#15,ioyspeed(a0)
		bgt.s	.yok
		move.l	#dominewait,ido(a0)
		bra.s	.done
.yok:
		movem.w	ioxspeed(a0),d0-d2
		move.w	d0,d3
		move.w	d2,d4
		asr.w	#3,d3
		asr.w	#3,d4
		sub.w	d3,d0
		sub.w	d4,d2
		sub.w	#gravity,d1
		cmp.w	#-terminalv,d1
		bge.s	.ysok
		move.w	#-terminalv,d1
.ysok:
		movem.w	d0-d2,ioxspeed(a0)
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
.done:
		rts

dominewait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)		;delete myself
		bmi.s	deletemine		;after a bit

		move.l	iocollcode(a0),d0	;just wait till a player
		beq.s	.done			;runs over me then blow up
		cmp.w	#layerCODE,d0
		beq.s	.done
		cmp.w	#playerCODE,d0
		beq.s	explodemine
.done:
		rts

doresmine:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		move.l	iocollcode(a0),d0	;blow up if the player
		cmp.w	#playerCODE,d0		;hits me
		beq.s	explodemine

		move.w	ioxspeed(a0),d0
		add.w	ioyspeed(a0),d0
		and.w	#2047,d0
		move.w	d0,ioxspeed(a0)
		jsr	sincos
		moveq.l	#9,d1
		asr.w	d1,d0
		ext.l	d0
		add.l	iorange(a0),d0
		move.l	d0,isycoord(a0)

		bsr	flatrotateobject
.done:
		rts

******************************* Mine Subroutines *****************************

deletemine:	move.l	#dotinybang,ido(a0)
		rts

explodemine:	move.l	#dosmallbang,ido(a0)
		rts

******************************* Object Generators ****************************

createplayermine:
		move.w	iopower(a0),d0
		subq.w	#1,d0
		move.w	d0,d1
		mulu	#minespacing/2,d1
		sub.w	d1,iobarrelx(a0)
.mines:
		move.w	d0,-(sp)
		bsr	createmine
		add.w	#minespacing,iobarrelx(a0)
		move.w	(sp)+,d0
		dbf	d0,.mines
   		rts

createmine:	bsr	getempty		;create a mine object
		beq.s	.none

		move.l	#dominefall,ido(a1)
		move.l	#mineanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		moveq.l	#0,d0
		bsr	movetobarrel

		move.w	iobarrelx(a0),d3
		asr.w	d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		move.w	d6,d3
		move.w	a2,d4
		asr.w	#6,d3
		asr.w	#6,d4
		neg.w	d3
		neg.w	d4
		add.w	d3,d0
		moveq.l	#70,d1
		add.w	d4,d2
		movem.w	d0-d2,ioxspeed(a1)

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#mineTYPE,iotype(a1)
		move.w	#mineDAMAGE,iodamage(a1)

		move.w	#100,iotimer(a1)
.none:
		rts

makeresmine:	bsr	getempty		;make a resistor mine object

		movem.l	position,d0-d2
		add.l	#200,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	isycoord(a1),iorange(a1)

		bsr	random
		and.w	#63,d0
		add.w	#64,d0
		clr.w	ioxspeed(a1)
		move.w	d0,ioyspeed(a1)

		bsr	random
		and.w	#31,d0
		bne.s	.ok
		moveq.l	#30,d0
.ok:
		sub.w	#16,d0
		move.w	d0,ioyrot(a1)

		move.l	#doresmine,ido(a1)
		move.l	#resmineanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#resmineTYPE,iotype(a1)
		move.w	#resmineDAMAGE,iodamage(a1)
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
mineanim:	dc.l	minevdf

resmineanim:	dc.l	resminevdf

********************************** VDF Files *********************************

minevdf:	incbin	"graphics\\shapes\\weapons\\mine.vdf"

resminevdf:	incbin	"graphics\\shapes\\enemies\\resmine.vdf"
