************************** Missile Control Routines **************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

*************************** Player Missile Routines **************************

doplayermissileseek:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)		;self destruct after a bit
		ble	explodemissile

		bsr	playermissilecollide	;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodemissile

		bsr	movemissile

		subq.w	#1,iotimer2(a0)		;try to find a target
		bpl.s	.done
		move.w	#shortaidelay,iotimer2(a0)

		move.w	#enemyCLASS,d0		;may not be any targets
		move.w	d0,d1			;left to shoot!
		bsr	closestobject
		move.l	a1,iotarget(a0)
		beq.s	.done

		movem.l	isxcoord(a1),d0-d2	;check that the target
		sub.l	isxcoord(a0),d0		;is in front of the missile
		sub.l	isycoord(a0),d1
		sub.l	iszcoord(a0),d2
		bsr	makeunitvec
		movem.w	iszx(a0),d3-d5
		muls	d3,d0
		muls	d4,d1
		muls	d5,d2
		add.l	d1,d0
		add.l	d2,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		cmp.w	#8192,d0		;should be cos(60)
		ble.s	.done

		move.l	#doplayermissilehome,ido(a0)	;we have a target!
.done:
		rts

doplayermissilehome:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)		;self destruct after a bit
		ble	explodemissile

		bsr	playermissilecollide	 ;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodemissile

		bsr	movemissile

		bsr	confirmtarget 		;reaquire target if needed
		beq.s	.losttarget
		bsr	rotatetotarget		;point at the target
.done:
		rts
.losttarget:
		move.l	#doplayermissileseek,ido(a0)
		rts

*************************** Enemy Missile Routines ***************************

domissileseek:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)		;self destruct after a bit
		beq	explodemissile

		bsr	enemymissilecollide	;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodemissile

		bsr	movemissile

		subq.w	#1,iotimer2(a0)		;try to find a target
		bne.s	.done
		move.w	#shortaidelay,iotimer2(a0)

		bsr	closesttarget		;may not be any targets
		move.l	a1,iotarget(a0)		;left to shoot!
		beq.s	.done

		movem.l	isxcoord(a1),d0-d2	;check that the target
		sub.l	isxcoord(a0),d0		;is in front of the missile
		sub.l	isycoord(a0),d1
		sub.l	iszcoord(a0),d2
		bsr	makeunitvec
		movem.w	iszx(a0),d3-d5
		muls	d3,d0
		muls	d4,d1
		muls	d5,d2
		add.l	d1,d0
		add.l	d2,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		cmp.w	#11585,d0		;should be cos(45)
		ble.s	.done

		move.l	#domissilehome,ido(a0)	;we have a target!
.done:
		rts

domissilehome:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		subq.w	#1,iotimer(a0)		;self destruct after a bit
		beq	explodemissile

		bsr.s	enemymissilecollide	;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodemissile

		bsr	movemissile

		bsr	confirmtarget 		;reaquire target if needed
		beq.s	.losttarget
		bsr	rotatetotarget		;point at the target
.done:
		rts
.losttarget:
		move.l	#domissileseek,ido(a0)
		rts

******************************* Missile Subroutines **************************

playermissilecollide:
		bsr	doobjcoll
		tst.l	iocollfloor(a0)
		bne.s	.collide
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		cmp.w	#tripswitchCODE,d0
		beq.s	.nocollide
		cmp.w	#repellCODE,d0
		beq.s	.nocollide
		cmp.w	#attractCODE,d0
		bne.s	.collide
.nocollide:
		rts
.collide:
		moveq.l	#$5,d7
		jsr	ADD_TO_SCORE
		move.w	#-1,ioenergy(a0)
		rts

enemymissilecollide:
		bsr	doobjcoll
		tst.l	iocollfloor(a0)
		bne.s	.collide
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		cmp.w	#tripswitchCODE,d0
		beq.s	.nocollide
		cmp.w	#repellCODE,d0
		beq.s	.nocollide
		cmp.w	#attractCODE,d0
		bne.s	.collide
.nocollide:
		rts
.collide:
		move.w	#-1,ioenergy(a0)
		rts

explodemissile:	move.l	#dosmallbang,ido(a0)
		rts

movemissile:	move.w	iozspeed(a0),d0		;accelerate the missile
		add.w	#50,d0			;to it's top speed
		cmp.w	#250,d0
		ble.s	.speedok
		move.w	#250,d0
.speedok:
		move.w	d0,iozspeed(a0)

		movem.w	iszx(a0),d0-d2 		;move the missile
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
		rts

******************************* Object Generators ****************************

createplayermissile:
		bsr	getempty		;create a player missile object
		beq.s	.none

		move.l	#doplayermissileseek,ido(a1)
		move.l	#missileanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	#200,d0
		bsr	movetobarrel

		move.w	#1,ioenergy(a1)
		move.w	#weaponCLASS,ioclass(a1)
		move.w	#missileTYPE,iotype(a1)
		move.w	#missileDAMAGE,iodamage(a1)

		move.l	#10000,iorange(a1)

		move.w	#60,iotimer(a1)
		move.w	#1,iotimer2(a1)
		move.w	#100,iozspeed(a1)

		moveq.l	#SFX_ENEMY_TURRET_LASER,d7
		jsr	ADD_SFX
.none:
		rts

createmissile:	bsr	getempty		;create a missile object
		beq.s	.none

		move.l	#domissileseek,ido(a1)
		move.l	#missileanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		movem.w	isxx(a0),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.w	#200,d0
		bsr	movetobarrel

		move.w	#1,ioenergy(a1)
		move.w	#weaponCLASS,ioclass(a1)
		move.w	#missileTYPE,iotype(a1)
		move.w	#missileDAMAGE,iodamage(a1)

		move.l	#10000,iorange(a1)

		move.w	#60,iotimer(a1)
		move.w	#1,iotimer2(a1)
		move.w	#100,iozspeed(a1)

		moveq.l	#SFX_ENEMY_TURRET_LASER,d7
		jsr	ADD_SFX
.none:
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
missileanim:	dc.l	missilevdf

********************************** VDF Files *********************************

missilevdf:	dc.w	missilec-missilevdf

missiles:	dc.w	350

		dc.w	6

		dc.w	0,0,-200,0,0,0			;0
		dc.w	0,0,200,0,0,0			;1
		dc.w	-25,0,100,0,0,0			;2
		dc.w	25,0,100,0,0,0			;3
		dc.w	0,-25,100,0,0,0			;4
		dc.w	0,25,100,0,0,0			;5

		dc.w	8

		dc.w	$4039,3,3,5,0	;0,5,3
		dc.w	$403a,3,4,3,0	;0,3,4
		dc.w	$4039,3,2,4,0	;0,4,2
		dc.w	$403a,3,5,2,0	;0,2,5
		dc.w	$4039,3,5,3,1	;1,3,5
		dc.w	$403a,3,3,4,1	;1,4,3
		dc.w	$4039,3,4,2,1	;1,2,4
		dc.w	$403a,3,2,5,1	;1,5,2

missilec:	dc.w	350

		dc.w	4

		dc.w	-25,-25,-200
		dc.w	50,50,100
		dc.w	missileCODE

		dc.w	-25,-25,-100
		dc.w	50,50,100
		dc.w	missileCODE

		dc.w	-25,-25,0
		dc.w	50,50,100
		dc.w	missileCODE

		dc.w	-25,-25,100
		dc.w	50,50,100
		dc.w	missileCODE






