************************ Mobile Missile Launcher Routines ********************

* Notes:

********************************* Code Section *******************************

		text
		.68000

****************** Mobile Waiting And Scanning For Targets *******************

domobilewait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	mobilecollide		;deal with collisions
		tst.w	ioenergy(a0)
	 	ble	explodemobile

		tst.w	ioyrot(a0)
		bpl.s	.rotpos
.rotneg:
		addq.w	#1,ioyrot(a0)
		ble.s	.rotok
		bra.s	.newrot
.rotpos:
		subq.w	#1,ioyrot(a0)
		bge.s	.rotok
.newrot:
		jsr	random
		and.w	#127,d0
		sub.w	#32,d0
		move.w	d0,ioyrot(a0)
.rotok:
		move.w	iozspeed(a0),d0
		addq.w	#1,d0
		cmp.w	#90,d0
		ble.s	.speedok
		move.w	#90,d0
.speedok:
		move.w	d0,iozspeed(a0)

		bsr	flatrotateobject
	 	bsr	flatmoveobject

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)		;look for a target
		bne.s	.done
		move.w	#shortaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#domobileattack,ido(a0)	;we have a target!
		move.w	#10,iotimer2(a0)
.done:
		rts

************************* Tank Attacking It's Target *************************

domobileattack:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	mobilecollide		;deal with collisions
		tst.w	ioenergy(a0)
	 	ble.s	explodemobile

		bsr	confirmtarget
		beq.s	.losttarget
		bsr	flatrotatetotarget
	 	bsr	flatmoveobject
		bsr	flatadjustspeed

		subq.w	#1,iotimer2(a0)		;shoot every now and then
		bne.s	.done
		move.w	#50,iotimer2(a0)
		bsr	createmissile
		neg.w	iobarrelx(a0)
.done:
		rts
.losttarget:
		move.l	#domobilewait,ido(a0)
		rts

****************************** Mobile Subroutines ****************************

mobilecollide:	bsr	doobjcoll
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodemobile:	move.l	#dobigbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makemobile:	bsr	getempty		;make mobile missile launcher

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)

		move.w	switch,ioswitch(a1)

		move.l	#domobilewait,ido(a1)
		move.l	#0,isanimframe(a1)

		move.l	#midrange,iorange(a1)

		jsr	random
		and.w	#63,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		jsr	random
		and.w	#63,d0
		addq.w	#4,d0
		move.w	d0,ioyrot(a1)

		addq.w	#1,baddies

		move.l	index,d0
		cmp.l	#1,d0
		beq	.type2
.type1:
		move.l	mobile1height,d0
		add.l	d0,isycoord(a1)
		move.l	#mobile1anim,isanimbase(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#mobile1TYPE,iotype(a1)
		move.w	#mobile1ENERGY,ioenergy(a1)
		move.w	#mobile1DAMAGE,iodamage(a1)

		move.w	#100,iobarrelx(a1)
		move.w	#100,iobarrely(a1)
		move.w	#300,iobarrelz(a1)
		rts
.type2:
		move.l	mobile2height,d0
		add.l	d0,isycoord(a1)
		move.l	#mobile2anim,isanimbase(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#mobile2TYPE,iotype(a1)
		move.w	#mobile2ENERGY,ioenergy(a1)
		move.w	#mobile2DAMAGE,iodamage(a1)

		move.w	#50,iobarrelx(a1)
		move.w	#75,iobarrely(a1)
		move.w	#200,iobarrelz(a1)
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
mobile1anim:	dc.l	mobile1vdf
mobile2anim:	dc.l	mobile2vdf

********************************* VDF Files **********************************

mobile1vdf: 	incbin	"graphics\\shapes\\enemies\\msln_01.vdf"
mobile2vdf: 	incbin	"graphics\\shapes\\enemies\\msln_02.vdf"

********************************* BSS Section ********************************

		bss

********************************** Variables *********************************

		even

mobile1height:	ds.l	1
mobile2height:	ds.l	1






