******************************* Notes For Atari ******************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

********************************* Main Routines ******************************

notes:		rts
		move.l	#firstpage,page
		st	IN_GAME
.pages:
		jsr	showpage
.wait:
		jsr	NEW_OL
		jsr	ADD_VIEWSCREEN
		jsr	wait_vbl
      		jsr	read_joypad

		move.l	joyedge1,d0
		or.l	joyedge2,d0
		btst	#LEFT_B,d0
		beq.s	.notprev
		move.l	page,d0
		subq.l	#4,d0
		cmp.l	#firstpage,d0
		bge.s	.prevok
		move.l	#lastpage-4,d0
.prevok:
		move.l	d0,page
		bra.s	.pages
.notprev:
		btst	#RIGHT_B,d0
		beq.s	.notnext
		move.l	page,a0
		addq.l	#4,a0
		tst.l	(a0)
		bne.s	.nextok
		move.l	#firstpage,a0
.nextok:
		move.l	a0,page
		bra.s	.pages
.notnext:
		btst	#FIRE_B,d0
		beq.s	.wait
.done:
		jsr	NEW_OL
		jsr	NEW_OL
		jsr	NEW_OL
		rts

showpage:	move.l	rasterb,a0		;clear raster
		move.l	#$00000000,d7
		jsr	clearraster_spread

		lea	standardtext,a6
		move.l	rasterb,d0
		move.l	#PITCH4|PIXEL16|WID320|XADDPIX,d1
		jsr	print_text_routine

		move.l	page,a6
		move.l	(a6),a6
		move.l	rasterb,d0
		move.l	#PITCH4|PIXEL16|WID320|XADDPIX,d1
		jsr	print_text_routine
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

		even

page:		dc.l	firstpage

firstpage:	dc.l	page1
		dc.l	page2
		dc.l	page3
		dc.l	page4
		dc.l	page5
		dc.l	page6
lastpage:	dc.l	0

************************************ Text ************************************

standardtext:	dc.b	PAT,0,80,0,16
		dc.b	"NETWAR.. Version 5.6"
		dc.b	PAT,0,48,0,192
		dc.b	"Press Left For Previous Page"
		dc.b	PAT,0,60,0,200
		dc.b	"Press Right For Next Page"
		dc.b	PAT,0,48,0,208
		dc.b	"Press Fire B To Run The Game"
		dc.b	PEND

page1:		dc.b	PAT,0,4,0,30
		;dc.b	"**************************************"
		dc.b	"These pages of text have been included",PCR
		dc.b	"to help the communication process",PCR
		dc.b	"between ATARI and Imagitec Design.They",PCR
		dc.b	"will not be in the final game.",PCR,PCR,PCR

		dc.b	"Please read them as they provide lots",PCR
		dc.b	"of useful information."
		dc.b	PEND

page2:		dc.b	PAT,0,4,0,30
		;dc.b	"**************************************"
		dc.b	"The storyline in the attract mode has",PCR
		dc.b	"been changed with Override as the",PCR
		dc.b	"computer enemy.",PCR,PCR
		dc.b	"An object viewer has been included in",PCR
		dc.b	"the attract mode. This describes the",PCR
		dc.b	"game objectives.",PCR,PCR
		dc.b	"The weapons screen has been removed.",PCR
		dc.b	"We are working on a new screen which",PCR
		dc.b	"will show the craft's configuration.",PCR,PCR
		dc.b	"A short tunnel sequence has been added",PCR
		dc.b	"before the player enter's a level.",PCR,PCR
		dc.b	"The in game viewer has been changed to",PCR
		dc.b	"show Override's defense systems.",PCR
	       	dc.b	PEND


page3:		dc.b	PAT,0,4,0,30
		dc.b	"The prompts displayed when the player",PCR
		dc.b	"picks up datapods/powerups are now",PCR
		dc.b	"shown in a bigger font.",PCR,PCR
		dc.b	"The Datalink tunnel has been tweaked",PCR
		dc.b	"to increase in difficulty as the",PCR
		dc.b	"levels progress",PCR,PCR
		dc.b	"Our sound guys are producing an effect",PCR
		dc.b	"for the data link energy fields.",PCR,PCR
		dc.b	"The status bar has been lowered and",PCR
		dc.b	"the timer removed.",PCR,PCR
		dc.b	"Leading zeros have been supressed on",PCR
		dc.b	"hi-score screen.",PCR,PCR
		dc.b	"Explosion debris when shooting the",PCR
		dc.b	"walls has been removed.",PCR
	       	dc.b	PEND

page4:		dc.b	PAT,0,4,0,30
		dc.b	"Explosion now produce less debris.",PCR,PCR
		dc.b	"Some rooms have been modified to",PCR
		dc.b	"produce passages that a door can be",PCR
		dc.b	"fitted into.",PCR,PCR
		dc.b	"The data link port inside the levels",PCR
		dc.b	"is now the player's start point. The",PCR
		dc.b	"tank is driven automatically outside",PCR
		dc.b	"the port and the port closes. However",PCR
		dc.b	"the player will still have to drive",PCR
		dc.b	"inside the port to complete the level.",PCR
		dc.b	PEND


page5:		dc.b	PAT,0,4,0,30
		dc.b	"The flyer inside the data link has",PCR
		dc.b	"been replaced with the player's tank.",PCR,PCR
		dc.b	"We have deferred the two player mode",PCR
		dc.b	"until the one player mode is back on",PCR
		dc.b	"track",PCR,PCR
		dc.b	"We have renamed the levels as nodes.",PCR
		dc.b	"At the moment they are still numbered",PCR
		dc.b	"but will be given unique names once",PCR
		dc.b	"the names have been chosen.",PCR,PCR
		dc.b	"We do not have enough memory at the",PCR
		dc.b	"moment for speech. We are looking into",PCR
		dc.b	"ways of reducing the memory usage.",PCR
	       	dc.b	PEND

page6:		dc.b	PAT,0,4,0,30
		dc.b	"Pick up weapons are being drawn and",PCR
		dc.b	"will be included in the game in the",PCR
		dc.b	"very near future. For the time being",PCR
		dc.b	"the player gets a pre-configured craft.",PCR,PCR
		dc.b	"The game flow has been modified to",PCR
		dc.b	"follow your suggestions.",PCR,PCR
		dc.b	"You will not be able to skip the attract",PCR
		dc.b	"mode. We have removed this option to be",PCR
		dc.b	"certain you get to see our changes.",PCR


	       	dc.b	PEND


	       .phrase
		.text
