************************* NetWar Object Control Routines *********************

* Notes:

* You should only do collision DETECTION on moving objects
* Static objects should only be hit by moving objects and the
* moving objects flag collisions to both objects involved

* BUT you should still do collision REACTION
* on all objects that require it

******************************** Include Files *******************************

		include	"game\\westy\\players.s"
		include	"game\\westy\\endboss.s"

		include	"game\\westy\\features.s"
		include	"game\\westy\\powerups.s"

		include	"game\\westy\\bombs.s"
		include	"game\\westy\\lasers.s"
		include	"game\\westy\\mines.s"
		include	"game\\westy\\missiles.s"
		include	"game\\westy\\plasma.s"
		include	"game\\westy\\drones.s"

		include	"game\\westy\\tanks.s"
		include	"game\\westy\\launcher.s"
		include	"game\\westy\\mobiles.s"
		include	"game\\westy\\layers.s"
		include	"game\\westy\\guns.s"
		include	"game\\westy\\guards.s"
		include	"game\\westy\\bombers.s"
		include	"game\\westy\\bouncers.s"
		include	"game\\westy\\fragment.s"
		include	"game\\westy\\phaser.s"
		include	"game\\westy\\homers.s"
		include	"game\\westy\\trundler.s"
		include	"game\\westy\\radar.s"
		include	"game\\westy\\dropship.s"

		include	"game\\westy\\explode.s"

******************************** Code Section ********************************

		text
		.68000

******************************* Update Routines ******************************

doworld:	jsr	initobjcoll
		jsr	dolist
		rts

****************************** Handy Subroutines *****************************

closesttarget:	move.l	#$7fffffff,d7		;search for the
		sub.l	a1,a1			;closest target
		lea	targettable,a2
		movem.l	isxcoord(a0),d0-d2
.find:
		move.l	(a2)+,d3
		beq.s	.found
		move.l	d3,a3

		movem.l	isxcoord(a3),d3-d5	;get distance to target

		sub.l	d0,d3
		bpl.s	.xpos
		neg.l	d3
.xpos:
		sub.l	d1,d4
		bpl.s	.ypos
		neg.l	d4
.ypos:
		sub.l	d2,d5
		bpl.s	.zpos
		neg.l	d5
.zpos:
		add.l	d4,d3
		add.l	d5,d3

		cmp.l	d3,d7  			;is that closer than
		ble.s	.find			;any previous candidates?
		move.l	d3,d7
		move.l	a3,a1
		bra.s	.find
.found:
		rts

rangetarget:	move.l	iorange(a0),d5		;search for any
		move.l	isxcoord(a0),d6		;target within range
		move.l	iszcoord(a0),d7
		sub.l	a1,a1
		lea	targettable,a2
		jsr	random
.find:
		move.l	(a2)+,d1
		beq.s	.found
		move.l	d1,a3

		move.l	isxcoord(a3),d1
		sub.l	d6,d1
		bpl.s	.xok
		neg.l	d1
.xok:
		cmp.l	d5,d1
		bge.s	.find

		move.l	iszcoord(a3),d1
		sub.l	d7,d1
		bpl.s	.yok
		neg.l	d1
.yok:
		cmp.l	d5,d1
		bge.s	.find

		move.l	a3,a1			;found one but should
		rol.l	d0			;we look for another?
		bcc.s	.find
.found:
		rts

confirmtarget:	move.l	iotarget(a0),a1		;check that the target
		move.l	isxcoord(a1),d0		;is still in range
		move.l	iszcoord(a1),d2
		move.l	isxcoord(a0),d3
		move.l	iszcoord(a0),d4
		move.l	d3,d5
		move.l	d4,d6
		move.l	iorange(a0),d7
		sub.l	d7,d3
		sub.l	d7,d4
		add.l	d7,d5
		add.l	d7,d6

		cmp.l	d3,d0
		ble.s	.losttarget
		cmp.l	d4,d2
		ble.s	.losttarget
		cmp.l	d5,d0
		bge.s	.losttarget
		cmp.l	d6,d2
		bge.s	.losttarget
		moveq.l	#-1,d0
		rts
.losttarget:
		moveq.l	#0,d0
		rts

rotatetotarget:	move.l	iotarget(a0),a1		;rotate the object
		movem.l	isxcoord(a1),d0-d2	;towards it's target
		movem.l	isxcoord(a0),d3-d5	;in x,y and z axes
		sub.l	d3,d0
		sub.l	d4,d1
		sub.l	d5,d2
		movem.w	iszx(a0),d3-d5
		asr.l	#7,d3
		asr.l	#7,d4
		asr.l	#7,d5
		sub.l	d3,d0
		sub.l	d4,d1
		sub.l	d5,d2
		asr.l	#6,d0			;this value controls
		asr.l	#6,d1			;his rotation speed
		asr.l	#6,d2			;bigger value = slower turn
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2
		moveq.l	#0,d3
		moveq.l	#0,d4
		moveq.l	#0,d5
		lea	isxx(a0),a6
		bsr	pointmatrix
		rts

moveobject:	movem.w	iszx(a0),d0-d2		;move the object
		move.w	iozspeed(a0),d3	       	;in x,y and z axes
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	isxcoord(a0),d0
		add.l	isycoord(a0),d1
		add.l	iszcoord(a0),d2
		cmp.l	iominx(a0),d0
		bge.s	.notlowx
		move.l	iominx(a0),d0
		bra.s	.nothighx
.notlowx:
		cmp.l	iomaxx(a0),d0
		ble.s	.nothighx
		move.l	iomaxx(a0),d0
.nothighx:
		cmp.l	iominy(a0),d1
		bge.s	.notlowy
		move.l	iominy(a0),d1
		bra.s	.nothighy
.notlowy:
		cmp.l	iomaxy(a0),d1
		ble.s	.nothighy
		move.l	iomaxy(a0),d1
.nothighy:
		cmp.l	iominz(a0),d2
		bge.s	.notlowz
		move.l	iominz(a0),d2
		bra.s	.nothighz
.notlowz:
		cmp.l	iomaxz(a0),d2
		ble.s	.nothighz
		move.l	iomaxz(a0),d2
.nothighz:
		movem.l	d0-d2,isxcoord(a0)
		rts

maintainheight:	move.w	ioyspeed(a0),d0		;maintain the object's
		move.l	isycoord(a0),d1		;height above it's
		move.l	iotarget(a0),a1		;target
		sub.l	isycoord(a1),d1
		cmp.l	#1273,d1		;a strange number will help
		bgt.s	.down			;the collision detection
		blt.s	.up
.same:
		jsr	random
		and.w	#15,d0
		subq.w	#8,d0
		bra.s	.ysok
.up:
		addq.w	#5,d0
		cmp.w	#25,d0
		ble.s	.ysok
		move.w	#25,d0
		bra.s	.ysok
.down:
		subq.w	#6,d0
		cmp.w	#-25,d0
		bge.s	.ysok
		move.w	#-25,d0
.ysok:
		move.w	d0,ioyspeed(a0)
		ext.l	d0
		add.l	d0,isycoord(a0)
		rts

flatadjustspeed:
		move.l	iotarget(a0),a1		;control the object's
		move.l	isxcoord(a1),d0		;in x and z axes
		move.l	iszcoord(a1),d2
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		muls	d0,d0
		muls	d2,d2
		add.l	d2,d0
		cmp.l	#4000*4000,d0
		bge.s	.stopmove
		cmp.l	#1500*1500,d0
		bge.s	.forwards
		cmp.l	#700*700,d0
		ble.s	.backquick
		cmp.l	#1000*1000,d0
		ble.s	.backslow
.stopmove:
		tst.w	iozspeed(a0)
		bpl.s	.zpos
.zneg:
		add.w	#30,iozspeed(a0)
		ble.s	.donespeed
		clr.w	iozspeed(a0)
		bra.s	.donespeed
.zpos:
		sub.w	#15,iozspeed(a0)
		bge.s	.donespeed
		clr.w	iozspeed(a0)
		bra.s	.donespeed
.forwards:
		add.w	#10,iozspeed(a0)
		cmp.w	#90,iozspeed(a0)
		ble.s	.donespeed
		move.w	#90,iozspeed(a0)
		bra.s	.donespeed
.backquick:
		sub.w	#40,iozspeed(a0)
.backslow:
		sub.w	#20,iozspeed(a0)
		cmp.w	#-160,iozspeed(a0)
		bge.s	.donespeed
		move.w	#-160,iozspeed(a0)
.donespeed:
		rts

flatrotatetotarget:
		move.l	iotarget(a0),a1		;rotate the object
		move.l	isxcoord(a1),d0		;towards it's target
		move.l	iszcoord(a1),d2	  	;in x and z axes
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d2
		move.w	iszx(a0),d3
		move.w	iszz(a0),d5
		ext.l	d3
		ext.l	d5
		asr.l	#7,d3
		asr.l	#7,d5
		sub.l	d3,d0
		sub.l	d5,d2
		asr.l	#5,d0			;this value controls
		asr.l	#5,d2			;his rotation speed
		add.l	d3,d0			;bigger value = slower turn
		add.l	d5,d2
		moveq.l	#0,d1
		moveq.l	#0,d3
		moveq.l	#0,d4
		moveq.l	#0,d5
		lea	isxx(a0),a6
		bsr	flatpointmatrix
		rts

flatrotateobject:
		movem.w	iszx(a0),d3-d5		;rotate the object
		move.w	isxx(a0),d0		;around the y axis
		move.w	isxz(a0),d2
		sub.w	d3,d0
		sub.w	d5,d2
		move.w	ioyrot(a0),d6
		muls	d6,d0
		muls	d6,d2
		moveq.l	#9,d6
		asr.l	d6,d0
		asr.l	d6,d2
		add.l	d3,d0
		add.l	d5,d2
		moveq.l	#0,d1
		moveq.l	#0,d3
		moveq.l	#0,d4
		moveq.l	#0,d5
		lea	isxx(a0),a6
		bsr	flatpointmatrix
		rts

flatmoveobject:	move.w	iszx(a0),d0		;move the object
		move.w	iszz(a0),d2		;in x and z axes
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d2
		ext.l	d0
		ext.l	d2
		add.l	isxcoord(a0),d0
		add.l	iszcoord(a0),d2
		cmp.l	iominx(a0),d0
		bge.s	.notlowx
		move.l	iominx(a0),d0
		bra.s	.nothighx
.notlowx:
		cmp.l	iomaxx(a0),d0
		ble.s	.nothighx
		move.l	iomaxx(a0),d0
.nothighx:
		cmp.l	iominz(a0),d2
		bge.s	.notlowz
		move.l	iominz(a0),d2
		bra.s	.nothighz
.notlowz:
		cmp.l	iomaxz(a0),d2
		ble.s	.nothighz
		move.l	iomaxz(a0),d2
.nothighz:
		move.l	d0,isxcoord(a0)
		move.l	d2,iszcoord(a0)
		rts

rollobject:	movem.w	iszx(a0),d3-d5		;rotate the object
		movem.w	isyx(a0),d0-d2		;around the x axis
		neg.w	d0
		neg.w	d1
		neg.w	d2
		sub.w	d3,d0
		sub.w	d4,d1
		sub.w	d5,d2
		move.w	ioxrot(a0),d6
		muls	d6,d0
		muls	d6,d1
		muls	d6,d2
		moveq.l	#9,d6
		asr.l	d6,d0
		asr.l	d6,d1
		asr.l	d6,d2
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2
		moveq.l	#0,d3
		moveq.l	#0,d4
		moveq.l	#0,d5
		lea	isxx(a0),a6
		bsr	pointmatrix
		rts

findobject:	move.l	isxcoord(a0),d4		;search for an object
		move.l	iszcoord(a0),d5		;with class d0 within
		move.l	d4,d6			;object a0's range
		move.l	d5,d7
		move.l	iorange(a0),d3
		sub.l	d3,d4
		sub.l	d3,d5
		add.l	d3,d6
		add.l	d3,d7
		sub.l	a1,a1
		lea	world,a2
		move.l	ifirst(a2),d1		;there must be at least one object - me!
.find:
		move.l	d1,a2
		cmp.w	ioclass(a2),d0
		bne.s	.nextobject

		move.l	isxcoord(a2),d1
		move.l	iszcoord(a2),d3
		cmp.l	d4,d1
		ble.s	.nextobject
		cmp.l	d5,d3
		ble.s	.nextobject
		cmp.l	d6,d1
		bge.s	.nextobject
		cmp.l	d7,d3
		bge.s	.nextobject
		move.l	a2,a1

		move.l	d0,d2			;should we look for
		jsr	random			;another object with
		and.w	#1,d0			;that class or not?
		beq.s	.found
		move.l	d2,d0
.nextobject:
		move.l	inext(a2),d1
		bne.s	.find
.found:
		rts

closestobject:	move.l	#$7fffffff,a3		;search for the closest
		lea	world,a2		;object with class d0 or d1
		sub.l	a1,a1
		move.l	ifirst(a2),d2		;there must be at least one object - me!
		movem.l	isxcoord(a0),d5-d7
.find:
		move.l	d2,a2
		cmp.w	ioclass(a2),d0
		beq.s	.tryit
		cmp.w	ioclass(a2),d1
		bne.s	.nextobject
.tryit:

		movem.l	isxcoord(a2),d2-d4	;get distance to object
		sub.l	d5,d2
		bpl.s	.xpos
		neg.l	d2
.xpos:
		sub.l	d6,d3
		bpl.s	.ypos
		neg.l	d3
.ypos:
		sub.l	d7,d4
		bpl.s	.zpos
		neg.l	d4
.zpos:
		add.l	d3,d2
		add.l	d4,d2

		cmp.l	d2,a3  			;is that closer than
		ble.s	.nextobject		;any previous candidates?
		move.l	d2,a3
		move.l	a2,a1
.nextobject:
		move.l	inext(a2),d2
		bne.s	.find
		rts

closesttype:	move.l	#$7fffffff,d7		;search for the closest
		lea	world,a2		;object with type d0
		sub.l	a1,a1
		move.l	ifirst(a2),d1		;there must be at least one object - me!
		movem.l	isxcoord(a0),d4-d6
.find:
		move.l	d1,a2
		cmp.w	iotype(a2),d0
		bne.s	.nextobject

		movem.l	isxcoord(a2),d1-d3	;get distance to object
		sub.l	d4,d1
		bpl.s	.xpos
		neg.l	d1
.xpos:
		sub.l	d5,d2
		bpl.s	.ypos
		neg.l	d2
.ypos:
		sub.l	d6,d3
		bpl.s	.zpos
		neg.l	d3
.zpos:
		add.l	d2,d1
		add.l	d3,d1

		cmp.l	d1,d7  			;is that closer than
		ble.s	.nextobject		;any previous candidates?
		move.l	d1,d7
		move.l	a2,a1
.nextobject:
		move.l	inext(a2),d1
		bne.s	.find
		rts

movetobarrel:	movem.w	iszx(a1),d1-d3		;slide object a1 forward
		muls	d0,d1			;by offset d0
		muls	d0,d2
		muls	d0,d3
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		add.l	d3,d3
		add.l	d3,d3
		swap	d1
		swap	d2
		swap	d3
		ext.l	d1
		ext.l	d2
		ext.l	d3
		movem.l	d1-d3,isxcoord(a1)

		movem.w	isxx(a0),d0-d2		;position object a1 at
		move.w	iobarrelx(a0),d7	;object a0's gun barrel
		muls	d7,d0
		muls	d7,d1
		muls	d7,d2
		movem.w	isyx(a0),d3-d5
		move.w	iobarrely(a0),d7
		muls	d7,d3
		muls	d7,d4
		muls	d7,d5
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2
		movem.w	iszx(a0),d3-d5
		move.w	iobarrelz(a0),d7
		muls	d7,d3
		muls	d7,d4
		muls	d7,d5
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2

		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		movem.l	isxcoord(a0),d3-d5
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2
		add.l	d0,isxcoord(a1)
		add.l	d1,isycoord(a1)
		add.l	d2,iszcoord(a1)
		rts

killobject:	move.l	a0,a1			;kill object a0
		move.l	iparent(a1),a2
		bsr	iremove			;remove item
		lea	empties,a2		;put that item
		bsr	iaddfirst		;back in the empties
		rts

**************************** Generation Subroutines **************************

clearworld:	lea	world,a2		;put all the items
		move.l	ifirst(a2),d0		;from the world list
		beq.s	.empty			;back into the
		move.l	d0,a1			;empties list
		bsr	iremove
		lea	empties,a2
		bsr	iaddfirst
		bra.s	clearworld
.empty:
		move.l	#16384,rezz
		rts

getempty:	lea	empties,a2		;get an empty
		move.l	ifirst(a2),d0		;object structure
		beq.s	.noempties
		move.l	d0,a1
		bsr	iremove
		lea	world,a2
		bsr	iaddfirst

		clr.w	isblowup(a1)
		clr.w	isonscreen(a1)
		move.w	#16384,isrezz(a1)

		clr.l	iocollcode(a1)
		clr.l	iocollfloor(a1)

		clr.l	iotarget(a1)

		clr.w	ioxspeed(a1)
		clr.w	ioyspeed(a1)
		clr.w	iozspeed(a1)

		clr.w	ioxrot(a1)
		clr.w	ioyrot(a1)
		clr.w	iozrot(a1)

		clr.w	iodamage(a1)
		clr.w	iowarped(a1)

		moveq.l	#-1,d0
.noempties:
		rts

settarget:	move.l	nexttarget,a6			;put object a1 in
		move.l	a1,(a6)+			;the target table
		clr.l	(a6)
		move.l	a6,nexttarget
		rts

setcoords:	movem.w	(a0)+,d0-d2			;sets specific coordinates
		add.l	roomx,d0
		add.l	roomy,d1
		add.l	roomz,d2
		movem.l	d0-d2,isxcoord(a1)
		rts

setangles:	movem.w	(a0)+,d0-d2  			;sets specific angles
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		bsr	anglematrix
		rts

clearangles:	moveq.l	#0,d0				;zeros the angles
		moveq.l	#0,d1				;and makes the matrix
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		bsr	anglematrix
		rts

setcam1:	lea	cam11,a2			;initialise player1's camera

		move.l	#dopanningcam,ido(a2)
		move.l	a1,ictarget(a2)

		movem.l	isxcoord(a1),d0-d2
		movem.l	d0-d2,icxcoord(a2)

		move.w	#2048-128,icxangle(a2)
		move.w	#0,icyangle(a2)
		move.w	#0,iczangle(a2)

		move.w	#400,icdist(a2)
		move.w	#0,iczoom(a2)

		clr.w	icxrot(a2)
		clr.w	icyrot(a2)
		clr.w	iczrot(a2)

		bsr	copycam
		rts

setcam2:	lea	cam22,a2			;initialise player2's camera

		move.l	#docockpitcam,ido(a2)
		move.l	a1,ictarget(a2)

		movem.l	isxcoord(a1),d0-d2
		movem.l	d0-d2,icxcoord(a2)

		move.w	#2048-128,icxangle(a2)
		move.w	#0,icyangle(a2)
		move.w	#0,iczangle(a2)

		move.w	#400,icdist(a2)
		move.w	#0,iczoom(a2)

		clr.w	icxrot(a2)
		clr.w	icyrot(a2)
		clr.w	iczrot(a2)
		rts

copycam:	lea	cam11,a2		;copy camera 11
		lea	cam21,a3		;to camera 21
		move.l	#icamlen-1,d7
.copy:
		move.b	(a2)+,(a3)+
		dbf	d7,.copy
		rts

initworld:	lea	world,a1		;make sure the world
		clr.l	iparent(a1)		;is empty
		clr.l	ifirst(a1)
		clr.l	ilast(a1)
		clr.l	iprev(a1)
		clr.l	inext(a1)
		rts

initempties:	lea	emptydata,a1		;create the list
		lea	empties,a2		;of empty objects
		clr.l	iparent(a2)
		clr.l	iprev(a2)
		clr.l	inext(a2)
		clr.l	ifirst(a2)
		clr.l	ilast(a2)
		move.w	#maxempties-1,d0
.makeempties:
		clr.l	iparent(a1)		;make sure the item
		clr.l	iprev(a1)		;isn't already linked
		clr.l	inext(a1)		;with anything
		clr.l	ifirst(a1)
		clr.l	ilast(a1)
		bsr	iaddlast
		add.l	#(iobjectlen&$fffffff8)+8,a1
		dbf	d0,.makeempties

		move.l	#shadetable,shade_list_pointer
		bsr	shadeshapes

		move.l	lightanim,heightstable
		move.l	mediumanim,heightstable+8
		move.l	heavyanim,heightstable+16

		lea	heightstable,a0
		bsr	getheights
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

		even

relativetox:	dc.l	0
relativetoy:	dc.l	0
relativetoz:	dc.l	0

objectx:	dc.l	0
objecty:	dc.l	0
objectz:	dc.l	0

viewerx:	dc.l	0
viewery:	dc.l	0
viewerz:	dc.l	0

NONE_LEFT:	dc.b	13,10,13,10,"Major catastrophe!!",13,10,"There are no empty objects left!",0

******************************** Object Lists ********************************

		phrase
world:		dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	doworld,donowt		;do,draw

empties:	dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	donowt,donowt		;do,draw

**************************** Temporary Shade Tables **************************

shadetable:	dc.l	guardheads
		dc.l	guardbodys
		dc.l	guntowers
		dc.l	gunturrets
		dc.l	bombs
		dc.l	bouncebombs
		dc.l	platforms
		dc.l	attracts
		dc.l	warp1s
		dc.l	warp2s
		dc.l	rprisms
		dc.l	lprisms
		dc.l	radartowers
		dc.l	radarscanners
		dc.l	column1s
		dc.l	0

*************************** Heights To Generate Table ************************

heightstable:	dc.l	0,lightheight
		dc.l	0,mediumheight
		dc.l	0,heavyheight

		dc.l	datapodvdf,datapodheight
		dc.l	databasevdf,databaseheight
		dc.l	keyvdf,keyheight

		dc.l	tank1vdf,tank1height
		dc.l	tank2vdf,tank2height
		dc.l	tank3vdf,tank3height
		dc.l	tank4vdf,tank4height
		dc.l	tank5vdf,tank5height
		dc.l	launcher1vdf,launcher1height
		dc.l	launcher2vdf,launcher2height
		dc.l	launcher3vdf,launcher3height
		dc.l	mobile1vdf,mobile1height
		dc.l	mobile2vdf,mobile2height
		dc.l	layervdf,layerheight
		dc.l	guntowervdf,guntowerheight
		dc.l	fragmentvdf,fragmentheight
		dc.l	straightvdf,straightheight
		dc.l	spiralvdf,spiralheight
		dc.l	trundlervdf,trundlerheight
		dc.l	phaservdf,phaserheight

		dc.l	0

**************************** Cursor Shape Definition *************************

		phrase
cursoranim:	dc.l	doorcursorvdf
smallcursoranim:dc.l	smallcursorvdf

doorcursorvdf:	dc.w	0

doorcursors:	dc.w	4000

		dc.w	8

		dc.w	-300,0,-300,0,0,0		;0
		dc.w	300,0,-300,0,0,0		;1
		dc.w	-300,0,300,0,0,0		;2
		dc.w	300,0,300,0,0,0			;3
		dc.w	-300,100,-300,0,0,0		;4
		dc.w	300,100,-300,0,0,0		;5
		dc.w	-300,100,300,0,0,0		;6
		dc.w	300,100,300,0,0,0		;7

		dc.w	6

		dc.w	$00f0,4,5,4,0,1
		dc.w	$00d1,4,7,5,1,3
		dc.w	$00e2,4,6,7,3,2
		dc.w	$0003,4,4,6,2,0
		dc.w	$0024,4,7,6,4,5
		dc.w	$0075,4,2,3,1,0

smallcursorvdf:	dc.w	smallcursorc-smallcursorvdf

smallcursors:	dc.w	4000

		dc.w	8

		dc.w	-100,-100,-100,0,0,0		;0
		dc.w	100,-100,-100,0,0,0		;1
		dc.w	-100,-100,100,0,0,0		;2
		dc.w	100,-100,100,0,0,0		;3
		dc.w	-100,100,-100,0,0,0		;4
		dc.w	100,100,-100,0,0,0		;5
		dc.w	-100,100,100,0,0,0		;6
		dc.w	100,100,100,0,0,0		;7

		dc.w	6

		dc.w	$00f0,4,5,4,0,1
		dc.w	$00d1,4,7,5,1,3
		dc.w	$00e2,4,6,7,3,2
		dc.w	$0003,4,4,6,2,0
		dc.w	$0024,4,7,6,4,5
		dc.w	$0075,4,2,3,1,0

smallcursorc:	dc.w	2000

		dc.w	1

		dc.w	-100,-100,-100
		dc.w	200,200,200
		dc.w	playertankCODE

********************************* BSS Section ********************************

		bss

********************************** Variables *********************************

		even

nexttarget:	ds.l	1

world_arena:	ds.l	1
world_anims: 	ds.l	1
world_shapes:	ds.l	1

roomx:		ds.l	1
roomy:		ds.l	1
roomz:		ds.l	1

rooms:		ds.w	1
baddies:	ds.w	1
baddieskilled:	ds.w	1

maxrooms:	ds.w	1

************************* Table Of Targets For Enemies ***********************

targettable:	ds.b	(maxplayers+1)*4	;last long must be zeroed!

************************** Object Structure Buffers **************************

		phrase
emptydata:		ds.b	((iobjectlen&$fffffff8)+8)*maxempties
load_world_area:	ds.b	world_volume








