************************ Phase Shifter Control Routines **********************

* Notes:

******************************** Code Section ********************************

		text
		.68000

********************** Phase Shifter Waiting For A Target ********************

dophaserwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	phasercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodelauncher

		subq.w	#1,iotimer(a0) 		;look for a target
		bne.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done
		move.l	#dophaserattack,ido(a0)
.done:
		rts

************************* Phase Shifter Watching Target **********************

dophaserattack:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	doobjcoll		;deal with collisions
		bsr.s	phasercollide
		tst.w	ioenergy(a0)
		ble	explodelauncher

		bsr	confirmtarget 		;look at target
		beq.s	.losttarget
		bsr	flatrotatetotarget
		bsr	flatmoveobject

		move.w	iozspeed(a0),d0
		addq.w	#8,d0
		cmp.w	#150,d0
		ble.s	.zspeedok
		move.w	#150,d0
.zspeedok:
		move.w	d0,iozspeed(a0)
.done:
		rts
.losttarget:
		move.l	#dophaserwait,ido(a0)
		rts

************************** Phase Shifter Subroutines *************************

phasercollide:	tst.l	iocollcode(a0)		;check collisions on phaser
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodephaser:	move.l	#dobigbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makephaser:	bsr	getempty		;make phase shifter objects

		movem.l	position,d0-d2
		add.l	phaserheight,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#midrange,iorange(a1)

		move.w	switch,ioswitch(a1)

		move.l	#dophaserwait,ido(a1)
		move.l	#phaseranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#phaserTYPE,iotype(a1)
		move.w	#phaserENERGY,ioenergy(a1)
		move.w	#phaserDAMAGE,iodamage(a1)

		jsr	random
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		move.w	#1,iotimer2(a1)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************
 
		phrase
phaseranim:	dc.l	phaservdf

********************************* VDF Files **********************************

phaservdf:	incbin	"graphics\\shapes\\enemies\\phaser.vdf"

******************************** BSS Section *********************************

		bss

********************************* Variables **********************************

phaserheight:	ds.l	1









