***************************** Plasma Control File ****************************

* Notes:


******************************** Code Section ********************************

		text
		.68000

******************************** Plasma Bolt *********************************

doplasma:	tst.w	isonscreen(a0)		;only update when onscreen
		beq	.done

		subq.w	#1,iotimer(a0)		;has the plasma been
		bmi	killobject		;on long enough?

		bsr	doobjcoll		;deal with collisions

		tst.l	iocollfloor(a0)
		bne.s	.tiny

		move.l	iocollcode(a0),d0
		beq	.moveplasma
		clr.l	iocollcode(a0)

		cmp.w	#stopCODE,d0		;stops
		beq.s	.small
		cmp.w	#warpCODE,d0		;warps
		beq.s	.small
		cmp.w	#rprismCODE,d0		;right prisms
		beq.s	.rprism
		cmp.w	#lprismCODE,d0		;left prisms
		beq.s	.lprism
		cmp.w	#tripswitchCODE,d0	;trip switches
		beq.s	.moveplasma
		cmp.w	#barrierCODE,d0		;energy barriers
		beq.s	.moveplasma
		cmp.w	#laserCODE,d0		;lasers
		beq.s	.moveplasma
		cmp.w	#plasmaCODE,d0		;other plasmas
		beq.s	.moveplasma

* add to player's score here

		bra.s	.small
.rprism:
		movem.w	isxx(a0),d0-d7/a1	;spin the plasma
		neg.w	d0			;right by 90 degrees
		neg.w	d3
		neg.w	d6
		exg.l	d0,d2
		exg.l	d3,d5
		exg.l	d6,a1
		movem.w	d0-d7/a1,isxx(a0)
		bra.s	.moveplasma
.lprism:
		movem.w	isxx(a0),d0-d7/a1	;spin the plasma
		exg.l	d0,d2			;left by 90 degrees
		exg.l	d3,d5
		exg.l	d6,a1
		neg.w	d0
		neg.w	d3
		neg.w	d6
		movem.w	d0-d7/a1,isxx(a0)
		bra.s	.moveplasma
.tiny:
		move.l	#dotinybang,ido(a0)
		bra.s	.done
.small:
		move.l	#dosmallbang,ido(a0)
		bra.s	.done
.moveplasma:
		movem.w	iszx(a0),d0-d2		;move the plasma
		move.w	iozspeed(a0),d3
		muls	d3,d0
		muls	d3,d1
		muls	d3,d2
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d2
		add.l	d2,d2
		swap	d0
		swap	d1
		swap	d2
		ext.l	d0
		ext.l	d1
		ext.l	d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
.done:
		rts

****************************** Object Generators *****************************

createplayerplasma:
		movem.w	isxx(a0),d0-d7/a2	;fools the plasma into following
		movem.w	d0-d7/a2,-(sp)		;the aim matrix and not
		move.l	ioweapons(a0),a1	;the player's matrix
		movem.w	AIMMATRIX(a1),d0-d7/a2
		movem.w	d0-d7/a2,isxx(a0)

		bsr	getempty		;create a plasma bolt
		beq	.none

		move.l	#doplasma,ido(a1)
		move.l	#plasmaanim,isanimbase(a1)

		movem.w	isxx(a0),d1-d7/a2-a3
		movem.w	d1-d7/a2-a3,isxx(a1)

		move.w	#400,d0
		bsr	movetobarrel

		move.w	#weaponCLASS,ioclass(a1)
		move.w	#plasmaTYPE,iotype(a1)

		move.w	#20,iotimer(a1)
		move.w	#400,iozspeed(a1)

		moveq.l	#0,d0			;adjust size and damage
		move.w	iopower(a0),d0		;depending on power
		lsr.w	#3,d0
		cmp.w	#5,d0
		ble.s	.ok
		moveq.l	#5,d0
.ok:
		move.l	d0,isanimframe(a1)
		lsr.w	#1,d0
		addq.w	#1,d0
		mulu	#plasmaDAMAGE,d0
		move.w	d0,iodamage(a1)
.none:
		movem.w	(sp)+,d0-d7/a2		;restore player's matrix
		movem.w	d0-d7/a2,isxx(a0)

		moveq.l	#SFX_PLAYER_LASER,d7
		jsr	ADD_SFX
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

********************************* Animations *********************************

		phrase

plasmaanim:	dc.l	plasma1vdf	;for different strengths of plasma
		dc.l	plasma2vdf
		dc.l	plasma3vdf
		dc.l	plasma4vdf
		dc.l	plasma5vdf
		dc.l	plasma6vdf

*************************** Plasma VDF Creator Macro *************************

macro		makeplasmashape label,scale

\label		equ	 *
		dc.w	.plasmac\~-\label

.plasmas\~:	dc.w	(350*\scale)/256

		dc.w	6

		dc.w	0				;0
		dc.w	0
		dc.w	-((200*\scale)/256)
		dc.w	0,0,0

		dc.w	0				;1
		dc.w	0
		dc.w	(200*\scale)/256
		dc.w	0,0,0

		dc.w	-((50*\scale)/256)		;2
		dc.w	0
		dc.w	(100*\scale)/256
		dc.w	0,0,0

		dc.w	(50*\scale)/256			;3
		dc.w	0
		dc.w	(100*\scale)/256
		dc.w	0,0,0

		dc.w	0				;4
		dc.w	-((50*\scale)/256)
		dc.w	(100*\scale)/256
		dc.w	0,0,0

		dc.w	0				;5
		dc.w	(50*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	0,0,0

		dc.w	8

		dc.w	$0102,3,0,3,5
		dc.w	$0102,3,0,4,3
		dc.w	$0102,3,0,2,4
		dc.w	$0102,3,0,5,2
		dc.w	$0102,3,1,5,3
		dc.w	$0102,3,1,3,4
		dc.w	$0102,3,1,4,2
		dc.w	$0102,3,1,2,5

.plasmac\~:	dc.w	(350*\scale)/256

		dc.w	8

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	-((200*\scale)/256)
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	-((150*\scale)/256)
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	-((100*\scale)/256)
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	0
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	(50*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		dc.w	-((50*\scale)/256)
		dc.w	-((50*\scale)/256)
		dc.w	(150*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(100*\scale)/256
		dc.w	(50*\scale)/256
		dc.w	plasmaCODE

		endm

******************************* plasma VDF files *****************************

		makeplasmashape	plasma1vdf,256
		makeplasmashape	plasma2vdf,307
		makeplasmashape	plasma3vdf,358
		makeplasmashape	plasma4vdf,410
		makeplasmashape	plasma5vdf,460
		makeplasmashape	plasma6vdf,512
