**************************** Player Control Routines *************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

****************************** Player Entering Node **************************

doplayerenter:	bsr	playercollide

		move.w	isrezz(a0),d0			;rezz in the world
		add.w	#1024,d0
		cmp.w	#16384,d0
		ble.s	.ok
		move.w	#16384,d0
.ok:
		move.w	d0,isrezz(a0)

		subq.w	#1,iotimer1(a0)			;wait for a bit
		bpl.s	.notyet

		move.l	#doenter2,ido(a0)
		move.w	#20,iotimer1(a0)
.notyet:
		rts

doenter2:	bsr	playercollide			;drive forwards for a bit
		add.l	#100,iszcoord(a0)

		subq.w	#1,iotimer1(a0)
		bpl.s	.notyet

		tst.b	endboss
		beq.s	.noboss

		move.l	#dobossplayer,ido(a0)		;use a different set
		move.w	#10,iotimer(a0)			;of routines when on
		move.b	#cockpitcam,usecam		;the end sequence
		bra.s	.notyet
.noboss:
		move.l	#doplayer,ido(a0)		;use proper player routine
		move.b	#cockpitcam,usecam		;and cut to internal camera
		sf.b	nochangecam			;and don't let them change cameras
.notyet:
		rts

***************************** Player Exiting Node ****************************

doplayerexit:	bsr	playercollide		;slow to a stop ( almost )
		bsr	moveplayertank

		move.w	ioxspeed(a0),d0
		add.w	ioyspeed(a0),d0
		add.w	iozspeed(a0),d0
		cmp.w	#10,d0
		bge.s	.notyet

		move.l	#doexit2,ido(a0)

		bsr	findsector

		move.w	d6,iobarrelx(a0)	;the offset to the target point
		move.w	d7,iobarrely(a0)

		clr.w	iozspeed(a0)
.notyet:
		rts

doexit2:	bsr	playercollide

		move.w	iozspeed(a0),d0		;accelerate to a decent speed
		addq.w	#6,d0
		cmp.w	#70,d0
		ble.s	.speedok
		move.w	#70,d0
.speedok:
		move.w	d0,iozspeed(a0)

		move.l	iotarget(a0),a1		;get target point relative
		movem.w	iobarrelx(a0),d0-d1	;to target object
		ext.l	d0
		ext.l	d1
		sub.l	d0,isxcoord(a1)
		sub.l	d1,iszcoord(a1)

		bsr	flatrotatetotarget
		bsr	flatmoveobject

		move.l	iotarget(a0),a1		;reset target
		movem.l	isxcoord(a1),d0-d2
		movem.w	iobarrelx(a0),d3-d4
		ext.l	d3
		ext.l	d4
		add.l	d3,isxcoord(a1)
		add.l	d4,iszcoord(a1)

		move.l	#300,d3			;check if we're close enough
		sub.l	isxcoord(a0),d0		;to target point
		bpl.s	.xok
		neg.l	d0
.xok:
		cmp.l	d3,d0
		bge.s	.notyet

		sub.l	isycoord(a0),d1
		bpl.s	.yok
		neg.l	d1
.yok:
		cmp.l	d3,d1
		bge.s	.notyet

		sub.l	iszcoord(a0),d2
		bpl.s	.zok
		neg.l	d2
.zok:
		cmp.l	d3,d2
		bge.s	.notyet

		clr.w	iobarrelx(a0)		;clear target offset so that
		clr.w	iobarrely(a0)		;we can now drive into the exit
		clr.w	iozspeed(a0)
.notyet:
		rts

findsector:	move.l	iotarget(a0),a1		;find out which sector
		move.l	isxcoord(a1),d0		;the player is in relative
		move.l	iszcoord(a1),d1		;to the exit
		sub.l	isxcoord(a0),d0
		sub.l	iszcoord(a0),d1

		lea	exitoffsets,a1
		move.l	a1,a2
		moveq.l	#3,d2
		move.l	#$7fffffff,d3
.tryeach:
		movem.w	(a1),d6-d7

		sub.w	d0,d6
		sub.w	d1,d7
		muls	d6,d6
		muls	d7,d7
		add.l	d6,d7

		cmp.l	d3,d7
		bgt.s	.nope

		move.l	d7,d3
		move.l	a1,a2
.nope:
		addq.l	#4,a1
		dbf	d2,.tryeach

		movem.w	(a2),d6-d7
		rts

************************ Standard Player Update For Game *********************

doplayer:	move.l	#0,isanimframe(a0)	;update using tank graphic

		tst.w	ioenergy(a0)		;check for dead
		ble	explodeplayer
		cmp.w	#MAX_CRITICAL_ENERGY,ioenergy(a0)	;flash damage message
		bge.s	.notnow					;if energy low

		move.w	counter,d0
		and.w	#$7f,d0
		bne.s	.nosfx
		moveq.l	#SAY_DAMAGE_CRITICAL,d7
		jsr	ADD_SFX
.nosfx:
		move.b	#DAMAGE,HUDMESSAGE
		clr.w	HUDTIMER
		st	HUDFLASH
.notnow:
		bsr	playerwarp		;warp the player
		bsr	playercollide		;do collisions
		bsr	playercontrol		;update controller
		bsr	moveplayertank		;move the tank
		bsr	nearestwarp		;show the nearest warp
		bsr	checkforexit		;check exiting

		jsr	autotarget
		jsr	toggle_weapons		;hey... seedy's code worked first time!!!!!!!!!!!!
		jsr	fire_weapons		;miracles CAN happen....

		tst.w	ioshield(a0)		;turn on the shield graphic
		beq.s	.noshield
		subq.w	#1,ioshield(a0)
		move.l	#1,isanimframe(a0)
.noshield:
		tst.w	iotimer2(a0)		;count down immortality
		beq.s	.mortal
		subq.w	#1,iotimer2(a0)
.mortal:
		tst.b	exit_on			;if the exit is on
		beq.s	.noderezz		;derezz
		move.w	isrezz(a0),d0
		sub.w	#1024,d0
		bpl.s	.ok
		move.w	#0,d0
.ok:
		move.w	d0,isrezz(a0)
.noderezz:
		rts

doplayerregen:	move.b	#REGENERATE,HUDMESSAGE
		clr.w	HUDTIMER
		st	HUDFLASH
		add.w	#50,isblowup(a0)
		blt.s	.notyet
		move.l	#doplayer,ido(a0)
		move.w	#playerENERGY,ioenergy(a0)
		move.w	#immortaltime,iotimer2(a0)

		clr.w	ioxspeed(a0)
		clr.w	ioyspeed(a0)
		clr.w	iozspeed(a0)

		clr.w	isblowup(a0)
		move.b	#NOMESSAGE,HUDMESSAGE
		clr.w	HUDTIMER
		sf	HUDFLASH
.notyet:
		rts

playerwarp:	clr.w	iowarped(a0)
		tst.w	iodestination(a0)
		bmi.s	.notwarping

		move.w	iotimer(a0),d0
		add.w	#128,d0
		and.w	#2047,d0
		move.w	d0,iotimer(a0)
		jsr	sincos
		asr.w	#1,d1
		add.w	#8192,d1
		move.w	d1,isrezz(a0)

		move.w	iotimer(a0),d0
		beq.s	.finished
		cmp.w	#1024,d0
		bne.s	.notwarping
.changepos:
		move.w	#-1,iowarped(a0)
		bsr	getdestination
		add.l	#100,d1
		movem.l	d0-d2,isxcoord(a0)
		st.b	WARPED
		bra.s	.notwarping
.finished:
		move.w	#-1,iodestination(a0)
		clr.w	iotimer(a0)
.notwarping:
		rts

playercollide:	bsr	doobjcoll		;deal with collisions

		move.l	iocollfloor(a0),d0	;bounce off the floor
		beq.s	.yok
		clr.l	iocollfloor(a0)
		add.l	d0,isycoord(a0)

		cmp.w	#-gravity,ioyspeed(a0)	;if we've fallen a decent
		bge.s	.noshake		;distance shake on impact
		bsr	wobbleplayer
.noshake:
		neg.w	ioyspeed(a0)
		asr.w	ioyspeed(a0)
.yok:
		move.l	iocollcode(a0),d0
		beq	.nocollide
		clr.l	iocollcode(a0)

		cmp.w	#stopCODE,d0
		beq	.stop

		cmp.w	#bombCODE,d0		;check weapon types
		beq	.wobble
		cmp.w	#laserCODE,d0
		beq	.wobble
		cmp.w	#mineCODE,d0
		beq	.wobble
		cmp.w	#missileCODE,d0
		beq	.wobble
		cmp.w	#plasmaCODE,d0
		beq	.wobble

		cmp.w	#powerupCODE,d0		;check powerup types
		beq	.powerup

		cmp.w	#exitCODE,d0		;check feature types
		beq	.exit
		cmp.w	#attractCODE,d0
		beq	.attract
		cmp.w	#platformCODE,d0
		beq	.platform
		cmp.w	#repellCODE,d0
		beq	.repell
		cmp.w	#springCODE,d0
		beq	.spring
		cmp.w	#warpCODE,d0
		beq	.warp
		cmp.w	#distorterCODE,d0
		beq	.distorter

		cmp.w	#tankCODE,d0		;check enemy types
		beq	.stop
		cmp.w	#launcherCODE,d0
		beq	.stop
		cmp.w	#mobileCODE,d0
		beq	.stop
		cmp.w	#layerCODE,d0
		beq	.stop
		cmp.w	#gunCODE,d0
		beq	.stop
		cmp.w	#guardCODE,d0
		beq	.stop
		cmp.w	#bomberCODE,d0
		beq	.stop
		cmp.w	#bouncerCODE,d0
		beq	.wobble
		cmp.w	#fragmentCODE,d0
		beq	.applydamage
		cmp.w	#phaserCODE,d0
		beq	.wobble
		cmp.w	#straightCODE,d0
		beq	.wobble
		cmp.w	#spiralCODE,d0
		beq	.wobble
		cmp.w	#trundlerCODE,d0
		beq	.stop
		cmp.w	#radarCODE,d0
		beq	.stop
		cmp.w	#dropshipCODE,d0
		beq	.stop
		cmp.w	#resmineCODE,d0
		beq	.wobble
		cmp.w	#droptankCODE,d0
		beq	.stop

		bra	.applydamage
.powerup:
		bsr	addpowerup
		bra	.applydamage
.exit:
		tst.b	ignoreexit		;we need this for the start
		bne	.nocollide		;when driving out

		st.b	exit_on
		bra	.nocollide
.attract:
		move.l	iocollobj(a0),a1	;pulls the player
		movem.w	ioxspeed(a1),d0-d2	;towards the attractor
		sub.w	d0,ioxspeed(a0)
		sub.w	d1,ioyspeed(a0)
		sub.w	d2,iozspeed(a0)
		bra	.applydamage
.platform:
		move.l	iocollobj(a0),a1
		movem.w	ioxspeed(a1),d0-d2
		add.l	d0,isxcoord(a0)
		add.l	d1,isycoord(a0)
		add.l	d2,iszcoord(a0)
		move.w	#gravity,ioyspeed(a0)
		bra	.applydamage
.repell:
		move.l	iocollobj(a0),a1	;pushes the player
		movem.w	ioxspeed(a1),d0-d2	;away from the repeller
		add.w	d0,ioxspeed(a0)
		add.w	d1,ioyspeed(a0)
		add.w	d2,iozspeed(a0)
		bra.s	.applydamage
.spring:
		move.w	#140+gravity,ioyspeed(a0)
		bra	.applydamage
.warp:
		tst.w	iodestination(a0)	;if already warping
		bpl.s	.applydamage
		move.l	iocollobj(a0),a1
		move.w	iodestination(a1),iodestination(a0)
		clr.w	iotimer(a0)
		bra.s	.applydamage
.distorter:
		move.l	iocollobj(a0),a1
		movem.w	ioxspeed(a1),d0-d2
		add.w	d0,ioxspeed(a0)
		add.w	d2,iozspeed(a0)
		bsr	wobbleplayer
		bra.s	.applydamage
.wobble:
		bsr	wobbleplayer		;wobble the player
     		bra.s	.applydamage
.stop:
		move.w	ioxspeed(a0),d0		;back off if the player
		move.w	iozspeed(a0),d1		;hit anything
		ext.l	d0
		ext.l	d1
		sub.l	d0,isxcoord(a0)
		sub.l	d1,iszcoord(a0)
		asr.w	ioxspeed(a0)
		asr.w	iozspeed(a0)
.applydamage:
		tst.w	iodestination(a0)	;invincible whilst warping
		bpl.s	.nocollide

		tst.w	ioshield(a0)		;invincible when
		bne.s	.nocollide		;the shield is on

		tst.w	iotimer2(a0)		;invincible for a few seconds
		bne.s	.nocollide		;after getting destroyed

		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

playercontrol:	move.l	iocontroller(a0),a1	;get controller state
		move.l	(a1)+,d0
		move.l	(a1),d1

		movem.w	iszx(a0),d5-d7
		moveq.l	#10,d4
		asr.w	d4,d5
		asr.w	d4,d6
		asr.w	d4,d7
		moveq.l	#6,d4

		move.l	lastframes,d3
		muls	d3,d4
		muls	d3,d5
		muls	d3,d6
		muls	d3,d7
		asr.l	#1,d4
		asr.l	#1,d5
		asr.l	#1,d6
		asr.l	#1,d7

		btst	#LEFT_B,d0		;control the tank
		beq.s	.noleft     		;rotate left

		sub.w	d4,ioyrot(a0)
		cmp.w	#-40,ioyrot(a0)
		bge.s	.noright
		move.w	#-40,ioyrot(a0)
		bra.s	.noright
.noleft:
		btst	#RIGHT_B,d0		;rotate right
		beq.s	.noright
		add.w	d4,ioyrot(a0)
		cmp.w	#40,ioyrot(a0)
		ble.s	.noright
		move.w	#40,ioyrot(a0)
.noright:
		btst	#UP_B,d0		;speed up
		beq.s	.noup
		add.w	d5,ioxspeed(a0)
		add.w	d6,ioyspeed(a0)
		add.w	d7,iozspeed(a0)
		bra.s	.nodown
.noup:
		btst	#DOWN_B,d0		;slow down
		beq.s	.nodown
		sub.w	d5,ioxspeed(a0)
		sub.w	d6,ioyspeed(a0)
		sub.w	d7,iozspeed(a0)
.nodown:
		rts

moveplayertank:	moveq.l	#5,d7
		move.l	lastframes,d6
		muls	d6,d7
		asr.l	#1,d7

		move.w	ioyrot(a0),d0		;reduce rotation
		beq.s	.yrotok
		bmi.s	.yrotn
.yrotp:
		sub.w	d7,d0
		bpl.s	.yrotok
		moveq.l	#0,d0
		bra.s	.yrotok
.yrotn:
		add.w	d7,d0
		ble.s	.yrotok
		moveq.l	#0,d0
.yrotok:
		move.w	d0,ioyrot(a0)

		movem.w	ioxspeed(a0),d0-d2	;update velocity

		move.w	d0,d3			;reduce the xspeed
		bpl.s	.xipos
		neg.w	d3
.xipos:
		lsr.w	#3,d3
		bne.s	.xiok
		moveq.l	#1,d3
.xiok:
		tst.w	d0
		bpl.s	.xspos
.xsneg:
		add.w	d3,d0
		ble.s	.xsok
		moveq.l	#0,d0
		bra.s	.xsok
.xspos:
		sub.w	d3,d0
		bge.s	.xsok
		moveq.l	#0,d0
.xsok:
		move.w	d2,d3			;reduce the zspeed
		bpl.s	.zipos
		neg.w	d3
.zipos:
		lsr.w	#3,d3
		bne.s	.ziok
		moveq.l	#1,d3
.ziok:
		tst.w	d2
		bpl.s	.zspos
.zsneg:
		add.w	d3,d2
		ble.s	.zsok
		moveq.l	#0,d2
		bra.s	.zsok
.zspos:
		sub.w	d3,d2
		bge.s	.zsok
		moveq.l	#0,d2
.zsok:
		sub.w	#gravity,d1		;simulate gravity
		cmp.w	#-terminalv,d1
		bge.s	.ysok
		move.w	#-terminalv,d1
.ysok:
		movem.w	d0-d2,ioxspeed(a0)

		movem.w	ioxangle(a0),d0-d2
		tst.w	d0			;update pitch
		beq.s	.xok
		cmp.w	#1024,d0
		bgt.s	.xup
.xdown:
		subq.w	#2,d0
		bpl.s	.xok
		moveq.l	#0,d0
		bra.s	.xok
.xup:
		addq.w	#2,d0
		cmp.w	#2048,d0
		blt.s	.xok
		moveq.l	#0,d0
.xok:
		tst.w	d2		 	;update roll
		beq.s	.zok
		cmp.w	#1024,d2
		bgt.s	.zup
.zdown:
		subq.w	#2,d2
		bpl.s	.zok
		moveq.l	#0,d2
		bra.s	.zok
.zup:
		addq.w	#2,d2
		cmp.w	#2048,d2
		blt.s	.zok
		moveq.l	#0,d2
.zok:
		add.w	ioyrot(a0),d1		;update yaw
		and.w	#2047,d1
		movem.w	d0-d2,ioxangle(a0)

		lea	isxx(a0),a6		;calculate the orientation matrix
		bsr	anglematrix

		movem.l	isxcoord(a0),d0-d2	;update position
		movem.w	ioxspeed(a0),d3-d5
		add.l	d3,d0
		add.l	d4,d1
		add.l	d5,d2
		movem.l	d0-d2,isxcoord(a0)
		rts

wobbleplayer:	bsr	random		;wobbling the ship by changing the
		move.w	d0,d1		;tilt and roll angles has been known
		swap	d0		;to let the ship fall through the floor
		and.w	#31,d0		;this is because a corner of the ship
		and.w	#31,d1		;might end up below the floor
		sub.w	#16,d0
		sub.w	#16,d1		;I've limited the maximum angles and made
		and.w	#2047,d0	;the floor thicker to guard against it
		and.w	#2047,d1
		move.w	d0,ioxangle(a0)	;if it occurs again a rethink may be required
		move.w	d1,iozangle(a0)

		bsr	random
		and.w	#15,d0
		add.w	d0,ioyspeed(a0)
		rts

explodeplayer:	move.l	#doplayerbang,ido(a0)
		move.b	#NOMESSAGE,HUDMESSAGE
		move.l	ioweapons(a0),a6
		sf	WEAPON_PLASMA_POWER(a6)	;turn the plasma gun to off
		rts

autotarget:	move.l	ioweapons(a0),a1	;make sure we've got auto
		tst.b	WEAPON_AUTO(a1)		;targetting fitted
		beq	.notarget

		move.w	#enemyCLASS,d0		;find the closest enemy
		move.w	#powerupCLASS,d1	;or powerup
		jsr	closestobject
		move.l	a1,d0
		beq.s	.notarget

		movem.l	isxcoord(a1),d0-d2	;make sure it's close enough
		sub.l	isxcoord(a0),d0
		sub.l	isycoord(a0),d1
		sub.l	iszcoord(a0),d2
		move.l	#12000,d3
		cmp.l	d3,d0
		bge.s	.notarget
		cmp.l	d3,d1
		bge.s	.notarget
		cmp.l	d3,d2
		bge.s	.notarget
		neg.l	d3
		cmp.l	d3,d0
		ble.s	.notarget
		cmp.l	d3,d1
		ble.s	.notarget
		cmp.l	d3,d2
		ble.s	.notarget

		movem.w	d0-d2,aimvectorx	;it is so save it's position
		sub.w	#camsize,aimvectory

		bsr	makeunitvec		;make the aim vector a unit vector
		ext.l	d0
		ext.l	d1
		ext.l	d2

		movem.w	iszx(a0),d3-d5		;check that it's in front
		muls	d0,d3			;within limits
		muls	d1,d4
		muls	d2,d5
		add.l	d4,d3
		add.l	d5,d3
		add.l	d3,d3
		add.l	d3,d3
		swap	d3
		cmp.w	#13000,d3		;roughly the window boundaries
		ble.s	.notarget

		moveq.l	#0,d3			;aim at the target
		moveq.l	#0,d4
		moveq.l	#0,d5
		move.l	ioweapons(a0),a1
		lea	AIMMATRIX(a1),a6
		bsr	pointmatrix

		bra.s	.positioncrosshair
.notarget:
		move.l	ioweapons(a0),a1

		movem.w	isxx(a0),d0-d7/a2	;if not auto targetting then
		movem.w	d0-d7/a2,AIMMATRIX(a1)	;just point straight ahead

		movem.w	d6-d7/a2,aimvectorx

.positioncrosshair:
		movem.w	aimvectorx,d0-d2   	;position crosshair on target

		move.w	d0,d3
		move.w	d1,d4
		move.w	d2,d5
		muls	isxx(a0),d3
		muls	isxy(a0),d4
		muls	isxz(a0),d5
		add.l	d4,d3
		add.l	d5,d3
		add.l	d3,d3
		add.l	d3,d3
		swap	d3
		ext.l	d3

		move.w	d0,d4
		move.w	d1,d5
		move.w	d2,d6
		muls	isyx(a0),d4
		muls	isyy(a0),d5
		muls	isyz(a0),d6
		add.l	d5,d4
		add.l	d6,d4
		add.l	d4,d4
		add.l	d4,d4
		swap	d4
		ext.l	d4

		move.w	d0,d5
		move.w	d1,d6
		move.w	d2,d7
		muls	iszx(a0),d5
		muls	iszy(a0),d6
		muls	iszz(a0),d7
		add.l	d6,d5
		add.l	d7,d5
		add.l	d5,d5
		add.l	d5,d5
		swap	d5
		ext.l	d5

		move.l	d3,d0
		move.l	d4,d1
		move.l	d5,d2

		add.l	#256,d5
		asl.l	#8,d3
		asl.l	#8,d4
		divs	d5,d3
		divs	d5,d4

		move.l	ioweapons(a0),a1
		sub.w	CROSSX(a1),d3
		sub.w	CROSSY(a1),d4
		asr.w	#2,d3
		asr.w	#2,d4
		add.w	CROSSX(a1),d3
		add.w	CROSSY(a1),d4

		moveq.l	#5,d7			;lock the moving crosshair
		cmp.w	d5,d3			;to the stationary crosshair
		bge.s	.ok			;if it's close enough
		cmp.w	d5,d4
		bge.s	.ok
		neg.w	d7
		cmp.w	d5,d3
		ble.s	.ok
		cmp.w	d5,d4
		ble.s	.ok
		moveq.l	#0,d3
		moveq.l	#0,d4
.ok:
		movem.w	d3-d4,CROSSX(a1)
		rts

nearestwarp:	move.w	#warpTYPE,d0
		bsr	closesttype
		move.l	a1,d0
		beq.s	.none
		move.w	ioxspeed(a1),mapper_index	 ;show that warp
.none:
		rts

checkforexit:	move.w	datapods,d0		;is the node finished?
		or.w	databases,d0
		bne.s	.notyet

		move.w	#exitTYPE,d0		;get the closest exit
		bsr	closesttype
		move.l	a1,d0
		beq	.notyet

		movem.l	isxcoord(a1),d0-d2	;is it close enough?
		move.l	#2000,d3
		sub.l	isxcoord(a0),d0
		bpl.s	.xok
		neg.l	d0
.xok:
		cmp.l	d3,d0
		bge.s	.notyet

		sub.l	isycoord(a0),d1
		bpl.s	.yok
		neg.l	d1
.yok:
		cmp.l	d3,d1
		bge.s	.notyet

		sub.l	iszcoord(a0),d2
		bpl.s	.zok
		neg.l	d2
.zok:
		cmp.l	d3,d2
		bge.s	.notyet

		move.l	#doplayerexit,ido(a0)	;drive player into exit
		move.l	a1,iotarget(a0)		;set target object

		movem.l	isxcoord(a1),d0-d2
		move.l	#3000,d3
		sub.l	d3,d0
		sub.l	d3,d2
		movem.l	d0-d2,iominx(a0)
		add.l	d3,d3
		add.l	d3,d0
		add.l	d3,d2
		movem.l	d0-d2,iomaxx(a0)

		move.b	#panningcam,usecam
.notyet:
		rts

****************************** Object Generators *****************************

* The player's are now generated at the exit position
* so we should ignore the player position defined in the maps
* and generate the player after generating the exit

makeplayer1:
makeplayer2:
		rts

realmakeplayer1:
		move.b	#panningcam,usecam	;keep on external for the moment
		st.b	nochangecam

		bsr	getempty		;make player1 object

		bsr	settarget		;set player 1 as a target
		bsr	setcam1			;set up camera 1

		movem.l	position,d0-d2		;set position
		add.l	#20,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	frontmat,d0-d7/a2	;set orientation
		movem.w	d0-d7/a2,isxx(a1)
		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)
		movem.w	d0-d2,ioxrot(a1)

		move.l	#joycur1,iocontroller(a1)
		move.l	#doplayerenter,ido(a1)
		move.l	#player1anim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#playerCLASS,ioclass(a1)
		move.w	#playerTYPE,iotype(a1)
		move.w	#playerENERGY,ioenergy(a1)
		move.w	#playerDAMAGE,iodamage(a1)
		move.l	#player1weapons,ioweapons(a1)
		clr.w	ioshield(a1)

		clr.w	iowarped(a1)

		clr.w	iotimer(a1)
		move.w	#20,iotimer1(a1)
		move.w	#immortaltime,iotimer2(a1)
		move.w	#-1,iodestination(a1)
		sf.b	warping

		clr.w	isrezz(a1)

		move.l	a0,-(sp)	     	;create a drone if
		move.l	a1,a0		     	;the player has one
		move.l	ioweapons(a0),a1

		clr.w	CROSSX(a1)
		clr.w	CROSSY(a1)

		bsr	createdrone

		move.l	(sp)+,a0
		rts

* Player 2 will be needed later
* Hope we've got room to fit it in!!!

realmakeplayer2:
		bsr	getempty		;make player2 object

		bsr	settarget		;set player 2 as a target
		bsr	setcam2			;set up camera 2

		movem.l	position,d0-d2		;set position
		add.l	#20,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2	;set orientation
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#joycur2,iocontroller(a1)
		move.l	#doplayer,ido(a1)
		move.l	#player2anim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#playerCLASS,ioclass(a1)
		move.w	#playerTYPE,iotype(a1)
		move.w	#playerENERGY,ioenergy(a1)
		move.w	#playerDAMAGE,iodamage(a1)
		move.l	#player2weapons,ioweapons(a1)
		clr.w	ioshield(a1)

		clr.w	iowarped(a1)

		clr.w	iotimer(a1)
		move.w	#20,iotimer1(a1)
		move.w	#immortaltime,iotimer2(a1)
		move.w	#-1,iodestination(a1)
		sf.b	warping

		move.l	a0,-(sp)	     	;create a drone if
		move.l	a1,a0		     	;the player has one
		move.l	ioweapons(a0),a1

		clr.w	CROSSX(a1)
		clr.w	CROSSY(a1)

		bsr	createdrone

		move.l	(sp)+,a0
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

		even

player1tab:	dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,-200,200,0,0,0,0,playerCODE
		dc.l	0

player2tab:	dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,0,0,0,0,0,0,playertankCODE
		dc.l	0,-200,200,0,0,0,0,playerCODE
		dc.l	0

exitoffsets:	dc.w	0,2000
		dc.w	0,-2000
		dc.w	-2000,0
		dc.w	2000,0

********************************* Animations *********************************

**************************** Player Tank Animations **************************

		phrase
player1anim:	dc.l	player1vdf
		dc.l	shieldvdf

player2anim:	dc.l	player2vdf
		dc.l	shieldvdf

********************************** VDF Files *********************************

shieldvdf:	incbin	"graphics\\shapes\\players\\shield.vdf"

********************************* BSS Section ********************************

		bss

********************************** Variables *********************************

		even

tankheights:
lightheight:	ds.l	1
mediumheight:	ds.l	1
heavyheight:	ds.l	1

************************* Buffer For Merged Player Tanks *********************

player1vdf:	ds.b	1024*10
player2vdf:	ds.b	1024*10

karl:		ds.w	1
warping:	ds.b	1
endboss:	ds.b	1

aimvectorx:	ds.w	1
aimvectory:	ds.w	1
aimvectorz:	ds.w	1
