*************************** Powerup Control Routines *************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

***************************** Standard Powerup Update ************************

dopowerup:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		move.l	iocollcode(a0),d0	;deal with collisions
		beq.s	.spin
		clr.l	iocollcode(a0)

		cmp.w	#playerCODE,d0		;vanish if hit by a player
		bne.s	.spin

		moveq.l	#SFX_COLLECT,d7
		jsr	ADD_SFX

		bsr	killobject
		rts
.spin:
		movem.w	ioxangle(a0),d0-d2
		add.w	ioxrot(a0),d0
		add.w	ioyrot(a0),d1
		add.w	iozrot(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		jsr	anglematrix
.done:
		rts

********************** Powerup Vanishing After Collection ********************

dopowerupvanish:
		movem.w	ioxangle(a0),d0-d2
		add.w	ioxrot(a0),d0
		add.w	ioyrot(a0),d1
		add.w	iozrot(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		jsr	anglematrix

		sub.w	#2000,isrezz(a0)	;powerup vanishing
		bpl.s	.done
		bsr	killobject
.done:
		rts

********************* Add A Powerup To A Player's Tank ***********************

addpowerup:	move.l	ioweapons(a0),a1
		move.l	iocollobj(a0),a2
		move.w	iotimer(a2),d0
		add.w	d0,d0
		add.w	d0,d0
		lea	addpoweruptable,a2
		move.l	0(a2,d0.w),a2
		movem.l	d0-d7/a0-a6,-(sp)
		jsr	(a2)
		movem.l	(sp)+,d0-d7/a0-a6
		rts
	
addlaser1:	move.l	#SCORE_LASER1,D7
		moveq	#LASERMK1MESSAGE,D6
		moveq	#1,d0
		bsr	add_laser		;choose which mounting
		move.b	d0,(a1,d1.w)
		bra	make_new_tank

addlaser2:	MOVE.L	#SCORE_LASER2,D7
		moveq	#LASERMK2MESSAGE,D6
		moveq	#2,d0
		bsr	add_laser
		move.b	d0,(a1,d1.w)
		bra	make_new_tank

addplasma1:	MOVE.L	#SCORE_PLASMA1,D7
		moveq	#PLASMAMK1MESSAGE,D6
		moveq	#1,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_PLASMA(a1)
		bra	make_new_tank

addplasma2:	MOVE.L	#SCORE_PLASMA2,D7
		moveq	#PLASMAMK2MESSAGE,D6
		moveq	#2,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_PLASMA(a1)
		bra	make_new_tank

addplasma3:	MOVE.L	#SCORE_PLASMA3,D7
		moveq	#PLASMAMK3MESSAGE,D6
		moveq	#3,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_PLASMA(a1)
		bra	make_new_tank

addshields1:	MOVE.L	#SCORE_SHIELD1,D7
		moveq	#SHIELDMK1MESSAGE,D6
		moveq	#1,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_SHIELD(a1)
		move.b	#10,WEAPON_SHIELD_NUMBER(a1)
		bra	make_new_tank
		
addshields2:	MOVE.L	#SCORE_SHIELD2,D7
		moveq	#SHIELDMK2MESSAGE,D6
		moveq	#2,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_SHIELD(a1)
		move.b	#20,WEAPON_SHIELD_NUMBER(a1)
		bra	make_new_tank

addshields3:	MOVE.L	#SCORE_SHIELD3,D7
		moveq	#SHIELDMK3MESSAGE,D6
		moveq	#3,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_SHIELD(a1)
		move.b	#30,WEAPON_SHIELD_NUMBER(a1)
		bra	make_new_tank

addreargun1:	MOVE.L	#SCORE_REARGUN1,D7
		moveq	#REARGUNMK1MESSAGE,D6
		moveq	#1,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_BACK(a1)
		sf	WEAPON_MINE(a1)
		bra	make_new_tank

addreargun2:	MOVE.L	#SCORE_REARGUN2,D7
		moveq	#REARGUNMK2MESSAGE,D6
		moveq	#2,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_BACK(a1)
		sf	WEAPON_MINE(a1)
		bra	make_new_tank


addreargun3:	MOVE.L	#SCORE_REARGUN3,D7
		moveq	#REARGUNMK3MESSAGE,D6
		moveq	#3,d0
		bsr	weapon_too_heavy
		move.b	d0,WEAPON_BACK(a1)
		sf	WEAPON_MINE(a1)
		bra	make_new_tank



addauto:	MOVE.L	#SCORE_AUTO,D7
		moveq	#AUTOTARGETMESSAGE,D6
		move.b	#1,WEAPON_AUTO(a1)
		bra	make_new_tank

addradar1:	MOVE.L	#SCORE_RADAR1,D7
		moveq	#RADARMK1MESSAGE,D6
		move.b	#1,WEAPON_RADAR(a1)
		bra	make_new_tank

addradar2:	MOVE.L	#SCORE_RADAR2,D7
		moveq	#RADARMK2MESSAGE,D6
		move.b	#2,WEAPON_RADAR(a1)
		bra	make_new_tank

adddrone1:	MOVE.L	#SCORE_DRONE1,D7
		moveq	#DRONEMK1MESSAGE,D6
		move.b	#1,WEAPON_DRONE(a1)
		jsr	createdrone
		bra	make_new_tank

adddrone2:	MOVE.L	#SCORE_DRONE2,D7
		moveq	#DRONEMK2MESSAGE,D6
		move.b	#2,WEAPON_DRONE(a1)
		jsr	createdrone
		bra	make_new_tank





addrearmine1:	MOVE.L	#SCORE_MINE1,D7
		moveq	#MINELAYERMK1MESSAGE,D6
		moveq	#0,d0
		bra	add_rear_mine
addrearmine2:	MOVE.L	#SCORE_MINE2,D7
		moveq	#MINELAYERMK2MESSAGE,D6
		moveq	#1,d0
		bra	add_rear_mine
addrearmine3:	MOVE.L	#SCORE_MINE3,D7
		moveq	#MINELAYERMK3MESSAGE,D6
		moveq	#2,d0
add_rear_mine:	
		cmp.b	PLAYER_SHIP(a1),d0
		ble.s	.allowed
.error:		
		move.b	#TOOHEAVYMESSAGE,d6
		bra.s	.not_allowed
.allowed:	addq.w	#4,d0
		move.b	d0,WEAPON_BACK(a1)	;add mines + bigger mine layer
.not_allowed:	tst.b	WEAPON_BACK(a1)		;if nothing back exit 
		beq.s	.ok
		add.b	#20,WEAPON_MINE(a1)
		cmp.b	#60,WEAPON_MINE(a1)
		blt.s	.ok
		move.b	#60,WEAPON_MINE(a1)
.ok:		bra	make_new_tank
		




addlauncher1:	MOVE.L	#SCORE_LAUNCHER1,D7
		moveq	#LAUNCHERMK1MESSAGE,D6
		moveq	#0,d0
		bra	add_launcher

addlauncher2:	MOVE.L	#SCORE_LAUNCHER2,D7
		moveq	#LAUNCHERMK2MESSAGE,D6
		moveq	#1,d0
		bra	add_launcher

addlauncher3:	MOVE.L	#SCORE_LAUNCHER3,D7
		moveq	#LAUNCHERMK3MESSAGE,D6
		moveq	#2,d0
add_launcher:	
		cmp.b	#2,PLAYER_SHIP(a1)		;if heavy 2 launchers
		bne.s	.fit_to_left

		move.b	WEAPON_LAUNCHER_L(a1),d1
		cmp.b	WEAPON_LAUNCHER_R(a1),d1
		bgt	.fit_to_right
		
.fit_to_left:	cmp.b	PLAYER_SHIP(a1),d0
		ble.s	.allow_left
		move.b	#TOOHEAVYMESSAGE,d6
		bra.s	.not_to_left

.allow_left:	addq	#1,d0
		move.b	d0,WEAPON_LAUNCHER_L(a1)


.not_to_left:
		moveq	#0,d1
		move.b	WEAPON_LAUNCHER_L(a1),d1
		move.b	#2,WEAPON_MISSILE_L_TYPE(a1)	;homers
		mulu	#20,d1
		add.b	#20,WEAPON_MISSILE_L_NUMBER(a1)
		cmp.b	WEAPON_MISSILE_L_NUMBER(a1),d1
		bge.s	.ok
		move.b	d1,WEAPON_MISSILE_L_NUMBER(a1)
.ok:		bra	make_new_tank

.fit_to_right:	cmp.b	PLAYER_SHIP(a1),d0
		bgt.s	.not_to_right

		addq	#1,d0
		move.b	d0,WEAPON_LAUNCHER_R(a1)


.not_to_right:	moveq	#0,d1
		move.b	WEAPON_LAUNCHER_R(a1),d1
		move.b	#2,WEAPON_MISSILE_R_TYPE(a1)	;homers
		mulu	#20,d1
		add.b	#20,WEAPON_MISSILE_R_NUMBER(a1)
		cmp.b	WEAPON_MISSILE_R_NUMBER(a1),d1
		bge.s	.okr
		move.b	d1,WEAPON_MISSILE_R_NUMBER(a1)
.okr:		bra	make_new_tank



add_laser:	tst.b	PLAYER_SHIP(a1)		; if 0 = small tank = 1 laser
		beq.s	.left
		tst.b	WEAPON_LASER_R(a1)	;always got left so if no right
		beq.s	.right			;laser then have one
		cmp.b	WEAPON_LASER_L(a1),d0	;else if laser left <> d0
		beq.s	.right
.left:		moveq	#WEAPON_LASER_L,d1	;then make it one to change ( left)
		rts
.right:		moveq	#WEAPON_LASER_R,d1	;else change the right one
		rts



weapon_too_heavy:
		cmp.b	PLAYER_SHIP(a1),d0
		blt.s	.error
		rts
.error:
		asr.l	#4,d7
		jsr	ADD_TO_SCORE
		bsr	modify_score_text
		move.w	#100,HUDTIMER
		sf	HUDFLASH
		move.b	#TOOHEAVYMESSAGE,HUDMESSAGE
		addq.l	#4,sp
		rts

modify_score_text:
		lsr.l	#4,d7		;divide score by 10
		move.l	a0,-(sp)
		lea	mess_too_num,a0
		move.l	d7,-(sp)
		moveq	#7-1,d0		;strip leading 0's off
.loop:		rol.l	#4,d7
		moveq	#$f,d1
		and.l	d7,d1
		bne.s	.num
		dbf	d0,.loop

.num:		addq	#1,d0 		;print rest of the number
.loop2:		moveq	#$f,d1
		and.l	d7,d1
		rol.l	#4,d7
		add.b	#"0",d1
		move.b	d1,(a0)+
		dbf	d0,.loop2
		move.b	#PCR,(a0)+	;end of the text
		move.b	#PEND,(a0)+
		move.l	(sp)+,d7
		move.l	(sp)+,a0
		rts

make_new_tank:	
		cmp.b	#TOOHEAVYMESSAGE,d6
		bne.s	.ok
		bsr	modify_score_text
.ok:		move.w	#100,HUDTIMER
		sf	HUDFLASH
		move.b	d6,HUDMESSAGE
		jsr	ADD_TO_SCORE			;add d7 to the score
		jmp	create_new_ship



addlife:	move.w	PLAYER_LIVES(a1),d0		;give the player an extra life
		addq.w	#1,d0
		cmp.w	#9,d0
		ble.s	.ok
		moveq.l	#9,d0
.ok:
		move.w	d0,PLAYER_LIVES(a1)
		move.b	#POWERUPMESSAGE,HUDMESSAGE
		move.w	#cameramessagetime,HUDTIMER
		sf.b	HUDFLASH
		rts

addenergy:	move.w	#playerENERGY,ioenergy(a0)	;boost the player's energy
		move.b	#POWERUPMESSAGE,HUDMESSAGE
		move.w	#cameramessagetime,HUDTIMER
		sf.b	HUDFLASH
		rts

****************************** Object Generators *****************************

makelaser1:	bsr	makepowerup
		move.l	#p_laser1anim,isanimbase(a1)
		move.w	#0,iotimer(a1)
		rts

makelaser2:	bsr	makepowerup
		move.l	#p_laser2anim,isanimbase(a1)
		move.w	#1,iotimer(a1)
		rts

makeplasma1:	bsr	makepowerup
		move.l	#p_plasma1anim,isanimbase(a1)
		move.w	#2,iotimer(a1)
		rts

makeplasma2:	bsr	makepowerup
		move.l	#p_plasma2anim,isanimbase(a1)
		move.w	#3,iotimer(a1)
		rts

makeplasma3:	bsr	makepowerup
		move.l	#p_plasma3anim,isanimbase(a1)
		move.w	#4,iotimer(a1)
		rts

makelauncher1:	bsr	makepowerup
		move.l	#p_launcher1anim,isanimbase(a1)
		move.w	#5,iotimer(a1)
		rts

makelauncher2:	bsr	makepowerup
		move.l	#p_launcher2anim,isanimbase(a1)
		move.w	#6,iotimer(a1)
		rts

makelauncher3:	bsr	makepowerup
		move.l	#p_launcher3anim,isanimbase(a1)
		move.w	#7,iotimer(a1)
		rts

makeshields1:	bsr	makepowerup
		move.l	#p_shields1anim,isanimbase(a1)
		move.w	#8,iotimer(a1)
		rts

makeshields2:	bsr	makepowerup
		move.l	#p_shields2anim,isanimbase(a1)
		move.w	#9,iotimer(a1)
		rts

makeshields3:	bsr	makepowerup
		move.l	#p_shields3anim,isanimbase(a1)
		move.w	#10,iotimer(a1)
		rts

makereargun1:	bsr	makepowerup
		move.l	#p_reargun1anim,isanimbase(a1)
		move.w	#11,iotimer(a1)
		rts

makereargun2:	bsr	makepowerup
		move.l	#p_reargun2anim,isanimbase(a1)
		move.w	#12,iotimer(a1)
		rts

makereargun3:	bsr	makepowerup
		move.l	#p_reargun3anim,isanimbase(a1)
		move.w	#13,iotimer(a1)
		rts

makerearmine1:	bsr	makepowerup
		move.l	#p_rearmine1anim,isanimbase(a1)
		move.w	#14,iotimer(a1)
		rts

makerearmine2:	bsr	makepowerup
		move.l	#p_rearmine2anim,isanimbase(a1)
		move.w	#15,iotimer(a1)
		rts

makerearmine3:	bsr	makepowerup
		move.l	#p_rearmine3anim,isanimbase(a1)
		move.w	#16,iotimer(a1)
		rts

makeauto:	bsr	makepowerup
		move.l	#p_autotargetanim,isanimbase(a1)
		move.w	#17,iotimer(a1)
		rts

makeradar1:	bsr	makepowerup
		move.l	#p_radar1anim,isanimbase(a1)
		move.w	#18,iotimer(a1)
		rts

makeradar2:	bsr	makepowerup
		move.l	#p_radar2anim,isanimbase(a1)
		move.w	#19,iotimer(a1)
		rts

makedrone1:	bsr	makepowerup
		move.l	#p_drone1anim,isanimbase(a1)
		move.w	#20,iotimer(a1)
		rts

makedrone2:	bsr	makepowerup
		move.l	#p_drone2anim,isanimbase(a1)
		move.w	#21,iotimer(a1)
		rts

makelife:	bsr	makepowerup
		move.l	#p_lifeanim,isanimbase(a1)
		move.w	#22,iotimer(a1)
		rts

makeenergy:	bsr	makepowerup
		move.l	#p_energyanim,isanimbase(a1)
		move.w	#23,iotimer(a1)
		rts

makepowerup:	bsr	getempty		;make a life powerup

		movem.l	position,d0-d2
		add.l	#100,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		move.l	#dopowerup,ido(a1)
		move.l	#0,isanimframe(a1)

		move.w	#powerupCLASS,ioclass(a1)
		move.w	#powerupTYPE,iotype(a1)
		move.w	#powerupDAMAGE,iodamage(a1)

		jsr	random
		move.l	d0,d1
		move.w	d1,d2
		swap	d1
		jsr	random
		and.w	#2047,d0
		and.w	#2047,d1
		and.w	#2047,d2
		movem.w	d0-d2,ioxangle(a1)

		move.w	#20,ioxrot(a1)
		move.w	#30,ioyrot(a1)
		move.w	#40,iozrot(a1)
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

addpoweruptable:	dc.l	addlaser1
			dc.l	addlaser2
			dc.l	addplasma1
			dc.l	addplasma2
			dc.l	addplasma3
			dc.l	addlauncher1
			dc.l	addlauncher2
			dc.l	addlauncher3
			dc.l	addshields1
			dc.l	addshields2
			dc.l	addshields3
			dc.l	addreargun1
			dc.l	addreargun2
			dc.l	addreargun3
			dc.l	addrearmine1
			dc.l	addrearmine2
			dc.l	addrearmine3
			dc.l	addauto
			dc.l	addradar1
			dc.l	addradar2
			dc.l	adddrone1
			dc.l	adddrone2
			dc.l	addlife
			dc.l	addenergy

********************************* Animations *********************************

			phrase
p_laser1anim:		dc.l	p_laser1vdf
p_laser2anim:		dc.l	p_laser2vdf
p_plasma1anim:		dc.l	p_plasma1vdf
p_plasma2anim:		dc.l	p_plasma2vdf
p_plasma3anim:		dc.l	p_plasma3vdf
p_launcher1anim:	dc.l	p_launcher1vdf
p_launcher2anim:	dc.l	p_launcher2vdf
p_launcher3anim:	dc.l	p_launcher3vdf
p_shields1anim:		dc.l	p_shields1vdf
p_shields2anim:		dc.l	p_shields2vdf
p_shields3anim:		dc.l	p_shields3vdf
p_reargun1anim:		dc.l	p_reargun1vdf
p_reargun2anim:		dc.l	p_reargun2vdf
p_reargun3anim:		dc.l	p_reargun3vdf
p_rearmine1anim:	dc.l	p_rearmine1vdf
p_rearmine2anim:	dc.l	p_rearmine2vdf
p_rearmine3anim:	dc.l	p_rearmine3vdf
p_autotargetanim:	dc.l	p_autotargetvdf
p_radar1anim:		dc.l	p_radar1vdf
p_radar2anim:		dc.l	p_radar2vdf
p_drone1anim:		dc.l	p_drone1vdf
p_drone2anim:		dc.l	p_drone2vdf
p_lifeanim:		dc.l	p_lifevdf
p_energyanim:		dc.l	p_energyvdf

********************************* VDF Files **********************************

p_laser1vdf:	   	incbin	"graphics\\shapes\\powerups\\P_LASER1.VDF"
p_laser2vdf:	   	incbin	"graphics\\shapes\\powerups\\P_LASER2.VDF"
p_plasma1vdf: 		incbin	"graphics\\shapes\\powerups\\P_PLASL1.VDF"
p_plasma2vdf:	   	incbin	"graphics\\shapes\\powerups\\P_PLASL2.VDF"
p_plasma3vdf:	   	incbin	"graphics\\shapes\\powerups\\P_PLASL3.VDF"
p_launcher1vdf:   	incbin	"graphics\\shapes\\powerups\\P_MSLCH1.VDF"
p_launcher2vdf:   	incbin	"graphics\\shapes\\powerups\\P_MSLCH2.VDF"
p_launcher3vdf:   	incbin	"graphics\\shapes\\powerups\\P_MSLCH3.VDF"
p_shields1vdf:   	incbin	"graphics\\shapes\\powerups\\P_SHILD1.VDF"
p_shields2vdf:   	incbin	"graphics\\shapes\\powerups\\P_SHILD2.VDF"
p_shields3vdf:   	incbin	"graphics\\shapes\\powerups\\P_SHILD3.VDF"
p_reargun1vdf: 	   	incbin	"graphics\\shapes\\powerups\\P_RLASR1.VDF"
p_reargun2vdf:		incbin	"graphics\\shapes\\powerups\\P_RLASR2.VDF"
p_reargun3vdf:		incbin	"graphics\\shapes\\powerups\\P_RLASR3.VDF"
p_rearmine1vdf:   	incbin	"graphics\\shapes\\powerups\\P_RMINE1.VDF"
p_rearmine2vdf:   	incbin	"graphics\\shapes\\powerups\\P_RMINE2.VDF"
p_rearmine3vdf:   	incbin	"graphics\\shapes\\powerups\\P_RMINE3.VDF"
p_autotargetvdf:	incbin	"graphics\\shapes\\powerups\\P_AUTOT.VDF"
p_radar1vdf:		incbin	"graphics\\shapes\\powerups\\P_RADAR1.VDF"
p_radar2vdf:		incbin	"graphics\\shapes\\powerups\\P_RADAR2.VDF"
p_drone1vdf:		incbin	"graphics\\shapes\\powerups\\P_DRONE1.VDF"
p_drone2vdf:		incbin	"graphics\\shapes\\powerups\\P_DRONE2.VDF"
p_lifevdf:  		incbin	"graphics\\shapes\\powerups\\P_LIFE.VDF"
p_energyvdf:		incbin	"graphics\\shapes\\powerups\\P_ENERGY.VDF"
