**************************** Radar Control Routines **************************

* Notes:

******************************** Code Section ********************************

		text
		.68000

*********************** Radar Tower Scanning For Targets *********************

doradarscan:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	radarcollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble.s	exploderadar

		bsr	readswitch
		beq.s	.done

		bsr	flatrotateobject

		subq.w	#1,iotimer(a0) 		;look for a target
		bne.s	.done
		move.w	#longaidelay,iotimer(a0)

		bsr	rangetarget		;this target will be used
		move.l	a1,iotarget(a0)		;by radar missile launchers
.done:
		rts

******************************** Gun Subroutines *****************************

radarcollide:	move.l	a0,a1
		bsr.s	.partcollide
		move.l	inext(a0),a1
.partcollide:
		tst.l	iocollcode(a1)
		beq.s	.nocollide
		clr.l	iocollcode(a1)
		move.l	iocollobj(a1),a2
		move.w	iodamage(a2),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

exploderadar:	move.l	inext(a0),a1
		move.l	#dobigbang,ido(a0)
		move.l	#dobigbang,ido(a1)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

makeradar:	bsr	getempty		;make gun objects
		bsr	getempty

		movem.l	position,d0-d2
		add.l	#500,d1
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#shortrange,iorange(a1)

		move.w	switch,ioswitch(a1)

		move.l	#doradarscan,ido(a1)
		move.l	#radarscanneranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#radarTYPE,iotype(a1)
		move.w	#radarENERGY,ioenergy(a1)
		move.w	#radarDAMAGE,iodamage(a1)

		jsr	random
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		move.w	#1,iotimer2(a1)

		move.w	#0,ioxrot(a1)
		move.w	#50,ioyrot(a1)
		move.w	#0,iozrot(a1)

		move.l	inext(a1),a2
		movem.l	isxcoord(a1),d0-d2
		movem.l	d0-d2,isxcoord(a2)
		movem.w	isxx(a1),d0-d7/a3
		movem.w	d0-d7/a3,isxx(a2)

		move.l	#donowt,ido(a2)
		move.l	#radartoweranim,isanimbase(a2)
		move.l	#0,isanimframe(a2)

		move.w	#enemyCLASS,ioclass(a2)
		move.w	#radarTYPE,iotype(a2)
		move.w	#radarENERGY,ioenergy(a2)
		move.w	#radarDAMAGE,iodamage(a2)

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************
 
		phrase
radarscanneranim:
		dc.l	radarscannervdf
radartoweranim:
		dc.l	radartowervdf

********************************* VDF Files **********************************

radarscannervdf:
		dc.w	radarscannerc-radarscannervdf

radarscanners:	dc.w	350

		dc.w	8

		dc.w	-100,0,-100,0,0,0		;0
		dc.w	100,0,-100,0,0,0		;1
		dc.w	-150,0,50,0,0,0			;2
		dc.w	150,0,50,0,0,0			;3
		dc.w	-150,100,50,0,0,0		;4
		dc.w	150,100,50,0,0,0		;5
		dc.w	-300,50,150,0,0,0		;6
		dc.w	300,50,150,0,0,0		;7

		dc.w	9

		dc.w	$40ff,4,0,1,5,4	;4,5,1,0
		dc.w	$40ff,4,1,0,2,3	;3,2,0,1
		dc.w	$4100,4,3,2,4,5	;5,4,2,3

		dc.w	$40e0,3,4,6,0	;0,6,4
		dc.w	$40e8,3,6,2,0	;0,2,6
		dc.w	$40d0,3,2,6,4	;4,6,2

		dc.w	$40e0,3,7,5,1	;1,5,7
		dc.w	$40e8,3,7,1,3	;3,1,7
		dc.w	$40d0,3,5,7,3	;3,7,5

radarscannerc:	dc.w	350

		dc.w	1

		dc.w	-300,0,-100
		dc.w	600,100,200
		dc.w	solid+static+radarCODE

radartowervdf:	dc.w	radartowerc-radartowervdf

radartowers:	dc.w	575

		dc.w	13

		dc.w	-130,-500,-200,0,0,0		;0
		dc.w	130,-500,-200,0,0,0		;1
		dc.w	-130,-500,200,0,0,0		;2
		dc.w	130,-500,200,0,0,0		;3
		dc.w	-130,-500,-60,0,0,0		;4
		dc.w	130,-500,-60,0,0,0		;5
		dc.w	-130,-500,60,0,0,0		;6
		dc.w	130,-500,60,0,0,0		;7

		dc.w	-200,-500,-40,0,0,0		;8
		dc.w	200,-500,-40,0,0,0		;9
		dc.w	-200,-500,40,0,0,0		;10
		dc.w	200,-500,40,0,0,0		;11
		dc.w	0,0,0,0,0,0			;12

		dc.w	10

		dc.w	$40fe,5,2,12,0,4,6	;0,12,2,6,4
		dc.w	$40fc,3,0,12,8	;8,12,0
		dc.w	$40fc,3,10,12,2	;2,12,10
		dc.w	$800b,3,8,12,10	;10,12,8

		dc.w	$40fe,5,1,12,3,7,5	;3,12,1,5,7
		dc.w	$40fc,3,9,12,1	;1,12,9
		dc.w	$40fc,3,3,12,11	;11,12,3
		dc.w	$800b,3,11,12,9	;9,12,11

		dc.w	$800b,3,5,12,4	;4,12,5
		dc.w	$800b,3,6,12,7	;7,12,6

radartowerc:	dc.w	575

		dc.w	1

		dc.w	-200,-500,-200
		dc.w	400,500,400
		dc.w	solid+static+radarCODE

