*************************** Trundler Control Routines ************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

***************** Trundler Waiting And Scanning For Targets ******************

dotrundlerwait:	tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr.s	trundlercollide		;deal with collisions
		tst.w	ioenergy(a0)
		ble	explodetrundler

		bsr	readswitch
		beq.s	.done

		subq.w	#1,iotimer(a0)		;look for a target
		bpl.s	.done
		move.w	#longaidelay,iotimer(a0)
		bsr	rangetarget
		move.l	a1,iotarget(a0)
		beq.s	.done

		move.l	#dotrundlerattack,ido(a0)	;we have a target!
.done:
		rts

************************ Trundler Attacking It's Target **********************

dotrundlerattack:
		tst.w	isonscreen(a0)		;only update when onscreen
		beq.s	.done

		bsr	doobjcoll		;deal with collisions
		bsr.s	trundlercollide
		tst.w	ioenergy(a0)
		ble.s	explodetrundler

		bsr	confirmtarget
		beq.s	.losttarget
		bsr	flatrotatetotarget
		bsr	flatmoveobject
		bsr	flatadjustspeed

		subq.w	#1,iotimer2(a0)		;shoot every now and then
		bpl.s	.done
		jsr	random
		and.w	#3,d0
		add.w	#12,d0
		move.w	d0,iotimer2(a0)
		bsr	createenemyfrontlaser3
.done:
		rts
.losttarget:
		move.l	#dotrundlerwait,ido(a0)
		rts

**************************** Trundler Subroutines ****************************

trundlercollide:
		tst.l	iocollcode(a0)
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		move.l	iocollobj(a0),a1
		move.w	iodamage(a1),d0
		sub.w	d0,ioenergy(a0)
.nocollide:
		rts

explodetrundler:
		move.l	#dobigbang,ido(a0)
		addq.w	#1,baddieskilled
		rts

****************************** Object Generators *****************************

maketrundler:	bsr	getempty		;make trundler object

		movem.l	position,d0-d2
		movem.l	d0-d2,isxcoord(a1)

		movem.w	orientation,d0-d7/a2
		movem.w	d0-d7/a2,isxx(a1)

		movem.l	boundary,d0-d5
		movem.l	d0-d5,iominx(a1)
		move.l	#midrange,iorange(a1)	;set attack range

		move.w	switch,ioswitch(a1)

		move.l	trundlerheight,d0
		add.l	d0,isycoord(a1)

		move.l	#dotrundlerwait,ido(a1)
		move.l	#trundleranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#trundlerTYPE,iotype(a1)
		move.w	#trundlerENERGY,ioenergy(a1)
		move.w	#trundlerDAMAGE,iodamage(a1)

		move.w	#0,iobarrelx(a1)
		move.w	#0,iobarrely(a1)
		move.w	#400,iobarrelz(a1)

		jsr	random			;delay for ai
		and.w	#31,d0
		addq.w	#1,d0
		move.w	d0,iotimer(a1)

		move.w	#1,iotimer2(a1)		;shooting delay

		addq.w	#1,baddies
		rts

******************************** Data Section ********************************

		data

********************************* Variables **********************************

********************************* Animations *********************************

		phrase
trundleranim:	dc.l	trundlervdf

********************************* VDF Files **********************************

trundlervdf: 	incbin	"graphics\\shapes\\enemies\\trundler.vdf"

******************************** BSS Section *********************************

		bss

********************************* Variables **********************************

		even

trundlerheight:	ds.l	1
