******************************* Tunnel Sequence ******************************

* Notes:

********************************* Code Section *******************************

		text
		.68000

********************************* Main Routines ******************************

*************************** Short Tunnel Before Game *************************

shorttunnel:	clr.l	clock
		jsr	NEW_OL
		jsr	NEW_OL

		st	in_tunnel
    		sf	tunnel_exit
		sf	clock_on
		move.b	#0,minutes
		move.b	#5,seconds
		move.w	minutes,max_time_in_tunnel

		bsr	initshorttunnel
		st	clock_on

.intunnel:
		bsr	handle_pause
		jsr	CLEAR_SFX_LIST		;ensure no sfx present
		jsr	ADD_VIEWSCREEN
      		jsr	read_joypad

		lea	colouranimtab,a0	;do the animated colours
		jsr	colouranim

		move.l	rasterb,rasterd

		move.l	rasterz,a0
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0
		bsr	doitem

		lea	tunnelcameras,a0
		bsr	doitem

		jsr	waitgpu			;wait for cameras
		jsr	waitblitter

		jsr	switchabc
		jsr	PROCESS_SFX		;sort sfx list by distance

		move.l	joyedge1,d0		;to allow skipping
		btst	#KEY_6,d0		;the tunnel sequence
		bne.s	.donetunnel

		tst.b	tunnel_exit
		beq	.intunnel
.donetunnel:
		sf	in_tunnel

		jsr	NEW_OL
		jsr	NEW_OL
		jsr	NEW_OL
		rts

initshorttunnel:
		;jsr	load_tunnel_music

		bsr	clearworld

		move.l	tunneldata,a0		;get that tunnel's parameters
		move.w	#-1,minedelay
		move.w	#-1,hazarddelay
		move.w	#-1,barrierdelay
		move.w	#2,bonusdelay
		lea	type1,a1		;short tunnel is always type 1 at the moment
		move.l	a1,tunnelanims
		addq.l	#4,a1
		move.l	a1,tunnelbarrieranim
		addq.l	#4,a1
		move.l	a1,tunnelbounds

		bsr	makeautoflyer

		move.l	#20000,d0
		moveq.l	#3,d1
.sections:
		movem.l	d0-d1,-(sp)
		bsr	makesection
		movem.l	(sp)+,d0-d1
		sub.l	#5000,d0
		dbf	d1,.sections

		bsr	makecamera

		move.w	minedelay,minedelaycounter
		move.w	hazarddelay,hazarddelaycounter
		move.w	barrierdelay,barrierdelaycounter
		move.w	bonusdelay,bonusdelaycounter

		move.b	#32,zoom_size
		st.b	IN_GAME
		st.b	texturesoff
		sf.b	createbonuses		;don't make bonuses
		sf.b	notunnelhud		;cause that would be silly
		rts

************************* After Game Tunnel Sequence *************************

tunnel:		clr.l	clock
		jsr	NEW_OL
		jsr	NEW_OL

		st	in_tunnel
    		sf	tunnel_exit
		sf	clock_on
		move.b	#0,minutes
		move.b	#60,seconds
		move.w	minutes,max_time_in_tunnel

		bsr	inittunnel
		st	clock_on

.intunnel:
		bsr	handle_pause
		jsr	CLEAR_SFX_LIST		;ensure no sfx present
		jsr	ADD_VIEWSCREEN
      		jsr	read_joypad

		lea	colouranimtab,a0	;do the animated colours
		jsr	colouranim

		move.l	rasterb,rasterd

		move.l	rasterz,a0
		move.l	#$7fff7fff,d7
		jsr	clearraster

		lea	world,a0
		bsr	doitem

		lea	tunnelcameras,a0
		bsr	doitem

		bsr	createtunnelmine
		bsr	createtunnelhazard

		jsr	waitgpu			;wait for cameras
		jsr	waitblitter

		jsr	switchabc
		jsr	PROCESS_SFX		;sort sfx list by distance

		move.l	joyedge1,d0		;to allow skipping
		btst	#KEY_6,d0		;the tunnel sequence
		bne.s	.donetunnel

		tst.b	tunnel_exit
		beq	.intunnel
.donetunnel:
		sf	in_tunnel
		rts

inittunnel:	jsr	load_tunnel_music

		bsr	clearworld

		move.l	tunneldata,a0		;get that tunnel's parameters
		move.w	(a0)+,minedelay
		move.w	(a0)+,hazarddelay
		move.w	(a0)+,barrierdelay
		move.w	(a0),d0
		add.w	d0,d0
		add.w	d0,d0
		lea	tunneltable,a1
		add.w	d0,a1
		move.l	(a1),a1
		move.l	a1,tunnelanims
		addq.l	#4,a1
		move.l	a1,tunnelbarrieranim
		addq.l	#4,a1
		move.l	a1,tunnelbounds

		bsr	makeflyer

		move.l	#20000,d0
		moveq.l	#3,d1
.sections:
		movem.l	d0-d1,-(sp)
		bsr	makesection
		movem.l	(sp)+,d0-d1
		sub.l	#5000,d0
		dbf	d1,.sections

		bsr	makecamera

		move.w	minedelay,minedelaycounter
		move.w	hazarddelay,hazarddelaycounter
		move.w	barrierdelay,barrierdelaycounter

		move.b	#32,zoom_size
		st.b	IN_GAME
		st.b	texturesoff
		st.b	createbonuses		;make bonuses
		st.b	notunnelhud

		clr.w	podsgenerated
		clr.w	podscollected
		rts

******************************* Object Updates *******************************

doflyer:	move.w	isrezz(a0),d0		;rezz into the tunnel
		add.w	#512,d0
		cmp.w	#16384,d0
		ble.s	.ok
		move.w	#16384,d0
.ok:
		move.w	d0,isrezz(a0)

		move.w	ioenergy(a0),energy_left_in_tunnel	;tell Seedy how much energy is left

		tst.w	minutes			;first check if we've
		bne.s	.noexit			;run out of time
		moveq	#SFX_TUNNEL_EXIT,d7
		jsr	ADD_SFX
		move.l	#doflyeraway,ido(a0)
		clr.w	iozrot(a0)
.noexit:
		move.l	iocontroller(a0),a1
		move.l	(a1),d7

		movem.w	ioxspeed(a0),d3-d5
		btst	#LEFT_B,d7
		beq.s	.notleft
		sub.w	#20,d3
		cmp.w	#-200,d3
		bge.s	.notright
		move.w	#-200,d3
		bra.s	.notright
.notleft:
		btst	#RIGHT_B,d7
		beq.s	.notright
		add.w	#20,d3
		cmp.w	#200,d3
		ble.s	.notright
		move.w	#200,d3
.notright:
		btst	#UP_B,d7
		beq.s	.notdown
		sub.w	#20,d4
		cmp.w	#-200,d4
		bge.s	.notup
		move.w	#-200,d4
		bra.s	.notup
.notdown:
		btst	#DOWN_B,d7
		beq.s	.notup
		add.w	#20,d4
		cmp.w	#200,d4
		ble.s	.notup
		move.w	#200,d4
.notup:
		btst	#FIRE_C,d7
		beq.s	.noslowdown
		sub.w	#40,d5
		cmp.w	#40,d5
		bge.s	.nospeedup
		move.w	#40,d5
		bra.s	.nospeedup
.noslowdown:
		btst	#FIRE_A,d7
		beq.s	.nospeedup
		add.w	#40,d5
		cmp.w	#1000,d5
		ble.s	.nospeedup
		move.w	#1000,d5
.nospeedup:
		tst.w	d3
		beq.s	.xok
		bpl.s	.xpos
.xneg:
		addq.w	#5,d3
		ble.s	.xok
		moveq.l	#0,d3
		bra.s	.xok
.xpos:
		subq.w	#5,d3
		bge.s	.xok
		moveq.l	#0,d3
.xok:
		tst.w	d4
		beq.s	.yok
		bpl.s	.ypos
.yneg:
		addq.w	#5,d4
		ble.s	.yok
		moveq.l	#0,d4
		bra.s	.yok
.ypos:
		subq.w	#5,d4
		bge.s	.yok
		moveq.l	#0,d4
.yok:
		movem.l	isxcoord(a0),d0-d2
		bsr	moveintunnel
		movem.l	d0-d2,isxcoord(a0)
		movem.w	d3-d5,ioxspeed(a0)

		movem.w	ioxspeed(a0),d0-d1
		and.w	#2047,d0
		and.w	#2047,d1
		move.w	d1,ioxangle(a0)
		move.w	d0,iozangle(a0)

		movem.w	ioxangle(a0),d0-d2
		lea	isxx(a0),a6
		bsr	anglematrix

		jsr	doobjcoll		;deal with collisions
		move.l	iocollcode(a0),d0
		beq.s	.nocollide
		clr.l	iocollcode(a0)
		cmp.w	#barrierCODE,d0
		beq.s	.barrier
		cmp.w	#mineCODE,d0
		beq.s	.obstacle
		cmp.w	#bonusCODE,d0
		beq.s	.bonus
		bra.s	.nocollide
.barrier:
		sub.w	#10,ioenergy(a0)
		ble.s	.explodeflyer
		bra.s	.nocollide
.obstacle:
		sub.w	#50,ioenergy(a0)
		ble.s	.explodeflyer
		bra.s	.nocollide
.bonus:
		moveq.l	#SFX_COLLECT,d7
		jsr	ADD_SFX

		addq.w	#1,podscollected

		bra.s	.nocollide
.explodeflyer:
		clr.w	ioenergy(a0)
		move.l	#doflyerbang,ido(a0)
.nocollide:
		rts

doflyeraway:	move.w	iozspeed(a0),d0		;slow down the tunnel speed
		asr.w	d0
		sub.w	d0,iozspeed(a0)
		bpl.s	.slowingdown
		clr.w	iozspeed(a0)
.slowingdown:
		add.w	#150,iozrot(a0)		;speed the flyer
		cmp.w	#3000,iozrot(a0)	;down the tunnel
		ble.s	.speedingup
		move.w	#3000,iozrot(a0)
.speedingup:
		move.w	iozrot(a0),d0		;until it's out the end
		ext.l	d0
		add.l	d0,iszcoord(a0)

		move.w	isrezz(a0),d0		;rezz out of the tunnel
		sub.w	#512,d0
		bgt.s	.ok
		moveq.l	#0,d0
		st	tunnel_exit		;then exit
.ok:
		move.w	d0,isrezz(a0)

		movem.w	frontmat,d0-d7/a2	;point the right way!
		movem.w	d0-d7/a2,isxx(a0)
		rts

dosectionspin:	movem.w	ioxangle(a0),d0-d2
		add.w	iozrot(a0),d2
		and.w	#2047,d2
		move.w	d2,iozangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix		;falls through into 'dosection'

dosection:	move.l	iotarget(a0),a1
		move.w	iozspeed(a1),d0
		ext.l	d0
		sub.l	d0,iszcoord(a0)
		bpl.s	.nowrap
		add.l	#20000,iszcoord(a0)

		clr.w	iozangle(a0)
		movem.w	frontmat,d0-d7/a1
		movem.w	d0-d7/a1,isxx(a0)

		bsr	createtunnelbonus
		bsr	createtunnelbarrier

		move.l	#dosection,ido(a0)
		jsr	random
		and.w	#63,d0
		cmp.w	#48,d0
		ble.s	.nowrap
;		move.l	#dosectionspin,ido(a0)	;spinning sections suck when the shape isn't cylindrical

		move.w	#40,d6
		jsr	random
		and.w	#1,d0
		bne.s	.noreverse
		neg.w	d6
.noreverse:
		move.w	d6,iozrot(a0)
.nowrap:
		rts

dotunnelhazard:	tst.l	iocollcode(a0)		;blow up when hit
		beq.s	.nohit
		move.l	#dotunnelbang,ido(a0)
.nohit:
		move.l	iotarget(a0),a1
		move.w	iozspeed(a1),d0
		add.w	iozspeed(a0),d0
		ext.l	d0
		sub.l	d0,iszcoord(a0)
		bpl.s	.ok
		bsr	killobject
.ok:
		movem.w	ioxangle(a0),d0-d2
		add.w	ioxrot(a0),d0
		add.w	ioyrot(a0),d1
		add.w	iozrot(a0),d2
		and.w	#2047,d0
		and.w	#2047,d1
		and.w	#2047,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
		rts

dotunnelbonus:	tst.l	iocollcode(a0)
		bne.s	.killbonus

		move.l	iotarget(a0),a1
		move.w	iozspeed(a1),d0
		ext.l	d0
		sub.l	d0,iszcoord(a0)
		bmi.s	.killbonus

		movem.w	ioxrot(a0),d0-d2
		add.w	ioxangle(a0),d0
		add.w	ioyangle(a0),d1
		add.w	iozangle(a0),d2
		move.w	#2047,d3
		and.w	d3,d0
		and.w	d3,d1
		and.w	d3,d2
		movem.w	d0-d2,ioxangle(a0)
		lea	isxx(a0),a6
		bsr	anglematrix
		rts
.killbonus:
		bsr	killobject
		rts

dotunnelbarrier:
		move.l	iotarget(a0),a1
		move.w	iozspeed(a1),d0
		ext.l	d0
		sub.l	d0,iszcoord(a0)
		bpl.s	.ok
		bsr	killobject
.ok:
		subq.w	#1,iotimer(a0)
		bpl.s	.done
		tst.l	isanimbase(a0)
		beq.s	.on

		clr.l	isanimbase(a0)
		move.w	#5,iotimer(a0)
		bra.s	.done
.on:
		move.l	tunnelbarrieranim,isanimbase(a0)
		move.w	#5,iotimer(a0)
.done:
		rts

******************************** Camera Updates ******************************

******************************** Internal camera *****************************

dotunnelincam:	move.l	ictarget(a0),a1		;set up position
		movem.l	isxcoord(a1),d0-d2
		movem.l	d0-d2,icxcoord(a0)

		movem.w	isxx(a1),d0-d7/a2	;set up orientation
		movem.w	d0-d7/a2,icxx(a0)

		move.l	isanimbase(a1),-(sp)	;have to clear 'isanimbase'
		move.l	a1,-(sp)		;to prevent the target
		clr.l	isanimbase(a1)		;being drawn
		bsr	showview
		move.l	(sp)+,a1
		move.l	(sp)+,isanimbase(a1)

		bsr	tunnelchangecam
		jsr	tunnel_hud
		rts

******************************** External camera *****************************

dotunnelexcam:	move.l	ictarget(a0),a1		;point the camera at the target
		movem.l	icxcoord(a0),d0-d1
		movem.l	isxcoord(a1),d3-d4
		moveq.l	#0,d2
		moveq.l	#0,d5
		sub.l	d0,d3
		sub.l	d1,d4
		asr.l	#3,d3
		asr.l	#3,d4

		movem.l	icxcoord(a0),d0-d2
		bsr	moveintunnel
		movem.l	d0-d2,icxcoord(a0)

		move.l	ictarget(a0),a1
		movem.l	isxcoord(a1),d0-d2
		movem.l	icxcoord(a0),d3-d5
		lea	icxx(a0),a6
		bsr	pointmatrix

		bsr	showview		;display camera
		jsr	tunnel_hud
		bsr	tunnelchangecam
		rts

****************************** Tunnel Subroutines ****************************

tunnelchangecam:
		move.l	ictarget(a0),a1		;set external camera
		cmp.l	#doflyeraway,ido(a1)	;if flyer is zooming away
		beq.s	.external		;or exploding
		tst.w	ioenergy(a1)
		ble.s	.external

		move.l	iccontroller(a0),a1
		move.l	4(a1),d0
		btst	#OPTIONS,d0
		beq.s	.nochange

		cmp.l	#dotunnelincam,ido(a0)
		beq.s	.external
		cmp.l	#dotunnelexcam,ido(a0)
		beq.s	.internal
.nochange:
		rts
.internal:
		move.l	#dotunnelincam,ido(a0)	;set the internal camera
		movem.w	frontmat,d0-d7/a1
		movem.w	d0-d7/a1,icxx(a0)
		rts
.external:
		move.l	#dotunnelexcam,ido(a0)	;set the external camera
		clr.l	iczcoord(a0)
		rts

moveintunnel:	bsr	getbound	;get the bounding box we're already in
		move.l	a3,a4

		ext.l	d3		;add on the required movement
		ext.l	d4
		add.l	d3,d0
		add.l	d4,d1

		bsr	getbound	;check if we've moved into a box
		move.l	a3,d7
		bne.s	.ynotbig

		cmp.l	(a4),d0		;ok, clip to the box
		bge.s	.xnotsmall	;that we were in before
		move.l	(a4),d0	    	;and clear speeds
		moveq.l	#0,d3
.xnotsmall:
		cmp.l	4(a4),d1
		bge.s	.ynotsmall
		move.l	4(a4),d1
		moveq.l	#0,d4
.ynotsmall:
		cmp.l	8(a4),d0
		ble.s	.xnotbig
		move.l	8(a4),d0
		moveq.l	#0,d3
.xnotbig:
		cmp.l	12(a4),d1
		ble.s	.ynotbig
		move.l	12(a4),d1
		moveq.l	#0,d4
.ynotbig:
		rts

getbound:	move.l	tunnelbounds,a1
		move.w	(a1)+,d7		;that we're already in
		subq.w	#1,d7
		sub.l	a3,a3
.findbound:
		move.l	a1,a2
		cmp.l	(a2)+,d0
		blt.s	.outside
		cmp.l	(a2)+,d1
		blt.s	.outside
		cmp.l	(a2)+,d0
		bgt.s	.outside
		cmp.l	(a2)+,d1
		bgt.s	.outside
		move.l	a1,a3
.outside:
		lea	16(a1),a1
		dbf	d7,.findbound
		rts

gettunnelxy:	move.l	tunnelbounds,a6		;pick a bounding box
		jsr	random
		and.w	#16383,d0
		move.w	(a6)+,d1
		mulu	d1,d0
		add.l	d0,d0
		add.l	d0,d0
		swap	d0
		lsl.w	#4,d0
		add.w	d0,a6

		jsr	random			;get a position inside
		move.w	d0,d1			;that bounding box
		swap	d0
		and.w	#16383,d0
		and.w	#16383,d1
		movem.l	(a6),d2-d5
		sub.l	d2,d4
		sub.l	d3,d5
		mulu	d4,d0
		mulu	d5,d1
		add.l	d0,d0
		add.l	d0,d0
		add.l	d1,d1
		add.l	d1,d1
		swap	d0
		swap	d1
		ext.l	d0
		ext.l	d1
		add.l	d2,d0
		add.l	d3,d1
		rts

****************************** Creation Routines *****************************

makeautoflyer:	bsr	makeflyer
		move.l	#nocontroller,iocontroller(a1)

		moveq.l	#0,d0			;fake the player holding
		bset	#FIRE_A,d0		;the accelerate button
		move.l	d0,nocontroller
		rts

makeflyer:	bsr	getempty
		bsr	clearangles

		move.l	#0,isxcoord(a1)
		move.l	#0,isycoord(a1)
		move.l	#1500,iszcoord(a1)

		move.l	#doflyer,ido(a1)
		move.l	#flyeranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)
		move.l	#joycur1,iocontroller(a1)

		move.l	#playerCLASS,ioclass(a1)
		move.l	#flyerTYPE,iotype(a1)
		move.w	#flyerENERGY,ioenergy(a1)

		clr.w	ioxspeed(a1)
		clr.w	ioyspeed(a1)
		move.w	#40,iozspeed(a1)

		move.l	a1,flyerobject

		clr.w	isrezz(a1)
		rts

makesection:	move.l	d0,-(sp)

		bsr	getempty
		bsr	clearangles

		move.l	#dosection,ido(a1)
		move.l	tunnelanims,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#arenaCLASS,ioclass(a1)
		move.w	#roomTYPE,iotype(a1)

		move.l	#0,isxcoord(a1)
		move.l	#0,isycoord(a1)
		move.l	(sp)+,iszcoord(a1)

		move.l	flyerobject,iotarget(a1)
		rts

makecamera:	lea	tunnelcam,a0		;set up the camera
		move.l	#dotunnelexcam,ido(a0)
		move.l	#pad1,iccontroller(a0)

		bsr	gettunnelxy
		moveq.l	#0,d2
		movem.l	d0-d2,icxcoord(a0)

		movem.w	frontmat,d0-d7/a1
		movem.w	d0-d7/a1,icxx(a0)

		tst.b	PAL_TV
		beq.s	.ntsc
.pal:
		movem.l	palwindow,d0-d2
		bra.s	.setwindow
.ntsc:
		movem.l	ntscwindow,d0-d2
.setwindow:
		movem.l	d0-d2,icclx(a0)
		rts

createtunnelmine:
		tst.w	minedelaycounter
		bmi	.none

		subq.w	#1,minedelaycounter
		bpl	.none
		move.w	minedelay,minedelaycounter

		jsr	getempty
		beq	.none

		move.l	flyerobject,iotarget(a1)

		jsr	random
		move.w	d0,d1
		swap	d0
		and.w	#127,d0
		and.w	#127,d1
		sub.w	#64,d0
		sub.w	#64,d1
		ext.l	d0
		ext.l	d1
		move.l	iotarget(a1),a2
		add.l	isxcoord(a2),d0
		add.l	isycoord(a2),d1
		move.l	#16000,d2
		movem.l	d0-d2,isxcoord(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		jsr	anglematrix

		move.w	#500,iozspeed(a1)

		clr.w	ioxrot(a1)
		clr.w	ioyrot(a1)
		clr.w	iozrot(a1)

		move.l	#dotunnelhazard,ido(a1)
		move.l	#starmineanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#obstacleTYPE,iotype(a1)
.none:
		rts

createtunnelhazard:
		tst.w	hazarddelaycounter
		bmi	.none

		subq.w	#1,hazarddelaycounter
		bpl	.none
		move.w	hazarddelay,hazarddelaycounter

		jsr	getempty
		beq	.none

		move.l	flyerobject,iotarget(a1)

		jsr	random
		move.w	d0,d1
		swap	d0
		and.w	#127,d0
		and.w	#127,d1
		sub.w	#64,d0
		sub.w	#64,d1
		ext.l	d0
		ext.l	d1
		move.l	iotarget(a1),a2
		add.l	isxcoord(a2),d0
		add.l	isycoord(a2),d1
		move.l	#16000,d2
		movem.l	d0-d2,isxcoord(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		jsr	anglematrix

		move.w	#0,iozspeed(a1)

		clr.w	ioxrot(a1)
		clr.w	ioyrot(a1)
		jsr	random
		move.w	d0,d1
		jsr	random
		move.l	d0,d2
		swap	d2
		and.w	#31,d0
		and.w	#31,d1
		and.w	#31,d2
		add.w	#32,d0
		add.w	#32,d1
		add.w	#32,d2
		movem.w	d0-d2,ioxrot(a1)

		move.l	#dotunnelhazard,ido(a1)
		move.l	#hazardanim,isanimbase(a1)
		jsr	random
		and.l	#3,d0
		move.l	d0,isanimframe(a1)

		move.w	#enemyCLASS,ioclass(a1)
		move.w	#obstacleTYPE,iotype(a1)
.none:
		rts

createtunnelbonus:
		tst.b	createbonuses
		beq	.none

		subq.w	#1,bonusdelaycounter
		bpl	.none
		move.w	bonusdelay,bonusdelaycounter

		jsr	getempty
		beq	.none

		move.l	flyerobject,iotarget(a1)

		bsr	gettunnelxy
		move.l	#2500,d2
		add.l	iszcoord(a0),d2
		movem.l	d0-d2,isxcoord(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		jsr	anglematrix

		move.l	#dotunnelbonus,ido(a1)
		move.l	#bonusanim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#powerupCLASS,ioclass(a1)
		move.w	#bonusTYPE,iotype(a1)

		move.w	#30,ioxrot(a1)
		clr.w	ioyrot(a1)
		move.w	#100,iozrot(a1)

		addq.w	#1,podsgenerated
.none:
		rts

createtunnelbarrier:
		tst.w	barrierdelaycounter
		bmi	.none

		subq.w	#1,barrierdelaycounter
		bpl	.none
		move.w	barrierdelay,barrierdelaycounter

		jsr	random
		and.w	#127,d0
		cmp.w	#100,d0
		bge.s	.none

		jsr	getempty
		beq	.none

		move.l	flyerobject,iotarget(a1)

		movem.l	isxcoord(a0),d0-d2
		movem.l	d0-d2,isxcoord(a1)

		moveq.l	#0,d0
		moveq.l	#0,d1
		moveq.l	#0,d2
		movem.w	d0-d2,ioxangle(a1)
		lea	isxx(a1),a6
		jsr	anglematrix

		move.l	#dotunnelbarrier,ido(a1)
		move.l	tunnelbarrieranim,isanimbase(a1)
		move.l	#0,isanimframe(a1)

		move.w	#powerupCLASS,ioclass(a1)
		move.w	#bonusTYPE,iotype(a1)

		move.w	#20,iotimer(a1)
.none:
		rts

******************************** Data Section ********************************

		data

********************************** Variables *********************************

nocontroller:	dc.l	0			;blank controller values
		dc.l	0

palwindow:	dc.w	-160,-140
		dc.w	160,140
		dc.w	160,140

ntscwindow:	dc.w	-160,-120
		dc.w	160,120
		dc.w	160,120

podsgenerated:	dc.w	0
podscollected:	dc.w	0

notunnelhud:	dc.b	0

**************************** Tunnel Sequence Cameras *************************

		phrase
tunnelcameras:	dc.l	0			;parent
		dc.l	0,0			;previous,next
		dc.l	tunnelcam,tunnelcam	;first,last
		dc.l	dolist,donowt		;do,draw

		phrase
tunnelcam:	dc.l	tunnelcameras		;parent
		dc.l	0,0			;previous,next
		dc.l	0,0			;first,last
		dc.l	dotunnelexcam,donowt	;do,draw
		dc.l	0			;controller
		dc.l	0,0,0			;xcoord,ycoord,zcoord
		dc.w	$4000,0,0		;orientation matrix
		dc.w	0,$4000,0
		dc.w	0,0,$4000
flyerobject:	dc.l	0			;target
		dc.w	2048-20,0,0		;xangle,yangle,zangle
		dc.w	0,0,0			;xrot,yrot,zrot
		dc.w	1500,0			;distance,zoom
tunnelwindow:	dc.w	-160,-120		;clx,cly	botleft
		dc.w	160,120			;chx,chy	topright
		dc.w	160,120			;gox,goy	midpoint

********************************** Animations ********************************

		phrase
flyeranim:	dc.l	player1vdf	;use the tank instead of the flyer. Atari insisted.....
bonusanim:	dc.l	bonusvdf
starmineanim:	dc.l	starminevdf
hazardanim:	dc.l	hazard1vdf
		dc.l	hazard2vdf
		dc.l	hazard3vdf
		dc.l	hazard4vdf

******************************* Tunnel Type Table ****************************

tunneltable:	dc.l	type1
		dc.l	type2
		dc.l	type3
		dc.l	type4
		dc.l	type5
		dc.l	type6

		phrase
type1:		dc.l	type1vdf		;tunnel section graphic
		dc.l	bar1vdf			;tunnel barrier anim
		dc.w	1			;number of bounding boxes
		dc.l	-800,-800,800,800	;flyer bounding boxes

		phrase
type2:		dc.l	type2vdf
		dc.l	bar2vdf
		dc.w	2
		dc.l	-800,-200,800,200
		dc.l	-200,-800,200,800

		phrase
type3:		dc.l	type3vdf
		dc.l	bar3vdf
		dc.w	1
		dc.l	-800,-800,800,800

		phrase
type4:		dc.l	type4vdf
		dc.l	bar4vdf
		dc.w	1
		dc.l	-800,-800,800,800

		phrase
type5:		dc.l	type5vdf
		dc.l	bar5vdf
		dc.w	1
		dc.l	-800,-800,800,800

		phrase
type6:		dc.l	type6vdf
		dc.l	bar6vdf
		dc.w	1
		dc.l	-800,-800,800,800

********************************** VDF Files *********************************

;flyervdf:	incbin	"graphics\\shapes\\tunnel\\flyer.vdf"
bonusvdf:	incbin	"graphics\\shapes\\tunnel\\bonus.vdf"
starminevdf:	incbin	"graphics\\shapes\\tunnel\\mine.vdf"
hazard1vdf:	incbin	"graphics\\shapes\\tunnel\\hazard1.vdf"
hazard2vdf:	incbin	"graphics\\shapes\\tunnel\\hazard2.vdf"
hazard3vdf:	incbin	"graphics\\shapes\\tunnel\\hazard3.vdf"
hazard4vdf:	incbin	"graphics\\shapes\\tunnel\\hazard4.vdf"

type1vdf:	incbin	"graphics\\shapes\\tunnel\\type1a.vdf"
type2vdf:	incbin	"graphics\\shapes\\tunnel\\type2a.vdf"
type3vdf:	incbin	"graphics\\shapes\\tunnel\\type3a.vdf"
type4vdf:	incbin	"graphics\\shapes\\tunnel\\type4a.vdf"
type5vdf:	incbin	"graphics\\shapes\\tunnel\\type5a.vdf"
type6vdf:	incbin	"graphics\\shapes\\tunnel\\type6a.vdf"

bar1vdf:	incbin	"graphics\\shapes\\tunnel\\bar1a.vdf"
bar2vdf:	incbin	"graphics\\shapes\\tunnel\\bar2a.vdf"
bar3vdf:	incbin	"graphics\\shapes\\tunnel\\bar3a.vdf"
bar4vdf:	incbin	"graphics\\shapes\\tunnel\\bar4a.vdf"
bar5vdf:	incbin	"graphics\\shapes\\tunnel\\bar5a.vdf"
bar6vdf:	incbin	"graphics\\shapes\\tunnel\\bar6a.vdf"

********************************* BSS Section ********************************

		bss

********************************** Variables *********************************

tunnelbarrieranim:	ds.l	1
tunnelanim:		ds.l	1
tunnelbounds:		ds.l	1
sectionlength:		ds.l	1

minedelay:		ds.w	1
hazarddelay:		ds.w	1
barrierdelay:		ds.w	1
bonusdelay:		ds.w	1
minedelaycounter:  	ds.w	1
hazarddelaycounter:	ds.w	1
barrierdelaycounter:	ds.w	1
bonusdelaycounter:	ds.w	1

max_time_in_tunnel:	ds.w	1
tunnel_exit:		ds.b	1
in_tunnel:		ds.b	1
createbonuses:		ds.b	1

		even



