	
LEVEL2	equ	$100

	data	
	phrase
BLANK_PHRASE:	dcb.b	8,0
null_ol:	dc.l	0,4
sound_me:	dc.w	5
my_sr:	dc.w	0
my_sp:	dc.l	0
	text
	even

null_routine::
	rts	
waitvbls:
	bsr.s	wait_vbl
	dbf	d0,waitvbls
	rts

wait_vbl:
	move.l	d0,-(sp)
	move.l	clock,d0
.lp:	cmp.l	clock,d0
	beq.s	.lp
	move.l	(sp)+,d0
	rts


reset_vbl::
	move.l	d0,-(sp)
	move.l	#null_ol,d0
	swap	d0
	move.l	d0,OLP
	move.l	(sp)+,d0
	
	move.w	d0,-(sp)
	move.w	INT1,d0
	bra.s	quick_exit_vbl
	
hum_70_vbl::
	move.w	(sp),my_sr
	move.l	sp,my_sp
	move.w	d0,-(sp)
	move.w	INT1,d0
	
	
.no_sound:
	btst	#0,d0			; if vbl occur give it priority
	bne.s	the_vbl
	illegal
quick_exit_vbl:
	lsl.w	#8,d0
	move.b	#1,d0
	move.w	d0,INT1			; allow new interrupts
	move.w	d0,INT2
	move.w	(sp)+,d0		; restore stack
	rte


the_vbl:
	sf.b	switches		;clear raster switches
	movem.l	d0-a6,-(sp)		;save for later
	
	move.w	d0,-(sp)		;save the INT value
	
	jsr	MAKE_OL			; make the ol
	
	tst.b	NEW_PALETTE
	beq.s	.no_palette
	sf	NEW_PALETTE
	lea	CLUT,a0			; now set up the palette quickly
	lea	view_pal,a1
	movem.l	(a1)+,d0-d7/a2-a6
	movem.l	d0-d7/a2-a6,(a0)
acid	set	1
	rept	8
	movem.l	(a1)+,d0-d7/a2-a6
	movem.l	d0-d7/a2-a6,acid*4*13(a0)
acid	set	acid+1
	endr
	movem.l	(a1)+,d0-d7/a2-a4
	movem.l	d0-d7/a2-a4,acid*4*13(a0)
.no_palette:
	bsr.s	house_work		; check star hash and 0
	move.w	(sp)+,d0
	move.w	#$0101,d0
	move.w	d0,INT1
	move.w	d0,INT2			; allow other interrupts
	
	addq.l	#1,frames		; update the clock
	addq.l	#1,clock		; update the clock
exit_vbl:
	
	tst.b	mus
	beq.s	.no_sound1		; see if we have a sound interrupt
	
	tst.b	PAL_TV
	bne.s	.pal_music
	move.w	sound_me,d0
	dbf	d0,.ok1
	moveq	#5,d0
	bra.s	.no_sound
.pal_music:
.ok1:	jsr	MUS_VBL_PLAY.w		; oh yes we do
.no_sound:
	move.w	d0,sound_me
.no_sound1:
	movem.l	(sp)+,d0-a6		;restore registers
	move.w	(sp)+,d0		;restore stack and quit gracefully
	rte

house_work:
	jsr	do_mapper_palette
	bsr.s	star_hash
	bsr	sound_flip
	jsr	clock_update
	rts

a_vbl:	rts

star_hash:
	jsr	Hash_Asterisk_Pressed1	;check pad 1
	bne.s	.both_down
	jsr	Hash_Asterisk_Pressed2	;and pad 2
	beq.s	.no_way
.both_down:
	tst.b	disable_reset		;allowed to reset
	bne.s	.no_reset_avilable
.shit_he_is_serious:
.rejoin:
	jsr	MUS_KILL
	jsr	stop_gpu
	st	disable_reset		; no more resets just yet
	move.l	#reset_vbl,LEVEL2.w	; null OL
	moveq	#0,d0
	lea	pad1,a0
	rept	4
	move.l	d0,(a0)+
	endr
	move.w	#$0101,d0
	move.w	d0,INT1
	move.w	d0,INT2			; reset the proper interrupt vectors
	;;lea	8+4*16(sp),sp
	move.l	my_sp,sp
	move.l	#restart_program,2(sp)	; quit back to start
	rte
	
.no_reset_avilable:
	sf	write_eeprom_allowed
	jsr	options_pressed
	beq.s	.shit_he_is_serious
	st	write_eeprom_allowed
.no_way:
	rts


volume_table:
	dc.b	$00,$0f,$1f,$2f,$3f,$4f,$5f,$6f,$8f,$9f,$af,$bf,$cf,$df,$ef,$ff
MAX_SLIDER_VALUE	equ	*-volume_table-1
	even

sound_flip:
	move.l	joyedge1,d0		;see if 0 on pad 1 or pressed
	or.l	joyedge2,d0
	btst	#KEY_0,d0
	bne.s	.ok1
	rts
.ok1:	tst.b	musloaded		;have we loaded in the music yet
	bne.s	soundonoff
	rts
soundonoff:
	moveq	#0,d0
	move.b	save_mod_level,d0	;get the alternative music level
	move.b	vol_mod,save_mod_level
	move.b	d0,vol_mod		;swap the 2 values over
	eor.b	#1,mustype		;change the state of the music
	cmp.b	#-1,d0			;if mustype is == -1
	beq.s	.cont			;then stop the mod
	move.b	volume_table(pc,d0.w),d0;with this volume setting
	jsr	MUS_SET_VOLUME
	jsr	MUS_START_MOD
	bra.s	.exit
.cont:	jsr	MUS_STOP_MOD		;stop the mod dead in its track !!
.exit:	move.l	#~(1<<KEY_0),d0
	and.l	d0,joyedge1
	and.l	d0,joyedge2
	rts	

	bss
frames:			ds.l	1
lastframes:		ds.l	1
clock:			ds.l	1
disable_reset:		ds.b	1
NEW_PALETTE::		ds.b	1
paused_view:		ds.b	1
write_eeprom_allowed:	ds.b	1
save_mod_level:      	ds.b	1
mustype:		ds.b	1
vol_sfx:		ds.b	1
vol_mod:		ds.b	1
paused:			ds.b	1
		even
		text
