************************************************************************************************

	.text
print_a_sprite_normal::

**	d0=x
**	d1=y
**	d4=sprite_number
**	a0=sprite header address

**	also this routine is for non flipped-horizontal sprites
**	above registers are not preserved - all the rest are

**	Clipping is performed to reduce the size of the OL - releasing time for 680000
**	sprite header table must have been converted before running this routine

	cmp.w	screen_width,d0
	blt.s	.ok
	rts
.ok:	movem.l	d3-d7,-(sp)
	lsl.w	#5,d4				;index into table entry
	add.w	d4,a0				;now pointing to entry in table
	tst.w	d1
	bpl.s	.top_y_ok			;if at top then
	moveq	#0,d3
	move.w	20(a0),d3			;height
	add.w	d1,d3
	bmi.s	no_print1
	beq.s	no_print1
	movem.l	(a0)+,d4-d7
	muls	(a0),d1				;times by width per scan line
	sub.l	d1,d4
	moveq	#0,d1				;top of the screen
	ror.l	#2,d3
	swap	d3
	and.l	#%11111111000000000011111111111111,d5
	or.l	d3,d5
	bra.s	.cont_me
.top_y_ok:
	cmp.w	screen_height,d1
	bge.s	no_print1
	movem.l	(a0),d4-d7
.cont_me:

	lsl.l	#8,d4

	add.w	d1,d1				;convert the scanline to jaguar y
	add.w	my_vdb,d1
	lsl.w	#3,d1
	add.w	d1,d5				;and the y position
	
	and.w	#$fff,d0			;mask the sprite
	or.w	d0,d7
	
	jsr	ADD_OL				;a0 returns with address to make an object at
	movem.l	d4/d5/d6/d7,(a0)
	move.b	#Q_BMO,O_TYPE(a0)		;indicate type of object
	
no_print1:
	movem.l	(sp)+,d3-d7
	rts


print_a_sprite_flipped::
	tst.w	d0
	bpl.s	.ok
	rts
.ok:	movem.l	d3-d7,-(sp)
	lsl.w	#5,d4				;index into table entry
	add.w	d4,a0				;now pointing to entry in table
	tst.w	d1
	bpl.s	.top_y_ok			;if at top then
	moveq	#0,d3
	move.w	20(a0),d3			;height
	add.w	d1,d3
	bmi.s	no_print2
	beq.s	no_print2
	movem.l	(a0)+,d4-d7
	muls	(a0)+,d1				;times by width per scan line
	add.w	(a0)+,d0			;width in pixels
	sub.l	d1,d4
	moveq	#0,d1				;top of the screen
	ror.l	#2,d3
	swap	d3
	and.l	#%11111111000000000011111111111111,d5
	or.l	d3,d5
	bra.s	.cont_me
.top_y_ok:
	cmp.w	screen_height,d1
	bge.s	no_print2
	add.w	18(a0),d0			;width in pixels
	movem.l	(a0),d4-d7
.cont_me:
	or.w	#$2000,d6
	lsl.l	#8,d4

	add.w	d1,d1				;convert the scanline to jaguar y
	add.w	my_vdb,d1
	lsl.w	#3,d1
	add.w	d1,d5				;and the y position
	
	and.w	#$fff,d0			;mask the sprite
	or.w	d0,d7
	
	jsr	ADD_OL				;a0 returns with address to make an object at
	movem.l	d4/d5/d6/d7,(a0)
	move.b	#Q_BMO,O_TYPE(a0)		;indicate type of object
	
no_print2::
	movem.l	(sp)+,d3-d7
	rts

print_a_sprite_flipped_minus::
	tst.w	d0
	bpl.s	.ok
	rts
.ok:	movem.l	d3-d7,-(sp)
	lsl.w	#5,d4				;index into table entry
	add.w	d4,a0				;now pointing to entry in table
	tst.w	d1
	bpl.s	.top_y_ok			;if at top then
	moveq	#0,d3
	move.w	20(a0),d3			;height
	add.w	d1,d3
	bmi.s	no_print3
	beq.s	no_print3
	movem.l	(a0)+,d4-d7
	muls	(a0)+,d1			;times by width per scan line
	sub.l	d1,d4
	moveq	#0,d1				;top of the screen
	ror.l	#2,d3
	swap	d3
	and.l	#%11111111000000000011111111111111,d5
	or.l	d3,d5
	bra.s	.cont_me
.top_y_ok:
	cmp.w	screen_height,d1
	bge.s	no_print3
	movem.l	(a0),d4-d7
.cont_me:
	or.w	#$2000,d6
	lsl.l	#8,d4

	add.w	d1,d1				;convert the scanline to jaguar y
	add.w	my_vdb,d1
	lsl.w	#3,d1
	add.w	d1,d5				;and the y position
	
	and.w	#$fff,d0			;mask the sprite
	or.w	d0,d7
	
	jsr	ADD_OL				;a0 returns with address to make an object at
	movem.l	d4/d5/d6/d7,(a0)
	move.b	#Q_BMO,O_TYPE(a0)		;indicate type of object
	
no_print3:
	movem.l	(sp)+,d3-d7
	rts


;converts the sprite header so that the relative address in the header is now absolute
;a1 point to the data
relocate_sprites:
	move.l	d0,-(sp)
	move.l	d1,-(sp)
	move.l	a1,d0
	move.l	(a1),d1
	lsr.l	#5,d1
	subq.w	#1,d1
.loop:	add.l	d0,(a1)
	lea	32(a1),a1
	dbf	d1,.loop
	move.l	(sp)+,d1
	move.l	(sp)+,d0
	rts
	

print_a_sprite_normal_no_clip:
	lsl.w	#5,d4				;index into table entry
	movem.l	(a0,d4.w),d4-d7
	lsl.l	#8,d4
	add.w	d1,d1
	add.w	my_vdb,d1
	lsl.w	#3,d1
	or.w	d1,d5				;and the y position
	or.w	d0,d7
	jsr	ADD_OL				;a0 returns with address to make an object at
	movem.l	d4/d5/d6/d7,(a0)
	move.b	#Q_BMO,O_TYPE(a0)		;indicate type of object
	rts

;*************************************************************************

ADD_VIEWSCREEN:
	pea	(a0)
	bsr	ADD_OL
	moveq	#%00000000000000000000000000000101,d2
	move.l	#%00000101000000100100000000000000,d3

	tst.b	IN_GAME
	bne.s	.in_game
	or.l	#%00000000000000001000000000000000,d2
.in_game:
	
	moveq	#14,d0
	moveq	#0,d1
	move.w	screen_height,d1
	lsl.l	d0,d1
	move.w	my_vdb,d0
	lsl.w	#3,d0
	or.w	d0,d1
	move.l	rasterb,d0
	lsl.l	#8,d0
	movem.l	d0-d3,(a0)
	move.b	#Q_BMO,O_TYPE(A0)
	tst.b	IN_GAME
	bne.s	.in_game1
	move.b	zoom_size,d7
	cmp.b	#32,d7
	beq.s	.in_game1
	move.w	#320,d0
	bsr	scale_x_sprite
	move.b	zoom_size,d7
	bsr	scale_y_sprite
.in_game1:
	move.l	(sp)+,a0
	rts



;*************************************************************************


ADD_STRIP:
	movem.l	d0-d3/a0,-(sp)
	bsr	ADD_OL
	move.l	#2<<14,d1		;sprite height of 2 pixels
	moveq	#2,d2
	move.l	#%10000000000000000011000000000000,d3
	moveq	#-2,d0			;y pos of 1/2 screen - 1
	add.w	screen_height,d0
	and.w	#~1,d0
	add.w	my_vdb,d0
	lsl.w	#3,d0
	or.w	d0,d1
	move.l	#BLANK_PHRASE,d0	; null image
	lsl.l	#8,d0
	movem.l	d0-d3,(a0)
	move.b	#Q_BMO,O_TYPE(A0)
	movem.l	(sp)+,d0-d3/a0
	rts

;*************************************************************************

ADD_TITLE_SCREEN:
	bsr	ADD_OL
	moveq	#%1010,d2
	move.l	#%0000010100000001100000000000000,d3
	move.l	#((280-1)<<14)|1,d1
	move.w	my_vdb,d0
	lsl.w	#3,d0
	or.w	d0,d1
	move.l	#rasteradata,d0
	tst.b	PAL_TV
	bne.s	.pal
	add.l	#40*320,d0
.pal:	
	lsl.l	#8,d0
	movem.l	d0-d3,(a0)
	
	move.w	title_scale,d0
	move.b	d0,23(a0)
	move.b	#32,22(a0)
	move.b	#32,21(a0)
	
	move.b	#Q_SBMO,O_TYPE(A0)
	
	rts


;*************************************************************************

add_choose_backdrop:
	bsr	ADD_OL
	moveq	#14,d0
	moveq	#0,d1

	moveq	#%101,d2
	move.l	#%00000101000000001100000000000000+((%11)<<15),d3

	move.w	#280,d1
	lsl.l	d0,d1
	move.w	my_vdb,d0
	lsl.w	#3,d0
	or.w	d0,d1
	move.l	rasterc,d0
	lsl.l	#8,d0
	movem.l	d0-d3,(a0)
	rts


;*************************************************************************

display_cockpit:
		rts
		movem.l	d0-a6,-(sp)
		moveq	#12,d0
		moveq	#-96,d1
		add.w	screen_height,d1
		move.w	#252,d4
		lea	level_sprites,a0
		bsr	print_a_sprite_normal_no_clip
		movem.l	(sp)+,d0-a6
		rts


;*************************************************************************

RADAR_RANGE_1	equ	180*2
RADAR_RANGE_2	equ	180*3
RADAR_1_COLOUR	equ	$7fff


displayradar:	
		movem.l	d0-a6,-(sp)
		move.l	ictarget(a0),a6
		move.l	ioweapons(a6),a6
		tst.b	WEAPON_RADAR(a6)
		beq.s	.no_radar
		move.w	#RADAR_RANGE_1,d0
		cmp.b	#1,WEAPON_RADAR(a6)
		beq.s	.range_1
		move.w	#RADAR_RANGE_2,d0
.range_1:	move.w	d0,RADAR_SCALER
		
		move.l	ictarget(a0),a4			;get pointer of target
		
		tst.b	radar_rmw_show
		beq.s	.no_show
		bsr.s	display_radar_rmw
.no_show:	bsr	draw_radar
		bsr.s	display_radar_overlay
.no_radar:	movem.l	(sp)+,d0-a6
		rts

display_radar_rmw:
		movem.l	gox,d0-d1
		sub.w	#(48/2),d0
		add.w	#50+Y_BOT,d1
		neg.w	d1
		add.w	screen_height,d1	
		sub.l	cly,d1
		tst.b	cockpit_visible
		beq.s	.no
		subq	#5,d1
.no:		lea	level_sprites,a0
		move.w	#RADAR_RMW_SPRITE,d4
		bsr	print_a_sprite_normal_no_clip
		or.b	#%01000000,10(a0)
		rts

		
display_radar_overlay:

		moveq	#24,d0
		movem.l	gox,d0-d1
		sub.w	#(48/2),d0
		add.w	#50+Y_BOT,d1
		neg.w	d1
		add.w	screen_height,d1
		sub.l	cly,d1
	
    		tst.b	cockpit_visible
		beq.s	.no
		subq	#5,d1
.no:		lea	level_sprites,a0
		move.w	#RADAR_NORM_SPRITE,d4
		bsr	print_a_sprite_normal_no_clip
		rts


;a0=camera addr
;a4=target addr
;a6=playfield

draw_radar:
		lea	HUD_POINTERS,a6
		cmp.w	#playerCLASS,ioclass(a4)
		beq.s	.its_only_player_1
		addq	#4,a6
.its_only_player_1:
		move.l	(a6),a6			;a6 points to the image

		move.l	a6,A1_BASE
		move.l	#PIXEL16|PITCH1|WID48|XADDPHR,d0
		move.l	d0,A1_FLAGS
		moveq	#0,d0
		move.l	d0,A1_PIXEL
		move.l	d0,B_PATD
		move.l	d0,B_PATD+4

		move.l	#$10000+((-RADAR_WIDTH)&$ffff),d0
		move.l	d0,A1_STEP
		move.l	#RADAR_HEIGHT*$10000+RADAR_WIDTH,B_COUNT

		move.l	#PATDSEL|UPDA1,B_CMD
		bsr	waitblitter


		bsr	PLOT_RADAR		
		
		move.l	a6,A1_BASE
		move.l	#radar_mask,A2_BASE
		move.l	#PIXEL16|PITCH1|WID48|XADDPHR,d0
		move.l	d0,A1_FLAGS
		move.l	d0,A2_FLAGS
		moveq	#0,d0
		move.l	d0,A1_PIXEL
		move.l	d0,A2_PIXEL
		move.l	#$10000+((-RADAR_WIDTH)&$ffff),d0
		move.l	d0,A1_STEP
		move.l	d0,A2_STEP
		move.l	#RADAR_HEIGHT*$10000+RADAR_WIDTH,B_COUNT

		move.l	#SRCEN|DSTEN|UPDA1|UPDA2|LFU_SAD,B_CMD
		bsr	waitblitter

		moveq	#24,d0
		movem.l	gox,d6-d7
		sub.w	#(48/2),d6
		add.w	#50+Y_BOT,d7
		neg.w	d7
		add.w	screen_height,d7	
		sub.l	cly,d7
    		tst.b	cockpit_visible
		beq.s	.no
		subq	#5,d7
.no:
		add.w	d7,d7
		add.w	my_vdb,d7
		lsl.w	#3,d7

		move.l	#RADAR_HEIGHT<<14,d1
		or.w	d7,d1
		move.l	a6,d0
		lsl.l	#8,d0
;			#%fedcba9876543210fedcba9876543210
		move.l	#%00000000000000001001111111000000,d2
		move.l	#%11000000001100001100000000000000,d3
		or.w	d6,d3

		jsr	ADD_OL
		movem.l	d0-d3,(a0)
		move.b	#Q_BMO,O_TYPE(A0)
	
		rts


PLOT_RADAR:	lea	PLOT_POSITION2(pc),a5
		cmp.w	#RADAR_RANGE_2,RADAR_SCALER
		beq.s	.rad_2
		lea	PLOT_POSITION1(pc),a5
.rad_2:	move.l	#$7fffffff,d3

		lea	world,a0
		move.l	ifirst(a0),d0
		beq.s	.empty
.doitems:	
		move.l	d0,a0
		move.l	inext(a0),-(sp)
		cmp.l	a0,a4
		beq.s	.me
		jsr	(a5)
.me:		move.l	(sp)+,d0
		bne.s	.doitems
.empty:	rts



PLOT_POSITION2:
		movem.l	isxrotated(a0),d0/d1/d2
		cmp.l	d3,d0
		beq.s	.no_show

		move.w	RADAR_SCALER,d1
		divs	d1,d0
		divs	d1,d2


		add.w	#RADAR_WIDTH/2,d0
		bmi.s	.no_show
		cmp.w	#RADAR_WIDTH,d0
		bgt.s	.no_show

		add.w	#RADAR_HEIGHT/2,d2
		bmi.s	.no_show
		cmp.w	#RADAR_HEIGHT,d2
		blt.s	.show
.no_show:	rts
.show:		neg.w	d2
		add.w	#RADAR_HEIGHT,d2

		move.w	iotype(a0),d1		;get object type
		bmi.s	.no_show_col


;d0=x
;d1=object type
;d2=z
;a6=object

		mulu	#RADAR_WIDTH,d2		;y offset
		add.w	d0,d2			;y+x
		add.w	d2,d2			;*2 = words 16 bits
		add.w	d1,d1
		move.w	2+.colourtable(pc,d1.w),(a6,d2.w)
.no_show_col:	rts
.colourtable:	incbin	"graphics\\bitmaps\\radcols.cpl"

PLOT_POSITION1:
		movem.l	isxrotated(a0),d0/d1/d2
		cmp.l	d3,d0
		beq.s	.no_show

		move.w	RADAR_SCALER,d1
		divs	d1,d0
		divs	d1,d2


		add.w	#RADAR_WIDTH/2,d0
		bmi.s	.no_show
		cmp.w	#RADAR_WIDTH,d0
		bgt.s	.no_show

		add.w	#RADAR_HEIGHT/2,d2
		bmi.s	.no_show
		cmp.w	#RADAR_HEIGHT,d2
		blt.s	.show
.no_show:	rts
.show:		neg.w	d2
		add.w	#RADAR_HEIGHT,d2

		move.w	iotype(a0),d1		;get object type
		bmi.s	.no_show_col


;d0=x
;d1=object type
;d2=z
;a6=object

		mulu	#RADAR_WIDTH,d2		;y offset
		add.w	d0,d2			;y+x
		add.w	d2,d2			;*2 = words 16 bits
		add.w	d1,d1
		move.w	#RADAR_1_COLOUR,(a6,d2.w)
.no_show_col:	rts



;*************************************************************************

;d0/d1 = x,y
;d3 = power if -ive then 0
;d4 = max power

display_power:
		tst.w	invincible
		bne.s	.super
		tst.w	d3
		bpl.s	.ok
		moveq	#0,d3
.ok:		mulu	#15,d3
		divu	d4,d3
		move.w	#POWER_BAR_SPRITE,d4
		add.w	d3,d4
.cont:		lea	level_sprites,a0
		bsr	print_a_sprite_normal_no_clip
		rts
.super:		move.w	#POWER_BAR_SPRITE,d4
		moveq	#%1100,d3
		and.l	clock,d3
		beq.s	.cont
		add.w	#15,d4
		bra.s	.cont



display_power_digits:
		tst.w	d3
		bpl.s	.ok
		moveq	#0,d3
.ok:		ext.l	d3
		divu	#100,d3
		
		movem.l	d0/d1/d3,-(sp)
		move.w	#149+100,d4
		add.w	d3,d4
		lea	level_sprites,a0
		bsr	print_a_sprite_normal_no_clip
		movem.l	(sp)+,d0/d1/d3
		swap	d3
		move	#149,d4
		add.w	d3,d4
		add.w	#10/2,d0
		lea	level_sprites,a0
		bsr	print_a_sprite_normal_no_clip
		rts

display_pod_digits:
		movem.l	d0-a6,-(Sp)
		ext.l	d3
		divu	#1000,d3
		lea	eight_bytes,a4
		move.b	d3,(a4)+
		clr.w	d3
		swap	d3
		divu	#100,d3
		move.b	d3,(a4)+
		clr.w	d3
		swap	d3
		divu	#10,d3
		move.b	d3,(a4)+
		clr.w	d3
		swap	d3
		move.b	d3,(a4)+

		lea	eight_bytes,a4
		tst.b	(a4)
		bne.s	.exit
		moveq	#3-1,d6
.lpa:		move.b	#" ",(a4)+
		tst.b	(a4)
		bne.s	.exit
		dbf	d6,.lpa
.exit:

		lea	eight_bytes,a6
		move.w	#4,-(sp)
.loop:		moveq	#0,d4
		move.b	(a6)+,d4
		cmp.b	#" ",d4
		beq.s	.skip_space
		add.w	#SCORE_DIGIT_SPRITES1,d4
		
		move.w	d0,-(sp)
		move.w	d1,-(sp)

		lea	level_sprites,a0
		jsr	print_a_sprite_normal_no_clip	;print the number

		move.w	(sp)+,d1
		move.w	(sp)+,d0
.skip_space:	addq	#8,d0
		subq.w	#1,(sp)
		bne.s	.loop
		addq.w	#2,sp

		movem.l	(Sp)+,d0-a6

		rts








display_power_vert:
		tst.w	d3
		bpl.s	.ok
		moveq	#0,d3
.ok:		mulu	#15,d3
		divu	d4,d3

		move.w	#254,d4
		add.w	d3,d4

		lea	level_sprites,a0
		bsr	print_a_sprite_normal_no_clip
		
		rts




draw_line_scaled:
		rts


colouranim:	move.l	(a0)+,d0		;updates a table
		beq.s	.doneanim		;of animated colours
		move.l	d0,a1

		move.l	(a1),a2
		move.l	4(a1),a3

		move.w	(a2)+,d0
		bpl.s	.ok
		lea	8(a1),a2
		move.w	(a2)+,d0
.ok:
		move.b	d0,(a3)
		move.l	a2,(a1)

		bra.s	colouranim
.doneanim:
		rts

		
clearraster:	bsr	waitgpu			;clear raster a0
		bsr	waitblitter

		move.l	a0,A1_BASE
		move.l	#0,A1_PIXEL
		move.l	#$00010000|(-320&$ffff),A1_STEP
		move.w	screen_height,d0
		swap	d0
		move.w	#320,d0
		move.l	d0,B_COUNT
		move.l	d7,B_PATD
		move.l	d7,B_PATD+4
		move.l	#PIXEL16|PITCH4|WID320|XADDPHR,A1_FLAGS
		move.l	#UPDA1|PATDSEL,B_CMD
		rts

		
clearraster_spread:
		bsr	waitgpu			;clear raster a0
		bsr	waitblitter

		if	0

		move.l	#PITCH4|PIXEL16|WID320|XADDPHR,A1_FLAGS
		move.l	rastera,A1_BASE
		move.l	#PIXEL16|PITCH4|WID320|XADDPHR,A2_FLAGS
		move.l	a0,A2_BASE
		move.l	#$00010000+(-320&$ffff),d0
		move.l	d0,A1_STEP
		move.l	d0,A2_STEP
		move.w	screen_height,d0
		swap	d0
		move.w	#320,d0
		move.l	d0,B_COUNT
		moveq	#0,d0
		move.l	d0,A1_PIXEL
		move.l	d0,A2_PIXEL

		move.l	#SRCEN|DSTEN|DSTA2|LFU_S|UPDA1|UPDA2,B_CMD
		rts

		else






		move.l	a0,A1_BASE
		moveq	#0,d1
		move.l	#$00010000,d2
		move.l	#$10000|320,d3
		move.l	#PATDSEL,d4
		move.l	#$00010001,d5
		lea	A1_BASE,a0
		move.l	#PIXEL16|PITCH4|WID320|XADDPHR,A1_FLAGS-A1_BASE(a0)

		move.w	screen_height,d6
		subq	#1,d6
		
.loop:		move.l	d1,A1_PIXEL-A1_BASE(a0)
		move.l	d3,B_COUNT-A1_BASE(a0)
		move.l	d7,B_PATD-A1_BASE(a0)
		move.l	d7,B_PATD+4-A1_BASE(a0)
		move.l	d4,B_CMD-A1_BASE(a0)
		add.l	d2,d1
		cmp.b	#$ff,d7
		beq.s	.intense
		add.l	d5,d7
.intense:	dbf	d6,.loop
		

		rts
		endif



***************************************************************************
;enter with d0 = height / width of the sprite
;           a0 = addr of the sprite
;will scale the dimension and centre the sprite



scale_x_sprite:
		move.w	14(a0),d1
		and.w	#$07ff,d1
		btst	#11,d1
		beq.s	.not_neg
		or.w	#$f800,d1		;sign extend x position
.not_neg:	moveq	#0,d2
		move.b	d7,d2
		tst.w	d2
		bne.s	.not_zero
		moveq	#1,d2			;not div by 0
.not_zero:	move.b	d2,21(a0)
		asr.w	#1,d0			;half length
		move.w	d0,d3
		mulu	d2,d0
		divu	#32,d0			;times 32 == 1:1
		neg	d0
		add.w	d3,d0
		add.w	d0,d1
		and.w	#$7ff,d1
		move.w	14(a0),d0
		and.w	#$f800,d0
		or.w	d0,d1
		move.w	d1,14(a0)
		rts		

scale_y_sprite:	
		move.w	6(a0),d0		;y_pos
		lsr.w	#3,d0
		and.w	#%111111111111,d0	; the ypos 2* y+ my_vdb

		move.l	4(a0),d1
		rol.l	#2,d1
		swap	d1			;the height of the sprite
		and.w	#%1111111111,d1
		asr.w	#1,d1
		move.w	d1,d3			;save height

		moveq	#0,d2
		move.b	d7,d2
		tst.w	d2
		bne.s	.not_zero
		moveq	#1,d2			;not div by 0
.not_zero:	or.b	#1,7(a0)		;tell its a SBMO
		move.b	d2,22(a0)
		move.b	d2,23(a0)
		move.b	#Q_SBMO,O_TYPE(a0)
		mulu	d2,d1
		divu	#32,d1
		neg.w	d1
		add.w	d3,d1			; offset to sprite

		add.w	d1,d1			; 2*y
		add.w	d1,d0			;add to original number
		lsl.w	#3,d0

		move.w	6(a0),d1		;update the y position
		and.w	#%1100000000000111,d1
		or.w	d1,d0
		move.w	d0,6(a0)


		move.l	4(a0),d1
		rol.l	#2,d1
		swap	d1			;the height of the sprite
		subq.w	#1,d1
		swap	d1
		ror.l	#2,d1
		move.l	d1,4(a0)		;decrease by 1 for scaled stuff


		rts

add_colour_to_sprite:
;enter with a0 pointing to the object..
;and d0.w = colour index

	
		lsl.w	#6,d0
		or.w	d0,10(a0)
		rts



get_sprite_data:
		lsl.w	#5,d0
		movem.l	(a0,d0.w),d4-d7
		rts

get_sprite_data_pause:
		lsl.w	#5,d4
		movem.l	(a0,d4.w),d4-d7
		lsl.l	#8,d4
		add.w	d1,d1
		add.w	my_vdb,d1
		lsl.w	#3,d1
		or.w	d1,d5
		or.w	d0,d7
		rts


get_addr_sprite:
		lsl.w	#5,d0
		move.l	(a0,d0.w),d0
		rts

		
change_height_of_sprite:
		lsl.w	#5,d0
		lea	(a0,d0.w),a0	;addr of the sprite
		addq	#4,a0
			;-1098765432109876543210876543210
		and.l	#%1111111100000000001111111111111,(a0)	;clear the height
		ror.l	#2,d1
		swap	d1
		or.l	d1,(a0)					;set new height
		rts


		
***************************** Crosshair Graphic ***************************
		.data
		.phrase
radar_mask:	incbin	"graphics\\bitmaps\\radamask.jsp"
		.text

		.bss
RADAR_SCALER:		ds.w	1
cockpit_visible:	ds.b	1
		even

