e_sig	equ	$cde9

	.text
restore_eeprom_buffer:
	movem.l	d0-a6,-(sp)
	
	lea	eeprom_buffer,a6		;point to buffer

	bsr	read_eeprom


	bsr	get_eeprom_check_sum

	cmp.w	(a6)+,d0
	bne.s	.not_valid_eeprom

	cmp.w	#e_sig,(a6)+			;restore the version number
	bne.s	.not_valid_eeprom

	move.b	(a6)+,vol_mod			;restore atari standard stuff
	move.b	(a6)+,vol_sfx
	move.b	(a6)+,d0
	ext.w	d0
	move.w	d0,JOYPAD_CONFIG		;default config


	moveq	#0,d1				;start bit

	moveq	#1,d7
	bsr	read_stuff
	move.w	d6,TEXTURES_ON

	moveq	#2,d7
	bsr	read_stuff
	move.w	d6,HOW_HARD


	lea	highscore_table,a0		;save the high score table
	moveq	#(9*4)-1,d0
.lp2:	moveq	#8,d7
	bsr	read_stuff
	move.b	d6,(a0)+
	dbf	d0,.lp2


	moveq	#(9*9)-1,d0
.lp3:	moveq	#5,d7
	bsr	read_stuff
	move.b	d6,(a0)+			;write it out
	dbf	d0,.lp3				;and do all the name
	
	lea	player1weapons,a5		;read in player 1 stuff
	bsr	read_player_stats

	if 0
	lea	player2weapons,a5		;read in player 2 stuff
	bsr	read_player_stats
	endif
	
	moveq	#5,d7
	bsr	read_stuff
	move.w	d6,restore_level			;last level saved

	bsr	point_to_end_of_this_junk
	
	bsr	eeprom_sound_setup
	movem.l	(sp)+,d0-a6
	rts
.not_valid_eeprom:
	move.b	#$c,vol_mod			;set up defaults
	move.b	#$c,vol_sfx
	clr.w	level
	clr.w	restore_level
	clr.w	last_level
	clr.w	JOYPAD_CONFIG
	clr.w	HOW_HARD
	jsr	convert_highscores
	bsr	eeprom_sound_setup
	lea	player1weapons,a6	;if new game the reset the scores
	lea	player2weapons,a5
	moveq	#WEAPON_SIZE-1,d0
.loop:	sf	(a6,d0.w)
	sf	(a5,d0.w)
	dbf	d0,.loop
	move.w	#NUMBER_OF_LIVES,PLAYER_LIVES(a6)
	move.w	#NUMBER_OF_LIVES,PLAYER_LIVES(a5)
	move.b	#1,WEAPON_LASER_L(a6)
	move.b	#1,WEAPON_LASER_L(a6)
	move.l	#player1weapons,which_players_weapons
	movem.l	(sp)+,d0-a6
	rts
reset_eeprom:
	movem.l	d0-a6,-(sp)
	move.b	#$c,vol_mod			;set up defaults
	move.b	#$c,vol_sfx
	clr.w	level
	clr.w	restore_level
	clr.w	last_level
	clr.w	JOYPAD_CONFIG
	clr.w	HOW_HARD
	jsr	convert_highscores
	bsr	eeprom_sound_setup
	lea	player1weapons,a6	;if new game the reset the scores
	lea	player2weapons,a5
	moveq	#WEAPON_SIZE-1,d0
.loop:	sf	(a6,d0.w)
	sf	(a5,d0.w)
	dbf	d0,.loop
	move.w	#NUMBER_OF_LIVES,PLAYER_LIVES(a6)
	move.w	#NUMBER_OF_LIVES,PLAYER_LIVES(a5)
	move.b	#1,WEAPON_LASER_L(a6)
	move.b	#1,WEAPON_LASER_L(a6)
	move.l	#player1weapons,which_players_weapons
	bsr	create_eeprom_buffer
	movem.l	(sp)+,d0-a6
	rts




create_eeprom_buffer:
	movem.l	d0-a6,-(sp)
	
	lea	eeprom_buffer,a6		;point to buffer

	bsr	read_eeprom

	addq	#2,a6				;handle checksum later

	move.w	#e_sig,(a6)+			;write the version number

	move.b	vol_mod,(a6)+			;restore atari standard stuff
	move.b	vol_sfx,(a6)+
	move.b	JOYPAD_CONFIG+1,(a6)+		;default config

	moveq	#0,d1				;start bit

	moveq	#1,d7
	move.w	TEXTURES_ON,d6
	bsr	write_stuff

	moveq	#2,d7
	move.w	HOW_HARD,d6
	bsr	write_stuff
	
	lea	highscore_table,a0		;save the high score table
	moveq	#(9*4)-1,d0
.lp2:	moveq	#8,d7
	move.b	(a0)+,d6
	bsr	write_stuff
	dbf	d0,.lp2
	moveq	#(9*9)-1,d0
.lp3:	moveq	#5,d7
.lp4:	move.b	(a0)+,d6
	bsr	write_stuff
	dbf	d0,.lp3				;and do all the name
	
	tst.b	save_game
	beq.s	.keep_the_same
	lea	player1weapons,a5		;read in player 1 stuff
	bsr	write_player_stats

	if 0
	lea	player2weapons,a5		;read in player 2 stuff
	bsr	write_player_stats
	endif
	
	moveq	#5,d7
	move.w	level,d6			;last level saved
	bsr	write_stuff
.keep_the_same:
	bsr	point_to_end_of_this_junk

	lea	eeprom_buffer,a6		;point to buffer
	bsr.s	get_eeprom_check_sum
	move.w	d0,(a6)
	
	bsr	write_eeprom
	movem.l	(sp)+,d0-a6
	rts



create_eeprom_buffer_pause:
	movem.l	d0-a6,-(sp)
	lea	eeprom_buffer,a6

	bsr	read_eeprom

	move.w	#e_sig,2(a6)			;write the version number

	move.b	vol_mod,4(a6)			;restore atari standard stuff
	move.b	vol_sfx,5(a6)

	bsr.s	get_eeprom_check_sum
	move.w	d0,(a6)
	bsr	write_eeprom_pause
	movem.l	(sp)+,d0-a6
	rts






;a6 points to the eeprom
get_eeprom_check_sum:
	moveq	#0,d0
	lea	128(a6),a5
	moveq	#63-1,d7
.lp:	ror.w	#3,d0
	add.w	-(a5),d0
	dbf	d7,.lp
	rts


eeprom_sound_setup:
	moveq	#0,d1
	moveq	#0,d0				;get the volume for that specific value

	move.b	#0,mustype

	tst.b	vol_mod
	spl	save_mod_level
	bmi.s	.quiet

	move.b	#1,mustype
	move.b	vol_mod,d0
.quiet:		
	lea	volume_table,a4
	move.b	(a4,d0.w),d0
	
	jsr	MUS_SET_VOLUME

 	moveq	#1,d1
 
 	moveq	#0,d0				;get the volume for that specific value
 	move.b	vol_sfx,d0
 
 	lea	volume_table,a4
 	move.b	(a4,d0.w),d0
 
 	jsr	MUS_SET_VOLUME

 	rts



point_to_end_of_this_junk:
	add.w	d3,a6
	tst.b	d2
	beq.s	.no_overflow
	addq	#1,a6
.no_overflow:
	rts



read_player_stats:
	lea	player_eeprom_data,a4

	move.w	(a4)+,-(sp)
.lp_b:	move.w	(a4)+,d7
	bsr	read_stuff
	move.w	(a4)+,d7
	move.b	d6,(a5,d7.w)
	subq.w	#1,(sp)
	bne.s	.lp_b
	addq	#2,sp

	move.w	(a4)+,-(sp)
.lp_w:	move.w	(a4)+,d7
	bsr	read_stuff
	move.w	(a4)+,d7
	move.w	d6,(a5,d7.w)
	subq.w	#1,(sp)
	bne.s	.lp_w
	addq	#2,sp

	move.w	(a4)+,-(sp)
.lp_l:	move.w	(a4)+,d7
	bsr.s	read_stuff
	move.w	(a4)+,d7
	move.l	d6,(a5,d7.w)
	subq.w	#1,(sp)
	bne.s	.lp_l
	addq	#2,sp

	sf	WEAPON_PLASMA_POWER(a5)
	rts


write_player_stats:
	lea	player_eeprom_data,a4

	move.w	(a4)+,-(sp)
.lp_b:	move.w	(a4)+,d7
	move.w	(a4)+,d6
	move.b	(a5,d6.w),d6
	bsr.s	write_stuff
	subq.w	#1,(sp)
	bne.s	.lp_b
	addq	#2,sp

	move.w	(a4)+,-(sp)
.lp_w:	move.w	(a4)+,d7
	move.w	(a4)+,d6
	move.w	(a5,d6.w),d6
	bsr.s	write_stuff
	subq.w	#1,(sp)
	bne.s	.lp_w
	addq	#2,sp

	move.w	(a4)+,-(sp)
.lp_l:	move.w	(a4)+,d7
	move.w	(a4)+,d6
	move.l	(a5,d6.w),d6
	bsr.s	write_stuff
	subq.w	#1,(sp)
	bne.s	.lp_l
	addq	#2,sp

	rts





write_stuff:
	bra.s	.start
.loop:	move.w	d1,d3
	moveq	#7,d2
	and.w	d3,d2
	addq	#1,d1
	lsr.w	#3,d3
	eor.b	#7,d2
	btst	d7,d6
	beq.s	.clear_bit
	bset	d2,0(a6,d3.w)
	bra.s	.cont
.clear_bit:
	bclr	d2,0(a6,d3.w)
.cont:	
.start:
	dbf	d7,.loop
	rts



read_stuff:
	moveq	#0,d6
	bra.s	.start
.loop:	moveq	#$7,d2
	and.w	d1,d2
	move.w	d1,d3
	addq	#1,d1
	lsr.w	#3,d3				;into bytes
	eor.b	#7,d2				;invert for bit test
	add.l	d6,d6
	btst	d2,0(a6,d3.w)
	beq.s	.no_set
	bset	#0,d6
.no_set:
.start:
	dbf	d7,.loop
	rts


;;;;;
;	a0 points to the area in memory where the eeprom is to be read/written
;	d0/d1 get corrupted
;	in write	d4 gets corrupted

read_eeprom:
	lea	128(a6),a6			;point to end of eeprom
	moveq	#128/2-1,d1
.lp:	bsr.s	eeread
	move.w	d0,-(a6)
	dbf	d1,.lp
	rts

write_eeprom_pause:
	lea	3*2(a6),a6			;point to end of eeprom
	moveq	#3-1,d1
.lp:	move.w	-(a6),d0
	bsr.s	eewrite
	dbf	d1,.lp
	rts
	

write_eeprom:
	lea	128(a6),a6			;point to end of eeprom
	moveq	#128/2-1,d1
.lp:	move.w	-(a6),d0
	bsr.s	eewrite
	dbf	d1,.lp
	rts
	
GPIO_0		.equ	$f14800		;General purpose I/O #0
GPIO_1		.equ	$f15000		;General purpose I/O #1

;   Equates derived from the above
;   to allow indirect with 16-bit displacement addressing

GPIO_0of	.equ	GPIO_0-JOYSTICK	;offset to GPIO_0 (when addr reg Ax -> JOY1) 
GPIO_1of	.equ	GPIO_1-JOYSTICK	;offset to GPIO_1 (when addr reg Ax -> JOY1) 

;   Commands tested on:
;	National Semiconductor NM93C14
;       Excel (equiv)
;	Atmel (equiv)
;	ISSI (equiv)
;
;  9-bit commands..
;		 876543210

eREAD		.equ	%110000000		;read from EEPROM
eEWEN		.equ	%100110000		;Erase/write Enable
eWRITE		.equ	%101000000		;Write selected register
eEWDS		.equ	%100000000		;Erase/Write disable (default)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; LOW-LEVEL PRIMITIVE (DO NOT CALL DIRECTLY...OR MODIFY FOR THAT MATTER)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Procedure: eewrite
;;;            Write a word to EEPROM
;;;
;;;  Inputs: d0.w = data to be written
;;;	     d1.w = least signifigant 6 bits specify write address (0-63)  
;;;

eewrite:
		movem.l	a0/d0-d3,-(sp)
		lea	JOYSTICK,a0  	;set ptr to EEPROM i/o addresses

		tst.w	GPIO_1of(a0)	;strobe ChipSelect

		move.w	#eEWEN,d2	;erase/write enable command
		bsr	out9bits	;send it to EEPROM

		tst.w	GPIO_1of(a0)	;strobe ChipSelect

		andi.w	#$3f,d1		;force write addr to be legit (0-63)
		ori.w	#eWRITE,d1	;form WRITE command
		move.w	d1,d2
		bsr.s	out9bits	;send it to EEPROM

		move.w	d0,d2		;get 16-bit data word to send
		bsr.s	out16bit	;  & send it

		tst.w	GPIO_1of(a0)	;strobe ChipSelect

;;; Chip specs say to wait 1 msec for status valid...we wait an additional
;;; 10 to ensure write has completed because the chip status report can't
;;; be relied upon in our case.

		move.w	#5267,d0    	; Wait 11 msecs
wrwait:
		nop			
		nop
		nop
		nop
		nop
		nop
		dbra	d0,wrwait

		move.w	#eEWDS,d2	;get erase/write disable command
		bsr.s	out9bits	;send it

		tst.w	GPIO_1of(a0)	;strobe ChipSelect

		movem.l	(sp)+,a0/d0-d3
		rts			;we're done

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; LOW-LEVEL PRIMITIVE (DO NOT CALL DIRECTLY...OR MODIFY FOR THAT MATTER)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Procedure: eeread
;;;            Read a word from EEPROM
;;;
;;;  Inputs: d1.w = least signifigant 6 bits specify read address (0-63)  
;;;
;;; Returns: d0.w = data as read from EEPROM
;;;

eeread:
		movem.l	a0/d1-d3,-(sp)
		lea	JOYSTICK,a0 	;set ptr to EEPROM i/o address

		tst.w	GPIO_1of(a0)	;strobe ChipSelect

		andi.w	#$3f,d1		;force legit read addr
		ori.w	#eREAD,d1
		move.w	d1,d2
		bsr.s	out9bits

		moveq	#0,d0
		moveq	#15,d2		;pick up 17 bits (1st is dummy)
inlp:	
		tst.w	GPIO_0of(a0)
		nop
		move.w	(a0),d1
		lsr.w	#1,d1
		addx.w	d0,d0
		nop
		nop
		nop
		nop
		nop
		nop
		dbra	d2,inlp

		movem.l	(sp)+,a0/d1-d3
		rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Procedures: out16bit/out9bits
;;;             Output 'x' bits to the eeprom.
;;;	      Serial data sent to device is written to DI, bit0 of GPIO_0
;;;
;;; Inputs: a0.l = JOYSTICK
;;;  	    d2.w = 9/16-bit data word to write
;;;
;;; Register Usage: d2.w, d3.l are destroyed
;;;			     

out16bit:
		rol.w	#1,d2		;align 1st serial data bit (bit15) to bit0
		moveq	#15,d3		;send 16 bits
		bra.s	out9lp
out9bits:
		rol.w	#8,d2		;align 1st serial data bit (bit8) to bit0
		moveq	#8,d3		;send 9
out9lp:
		move.w	d2,GPIO_0of(a0)	;write next bit
		nop
		nop
		nop			;delay next write
		nop
		nop
		nop
		rol.w	#1,d2		;adjust bit0 for next datum
		dbra	d3,out9lp	;go for all 9 or all 16
		rts

	
	.data

player_eeprom_data:
	
	dc.w	16
	dc.w	2,WEAPON_LASER_L
	dc.w	2,WEAPON_LASER_R
	dc.w	2,WEAPON_PLASMA
	dc.w	2,WEAPON_LAUNCHER_L
	dc.w	2,WEAPON_LAUNCHER_R
	dc.w	2,WEAPON_MISSILE_L_TYPE
	dc.w	7,WEAPON_MISSILE_L_NUMBER
	dc.w	2,WEAPON_MISSILE_R_TYPE
	dc.w	7,WEAPON_MISSILE_R_NUMBER
	dc.w	7,WEAPON_MINE
	dc.w	3,WEAPON_BACK
	dc.w	2,WEAPON_SHIELD
	dc.w	2,WEAPON_DRONE
	dc.w	2,WEAPON_RADAR
	dc.w	2,PLAYER_SHIP
	dc.w	1,WEAPON_AUTO	

	dc.w	1
	dc.w	4,PLAYER_LIVES

	dc.w	1
	dc.w	32,PLAYER_SCORE
;	dc.w	32,PLAYER_ENERGY




	.bss
	even
save_game:		ds.b	1
	even
restore_level:		ds.w	1
eeprom_buffer:		
	ds.b	128
