rom_file_table	equ	$802a00


; entry	.l == on the stack is a pointer to the filename
; returns	.l == addr of the end of the file loaded

	.text

macro	set_load_addr address
	move.l	/address,load_here_pointer
endm

;************************************************************

load_file:
	
	movem.l	d0-a6,-(sp)
	jsr	locate_file
	GET_FILE_OFFSET
	moveq	#0,d0
	jsr	DECOMPRESSGPUPP
	jsr	waitgpu
	movem.l	(sp)+,d0-a6
	rts

;************************************************************

	if 0

align_addr:
	subq	#1,d0
	move.l	(a0),d1
	add.l	d0,d1
	not.l	d0
	and.l	d0,d1
	move.l	d1,(a0)
	rts

;************************************************************

load_and_allocate_sprites:
	movem.l	d0-a6,-(sp)

	pea	(a2)
	lea	load_here_pointer,a0	;align data to phrase boundaries
	moveq	#8,d0
	bsr.s	align_addr

	bsr	locate_file		;get file info
	GET_FILE_LENGTH

	add.l	d0,d0	   		;load data in way past end of info
	move.l	d0,-(sp)
	move.l	load_here_pointer,a1
	add.l	d0,a1
	GET_FILE_OFFSET
	bsr	unpack_file
	move.l	load_here_pointer,a0	;convert data to object headers
	bsr	convert_JHD
	move.l	(sp)+,d0
	add.l	d0,load_here_pointer

	move.l	(sp)+,a0	
	bsr	locate_file		;get file data
	move.l	load_here_pointer,a1
	GET_FILE_OFFSET
	bsr	unpack_file		;load in the data
	GET_FILE_LENGTH
	add.l	d0,load_here_pointer	;update pointers

	movem.l	(sp)+,d0-a6
	rts

	endif

;************************************************************


;enter with a0 pointing to filename

;returns with a6 pointing to the header


locate_file:
	lea	rom_file_table,a2
	move.w	(a2)+,d0
	subq.w	#1,d0
.loop:	move.l	a2,a3
	move.l	a0,-(sp)
	bsr.s	.compare_string
	movem.l	(sp)+,a0
	bne.s	.dec
	move.l	a2,a6
	rts
.dec:	lea	22(a2),a2
	dbra	d0,.loop

	lea	filename_error_name,a3
.lp:	move.b	(a0)+,(a3)+
	bne.s	.lp
	pea	filename_error
	move.w	#$f000,-(sp)
	move.w	#5,-(sp)
	move.w	#$b,-(sp)
	trap	#14
	illegal
.exit:	rts

.compare_string:
	tst.b	(a0)
	beq.s	.done
	cmp.b	(a0)+,(a3)+
	beq.s	.compare_string
	rts
.done:	tst.b	(a3)
	rts




;************************************************************


;enter with a1 pointing to JHD data
;and a0 points to an area where to make sprite in jaguar format
;d0=filelength

convert_JHD:
	movem.l	d0-a6,-(sp)
	
	
convert_image:
	move.l	image_length1,d1
	move.l	start_of_image_1,a0
	lea	0(a0,d1.l),a1
	lsr.l	#4,d1
.loop:	cmp.l	a0,a1
	beq.s	.exit
.ok:	
	move.b	9(a0),d2
	and.b	#2,d2
	lsr.b	#1,d2
	move.b	d2,9(a0)
	addq	#4,a0
	moveq	#0,d2
	move.w	(a0)+,d2			;d0 is the width in pixels
	moveq	#6,d1
	sub.b	2(a0),d1
	lsr.w	d1,d2
	addq.l	#6,a0
	move.w	d2,d1
	move.w	d2,2(a0)			; save byte
	lsl.w	#3,d2
	move.w	d2,(a0)				; save phrases   
	addq.l	#4,a0
	bra.s	.loop

.exit:	move.l	start_of_image_1,a0
	move.l	new_header,a1
	move.l	image_length1,d0
	add.l	d0,d0
	lea	0(a1,d0.l),a2
	add.l	a1,d0
.loop1:
	
	move.l	(a0),a6				;now pointing to the image
	add.l	d0,a6
	move.w	4(a0),d2			;width in pixels
	move.w	d2,18(a1)
	move.w	6(a0),d3			;height
	move.w	d3,20(a1)
	moveq	#0,d4
	move.b	8(a0),d4			;graphic planes 0 -> 4   
	move.w	10(a0),d1			;add y offset to y !! logical
	move.w	12(a0),d7			;width of the sprite in bytes
	move.w	d7,16(a1)


	moveq	#0,d6
	move.w	14(a0),d6			;read the phrase width of the sprite
	move.w	d6,d2
	ror.l	#4,d6
	bset	#15,d6				;set transparency
	swap	d6
	lsl.w	#2,d2				;correct Dwidth
	or.w	d2,d6				;mask to Iwidth
	ext.l	d3
	ror.l	#2,d3				;shift height into place
	swap	d3				;equivalent to rol.l #14,d3
	bset	#3,d4				;enable pitch of 1
	ror.w	#4,d4				;shift pitch into place
	move.l	a6,(A1)+
	move.l	d3,(a1)+			;first two words done
	clr.w	(a1)+				;no first pixel and no release of the bus
	move.l	d6,(a1)+
	move.w	d4,(a1)+			;rest of it has been done
	lea	16(a0),a0
	lea	16(a1),a1
	cmp.l	a1,a2
	bne	.loop1
	movem.l	(sp)+,d0-a6
	rts
	
	
;************************************************************

unpack_file:
	movem.l	a0/a1/a6,-(sp)
	;lea	TREV_GPU,a0
	;jsr	SET_UP_GPU
	movem.l	(sp)+,a0/a1/a6

	moveq	#0,d0
	;jsr	DECOMPRESSGPU
	rts

;************************************************************


	data
filename_error:
		dc.b	"The following file is missing form the ROM image ::::::::: "
filename_error_name:
		dc.b	"0123456789ABCDEF",0
		even	
	.bss
load_here_pointer:	ds.l	1
image_length1:		ds.l	1
start_of_image_1:	ds.l	1
new_header:		ds.l	1
