.if wantdebug
.macro debug
	G_JSR debugsub
.endm
.endif

.if wantbreak
.macro break
here\~:
	jr	here\~
	nop
.endm
.endif


.macro G_JSR where
;jump to subroutine at label/address
;not reentrant code
;no effect on flags

	movei	#.here\~,JSRtemp	;get return address
	subqt	#4,G_SP		;predecrement
	store	JSRtemp,(G_SP)	;push return
	movei	#\where,JSRtemp	;get target address
	jump	t,(JSRtemp)	;and jump to it
	nop			;always executed
.here\~:
.endm


.macro G_RTS
;return from subroutine
;not reentrant code

	load	(G_SP),JSRtemp	;pop return address
	jump	t,(JSRtemp)	;jump to return
	addqt	#4,G_SP		;postincrement

.endm


.macro G_BRA
;unconditional jump if carry set

	movei	#\1,jumptemp
	jump	(jumptemp)
	nop
.endm

.macro G_BCC
;conditional jump if carry clear

	movei	#\1,jumptemp
	jump	CC,(jumptemp)
	nop
.endm

.macro G_BCS
;conditional jump if carry set

	movei	#\1,jumptemp
	jump	CS,(jumptemp)
	nop
.endm

.macro G_BMI
;conditional jump if minus

	movei	#\1,jumptemp
	jump	MI,(jumptemp)
	nop
.endm

.macro G_BPL
;conditional jump if plus

	movei	#\1,jumptemp
	jump	PL,(jumptemp)
	nop
.endm

.macro G_BEQ
;conditional jump if zero

	movei	#\1,jumptemp
	jump	EQ,(jumptemp)
	nop
.endm

.macro G_BNE
;conditional jump if not zero

	movei	#\1,jumptemp
	jump	NE,(jumptemp)
	nop
.endm


.macro BRAS
;unconditional relative jump if carry set

	jr	\1
	nop
.endm

.macro BCCS
;conditional jump if carry clear

	jr	CC,\1
	nop
.endm

.macro BCSS
;conditional jump if carry set

	jr	CS,\1
	nop
.endm

.macro BMIS
;conditional jump if minus

	jr	MI,\1
	nop
.endm

.macro BPLS
;conditional jump if plus

	jr	PL,\1
	nop
.endm

.macro BEQS
;conditional jump if zero

	jr	EQ,\1
	nop
.endm

.macro BNES
;conditional jump if not zero

	jr	NE,\1
	nop
.endm


