
	.text

FIRE_A		equ	29
PAUSE		equ	28
FIRE_B		equ	25
RIGHT_B	equ	23
LEFT_B		equ	22
DOWN_B		equ	21
UP_B		equ	20
KEY_1		equ	19
KEY_4		equ	18
KEY_7		equ	17
STAR		equ	16
FIRE_C		equ	13
OPTIONS	equ	09
KEY_2		equ	07
KEY_5		equ	06
KEY_8		equ	05
KEY_0		equ	04
KEY_3		equ	03
KEY_6		equ	02
KEY_9		equ	01
HASH		equ	00

fire_a_pressed:
	Move.l	joycur1,d0
	not.l	d0
	Btst	#FIRE_A,d0
	Rts
fire_b_pressed:
	Move.l	joycur1,d0
	not.l	d0
	Btst	#FIRE_B,d0
	Rts
fire_c_pressed:
	Move.l	joycur1,d0
	not.l	d0
	Btst	#FIRE_C,d0
	Rts
options_pressed:
	Move.l	joycur1,d0
	Btst	#OPTIONS,d0
	Rts

check_1_and_3:
	Move.l	joycur1,d0
	Btst	#KEY_1,d0
	Beq.s	.Not_Pressed
	Btst	#KEY_3,d0
	Beq.s	.Not_Pressed
	sf	paused_view
.Not_Pressed:	
	Rts

	
	
read_joypad:
	movem.l	d0-a6,-(sp)
	lea	scan_joypad,a0
	cmp.b	#DEMO_OFF,demo_mode
	beq.s	.normal
	lea	joypad_record,a0
	cmp.b	#DEMO_RECORD,demo_mode
	beq.s	.rec
	lea	joypad_playback,a0
.rec:	
.normal:
	jsr	(a0)
	movem.l	(sp)+,d0-a6
	rts
	
scan_joypad:

;scan for player 1
	move.l	#$f0fffffc,d1		; d1 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading

	move.w	#$81fe,JOYOUT
	move.l	JOYIN,d0		; Read joypad, pause button, A button
	or.l	d1,d0			; Mask off unused bits
	ror.l	#4,d0
	and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	move.w	#$81fd,JOYOUT
	move.l	JOYIN,d0		; Read *741 keys, B button
	or.l	d1,d0			; Mask off unused bits
	ror.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
	move.w	#$81fb,JOYOUT
	move.l	JOYIN,d0		; Read 2580 keys, C button
	or.l	d1,d0			; Mask off unused bits
	rol.l	#6,d0
	rol.l	#6,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
	move.w	#$81f7,JOYOUT
	move.l	JOYIN,d0		; Read 369# keys, Option button
	or.l	d1,d0			; Mask off unused bits
	rol.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

	moveq.l	#-1,d1
	eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

;scan for player 2
	move.l	#$0ffffff3,d3		; d3 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading

	move.w	#$817f,JOYOUT
	move.l	JOYIN,d4		; Read joypad, pause button, A button
	or.l	d3,d4			; Mask off unused bits
	rol.b	#2,d4			; note the size of rol
	ror.l	#8,d4
	and.l	d4,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	move.w	#$81bf,JOYOUT
	move.l	JOYIN,d4		; Read *741 keys, B button
	or.l	d3,d4			; Mask off unused bits
	rol.b	#2,d4			; note the size of rol
	ror.l	#8,d4
	ror.l	#4,d4
	and.l	d4,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
	move.w	#$81df,JOYOUT
	move.l	JOYIN,d4		; Read 2580 keys, C button
	or.l	d3,d4			; Mask off unused bits
	rol.b	#2,d4			; note the size of rol
	rol.l	#8,d4
	and.l	d4,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
	move.w	#$81ef,JOYOUT
	move.l	JOYIN,d4		; Read 369# keys, Option button
	or.l	d3,d4			; Mask off unused bits
	rol.b	#2,d4			; note the size of rol
	rol.l	#4,d4
	and.l	d4,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

	moveq.l	#-1,d3
	eor.l	d2,d3			; d3 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

	move.l	joycur1,d0		; old joycur needed for determining the new joyedge
	
	bsr.s	convert_buttons
	move.l	d1,joycur1		; Current joypad reading stored into joycur
.not:	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge1		;joypad, buttons, keys that were just pressed






	move.l	joycur2,d0		; old joycur needed for determining the new joyedge
	
	move.l	d3,d1
	bsr.s	convert_buttons
	move.l	d1,joycur2		; Current joypad reading stored into joycur
	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge2		;joypad, buttons, keys that were just pressed
	rts


convert_buttons:
	move.w	d7,-(sp)
	move.l	d1,d2					; copy status
	and.l	#(1<<FIRE_A)+(1<<FIRE_B)+(1<<FIRE_C),d2	; fire
	eor.l	d2,d1					;d1 = joy pad - no fire
	move.w	JOYPAD_CONFIG,d7
	mulu	#6,d7
	tst.b	paused
	bne.s	.in_pause
	cmp.b	#DEMO_REPLAY,demo_mode
	bne.s	.no_demo_playback
.in_pause:
	moveq	#0,d7					;if in demoplayback then buttons are configured already	
.no_demo_playback:
	lea	.pad_buttons(pc,d7.w),a0
	move.w	(a0)+,d7
	btst	#FIRE_A,d2
	beq.s	.no_a
	bset	d7,d1
.no_a:	move.w	(a0)+,d7
	btst	#FIRE_B,d2
	beq.s	.no_b
	bset	d7,d1
.no_b: move.w	(a0)+,d7
	btst	#FIRE_C,d2
	beq.s	.no_c
	bset	d7,d1
.no_c:	move.w	(sp)+,d7
	rts


.pad_buttons:
	dc.w	FIRE_A,FIRE_B,FIRE_C
	dc.w	FIRE_A,FIRE_C,FIRE_B
	dc.w	FIRE_B,FIRE_A,FIRE_C
	dc.w	FIRE_B,FIRE_C,FIRE_A
	dc.w	FIRE_C,FIRE_A,FIRE_B
	dc.w	FIRE_C,FIRE_B,FIRE_A


pad_buttons_table:
		dc.w	SPA,SPB,SPC
		dc.w	SPA,SPC,SPB
		
		dc.w	SPB,SPA,SPC
		dc.w	SPB,SPC,SPA
		
		dc.w	SPC,SPA,SPB
		dc.w	SPC,SPB,SPA


pause_buttons_table:
		dc.w	PSPA,PSPB,PSPC
		dc.w	PSPA,PSPC,PSPB
		
		dc.w	PSPB,PSPA,PSPC
		dc.w	PSPB,PSPC,PSPA
		
		dc.w	PSPC,PSPA,PSPB
		dc.w	PSPC,PSPB,PSPA



	

Hash_Asterisk_Pressed1:
	Move.l	joycur1,d0
	Btst	#STAR,d0
	Beq.s	.Not_Pressed
	Btst	#HASH,d0
.Not_Pressed:	
	Rts

Hash_Asterisk_Pressed2:
	Move.l	joycur2,d0
	Btst	#STAR,d0
	Beq.s	.Not_Pressed
	Btst	#HASH,d0
.Not_Pressed:	
	Rts

keys_1_2_3_down:
	Move.l	joycur1,d0
	Btst	#KEY_1,d0
	Beq.s	.Not_Pressed
	Btst	#KEY_2,d0
	Beq.s	.Not_Pressed
	Btst	#KEY_3,d0
.Not_Pressed:	
	Rts

direction_pressed:
	move.l	d1,-(sp)
	Move.l	joycur1,d0
	Moveq	#20,d1
	Lsr.l	d1,d0
	And.w	#$f,d0
	move.l	(sp)+,d1
	Rts

JOYPAD_CONFIG:		dc.w	0

	bss	
pad1:
joycur1:   	ds.l	1
joyedge1:	ds.l	1
pad2:
joycur2:   	ds.l	1
joyedge2:	ds.l	1
	text

