;	include 'c:\\jaguar\\bin\\jaguar.inc'
;	include	"..\\game\\core\\code\\gpu_equ.s"


	.text
;a1 is the source addr
;a1 is the destination data
DECOMPRESSGPUPP:
	movem.l	d1-a6,-(sp)
	lea	INBUF,a6		;GPU parameter base
	move.l	a0,(a6)+		;input address
	move.l	a1,(a6)+		;output address
	moveq	#0,d0
	move.l	d0,(a6)+		;clear status flag
	move.l	d0,(a6)+		;set CRC flags
	lea	gpupp,a6		;rungpu sets semaphore
	
	jsr	rungpu
	
	movem.l	(sp)+,d1-a6
	move.b	4(a0),d0
	lsl.l	#8,d0
	move.b	5(a0),d0
	lsl.l	#8,d0
	move.b	6(a0),d0
	lsl.l	#8,d0
	move.b	7(a0),d0
	rts


	.data
gpupp:
	dc.l	pp_start,gpuprog,pp_end-pp_start

	.phrase
pp_start:
	.gpu
	
	.org	gpuprog

wantdebug 	equ	0
wantbreak	equ	0

include "jag\\seedy\\gpumacro.inc"

;------------------------------------------------------------------------------
; PRO-PACK Unpack Source Code - Jaguar GPU, Method 1
;
; Copyright (c) 1993 Imagitec Design Inc, U.K. All Rights Reserved.
;
; File: PP_1.GAS
;
; Date: 19-Jul-93
;------------------------------------------------------------------------------
;
;----------------
; File Includes
;----------------



DEBUGBASE	equ $30000
DEBUGCOUNT	equ $2000

;IFNE	macros
;	IF	\1<>0

;IFEQ	macros
;	IF	\1<>0

;----------------------------------------------------------------------------
; Conditional Assembly Flags
;------------------------------------------------------------------------------

checksums	equ	1		; set this flag to 1 if you require
					; the data to be validated

protected	equ	0		; set this flag to 1 if you are unpacking
					; a file packed with option "-K"

;------------------------------------------------------------------------------
; Return Codes
;------------------------------------------------------------------------------

NOT_PACKED	equ	0
PACKED_CRC	equ	-1
UNPACKED_CRC	equ	-2

;------------------------------------------------------------------------------
; Other Equates
;------------------------------------------------------------------------------

PACK_TYPE	equ	1
PACK_ID		equ	$524e4301	;"R"<<24+"N"<<16+"C"<<8+PACK_TYPE
HEADER_LEN	equ	18
CRC_POLY	equ	$A001


;equates for crcflags
CRC_CHECK_IN	equ	0		;bits of control flags
CRC_CHECK_OUT	equ	1


;Primary register defines
;r0 and r3 also used during initialisation

debugdata	regequ	r13	;debug

keepbotbyte	regequ	r1
status		regequ	r2

seventeen	regequ	r3

counts		regequ	r4	;d4
bitbuf		regequ	r6	;d6
bitcount	regequ	r7	;d7

G_d4		regequ	r4
G_d5		regequ	r5
G_d6		regequ	r6
G_d7		regequ	r7

input		regequ	r8	;a3
output		regequ	r9	;a5
output_hi	regequ	r10	;a6

ptr		regequ	r11

dtemp1		regequ	r12	;debug
ivtemp1		regequ	r0
ivtemp2		regequ	r12
dtemp2		regequ	r13	;debug

table		regequ	r14
table1		regequ	r15

flagsptr	regequ	r16	;debug

G_d0		regequ	r17
G_d1		regequ	r18
G_d2		regequ	r19
G_d3		regequ	r20


bytes		regequ	r21
temp1		regequ	r22
temp2		regequ	r23

keepbotword	regequ	r24

debugtemp	regequ	r25	;debug

inbuf		regequ	r26	;only used at entry and exit
d0w		regequ	r26	;used in body

jumptemp	regequ	r27
JSRtemp	regequ	r28
G_SP		regequ	r29

;Secondary registers

savecrc		regequ	r0
okstatus	regequ	r1
saveoutput	regequ	r2
crcflags	regequ	r3

;r4	saves	G_d4
;r5	saves	G_d5
;r6	saves	G_d6


;*------------------------------------------------------------------------------
;* Macros
;*------------------------------------------------------------------------------

macro getrawREP

.getrawREP2\~:
	loadb	(input),temp1
	subq	#1,d0w
	addqt	#1,input
	storeb	temp1,(output)

	jr	PL,.getrawREP2\~
	addqt	#1,output
endm


macro JSRinputvalue
	movei	#here\~,flagsptr
	jump	(G_d5)
	nop
here\~:
endm

macro JSRinputbits3
	movei	#here\~,debugtemp
	jump	(debugdata)
	nop
here\~:
endm


;------------------------------------------------------------------------------
; PRO-PACK Unpack Routine - Jaguar GPU, Method 1
;
; on entry,
;	
;	INBUF+ 0 = start address of packed file
;	INBUF+ 4 = start address to write unpacked file
; on exit,
;	INBUF+ 8 = length of unpacked file in bytes OR error code
;		   0 = not a packed file
;		  -1 = packed data CRC error
;		  -2 = unpacked data CRC error
;
;	INBUF+12 = crcflags
;	INBUF+16 = GPU completion semaphore
;		    0 = running
;		  <>0 = finished
;------------------------------------------------------------------------------


;initialise variables and registers
	movei	#G_ENDRAM,G_SP		;init stack pointer
	nop

if checksums
	G_JSR	make_crc_table
endif

start:
	movei	#pp_semaphore,inbuf	;parameter area
	nop
	movei	#$0000ffff,keepbotword
	nop
	movei	#$000000ff,keepbotbyte
	nop
if wantdebug
	movei	DEBUGBASE,debugdata
	nop
	movei	DEBUGCOUNT,debugtemp
	nop
	movei	#G_FLAGS,flagsptr
	nop
endif

;waitforgo:
;	load	(inbuf),r0
;	cmpq	#0,r0
;	BEQS	waitforgo

	movei	#INBUF,inbuf
	nop
	load	(inbuf),input
	addqt	#4,inbuf
	load	(inbuf),output
	addqt	#8,inbuf		;skip exit status
	load	(inbuf),r0
	moveta	r0,crcflags

;check packing type
	move	input,r3
	addqt	#HEADER_LEN,input	;skip over header for start

	G_JSR	read_long		;returns result in r0
	movei	#PACK_ID,temp1
	moveq	#NOT_PACKED,status	;set possible error status return
	cmp	temp1,r0
	G_BNE	unpack17
	
;get no of bytes to output
	G_JSR	read_long		;r3 still valid
	moveta	r0,okstatus		;save, for ok status return

;find end address of output
	move	output,output_hi
	add	r0,output_hi


	if checksums
	moveta	output,saveoutput	;for later unpacked CRC

	movefa	crcflags,r0
	btst	#CRC_CHECK_IN,r0
	G_BEQ	noincrc
	
	G_JSR	read_long		;gets input size into r0
	move	input,ptr
	G_JSR	check_crc		;returns G_d2
;get CRC words
	G_JSR	read_long
	moveta	r0,savecrc
	and	keepbotword,r0
	cmp	G_d2,r0
	movei	#PACKED_CRC,status
	G_BNE	unpack17
noincrc:
	endif


	movei	#17,seventeen
	nop
	movei	#inputvalue,G_d5
	nop
	movei	#inputbits3,debugdata
	nop
unpack7:
	moveq	#0,bitcount
	loadb	(input),temp1
	addqt	#1,input
	loadb	(input),bitbuf
	subqt	#1,input
	shlq	#8,bitbuf
	or	temp1,bitbuf

	moveq	#2,G_d0
	moveq	#2,G_d1
	G_JSR	inputbits

unpack8:

	movei	#rawtable,table
	G_JSR	makehuftable

	movei	#postable,table
	G_JSR	makehuftable

	movei	#lentable,table
	G_JSR	makehuftable

unpack9:
	moveq	#0,G_d0
	moveq	#16,G_d1
	not	G_d0
	and	keepbotword,G_d0
	G_JSR	inputbits

;must fixup G_d0 top word

	moveq	#0,temp1	;fixup
	move	G_d0,counts
	not	temp1		;fixup
	move	G_d0,d0w
	shlq	#16,temp1	;fixup
	subq	#1,counts
	or	temp1,G_d0	;fixed up

	G_BRA	unpack12
unpack10:
	movei	#postable,table

	moveq	#0,G_d0
	moveq	#0,d0w
	JSRinputvalue
	move	output,ptr
	neg	G_d0
	subq	#1,ptr
	movei	#lentable,table
	add	G_d0,ptr

	JSRinputvalue

	addq	#1,d0w
;	loadb	(ptr),temp1
;	addqt	#1,ptr
;	storeb	temp1,(output)
;	addqt	#1,output

unpack11:
	loadb	(ptr),temp1
	subq	#1,d0w
	addqt	#1,ptr
	storeb	temp1,(output)
	jr	PL,unpack11
	addqt	#1,output

;	G_BPL	unpack11
unpack12:

	movei	#rawtable,table

	JSRinputvalue
	subq	#1,d0w
	G_BMI	unpack13
	getrawREP
	loadb	(input),temp1
	addqt	#1,input
	loadb	(input),d0w
	subqt	#1,input
	shlq	#8,d0w
	move	bitcount,temp2
	or	temp1,d0w
	neg	temp2
	shrq	#16,G_d0
	moveq	#1,G_d1
	shlq	#16,G_d0
	sh	temp2,G_d1
	or	d0w,G_d0
	subq	#1,G_d1
	sh	temp2,G_d0

	and	G_d1,bitbuf
	or	G_d0,bitbuf

unpack13:
	subq	#1,counts
	G_BPL	unpack10

	cmp	output_hi,output
	G_BCS	unpack8


unpack15:
	if checksums
	movefa	crcflags,r0
	btst	#CRC_CHECK_OUT,r0
	G_BEQ	nooutcrc

	movefa	saveoutput,ptr			;output base
	movefa	okstatus,r0			;output length
	
	G_JSR	check_crc			;returns G_d2
	movefa	savecrc,r0
	shrq	#16,r0
	movei	#UNPACKED_CRC,status
	cmp	r0,G_d2
	BNES	unpack17
nooutcrc:
	endif
	
unpack16:
	movefa	okstatus,status
unpack17:
	movei	#(INBUF+8),inbuf
	nop
	store	status,(inbuf)

stopgpu:
;Set completion semaphore
	moveq	#0,temp1
	movei	#pp_semaphore,inbuf
	nop
	store	temp1,(inbuf)
	moveq	#8,r0
	movei	#G_CTRL,r1
	store	r0,(r1)
.lpas:	jr	t,.lpas
	nop



;	G_BRA	start

;call with table as required
inputvalue:
;d0w holds the new bottom word of G_d0

	movei	#halftabsize,table1
	nop
	add	table,table1
	subqt	#8,table1

inputvalue1:
	load	(table),d0w
	addqt	#4,table
	and	bitbuf,d0w
	load	(table),temp2
	sub	temp2,d0w
	addqt	#8,table1
	jr	NE,inputvalue1
	addqt	#4,table

;	BNES	inputvalue1
	load	(table1),bytes		;two bytes
	addqt	#4,table1
;replace byte 0 of d0w
	move	bytes,G_d1
	shrq	#8,d0w			;replace
	shrq	#8,G_d1
	shlq	#8,d0w			;replace
	sub	G_d1,bitcount
	BPLS	inputvalue2
	JSRinputbits3
;	movei	inputvalue2,debugtemp
;	jump	(debugdata)
inputvalue2:
	and	keepbotbyte,bytes	;replace
	sh	G_d1,bitbuf
	or	bytes,d0w		;replaced
	cmpq	#2,bytes
	G_BMI	inputvalue4

	subq	#1,bytes
	load	(table1),d0w
	move	bytes,G_d1
	and	bitbuf,d0w
	sub	G_d1,bitcount
	move	bytes,G_d2
	BPLS	inputvalue3

	JSRinputbits3
;	movei	inputvalue3,debugtemp
;	jump	(debugdata)

inputvalue3:
	sh	G_d1,bitbuf
;rebuild G_d0
;	bset	G_d2,G_d0
	move	G_d2,temp2
	moveq	#1,temp1
	neg	temp2
	shrq	#16,G_d0
	sh	temp2,temp1
	shlq	#16,G_d0
	or	temp1,d0w

	or	d0w,G_d0

;	debug
;	G_RTS
	jump	(flagsptr)
	nop

inputvalue4:
;rebuild G_d0
	shrq	#16,G_d0
	shlq	#16,G_d0
	or	d0w,G_d0

;	debug
;	G_RTS
	jump	(flagsptr)
	nop

inputbits:
	and	bitbuf,G_d0
	sub	G_d1,bitcount
	BPLS	inputbits2
	JSRinputbits3
inputbits2:
	sh	G_d1,bitbuf
;	debug
	nop
	G_RTS

inputbits3:
	add	G_d1,bitcount
	addqt	#3,input
	sh	bitcount,bitbuf
	loadb	(input),ivtemp1
	subqt	#1,input
	shlq	#24,ivtemp1
	loadb	(input),ivtemp2
	and	keepbotword,bitbuf
	shlq	#16,ivtemp2
	sub	bitcount,G_d1
	or	ivtemp1,bitbuf
	moveq	#16,bitcount
	or	ivtemp2,bitbuf
	sub	G_d1,bitcount

;	G_RTS
	jump	(debugtemp)
	nop

read_long:
	loadb	(r3),temp1
	addqt	#1,r3
	move	temp1,r0		;init result in r0

	loadb	(r3),temp2		;get next byte
	shlq	#8,r0			;shift previous byte up
	addqt	#1,r3			;bump address
	or	temp2,r0		;or in new byte
	
	loadb	(r3),temp1
	shlq	#8,r0
	addqt	#1,r3
	or	temp1,r0
	
	loadb	(r3),temp2
	shlq	#8,r0
	addqt	#1,r3
	or	temp2,r0
	
	G_RTS
	
;call with table as base of appropriate table
makehuftable:
	movei	#halftabsize,table1
	nop
	add	table,table1

	moveq	#$1f,G_d0
	moveq	#5,G_d1
	G_JSR	inputbits
	subq	#1,G_d0
	G_BMI	makehuf8
	move	G_d0,G_d2
	move	G_d0,G_d3

	movei	#tempspace,ptr

makehuf3:
	moveq	#$f,G_d0
	moveq	#4,G_d1
	G_JSR	inputbits
	subq	#1,G_d2
	store	G_d0,(ptr)
;	addqt	#4,ptr
;	BPLS	makehuf3
	jr	PL,makehuf3
	addqt	#4,ptr

	moveq	#1,G_d0
	moveq	#1,G_d1
	rorq	#1,G_d0
	moveq	#0,G_d2
	moveta	G_d5,G_d5
	moveta	G_d6,G_d6
	moveta	G_d7,G_d7

makehuf4:
	move	G_d3,G_d4
	movei	#tempspace,ptr
	nop
makehuf5:
	load	(ptr),temp1
	addqt	#4,ptr
	cmp	temp1,G_d1
	G_BNE	makehuf7

	moveq	#1,G_d5
	move	G_d1,temp1
	neg	temp1
	sh	temp1,G_d5
	subq	#1,G_d5
	store	G_d5,(table)
	addqt	#4,table
	move	G_d2,G_d5
	move	G_d1,G_d7
	subq	#1,G_d7
	moveq	#0,G_d6
	moveq	#0,temp1
makehuf6:
	rorq	#31,G_d5
	addc	temp1,G_d6
	rorq	#1,G_d6
	subq	#1,G_d7
	BPLS	makehuf6

	shrq	#16,G_d6

	moveq	#16,G_d5
	sub	G_d1,G_d5
	sh	G_d5,G_d6
	store	G_d6,(table)
	addqt	#4,table
	move	G_d1,temp1
	move	G_d3,G_d5
	shlq	#8,temp1
	sub	G_d4,G_d5
	moveq	#1,G_d6
	or	G_d5,temp1
	subq	#1,G_d5
	store	temp1,(table1)		;two bytes
;	move	G_d5,temp1
	neg	G_d5
	addqt	#4,table1
;	neg	temp1
;	sh	temp1,G_d6
	sh	G_d5,G_d6
	subq	#1,G_d6
	add	G_d0,G_d2
	store	G_d6,(table1)
	addqt	#4,table1
makehuf7:
	subq	#1,G_d4
	G_BPL	makehuf5

	shrq	#1,G_d0
	addq	#1,G_d1
	cmp	seventeen,G_d1
	G_BNE	makehuf4
	movefa	G_d5,G_d5
	movefa	G_d6,G_d6
	movefa	G_d7,G_d7
makehuf8:
	G_RTS


if checksums

make_crc_table:

	movei	#crctable,table
	movei	#CRC_POLY,G_d4
	moveq	#0,G_d3
crc2:
	move	G_d3,G_d1
	moveq	#8,G_d2
crc3:
	shrq	#1,G_d1
	BCCS	crc4
	xor	G_d4,G_d1
crc4:
	subq	#1,G_d2
	BNES	crc3
	addqt	#1,G_d3
	store	G_d1,(table)
	btst	#8,G_d3
	addqt	#4,table
	BEQS	crc2

	G_RTS

check_crc:
;call with ptr as base of data to check
;r0 with length of data to check
;G_d2 returns CRC

	movei	#crctable,table
	moveq	#0,G_d2

	loadb	(ptr),G_d1
crc5:
	addqt	#1,ptr
	xor	G_d1,G_d2
	move	G_d2,G_d1
	and	keepbotbyte,G_d2
	shlq	#2,G_d2
	load	(table+G_d2),G_d2
	shrq	#8,G_d1
	xor	G_d1,G_d2
	subq	#1,r0
;	BNES	crc5
	jr	ne,crc5
	loadb	(ptr),G_d1

	G_RTS

endif

if wantdebug
debugsub:
;dumps key values to store as words

macro pushw
	storew	dtemp1,(debugdata)
	addqt	#2,debugdata
endm

macro pushl
	store	dtemp1,(debugdata)
	addqt	#4,debugdata
endm

	subq	#1,debugtemp
	BEQ	exit

	load	(G_SP),dtemp1		;get call address from stack
	pushw

	move	bitcount,dtemp1
	pushw

	move	bitbuf,dtemp1
	pushl

	move	input,dtemp1
	pushw

	move	output,dtemp1		;only want bottom word
	pushw

	move	G_d0,dtemp1
	pushl

exit:
	G_RTS
endif
	.long
	.68000
pp_end:
	
tabsize	equ	16*4*4
halftabsize	equ	tabsize/2

	.long

GPUFINISHED	equ	$12345678

pad:		dcb.l	3,0

tempspace:	dcb.l	16,0

rawtable:	dcb.b	tabsize,0
postable:	dcb.b	tabsize,0
lentable:	dcb.b	tabsize,0



if checksums

crctabsize	equ	256
xdef	crctable

		.long
crctable:	dcb.l	crctabsize,0

endif
	.long


