	.text	  
	.68000

;enter with a6 pointing to text
;d0=addr of screen
;d1=flags -> needs to be in pixel mode
;this asssumes the area is clear (0 filled) - if not then clear it ..

space_width		equ	8
font_height		equ	8
big_font_height	equ	15


PEND	equ	0
PCR	equ	1
PAT	equ	2
PATY	equ	3
PCEN	equ	4
PPAL	equ	5

print_text_routine:
	movem.l	d0-d7/a0-a6,-(Sp)
	jsr	waitgpu
	movem.l	(sp)+,d0-d7/a0-a6

	movem.l	d0-a6,-(sp)
	move.l	d0,A1_BASE
	move.l	d1,A1_FLAGS
	move.l	#SRCEN|DSTEN|UPDA1|UPDA2|LFU_SORD,d7
	and.l	#PITCH4,d1
	beq.s	.one_bpl
	move.l	#$77ff77ff,d7
	move.l	d7,B_PATD
	move.l	d7,B_PATD+4
	move.l	#BCOMPEN|PATDSEL|SRCEN|DSTEN|UPDA1|UPDA2|LFU_S,d7

.one_bpl:
	move.l	#print_font,A2_BASE
	move.l	#WID64|PIXEL1|PITCH1|XADDPIX,A2_FLAGS
	lea	print_font_width_table,a4
.next:
	moveq	#0,d0
	move.b	(a6)+,d0
	cmp.b	#PEND,d0
	bne.s	.not_end
	movem.l	(sp)+,d0-a6
	rts
.not_end:
	cmp.b	#PAT,d0
	bne.s	.some_text
	move.b	(a6)+,d0
	lsl.w	#8,d0
	move.b	(a6)+,d0
	move.b	(a6)+,d1
	lsl.w	#8,d1
	move.b	(a6)+,d1
	move.w	d0,print_x_pos
	move.w	d0,print_x_cr
	move.w	d1,print_y_pos
	bra.s	.next
.some_text:
	cmp.b	#PPAL,d0
	bne.s	.not_pal
	tst.b	PAL_TV
	beq.s	.next
	add.w	#20,print_y_pos
	bra.s	.next
.not_pal:
	cmp.b	#PCR,d0
	bne.s	.no_new_line
	move.w	print_x_cr,print_x_pos
	add.w	#font_height,print_y_pos
	bra.s	.next
.no_new_line:
	sub.b	#32,d0
	bne.s	.not_space
	add.w	#space_width,print_x_pos
	bra.s	.next
.not_space:
	move.b	(a4,d0.w),d1			;get the width
	mulu	#font_height,d0
	swap	d0
	move.l	d0,A2_PIXEL
	ext.w	d1
	move.w	print_y_pos,d2
	swap	d2
	move.w	print_x_pos,d2
	move.l	d2,A1_PIXEL			;set pixel on screen
	add.w	d1,print_x_pos			;update position
	move.l	#(font_height*$10000),d4
	or.w	d1,d4
	move.l	d4,B_COUNT
	moveq	#1,d4
	swap	d4
	move.w	d1,d4
	neg.w	d4
	move.l	d4,A1_STEP
	move.l	d4,A2_STEP
	move.l	d7,B_CMD
	bra	.next


print_text_sprites:
	movem.l	d0-d7/a0-a6,-(Sp)
	jsr	waitgpu
	movem.l	(sp)+,d0-d7/a0-a6

	movem.l	d0-a6,-(sp)
	move.l	d0,A1_BASE
	move.l	d1,A1_FLAGS
	move.l	#SRCEN|DSTEN|UPDA1|LFU_SORD,d7
	move.l	#WID64|PIXEL4|PITCH1|XADDPIX,A2_FLAGS
	lea	hi_letters_offset,a4
.next:
	moveq	#0,d0
	move.b	(a6)+,d0
	cmp.b	#PEND,d0
	bne.s	.not_end
	movem.l	(sp)+,d0-a6
	rts
.not_end:
	cmp.b	#PAT,d0
	bne.s	.some_text
	move.b	(a6)+,d0
	lsl.w	#8,d0
	move.b	(a6)+,d0
	move.b	(a6)+,d1
	lsl.w	#8,d1
	move.b	(a6)+,d1
	move.w	d0,print_x_pos
	move.w	d0,print_x_cr
	add.w	view_window_height,d1
	move.w	d1,print_y_pos
	bra.s	.next
.some_text:
	cmp.b	#PCR,d0
	bne.s	.no_new_line
	move.w	print_x_cr,print_x_pos
	add.w	#2*font_height,print_y_pos
	bra.s	.next
.no_new_line:
	cmp.b	#PATY,d0
	bne.s	.no_new_y
	move.b	(a6)+,d0
	lsl.w	#2,d0
	move.b	(a6)+,d0
	move.w	d0,print_y_pos
	bra.s	.next
.no_new_y:
	cmp.b	#PCEN,d0
	beq	.calc_center

	sub.b	#32,d0
	bne.s	.not_space
	add.w	#space_width,print_x_pos
	bra	.next
.not_space:
	sub.b	#"0"-" ",d0	;check if its a number
	bmi.s	.alpha
	
	cmp.b	#9,d0
	bgt.s	.alpha
	add.b	#29,d0
	bra.s	.ok

.alpha:
	sub.b	#"A"-"0",d0
	bpl.s	.ok
	add.b	#"A",d0
	move.b	d0,d1
	moveq	#25,d0
	cmp.b	#" ",d1
	beq.s	.spa
	cmp.b	#".",d1
	beq.s	.dot
	cmp.b	#"!",d1
	beq.s	.ex
	cmp.b	#"1",d1
	beq.s	.one
	cmp.b	#"2",d1
	beq.s	.two
.three:addq	#1,d0
.two:	addq	#1,d0
.one:	addq	#1,d0
.ex:	addq	#1,d0
.dot:	addq	#1,d0
.spa:	addq	#1,d0
	

.ok:	move.w	d0,-(sp)
	move.b	(a4,d0.w),d1			;get the width
	addq	#2,d1
	ext.w	d1
	
	lea	level_sprites,a0
	jsr	get_addr_sprite
	move.l	d0,A2_BASE
	
	move.l	#0,A2_PIXEL
	move.w	print_y_pos,d2
	swap	d2
	move.w	print_x_pos,d2
	move.l	d2,A1_PIXEL			;set pixel on screen
	cmp.w	#29,(sp)+
	blt.s	.no_num
	moveq	#16,d1
.no_num:
	add.w	d1,print_x_pos			;update position
	move.l	#(big_font_height*$10000),d4
	moveq	#16,d1
	or.w	d1,d4
	move.l	d4,B_COUNT
	moveq	#1,d4
	swap	d4
	move.w	d1,d4
	neg.w	d4
	move.l	d4,A1_STEP
	move.l	d4,A2_STEP
	move.l	d7,B_CMD
	bra	.next

.calc_center:
	clr.w	print_x_pos
	pea	(a6)
.loop:	move.b	(a6)+,d0
	cmp.b	#PCR,d0
	beq.s	.end_cen

	sub.b	#32,d0
	bne.s	.cnot_space
	add.w	#space_width,print_x_pos
	bra.s	.loop
.cnot_space:
	sub.b	#"0"-" ",d0	;check if its a number
	bmi.s	.calpha
	
	cmp.b	#9,d0
	bgt.s	.calpha
	add.b	#29,d0
	bra.s	.cok

.calpha:
	sub.b	#"A"-"0",d0
	bpl.s	.cok
	add.b	#"A",d0
	move.b	d0,d1
	moveq	#25,d0
	cmp.b	#" ",d1
	beq.s	.cspa
	cmp.b	#".",d1
	beq.s	.cdot
	cmp.b	#"!",d1
	beq.s	.cex
	cmp.b	#"1",d1
	beq.s	.cone
	cmp.b	#"2",d1
	beq.s	.ctwo
.cthree:addq	#1,d0
.ctwo:	addq	#1,d0
.cone:	addq	#1,d0
.cex:	addq	#1,d0
.cdot:	addq	#1,d0
.cspa:	addq	#1,d0
	

.cok:	move.w	d0,-(sp)
	move.b	(a4,d0.w),d1			;get the width
	addq	#2,d1
	ext.w	d1
	
	cmp.w	#29,(sp)+
	blt.s	.cno_num
	moveq	#16,d1
.cno_num:
	add.w	d1,print_x_pos			;update position
	bra.s	.loop
.end_cen:
	move.l	(sp)+,a6
	move.w	#320,d0
	sub.w	print_x_pos,d0
	asr.w	#1,d0
	move.w	d0,print_x_pos
	bra	.next



	

	.data

print_y_pos:	dc.w	0
print_x_pos:	dc.w	0
print_x_cr:	dc.w	0
	
print_font_width_table:
	rept	128-32
	dc.b	8
	endr

	.phrase
print_font:	incbin	"graphics\\bitmaps\\story\\poo.jsp"		


