max_sfx	equ	100


CLEAR_SFX_LIST:
		move.l	d0,-(sp)
		pea	(a0)
		lea	sfx_table_start,a0
		move.l	a0,sfx_pointer
		clr.w	sfx_number
		moveq	#max_sfx-1,d0
.lp:		st	(a0)
		addq	#6,a0
		dbf	d0,.lp
		move.l	(sp)+,a0
		move.l	(sp)+,d0
		rts


ADD_SFX:	pea	(a6)
		move.l	sfx_pointer,a6
		move.w	d7,(a6)+		;sample number
		move.l	a0,(a6)+		;object addr
		move.l	a6,sfx_pointer
		addq.w	#1,sfx_number
		move.l	(sp)+,a6
		rts



PROCESS_SFX:	tst.w	sfx_number
		beq.s	.exit
		
		movem.l	d0-a6,-(sp)

		bsr	sfx_lengths
		bsr.s	SORT_SFX
		
		lea	new_sfx_table,a6
		
		moveq	#6-1,d7
		move.w	sfx_number,d2
		dbf	d2,.ok
		rts
.ok:		cmp.w	d7,d2
		bgt.s	.no_dec
		move.w	d2,d7
.no_dec:
		moveq	#0,d1
.lp:		move.w	(a6)+,d0
		bmi.s	.next
		bsr.s	sfxplay
.next:		addq	#1,d1  		;next priority
		addq.l	#6-2,a6		;get next sample
		dbf	d7,.lp
		movem.l	(sp)+,d0-a6
.exit:		rts



SORT_SFX:	lea	new_sfx_table,a6
		moveq	#6-1,d0
		move.l	#$7ffffff,d1		
		move.w	sfx_number,d2
		subq.w	#1,d2
		cmp.w	d0,d2
		bgt.s	.no_dec
		move.w	d2,d0
.no_dec:
.outer_loop:	lea	sfx_table_start,a0
		move.l	a0,a1
		move.l	d1,d3
		move.w	d2,d4

.inner_loop:	cmp.l	2(a0),d3
		bgt.s	.not_new

		move.l	a0,a1
		move.l	2(a0),d3

.not_new:	dbf	d4,.inner_loop
		

		move.w	(a1)+,(a6)+
		move.l	(a1),(a6)+
		move.l	d1,(a1)

		dbf	d0,.outer_loop
		rts


; d0 = effect

sfxplay:	
		movem.l	d0-a6,-(sp)		;save registers
		move.l	sfxadd,a2		;address of sample data
		moveq	#0,d1
		moveq	#0,d3
		move.b	d0,d3
		add.b	d3,d3
		move.w	.sfx_num(pc,d3.w),d0
		move.w	.sfx_tab(pc,d3.w),d3
		move.w	(a2)+,d1		;read number of effects
		cmp.w	d1,d0			;effect ok?
		bgt.s	.sfxplay6		;no, illegal number!
		lsl.w	#2,d1
		lea.l	(a2,d1.w),a0		;find address of first effect
		subq.w	#1,d0			;decrement effect
		bmi.s	.sfxplay5		;first effect
.sfxplay4:	add.l	(a2)+,a0		;add length of effect
		dbra	d0,.sfxplay4		;find address of effect
.sfxplay5:	moveq	#0,d0
		move.l	(a2),d0			;read length of effect
		moveq	#1,d1
		move.w	#$3fff,d2		;pan value
		jsr	MUS_PLAY_FX
.sfxplay6:	movem.l	(sp)+,d0-a6		;restore registers
		rts


;		**	  00,  01,  02,  03,  04,  05,  06,  07,  08,  09,  10,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20, 21, 22, 23
.sfx_tab:	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$100,$120,$140,$160,$100,$100,$000,$130,$130,$130,$130,$130	
.sfx_num:	dc.w	$000,$001,$002,$003,$004,$005,$006,$007,$008,$009,$00a,$00b,$004,$004,$004,$004,$012,$010,$00c,$00d,$00e,$013,$014,$015

sfx_lengths:
	move.w	sfx_number,d7
	subq.w	#1,d7
	move.l	camera_addr,a0
	move.l	ifirst(a0),d0
	movem.l	icxcoord(a0),d0-d2
	lea	sfx_table_start,a0
.loop:	
	addq.l	#2,a0
	
	move.l	(a0),a2			;addr of the object
	movem.l	isxcoord(a2),d4-d6
	sub.l	d0,d4
	sub.l	d1,d5
	sub.l	d2,d6
	asr.l	#8,d4
	asr.l	#8,d5
	asr.l	#8,d6
	muls	d4,d4
	muls	d5,d5
	muls	d6,d6
	add.l	d4,d5
	add.l	d5,d6
	move.l	d6,(a0)
	addq.l	#4,a0
	dbf	d7,.loop
	rts




	.data


sfx_file_name:	dc.b	"SAMPLES.BIN",0
		even
	.bss
sfx_pointer:	ds.l	1
sfx_number:	ds.w	1

sfx_table_start:	ds.b	6*max_sfx
sfx_table_end:

new_sfx_table:		ds.b	6*6


