*************************** Jaguar Initialisation ****************************

* Notes:

* This code was all nice and clean
* Until Seedy got his hands on it

******************************* Code Section *********************************

		text
		.68000

**************************** Initialise Everything ***************************
****************************** Then Go To Program ****************************

init:		
restart_program:
		move.l	#stackstart,sp		;set up 68000 stack

		jsr	system_initalise
		jsr	restore_eeprom_buffer
		jsr	initrandom

	       	move.l	#rasteradata,rastera	;set up raster pointers
		move.l	#rasterbdata,rasterb	;must be phrase aligned
		move.l	#rastercdata,rasterc
		move.l	#rasterzdata,rasterz

		clr.l	gpu_routine_addr	;indicate no gpu routine loaded
		jmp	game			;go to program

****************************** Handy Subroutines *****************************

switchab:	movem.l	d0-d1,-(sp)		;switch rasters a and b
		movem.l	rastera,d0-d1
		exg.l	d0,d1
		movem.l	d0-d1,rastera
		addq.b	#1,switches
.wait:
		cmp.b	#1,switches
		beq.s	.wait
		movem.l	(sp)+,d0-d1
		rts

switchabc:	movem.l	d0-d2,-(sp)		;switch rasters a,b and c
		movem.l	rastera,d0-d2
		exg.l	d0,d1
		exg.l	d1,d2
		movem.l	d0-d2,rastera
		addq.b	#1,switches
.wait:
		cmp.b	#2,switches
		beq.s	.wait
		movem.l	(sp)+,d0-d2
		rts
		
waitvblank:	st.b	switches		;wait for vertical blank
.wait:
		tst.b	switches
		bne.s	.wait
		rts

initrandom:	move.l	#$74652319,seeda	;prepare random number seeds
		move.l	#$facbde72,seedb
		move.l	#$5d3b9a7d,seedc
		rts

random:		movem.l	d1-d2,-(sp)		;return a random
		movem.l	seeda,d0-d2		;number in d0
		add.l	d0,d1
		add.l	d1,d2
		exg.l	d0,d2
		movem.l	d0-d2,seeda
		movem.l	(sp)+,d1-d2
		rts

waitblitter:	move.l	B_CMD,d0		;return when the
		lsr.w	d0			;blitter stops
		bcc.s	waitblitter
		rts

donowt:		rts				;err...do nothing?

********************************* Data Section *******************************

		data

********************************** Variables *********************************

		even

seeda:		dc.l	0
seedb:		dc.l	0
seedc:		dc.l	0

MOD_FILE_NAME:		dc.b	"DREDTITL.MOD",0
TITLE_FILE_NAME:	dc.b	"TITLE.CRY",0

********************************* BSS Section ********************************

		bss

********************************** Variables *********************************

		even

stackend:	ds.b	stacksize	;stack buffer
stackstart:

rasterz:	ds.l	1		;zbuffer pointer
switches:	ds.b	1		;switch counter

******************************** Raster Buffers ******************************

		phrase
view_pal::	ds.w	256		


olist_view_pointer:		ds.l	1

swap_pointer:

;one i'm seeing

display_olist_pointer:		ds.l	1
display_number_of_items:	ds.l	1
display_ol_base:		ds.l	1

;currently being worked upon

olist_pointer:			ds.l	1
number_of_items:		ds.l	1
working_ol_base:		ds.l	1

;one spare

spare_olist_pointer:		ds.l	1
spare_number_of_items:		ds.l	1
spare_ol_base:			ds.l	1


		.qphrase
olist_data::	ds.b	SPRITE_BANK
		.qphrase
olist_master::	ds.b	SPRITE_BANK
		.qphrase
olist_master1::ds.b	SPRITE_BANK
		.qphrase
olist_master2::ds.b	SPRITE_BANK

