************************ Draw A List Of Shaded Polygons **********************

* Notes:

* The polygon filler does a preclip on all the polygons
* this is quicker and more flexible than
* trying to clip them as you draw them
* I know what I'm talking about here.....

* The polygon filler scales and offsets zcoordinates
* This is to prevent the blitter z registers from saturating
* Same for ivalues

* Useable zvalues range from 0 to 114686
* Usable ivalues range from $18 to $e7

* Polygons should not be too 'deep'
* ie furthest zcoord - closest zcoord < 16384

* Also the filler is very optimised to the GPU's pipelining
* So things are not always in the order they seem to be

* You have been warned!

************************* Shaded Polygon List Routine ************************

	text
	.68000

	phrase
shaded:
	.gpu
	org	gpuprog

	movei	#B_CMD,r0			;wait for blitter
.wait1:
	load	(r0),r1
	btst	#0,r1
	jr	eq,.wait1
	nop

	movei	#rasterd,r0			;set blitter base address
	movei	#rasterz,r1			;and blitter flags
	load	(r0),r0
	load	(r1),r1
	sub	r0,r1
	shrq	#3,r1
	shlq	#6,r1
	movei	#PITCH4|PIXEL16|WID320|XADDPHR,r2
	or	r2,r1
	movei	#A1_BASE,r14
	store	r0,(r14)
	store	r1,(r14+1)

	movei	#nextshaded,r0			;get polygon list
	load	(r0),r0
.polygon:
	load	(r0),r1				;get the points and
	movei	#.donelist,r2			;check if we should
	cmpq	#0,r1				;clip the polygon
	jump	eq,(r2)
	addq	#4,r0
	load	(r0),r2
	addq	#4,r0

	movei	#numpoints,r3
	movei	#colour,r4
	store	r1,(r3)
	store	r2,(r4)

	load	(r0),r3				;get initial minx,y,maxx,y
	addq	#4,r0
	load	(r0),r5
	subq	#4,r0
	move	r3,r4
	move	r5,r6

	movei	#points1,r7
	movei	#.getpoints,r12
.getpoints:
	load	(r0),r8				;load the point from
	addq	#4,r0				;external memory
	load	(r0),r9
	addq	#4,r0
	load	(r0),r10
	addq	#4,r0
	load	(r0),r11
	addq	#4,r0
	or	r11,r11

	store	r8,(r7)				;store the point in
	addq	#4,r7				;internal memory
	store	r9,(r7)
	addq	#4,r7
	store	r10,(r7)
	addq	#4,r7
	store	r11,(r7)
	addq	#4,r7

	cmp	r8,r3				;check for minx
	jr	mi,.notminx
	cmp	r4,r8
	move	r8,r3
.notminx:
	jr	mi,.notmaxx			;check for maxx
	cmp	r9,r5
	move	r8,r4
.notmaxx:
	jr	mi,.notminy			;check for miny
	cmp	r6,r9
	move	r9,r5
.notminy:
	jr	mi,.notmaxy			;check for maxy
	subq	#1,r1
	move	r9,r6
.notmaxy:
	jump	ne,(r12)
	moveta	r0,r0				;save polygon pointer

	movei	#.donepolygon,r8
	cmp	r5,r6				;check for polygons
	jump	eq,(r8)				;with zero height
	nop

	movei	#clx,r12			;get clip limits
	load	(r12),r9			;and check for polygons
	cmp	r9,r4				;totally offscreen
	jump	mi,(r8)
	addq	#4,r12
	load	(r12),r10
	cmp	r10,r6
	jump	mi,(r8)
	addq	#4,r12
	load	(r12),r11
	cmp	r3,r11
	jump	mi,(r8)
	addq	#4,r12
	load	(r12),r12
	cmp	r5,r12
	jump	mi,(r8)
	subq	#1,r11

	cmp	r9,r3				;check for polygons
	jr	mi,.hclip			;totally onscreen
	cmp	r4,r11
	jr	mi,.hclip
	cmp	r10,r5
	jr	mi,.hclip
	cmp	r6,r12
	movei	#.clipped,r8
	jump	pl,(r8)
	nop

.hclip:
	movei	#numpoints,r0			;horizontal clip
	load	(r0),r0
	moveq	#0,r1
	movei	#points1,r2
	movei	#points2,r3
	movei	#clx,r4
	movei	#chx,r5
	move	r0,r6
	load	(r4),r4
	subq	#1,r6
	load	(r5),r5
	shlq	#4,r6
	subq	#1,r5
	add	r2,r6
	load	(r6),r11			;last point is linked to first
	addq	#4,r6
	load	(r6),r12
	addq	#4,r6
	load	(r6),r13
	addq	#4,r6
	load	(r6),r14
.dohclip:
	move	r11,r6				;end point to start point
	move	r12,r7
	move	r13,r8
	move	r14,r9
	load	(r2),r11			;get new end point
	addq	#4,r2
	load	(r2),r12
	addq	#4,r2
	load	(r2),r13
	addq	#4,r2
	load	(r2),r14
	addq	#4,r2

	cmp	r4,r6				;clip startpoint
	movei	#.hstartclip1,r29		;if necessary
	jump	mi,(r29)
	cmp	r6,r5
	movei	#.hstartclip2,r29
	jump	mi,(r29)
	nop

	store	r6,(r3)				;startpoint is onscreen
	addq	#4,r3				;so save it
	store	r7,(r3)
	addq	#4,r3
	store	r8,(r3)
	addq	#4,r3
	store	r9,(r3)
	addq	#4,r3
	addq	#1,r1

	movei	#.hcalc,r28			;clip endpoint
	movei	#.hreturn3,r29			;if necessary

	cmp	r4,r11
	jump	mi,(r28)
	move	r4,r21

	cmp	r11,r5
	jump	mi,(r28)
	move	r5,r21

	movei	#.hnextedge,r29
	jump	t,(r29)
.hstartclip1:
	cmp	r4,r11
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.hcalc,r28
	movei	#.hreturn1,r29
	jump	t,(r28)
	nop
.hreturn1:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r5,r11
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.hcalc,r28
	movei	#.hreturn3,r29
	jump	t,(r28)
.hstartclip2:
	cmp	r11,r5
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.hcalc,r28
	movei	#.hreturn2,r29
	jump	t,(r28)
	nop
.hreturn2:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r11,r4
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.hcalc,r28
	movei	#.hreturn3,r29
	jump	t,(r28)
	nop
.hreturn3:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	addq	#1,r1
.hnextedge:
	movei	#.dohclip,r29
	subq	#1,r0
	jump	ne,(r29)
	cmpq	#3,r1
	movei	#.donepolygon,r0
	jump	mi,(r0)
	nop
	movei	#numpoints,r0
	store	r1,(r0)

.vclip:
	movei	#numpoints,r0			;vertical clip
	load	(r0),r0
	moveq	#0,r1
	movei	#points2,r2
	movei	#points1,r3
	movei	#cly,r4
	move	r0,r6
	movei	#chy,r5
	subq	#1,r6
	load	(r4),r4
	shlq	#4,r6
	load	(r5),r5
	add	r2,r6
	load	(r6),r11			;last point is linked to first
	addq	#4,r6
	load	(r6),r12
	addq	#4,r6
	load	(r6),r13
	addq	#4,r6
	load	(r6),r14
.dovclip:
	move	r11,r6				;end point to start point
	move	r12,r7
	move	r13,r8
	move	r14,r9
	load	(r2),r11			;get new end point
	addq	#4,r2
	load	(r2),r12
	addq	#4,r2
	load	(r2),r13
	addq	#4,r2
	load	(r2),r14
	addq	#4,r2

	cmp	r4,r7				;clip startpoint
	movei	#.vstartclip1,r29
	jump	mi,(r29)
	cmp	r7,r5
	movei	#.vstartclip2,r29
	jump	mi,(r29)
	nop

	store	r6,(r3)				;startpoint is onscreen
	addq	#4,r3				;so save it
	store	r7,(r3)
	addq	#4,r3
	store	r8,(r3)
	addq	#4,r3
	store	r9,(r3)
	addq	#4,r3
	addq	#1,r1

	movei	#.vcalc,r28			;clip the endpoint
	movei	#.vreturn3,r29			;if necessary

	cmp	r4,r12
	jump	mi,(r28)
	move	r4,r21

	cmp	r12,r5
	jump	mi,(r28)
	move	r5,r21

	movei	#.vnextedge,r29
	jump	t,(r29)
.vstartclip1:
	cmp	r4,r12
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.vcalc,r28
	movei	#.vreturn1,r29
	jump	t,(r28)
	nop
.vreturn1:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r5,r12
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.vcalc,r28
	movei	#.vreturn3,r29
	jump	t,(r28)
.vstartclip2:
	cmp	r12,r5
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.vcalc,r28
	movei	#.vreturn2,r29
	jump	t,(r28)
	nop
.vreturn2:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r12,r4
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.vcalc,r28
	movei	#.vreturn3,r29
	jump	t,(r28)
	nop
.vreturn3:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	addq	#1,r1
.vnextedge:
	movei	#.dovclip,r29
	subq	#1,r0
	jump	ne,(r29)
	cmpq	#3,r1
	movei	#.donepolygon,r0
	jump	mi,(r0)
	nop
	movei	#numpoints,r0
	store	r1,(r0)

.clipped:
	movei	#numpoints,r0			;get pointer to highest y
	load	(r0),r0
	movei	#points1,r14
	move	r14,r20
	load	(r14+1),r1			;r1 = lowest y
	move	r1,r2				;r2 = highest y
.getlowhigh:
	load	(r14+1),r3			;get ycoord
	cmp	r1,r3				;check for lowest
	jr	pl,.notlowy
	cmp	r3,r2
	move	r3,r1
	move	r14,r20
.notlowy:
	jr	pl,.nothighy			;check for highest
	subq	#1,r0
	move	r3,r2
.nothighy:
	addqt	#16,r14				;move onto next point
	jr	ne,.getlowhigh
	move	r20,r21

	movei	#.donepolygon,r0		;check the polygon is
	cmp	r1,r2				;not horizontal
	jump	eq,(r0)

	subq	#16,r14				;save last point address
	movei	#lastpoint,r0
	store	r14,(r0)
	movei	#lasty,r0			;save last y
	store	r2,(r0)

	movei	#$7ffff,r1			;set some constants in
	movei	#$ffff0000,r2			;an easy to reach place
	movei	#DSTEN|DSTENZ|DSTWRZ|ZBUFF|PATDSEL|ZMODEGT|ZMODEEQ,r3

	movei	#colour,r12			;get the colour and check
	load	(r12),r12			;if it is a flat shaded
	move	r12,r13				;polygon or a gouraud
	movei	#$3fff,r4			;shaded polygon
	and	r4,r12
	not	r4
	and	r4,r13
	movei	#shadedmode,r4
	cmp	r4,r13
	movei	#.shaded,r13			;textured polygons are
	jump	eq,(r13)			;dealt with elsewhere
	nop
.flat:
	movei	#flatcolours,r13		;doing a flat polygon
	add	r12,r12
	add	r12,r13
	loadw	(r13),r12
	movei	#.fud_setz,r4
	movei	#.fdu_setz,r5
	movei	#.flatud,r6
	movei	#.flatdu,r7
	movei	#.both,r13
	jump	t,(r13)
	nop
.shaded:
	bset	#12,r3				;doing a shaded polygon
	movei	#shadedcolours,r13
	add	r13,r12
	loadb	(r12),r12
	shlq	#8,r12
	movei	#.sud_setzi,r4
	movei	#.sdu_setzi,r5
	movei	#.shadedud,r6
	movei	#.shadeddu,r7
.both:
	movei 	#.nextline,r8
	movei	#$10000,r9
	moveta	r1,r1
	moveta	r2,r2
	moveta	r3,r3
	moveta	r4,r4
	moveta	r5,r5
	moveta	r6,r6
	moveta	r7,r7
	moveta	r8,r8
	moveta	r9,r9

	movei	#A1_BASE,r14			;r14 MUST NOT BE CHANGED!
	movei	#B_CMD,r15			;r15 MUST NOT BE CHANGED!
.wait2:
	load	(r15),r0			;wait for blitter
	btst	#0,r0
	jr	eq,.wait2

	move	r12,r13
	shlq	#16,r12
	or	r13,r12
	store	r12,(r14+26)			;sets B_PATD
	store	r12,(r14+27)			;sets B_PATD+4

	movei	#.checkboth,r24			;skip past to get
	moveq	#1,r12				;first edges
	jump	t,(r24)
	moveq	#1,r13

**************************** Flat Colour Line Code ***************************

.flatdu:
	neg	r18				;make line length positive

	move	r4,r17				;calc B_ZINC
	shrq	#16,r18
	sub	r5,r17
	addq	#1,r18

	abs	r17
	div	r18,r17
	jr	cs,.fdu_zinc
	neg	r17
	neg	r17
.fdu_zinc:

	moveq	#3,r24				;set the start z
	move	r1,r25				;depending on the pixel
	shrq	#16,r25				;that we're on
	movefa	r5,r22
	and	r25,r24
	shlq	#1,r24
	sub	r24,r22
	jump	t,(r22)
	move	r5,r24
	sub	r17,r24
	sub	r17,r24
	sub	r17,r24
.fdu_setz:

	move	r1,r26
	movefa	r3,r22
	shrq	#16,r26
	or	r19,r26

	move	r17,r27
	shlq	#2,r27
.fdu_wait:
	load	(r15),r25			;wait for blitter
	btst	#0,r25
	jr	eq,.fdu_wait
	bset	#16,r18				;make ycount = 1

	store	r26,(r14+3)			;sets A1_PIXEL

	store	r24,(r15+24)			;sets B_Z3
	add	r17,r24
	store	r24,(r15+23)			;sets B_Z2
	add	r17,r24
	store	r24,(r15+22)			;sets B_Z1
	add	r17,r24
	store	r24,(r15+21)			;sets B_Z0

	store	r27,(r14+29)			;sets B_ZINC

	store	r18,(r14+15)			;sets B_COUNT
	store	r22,(r14+14)			;sets B_CMD

	movefa	r8,r25
	jump	t,(r25)
	nop

.flatud:
	move	r1,r18				;get line length in r18
	movefa	r1,r22				;needed for both line draws
	movefa	r2,r16
	and	r16,r18
	and	r0,r16
	movefa	r7,r23
	sub	r16,r18				;if line length negative
	jump	mi,(r23)			;draw line other way

	move	r5,r17				;calc B_ZINC
	shrq	#16,r18
	sub	r4,r17
	addq	#1,r18

	abs	r17
	div	r18,r17
	jr	cs,.fud_zinc
	neg	r17
	neg	r17
.fud_zinc:

	moveq	#3,r24				;set the start z
	move	r0,r25				;depending on the pixel
	shrq	#16,r25				;that we're on
	movefa	r4,r22
	and	r25,r24
	shlq	#1,r24
	sub	r24,r22
	jump	t,(r22)
	move	r4,r24
	sub	r17,r24
	sub	r17,r24
	sub	r17,r24
.fud_setz:

	move	r0,r26
	movefa	r3,r22
	shrq	#16,r26
	or	r19,r26

	move	r17,r27
	shlq	#2,r27
.fud_wait:
	load	(r15),r25			;wait for blitter
	btst	#0,r25
	jr	eq,.fud_wait
	bset	#16,r18				;make ycount = 1

	store	r26,(r14+3)			;sets A1_PIXEL

	store	r24,(r15+24)			;sets B_Z3
	add	r17,r24
	store	r24,(r15+23)			;sets B_Z2
	add	r17,r24
	store	r24,(r15+22)			;sets B_Z1
	add	r17,r24
	store	r24,(r15+21)			;sets B_Z0

	store	r27,(r14+29)			;sets B_ZINC

	store	r18,(r14+15)			;sets B_COUNT
	store	r22,(r14+14)			;sets B_CMD

	movefa	r8,r25
	jump	t,(r25)
	nop

************************* Gouraud Shaded Line Code ***************************

.shadedud:
	move	r1,r18				;get line length in r18
	movefa	r1,r22				;needed for both line draws
	movefa	r2,r16
	and	r16,r18
	and	r0,r16
	movefa	r7,r23
	sub	r16,r18				;if line length negative
	jump	mi,(r23)			;draw line other way

	move	r3,r16				;calc B_IINC and B_ZINC
	move	r5,r17
	sub	r2,r16
	shrq	#16,r18
	sub	r4,r17
	addq	#1,r18

	abs	r16
	div	r18,r16
	jr	cs,.sud_iinc
	neg	r16
	neg	r16
.sud_iinc:
	abs	r17
	div	r18,r17
	jr	cs,.sud_zinc
	neg	r17
	neg	r17
.sud_zinc:

	cmp	r22,r16				;check B_IINC against
	jr	mi,.sud_iok1			;it's allowed values
	move	r2,r23				;biggest iinc = 7
	move	r22,r16				;smallest iinc = -8
.sud_iok1:
	not	r22
	cmp	r22,r16
	jr	pl,.sud_iok2
	moveq	#3,r24
	move	r22,r16
.sud_iok2:

	move	r0,r25				;set the start z and i
	shlq	#8,r23				;depending on the pixel
	shrq	#16,r25				;that we're on
	shrq	#8,r23
	and	r25,r24
	movefa	r4,r22
	shlq	#2,r24
	sub	r24,r22
	jump	t,(r22)
	move	r4,r24
	sub	r16,r23
	sub	r17,r24
	sub	r16,r23
	sub	r17,r24
	sub	r16,r23
	sub	r17,r24
.sud_setzi:

	move	r0,r26
	shrq	#16,r26
	bset	#16,r18				;make ycount = 1
	or	r19,r26

	move	r16,r27
	move	r17,r28
	shlq	#8+2,r27
	shlq	#2,r28
	shrq	#8,r27
.sud_wait:
	load	(r15),r25			;wait for blitter
	btst	#0,r25
	jr	eq,.sud_wait
	movefa	r3,r22

	store	r26,(r14+3)			;sets A1_PIXEL
	
	store	r23,(r15+20)			;sets B_I3
	store	r24,(r15+24)			;sets B_Z3
	add	r16,r23
	add	r17,r24
	store	r23,(r15+19)			;sets B_I2
	store	r24,(r15+23)			;sets B_Z2
	add	r16,r23
	add	r17,r24
	store	r23,(r15+18)			;sets B_I1
	store	r24,(r15+22)			;sets B_Z1
	add	r16,r23
	add	r17,r24
	store	r23,(r15+17)			;sets B_I0
	store	r24,(r15+21)			;sets B_Z0

	store	r28,(r14+29)			;sets B_ZINC
	store	r27,(r14+28)			;sets B_IINC

	store	r18,(r14+15)			;sets B_COUNT
	store	r22,(r14+14)			;sets B_CMD

	movefa	r8,r25				;need this later
	jump	t,(r25)
	nop

.shadeddu:
	neg	r18				;make line length positive

	move	r2,r16				;calc B_IINC and B_ZINC
	move	r4,r17
	sub	r3,r16
	shrq	#16,r18
	sub	r5,r17
	addq	#1,r18

	abs	r16
	div	r18,r16
	jr	cs,.sdu_iinc
	neg	r16
	neg	r16
.sdu_iinc:
	abs	r17
	div	r18,r17
	jr	cs,.sdu_zinc
	neg	r17
	neg	r17
.sdu_zinc:

	cmp	r22,r16				;check B_IINC against
	jr	mi,.sdu_iok1			;it's allowed values
	move	r3,r23				;biggest iinc = 7
	move	r22,r16				;smallest iinc = -8
.sdu_iok1:
	not	r22
	cmp	r22,r16
	jr	pl,.sdu_iok2
	moveq	#3,r24
	move	r22,r16
.sdu_iok2:

	move	r1,r25				;set the start z and i
	shlq	#8,r23				;depending on the pixel
	shrq	#16,r25				;that we're on
	shrq	#8,r23
	and	r25,r24
	movefa	r5,r22
	shlq	#2,r24
	sub	r24,r22
	jump	t,(r22)
	move	r5,r24
	sub	r16,r23
	sub	r17,r24
	sub	r16,r23
	sub	r17,r24
	sub	r16,r23
	sub	r17,r24
.sdu_setzi:

	move	r1,r26
	shrq	#16,r26
	bset	#16,r18				;make ycount = 1
	or	r19,r26

	move	r16,r27
	move	r17,r28
	shlq	#8+2,r27
	shlq	#2,r28
	shrq	#8,r27
.sdu_wait:
	load	(r15),r25			;wait for blitter
	btst	#0,r25
	jr	eq,.sdu_wait
	movefa	r3,r22

	store	r26,(r14+3)			;sets A1_PIXEL

	store	r23,(r15+20)			;sets B_I3
	store	r24,(r15+24)			;sets B_Z3
	add	r16,r23
	add	r17,r24
	store	r23,(r15+19)			;sets B_I2
	store	r24,(r15+23)			;sets B_Z2
	add	r16,r23
	add	r17,r24
	store	r23,(r15+18)			;sets B_I1
	store	r24,(r15+22)			;sets B_Z1
	add	r16,r23
	add	r17,r24
	store	r23,(r15+17)			;sets B_I0
	store	r24,(r15+21)			;sets B_Z0

	store	r28,(r14+29)			;sets B_ZINC
	store	r27,(r14+28)			;sets B_IINC

	store	r18,(r14+15)			;sets B_COUNT
	store	r22,(r14+14)			;sets B_CMD

******************* Set Up For The Next Line In The Polygon ******************

.nextline:
	add	r6,r0				;update up edge
	add	r8,r2
	add	r10,r4

	add	r7,r1				;update down edge
	add	r9,r3
	add	r11,r5

	movefa	r9,r22				;increment ycoord
	sub	r22,r19

.checkboth:
	subq	#1,r12				;check for new edges
	jr	eq,.newup
	subq	#1,r13
	movefa	r6,r22
	jump	ne,(r22)			;no new edges needed
	nop					;do next line
	movei	#.newdown,r22
	jump	t,(r22)
	nop

.newup:
	load	(r20),r6			;get end xcoord
	addq	#4,r20
	load	(r20),r12			;get end ycoord
	addq	#4,r20
	load	(r20),r10			;get end zcoord
	addq	#4,r20
	load	(r20),r8			;get end intensity
	subq	#12,r20

	movei	#lasty,r22			;check if the end y
	load	(r22),r23			;is the last y allowed
	movei	#.donepolygon,r24		;that means we've finished
	cmp	r23,r12
	jump	pl,(r24)
	nop

	movei	#.getup,r23
	movei	#lastpoint,r24
	load	(r24),r22
.getup:
	addq	#16,r20				;move to next point
	cmp	r20,r22
	jr	pl,.noupwrap
	nop
	movei	#points1,r20
.noupwrap:
	move	r6,r0				;copy end point
	move	r12,r16				;to start point
	move	r10,r4
	move	r8,r2
	load	(r20),r6			;get end xcoord
	addq	#4,r20
	load	(r20),r12			;get end ycoord
	addq	#4,r20
	load	(r20),r10			;get end zcoord
	addq	#4,r20
	load	(r20),r8			;get end intensity
	subq	#12,r20
	cmp	r12,r16				;make sure the line goes up
	jump	pl,(r23)
	nop

	movei	#gox,r22			;add graphics origin
	load	(r22),r22			;to xcoords
	add	r22,r0
	add	r22,r6

	movei	#goy,r19			;add graphics origin
	load	(r19),r19			;to start ycoord
	add	r16,r19				;and flip vertical axis
	neg	r19

	movei	#gpu_scr_height,r22
	load	(r22),r22
	subq	#1,r22

	add	r22,r19
	shlq	#16,r19

	sharq	#3,r4				;scale zcoords and
	sharq	#3,r10				;add offset to prevent
	movei	#8192,r22			;blitter zvalues from
	add	r22,r4				;saturating
	add	r22,r10

	shlq	#16,r0				;scale start xcoord
	shlq	#16,r4				;scale start zcoord
	shlq	#16,r2				;scale start intensity

	shlq	#16,r6				;scale end xcoord
	shlq	#16,r10				;scale end zcoord
	shlq	#16,r8				;scale end intensity

	sub	r0,r6				;r6 = left dx
	sub	r16,r12				;r12 = left dy
	sub	r4,r10				;r10 = left dz
	sub	r2,r8				;r8 = left di

	abs	r6				;r6 = left xinc
	div	r12,r6
	jr	cs,.updx
	neg	r6
	neg	r6
.updx:
	abs	r10				;r10 = left zinc
	div	r12,r10
	jr	cs,.updz
	neg	r10
	neg	r10
.updz:
	abs	r8				;r8 = left iinc
	div	r12,r8
	jr	cs,.updi
	neg	r8
	neg	r8
.updi:

.checkdown:
	movefa	r6,r22				;do we need a
	cmpq	#0,r13				;new right edge
	jump	ne,(r22)
	nop
.newdown:
	load	(r21),r7			;get end xcoord
	addq	#4,r21
	load	(r21),r13			;get end ycoord
	addq	#4,r21
	load	(r21),r11			;get end zcoord
	addq	#4,r21
	load	(r21),r9			;get end intensity
	subq	#12,r21

	movei	#points1,r22
	movei	#.getdown,r23
.getdown:
	subq	#16,r21				;move onto next point
	cmp	r22,r21
	jr	pl,.nodownwrap
	nop
	movei	#lastpoint,r24
	load	(r24),r21
.nodownwrap:
	move	r7,r1				;copy the end point
	move	r13,r17				;to the start point
	move	r11,r5
	move	r9,r3
	load	(r21),r7			;get end xcoord
	addq	#4,r21
	load	(r21),r13			;get end ycoord
	addq	#4,r21
	load	(r21),r11			;get end zcoord
	addq	#4,r21
	load	(r21),r9			;get end intensity
	subq	#12,r21
	cmp	r13,r17				;make sure the line goes down
	jump	pl,(r23)
	nop

	movei	#gox,r22			;add graphics origin
	load	(r22),r22			;to xcoords
	add	r22,r1
	add	r22,r7

	sharq	#3,r5				;scale zcoords and
	sharq	#3,r11				;add offset to prevent
	movei	#8192,r22			;blitter zvalues from
	add	r22,r5				;saturating
	add	r22,r11

 	shlq	#16,r1				;scale start xcoord
	shlq	#16,r5				;scale start zcoord
	shlq	#16,r3				;scale start intensity

	shlq	#16,r7				;scale end xcoord
	shlq	#16,r11				;scale end zcoord
	shlq	#16,r9				;scale end intensity

	sub	r1,r7				;r7 = dx
	sub	r17,r13				;r13 = dy
	sub	r5,r11				;r11 = dz
	sub	r3,r9				;r9 = di

	abs	r7				;r7 = right xinc
	div	r13,r7
	jr	cs,.downdx
	neg	r7
	neg	r7
.downdx:
	abs	r11				;r11 = right zinc
	div	r13,r11
	jr	cs,.downdz
	neg	r11
	neg	r11
.downdz:
	abs	r9				;r9 = right iinc
	div	r13,r9
	jr	cs,.downdi
	neg	r9
	neg	r9
.downdi:

.noright:
	movefa	r6,r22				;carry on with polygon
	jump	t,(r22)
	nop

.donepolygon:
	movei	#.polygon,r1
	movefa	r0,r0				;get pointer to next polygon
	jump	t,(r1)
	nop

.donelist:
	moveq	#8,r0				;stop gpu
	movei	#G_CTRL,r1
	store	r0,(r1)
.halt:
	jr	t,.halt
	nop

.hcalc:
	cmp	r6,r11				;calculate the point
	movei	#.hcalc2,r28			;at the intersection
	jump	mi,(r28)			;of line r6,7,8,9
	move	r11,r16				;to r11,12,13,14
	move	r12,r17				;with x at r21
	move	r13,r18
	move	r14,r19
	sub	r6,r16
	sub	r7,r17
	sub	r8,r18
	sub	r9,r19
	sub	r6,r21
	imult	r21,r17
	imult	r21,r18
	imult	r21,r19
	abs	r17
	div	r16,r17
	jr	cs,.hypos1
	neg	r17
	neg	r17
.hypos1:
	abs	r18
	div	r16,r18
	jr	cs,.hzpos1
	neg	r18
	neg	r18
.hzpos1:
	abs	r19
	div	r16,r19
	jr	cs,.hipos1
	neg	r19
	neg	r19
.hipos1:
	move	r21,r16
	add	r6,r16
	add	r7,r17
	add	r8,r18
	jump	t,(r29)
	add	r9,r19
.hcalc2:
	move	r6,r16
	move	r7,r17
	move	r8,r18
	move	r9,r19
	sub	r11,r16
	sub	r12,r17
	sub	r13,r18
	sub	r14,r19
	sub	r11,r21
	imult	r21,r17
	imult	r21,r18
	imult	r21,r19
	abs	r17
	div	r16,r17
	jr	cs,.hypos2
	neg	r17
	neg	r17
.hypos2:
	abs	r18
	div	r16,r18
	jr	cs,.hzpos2
	neg	r18
	neg	r18
.hzpos2:
	abs	r19
	div	r16,r19
	jr	cs,.hipos2
	neg	r19
	neg	r19
.hipos2:
	move	r21,r16
	add	r11,r16
	add	r12,r17
	add	r13,r18
	jump	t,(r29)
	add	r14,r19

.vcalc:
	cmp	r7,r12				;calculate the point
	movei	#.vcalc2,r28			;at the intersection
	jump	mi,(r28)			;of line r6,7,8,9
	move	r11,r16				;to r11,12,13,14
	move	r12,r17				;with y at r21
	move	r13,r18
	move	r14,r19
	sub	r6,r16
	sub	r7,r17
	sub	r8,r18
	sub	r9,r19
	sub	r7,r21
	imult	r21,r16
	imult	r21,r18
	imult	r21,r19
	abs	r16
	div	r17,r16
	jr	cs,.vposy1
	neg	r16
	neg	r16
.vposy1:
	abs	r18
	div	r17,r18
	jr	cs,.vposz1
	neg	r18
	neg	r18
.vposz1:
	abs	r19
	div	r17,r19
	jr	cs,.vposi1
	neg	r19
	neg	r19
.vposi1:
	move	r21,r17
	add	r6,r16
	add	r7,r17
	add	r8,r18
	jump	t,(r29)
	add	r9,r19
.vcalc2:
	move	r6,r16
	move	r7,r17
	move	r8,r18
	move	r9,r19
	sub	r11,r16
	sub	r12,r17
	sub	r13,r18
	sub	r14,r19
	sub	r12,r21
	imult	r21,r16
	imult	r21,r18
	imult	r21,r19
	abs	r16
	div	r17,r16
	jr	cs,.vposy2
	neg	r16
	neg	r16
.vposy2:
	abs	r18
	div	r17,r18
	jr	cs,.vposz2
	neg	r18
	neg	r18
.vposz2:
	abs	r19
	div	r17,r19
	jr	cs,.vposi2
	neg	r19
	neg	r19
.vposi2:
	move	r21,r17
	add	r11,r16
	add	r12,r17
	add	r13,r18
	jump	t,(r29)
	add	r14,r19

	.68000

endshaded:

******************************* Data Section *********************************

	data

**************************** Shaded Colour Table *****************************

		even
shadedcolours:
crynumber	set	0
		rept	256			;cry colours
		dc.b	crynumber
crynumber	set	crynumber+1
		endr

animcols:	dcb.w	6,0			;6 animated colours

****************************** Flat Colour Table *****************************

		even

flatcolours:	dc.w	$ff00
crynumber	set	$01ff
		rept	255			;cry colours
		dc.w	crynumber
crynumber	set	crynumber+$0100
		endr

		dc.w	$ecff			;bright yellow
		dc.w	$f0ff			;bright red
		dc.w	$7fff			;bright green

******************* Shaded Polygon List Routine Definition *******************

		even

gpushaded:	dc.l	shaded,gpuprog,endshaded-shaded

******************************* BSS Section **********************************

		bss

************************** Shaded Polygon Buffer *****************************

		phrase
shadedbuffer:	ds.b	maxshaded*4*16	;4 points each, 16 bytes per point
