*********************** Draw A List Of Textured Polygons *********************

* Notes:

* The polygon filler scales and offsets zcoordinates
* This is to prevent the blitter z registers from saturating

* Useable zvalues range from 0 to 114686

* Polygons should not be too 'deep'
* ie furthest zcoord - closest zcoord < 16384

* Also the filler is very optimised to the GPU's pipelining
* So things are not always in the order they seem to be

* You have been warned!

* The source and destination pointers ( A1 and A2 )
* have been reversed to allow reading the texture
* Unforunately this means we can't tile the textures
* but you can't have everything, eh?

************************* Textured Polygon List Routine **********************

	text
	.68000

	phrase
textured:
	.gpu
	org	gpuprog

	movei	#nexttextured,r0		;get polygon list
	load	(r0),r0
.polygon:
	load	(r0),r1				;get the points and
	movei	#.donelist,r2			;check if we should
	cmpq	#0,r1				;clip the polygon
	jump	eq,(r2)
	addq	#4,r0
	load	(r0),r2
	addq	#4,r0

	movei	#numpoints,r3
	movei	#pixelmap,r4
	store	r1,(r3)
	store	r2,(r4)

	load	(r0),r3				;get initial minx,y,maxx,y
	addq	#4,r0
	load	(r0),r5
	subq	#4,r0
	move	r3,r4
	move	r5,r6

	movei	#points1,r7
	movei	#.getpoints,r29
.getpoints:
	load	(r0),r8				;load the point from
	addq	#4,r0				;external memory
	load	(r0),r9
	addq	#4,r0
	load	(r0),r10
	addq	#4,r0
	load	(r0),r11
	addq	#4,r0
	load	(r0),r12
	addq	#4,r0
	or	r12,r12

	store	r8,(r7)				;store the point in
	addq	#4,r7				;internal memory
	store	r9,(r7)
	addq	#4,r7
	store	r10,(r7)
	addq	#4,r7
	store	r11,(r7)
	addq	#4,r7
	store	r12,(r7)
	addq	#4,r7

	cmp	r8,r3				;check for minx
	jr	mi,.notminx
	cmp	r4,r8
	move	r8,r3
.notminx:
	jr	mi,.notmaxx			;check for maxx
	cmp	r9,r5
	move	r8,r4
.notmaxx:
	jr	mi,.notminy			;check for miny
	cmp	r6,r9
	move	r9,r5
.notminy:
	jr	mi,.notmaxy			;check for maxy
	subq	#1,r1
	move	r9,r6
.notmaxy:
	jump	ne,(r29)
	moveta	r0,r0				;save polygon pointer

	movei	#.donepolygon,r8
	cmp	r5,r6				;check for polygons
	jump	eq,(r8)				;with zero height
	nop

	movei	#clx,r12			;get clip limits
	load	(r12),r9			;and check for polygons
	cmp	r9,r4				;totally offscreen
	jump	mi,(r8)
	addq	#4,r12
	load	(r12),r10
	cmp	r10,r6
	jump	mi,(r8)
	addq	#4,r12
	load	(r12),r11
	cmp	r3,r11
	jump	mi,(r8)
	addq	#4,r12
	load	(r12),r12
	cmp	r5,r12
	jump	mi,(r8)
	subq	#1,r11

	cmp	r9,r3				;check for polygons
	jr	mi,.hclip			;totally onscreen
	cmp	r4,r11
	jr	mi,.hclip
	cmp	r10,r5
	jr	mi,.hclip
	cmp	r6,r12
	movei	#.clipped,r8
	jump	pl,(r8)
	nop

.hclip:
	movei	#numpoints,r0			;horizontal clip
	load	(r0),r0
	moveq	#0,r1
	movei	#points1,r2
	movei	#points2,r3
	movei	#clx,r4
	movei	#chx,r5
	move	r0,r6
	load	(r4),r4
	subq	#1,r6
	load	(r5),r5
	subq	#1,r5
	shlq	#2,r6
	move	r6,r11
	shlq	#2,r6
	add	r11,r6
	add	r2,r6
	load	(r6),r11			;last point is linked to first
	addq	#4,r6
	load	(r6),r12
	addq	#4,r6
	load	(r6),r13
	addq	#4,r6
	load	(r6),r14
	addq	#4,r6
	load	(r6),r15
.dohclip:
	move	r11,r6				;end point to start point
	move	r12,r7
	move	r13,r8
	move	r14,r9
	move	r15,r10
	load	(r2),r11			;get new end point
	addq	#4,r2
	load	(r2),r12
	addq	#4,r2
	load	(r2),r13
	addq	#4,r2
	load	(r2),r14
	addq	#4,r2
	load	(r2),r15
	addq	#4,r2

	cmp	r4,r6				;clip startpoint
	movei	#.hstartclip1,r29		;if necessary
	jump	mi,(r29)
	cmp	r6,r5
	movei	#.hstartclip2,r29
	jump	mi,(r29)
	nop

	store	r6,(r3)				;startpoint is onscreen
	addq	#4,r3				;so save it
	store	r7,(r3)
	addq	#4,r3
	store	r8,(r3)
	addq	#4,r3
	store	r9,(r3)
	addq	#4,r3
	store	r10,(r3)
	addq	#4,r3
	addq	#1,r1

	movei	#.hcalc,r28			;clip endpoint
	movei	#.hreturn3,r29			;if necessary

	cmp	r4,r11
	jump	mi,(r28)
	move	r4,r21

	cmp	r11,r5
	jump	mi,(r28)
	move	r5,r21

	movei	#.hnextedge,r29
	jump	t,(r29)
.hstartclip1:
	cmp	r4,r11
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.hcalc,r28
	movei	#.hreturn1,r29
	jump	t,(r28)
	nop
.hreturn1:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	store	r20,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r5,r11
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.hcalc,r28
	movei	#.hreturn3,r29
	jump	t,(r28)
.hstartclip2:
	cmp	r11,r5
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.hcalc,r28
	movei	#.hreturn2,r29
	jump	t,(r28)
	nop
.hreturn2:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	store	r20,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r11,r4
	movei	#.hnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.hcalc,r28
	movei	#.hreturn3,r29
	jump	t,(r28)
	nop
.hreturn3:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	store	r20,(r3)
	addq	#4,r3
	addq	#1,r1
.hnextedge:
	movei	#.dohclip,r29
	subq	#1,r0
	jump	ne,(r29)
	cmpq	#3,r1
	movei	#.donepolygon,r0
	jump	mi,(r0)
	nop
	movei	#numpoints,r0
	store	r1,(r0)

.vclip:
	movei	#numpoints,r0			;vertical clip
	load	(r0),r0
	moveq	#0,r1
	movei	#points2,r2
	movei	#points1,r3
	movei	#cly,r4
	movei	#chy,r5
	move	r0,r6
	load	(r4),r4
	subq	#1,r6
	load	(r5),r5
	shlq	#2,r6
	move	r6,r11
	shlq	#2,r6
	add	r11,r6
	add	r2,r6
	load	(r6),r11			;last point is linked to first
	addq	#4,r6
	load	(r6),r12
	addq	#4,r6
	load	(r6),r13
	addq	#4,r6
	load	(r6),r14
	addq	#4,r6
	load	(r6),r15
.dovclip:
	move	r11,r6				;end point to start point
	move	r12,r7
	move	r13,r8
	move	r14,r9
	move	r15,r10
	load	(r2),r11			;get new end point
	addq	#4,r2
	load	(r2),r12
	addq	#4,r2
	load	(r2),r13
	addq	#4,r2
	load	(r2),r14
	addq	#4,r2
	load	(r2),r15
	addq	#4,r2

	cmp	r4,r7				;clip startpoint
	movei	#.vstartclip1,r29
	jump	mi,(r29)
	cmp	r7,r5
	movei	#.vstartclip2,r29
	jump	mi,(r29)
	nop

	store	r6,(r3)				;startpoint is onscreen
	addq	#4,r3				;so save it
	store	r7,(r3)
	addq	#4,r3
	store	r8,(r3)
	addq	#4,r3
	store	r9,(r3)
	addq	#4,r3
	store	r10,(r3)
	addq	#4,r3
	addq	#1,r1

	movei	#.vcalc,r28			;clip the endpoint
	movei	#.vreturn3,r29			;if necessary

	cmp	r4,r12
	jump	mi,(r28)
	move	r4,r21

	cmp	r12,r5
	jump	mi,(r28)
	move	r5,r21

	movei	#.vnextedge,r29
	jump	t,(r29)
.vstartclip1:
	cmp	r4,r12
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.vcalc,r28
	movei	#.vreturn1,r29
	jump	t,(r28)
	nop
.vreturn1:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	store	r20,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r5,r12
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.vcalc,r28
	movei	#.vreturn3,r29
	jump	t,(r28)
.vstartclip2:
	cmp	r12,r5
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r5,r21
	movei	#.vcalc,r28
	movei	#.vreturn2,r29
	jump	t,(r28)
	nop
.vreturn2:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	store	r20,(r3)
	addq	#4,r3
	addq	#1,r1

	cmp	r12,r4
	movei	#.vnextedge,r29
	jump	mi,(r29)
	move	r4,r21
	movei	#.vcalc,r28
	movei	#.vreturn3,r29
	jump	t,(r28)
	nop
.vreturn3:
	store	r16,(r3)
	addq	#4,r3
	store	r17,(r3)
	addq	#4,r3
	store	r18,(r3)
	addq	#4,r3
	store	r19,(r3)
	addq	#4,r3
	store	r20,(r3)
	addq	#4,r3
	addq	#1,r1
.vnextedge:
	movei	#.dovclip,r29
	subq	#1,r0
	jump	ne,(r29)
	cmpq	#3,r1
	movei	#.donepolygon,r0
	jump	mi,(r0)
	nop
	movei	#numpoints,r0
	store	r1,(r0)

.clipped:
	movei	#numpoints,r5			;get pointer to highest y
	load	(r5),r5
	movei	#points1,r14
	move	r14,r0
	load	(r14+1),r6			;r1 = lowest y
	move	r6,r7				;r2 = highest y
.getlowhigh:
	load	(r14+1),r3			;get ycoord
	cmp	r6,r3				;check for lowest
	jr	pl,.notlowy
	cmp	r3,r7
	move	r3,r6
	move	r14,r0
.notlowy:
	jr	pl,.nothighy			;check for highest
	subq	#1,r5
	move	r3,r7
.nothighy:
	addqt	#20,r14				;move onto next point
	jr	ne,.getlowhigh
	move	r0,r1

	movei	#.donepolygon,r29		;check the polygon is
	cmp	r6,r7				;not horizontal
	jump	eq,(r29)

	subq	#20,r14				;save last point address
	movei	#lastpoint,r29
	store	r14,(r29)
	movei	#lasty,r29			;save last y
	store	r7,(r29)

	movei	#$ffff0000,r2			;set up some constants
	movei	#DCOMPEN|SRCEN|DSTEN|DSTENZ|DSTWRZ|DSTA2|ZBUFF|ZMODEGT|ZMODEEQ|LFU_REPLACE,r3
	movei	#.lineud,r6
	movei	#.linedu,r7
	movei 	#.nextline,r8
	movei	#$10000,r10
	movei	#rasterd,r11
	movei	#rasterz,r12
	load	(r11),r11
	load	(r12),r12
	sub	r11,r12
	shrq	#3,r12
	shlq	#6,r12
	movei	#PITCH4|PIXEL16|WID320|XADDPIX,r9
	or	r12,r9

	moveta	r1,r1				;stick them in alternate registers
	moveta	r2,r2				;so they are easy to get at
	moveta	r3,r3
	moveta	r4,r4
	moveta	r5,r5
	moveta	r6,r6
	moveta	r7,r7
	moveta	r8,r8
	moveta	r9,r9
	moveta	r10,r10

	movei	#A1_BASE,r14			;r14 MUST NOT BE CHANGED!
	movei	#B_CMD,r15			;r15 MUST NOT BE CHANGED!
.wait:
	load	(r15),r29			;wait for blitter
	btst	#0,r29
	jr	eq,.wait
	nop

	store	r11,(r14+9)			;sets A2_BASE

	moveq	#0,r28				;set zero as transparent
	store	r28,(r14+26)
	store	r28,(r14+27)

	movei	#pixelmap,r28			;set up source base and flags
	load	(r28),r28
	or	r28,r28
	load	(r28),r12
	addq	#4,r28
	load	(r28),r13
	store	r12,(r14)			;sets A1_BASE
	store	r13,(r14+1)			;sets A1_FLAGS

	movei	#.checkboth,r29			;skip past to get
	moveq	#1,r12				;first edges
	jump	t,(r29)
	moveq	#1,r13

***************************** The Polygon Filler *****************************

.lineud:
	move	r3,r29				;get line length
	movefa	r2,r27
	and	r27,r29
	and	r2,r27
	movefa	r7,r28
	sub	r27,r29				;if line length negative
	jump	mi,(r28)			;draw line other way

	move	r5,r28
	shrq	#16,r29
	sub	r4,r28
	addq	#1,r29

	abs	r28				;calculate B_ZINC
	div	r29,r28
	jr	cs,.ud_zinc
	neg	r28
	neg	r28
.ud_zinc:
	movefa	r2,r26				;get A1_PIXEL
	move	r26,r30
	and	r16,r26
	and	r17,r30
	shrq	#16,r26
	or	r26,r30

	movefa	r2,r26				;get A1_FPIXEL
	shrq	#16,r26
	move	r26,r31
	and	r16,r26
	and	r17,r31
	shlq	#16,r31
	or	r26,r31

	move	r2,r26				;get A2_PIXEL
	movefa	r3,r25
	shrq	#16,r26
	or	r9,r26

	move	r18,r20				;calculate line increment
	move	r19,r21
	sub	r16,r20
	sub	r17,r21

	abs	r20
	div	r29,r20
	jr	cs,.udxinc
	neg	r20
	neg	r20
.udxinc:
	abs	r21
	div	r29,r21
	jr	cs,.udyinc
	neg	r21
	neg	r21
.udyinc:
	move	r20,r22
	move	r21,r23
	movefa	r2,r24

	and	r24,r20		;integer part
	and	r24,r21
	shrq	#16,r24
	and	r24,r22		;fractional part
	and	r24,r23

	shrq	#16,r20
	or	r20,r21

	shlq	#16,r23
	or	r22,r23

	movefa	r9,r20
.ud_wait:
	load	(r15),r24			;wait for blitter
	btst	#0,r24
	jr	eq,.ud_wait
	bset	#16,r29				;make ycount = 1

	store	r30,(r14+3)			;sets A1_PIXEL
	store	r31,(r14+6)			;sets A1_FPIXEL
	store	r21,(r14+7)			;sets A1_INC
	store	r23,(r14+8)			;sets A1_FINC

	store	r26,(r14+12)			;sets A2_PIXEL
	store	r20,(r14+10)			;sets A2_FLAGS

	store	r4,(r15+21)			;sets B_Z0
	store	r28,(r14+29)			;sets B_ZINC

	store	r29,(r14+15)			;sets B_COUNT
	store	r25,(r14+14)			;sets B_CMD

	movefa	r8,r29
	jump	t,(r29)
	nop

.linedu:
	neg	r29				;make line length positive

	move	r4,r28
	shrq	#16,r29
	sub	r5,r28
	addq	#1,r29

	abs	r28				;calculate B_ZINC
	div	r29,r28
	jr	cs,.du_zinc
	neg	r28
	neg	r28
.du_zinc:

	movefa	r2,r26				;get A1_PIXEL
	move	r26,r30
	and	r18,r26
	and	r19,r30
	shrq	#16,r26
	or	r26,r30

	movefa	r2,r26				;get A1_FPIXEL
	shrq	#16,r26
	move	r26,r31
	and	r18,r26
	and	r19,r31
	shlq	#16,r31
	or	r26,r31

	move	r3,r26				;get A2_PIXEL
	movefa	r3,r25
	shrq	#16,r26
	or	r9,r26

	move	r16,r20				;calculate line increment
	move	r17,r21
	sub	r18,r20
	sub	r19,r21

	abs	r20
	div	r29,r20
	jr	cs,.duxinc
	neg	r20
	neg	r20
.duxinc:
	abs	r21
	div	r29,r21
	jr	cs,.duyinc
	neg	r21
	neg	r21
.duyinc:
	move	r20,r22
	move	r21,r23
	movefa	r2,r24

	and	r24,r20		;integer part
	and	r24,r21
	shrq	#16,r24
	and	r24,r22		;fractional part
	and	r24,r23

	shrq	#16,r20
	or	r20,r21

	shlq	#16,r23
	or	r22,r23

	movefa	r9,r20
.du_wait:
	load	(r15),r24			;wait for blitter
	btst	#0,r24
	jr	eq,.du_wait
	bset	#16,r29				;make ycount = 1

	store	r30,(r14+3)			;sets A1_PIXEL
	store	r31,(r14+6)			;sets A1_FPIXEL
	store	r21,(r14+7)			;sets A1_INC
	store	r23,(r14+8)			;sets A1_FINC

	store	r26,(r14+12)			;sets A2_PIXEL
	store	r20,(r14+10)			;sets A2_FLAGS

	store	r5,(r15+21)			;sets B_Z0
	store	r28,(r14+29)			;sets B_ZINC

	store	r29,(r14+15)			;sets B_COUNT
	store	r25,(r14+14)			;sets B_CMD

******************* Set Up For The Next Line In The Polygon ******************

.nextline:
	movefa	r20,r20				;get texture increments
	movefa	r21,r21
	movefa	r22,r22
	movefa	r23,r23

	add	r6,r2				;update up edge
	add	r10,r4
	add	r20,r16
	add	r21,r17

	add	r7,r3				;update down edge
	add	r11,r5
	add	r22,r18
	add	r23,r19

	movefa	r10,r29				;increment ycoord
	sub	r29,r9

.checkboth:
	subq	#1,r12				;check for new edges
	jr	eq,.newup
	subq	#1,r13
	movefa	r6,r29
	jump	ne,(r29)			;no new edges needed
	nop					;do next line
	movei	#.newdown,r29
	jump	t,(r29)
	nop

.newup:
	load	(r0),r6				;get end xcoord
	addq	#4,r0
	load	(r0),r12			;get end ycoord
	addq	#4,r0
	load	(r0),r10			;get end zcoord
	addq	#4,r0
	load	(r0),r20			;get end texture x
	addq	#4,r0
	load	(r0),r21			;get end texture y
	subq	#16,r0

	movei	#lasty,r29			;check if the end y
	load	(r29),r28			;is the last y allowed
	movei	#.donepolygon,r24		;that means we've finished
	cmp	r28,r12
	jump	pl,(r24)
	nop

	movei	#.getup,r28
	movei	#lastpoint,r29
	load	(r29),r29
.getup:
	addq	#20,r0				;move to next point
	cmp	r0,r29
	jr	pl,.noupwrap
	nop
	movei	#points1,r0
.noupwrap:
	move	r6,r2				;copy end point
	move	r12,r8				;to start point
	move	r10,r4
	move	r20,r16
	move	r21,r17
	load	(r0),r6				;get end xcoord
	addq	#4,r0
	load	(r0),r12			;get end ycoord
	addq	#4,r0
	load	(r0),r10			;get end zcoord
	addq	#4,r0
	load	(r0),r20			;get end texture x
	addq	#4,r0
	load	(r0),r21			;get end texture y
	subq	#16,r0
	cmp	r12,r8				;make sure the line goes up
	jump	pl,(r28)
	nop

	movei	#gox,r29			;add graphics origin
	load	(r29),r29			;to xcoords
	add	r29,r2
	add	r29,r6

	movei	#goy,r9				;add graphics origin
	load	(r9),r9				;to start ycoord
	add	r8,r9				;and flip vertical axis
	neg	r9

	movei	#gpu_scr_height,r29
	load	(r29),r29

	subq	#1,r29
	add	r29,r9
	shlq	#16,r9

	sharq	#3,r4				;scale zcoords and
	sharq	#3,r10				;add offset to prevent
	movei	#8192,r29			;blitter zvalues from
	add	r29,r4				;saturating
	add	r29,r10

	shlq	#16,r2				;scale start xcoord
	shlq	#16,r4				;scale start zcoord
	shlq	#16,r16				;scale start texture xcoord
	shlq	#16,r17				;scale start texture ycoord

	shlq	#16,r6				;scale end xcoord
	shlq	#16,r10				;scale end zcoord
	shlq	#16,r20				;scale end texture xcoord
	shlq	#16,r21				;scale end texture ycoord

	sub	r2,r6				;left dx
	sub	r8,r12				;left dy
	sub	r4,r10				;left dz
	sub	r16,r20				;left tdx
	sub	r17,r21				;left tdy

	abs	r6				;calculate left xinc
	div	r12,r6
	jr	cs,.updx
	neg	r6
	neg	r6
.updx:
	abs	r10				;calculate left zinc
	div	r12,r10
	jr	cs,.updz
	neg	r10
	neg	r10
.updz:
	abs	r20				;calculate left texture xinc
	div	r12,r20
	jr	cs,.uptdx
	neg	r20
	neg	r20
.uptdx:
	abs	r21				;calculate left texture yinc
	div	r12,r21
	jr	cs,.uptdy
	neg	r21
	neg	r21
.uptdy:
	moveta	r20,r20
	moveta	r21,r21

.checkdown:
	movefa	r6,r29				;do we need a
	cmpq	#0,r13				;new down edge?
	jump	ne,(r29)
	nop
.newdown:
	load	(r1),r7				;get end xcoord
	addq	#4,r1
	load	(r1),r13			;get end ycoord
	addq	#4,r1
	load	(r1),r11			;get end zcoord
	addq	#4,r1
	load	(r1),r22			;get end texture x
	addq	#4,r1
	load	(r1),r23			;get end texture y
	subq	#16,r1

	movei	#.getdown,r28
	movei	#points1,r29
.getdown:
	subq	#20,r1				;move onto next point
	cmp	r29,r1
	jr	pl,.nodownwrap
	nop
	movei	#lastpoint,r24
	load	(r24),r1
.nodownwrap:
	move	r7,r3				;copy the end point
	move	r13,r8				;to the start point
	move	r11,r5
	move	r22,r18
	move	r23,r19
	load	(r1),r7				;get end xcoord
	addq	#4,r1
	load	(r1),r13			;get end ycoord
	addq	#4,r1
	load	(r1),r11			;get end zcoord
	addq	#4,r1
	load	(r1),r22			;get end texture x
	addq	#4,r1
	load	(r1),r23			;get end texture y
	subq	#16,r1
	cmp	r13,r8				;make sure the line goes down
	jump	pl,(r28)
	nop

	movei	#gox,r29			;add graphics origin
	load	(r29),r29			;to xcoords
	add	r29,r3
	add	r29,r7

	sharq	#3,r5				;scale zcoords and
	sharq	#3,r11				;add offset to prevent
	movei	#8192,r29			;blitter zvalues from
	add	r29,r5				;saturating
	add	r29,r11

 	shlq	#16,r3				;scale start xcoord
	shlq	#16,r5				;scale start zcoord
	shlq	#16,r18				;scale start texture xcoord
	shlq	#16,r19				;scale start texture ycoord

	shlq	#16,r7				;scale end xcoord
	shlq	#16,r11				;scale end zcoord
	shlq	#16,r22				;scale end texture xcoord
	shlq	#16,r23				;scale end texture ycoord

	sub	r3,r7				;right dx
	sub	r8,r13				;right dy
	sub	r5,r11				;right dz
	sub	r18,r22				;right tdx
	sub	r19,r23				;right tdy

	abs	r7				;calculate right xinc
	div	r13,r7
	jr	cs,.downdx
	neg	r7
	neg	r7
.downdx:
	abs	r11				;calculate right zinc
	div	r13,r11
	jr	cs,.downdz
	neg	r11
	neg	r11
.downdz:
	abs	r22				;calculate right texture xinc
	div	r13,r22
	jr	cs,.downtdx
	neg	r22
	neg	r22
.downtdx:
	abs	r23				;calculate right texture yinc
	div	r13,r23
	jr	cs,.downtdy
	neg	r23
	neg	r23
.downtdy:
	moveta	r22,r22
	moveta	r23,r23

.nodown:
	movefa	r6,r29				;carry on with polygon
	jump	t,(r29)
	nop

.donepolygon:
	movei	#.polygon,r1
	movefa	r0,r0				;get pointer to next polygon
	jump	t,(r1)
	nop

.donelist:
	moveq	#8,r0				;stop gpu
	movei	#G_CTRL,r1
	store	r0,(r1)
.halt:
	jr	t,.halt
	nop

.hcalc:
	cmp	r6,r11				;calculate the point
	movei	#.hcalc2,r28			;at the intersection
	jump	mi,(r28)			;of line r6,7,8,9,10
	move	r11,r16				;to r11,12,13,14,15
	move	r12,r17				;with x at r21
	move	r13,r18
	move	r14,r19
	move	r15,r20
	sub	r6,r16
	sub	r7,r17
	sub	r8,r18
	sub	r9,r19
	sub	r10,r20
	sub	r6,r21
	imult	r21,r17
	imult	r21,r18
	imult	r21,r19
	imult	r21,r20
	abs	r17
	div	r16,r17
	jr	cs,.hypos1
	neg	r17
	neg	r17
.hypos1:
	abs	r18
	div	r16,r18
	jr	cs,.hzpos1
	neg	r18
	neg	r18
.hzpos1:
	abs	r19
	div	r16,r19
	jr	cs,.htxpos1
	neg	r19
	neg	r19
.htxpos1:
	abs	r20
	div	r16,r20
	jr	cs,.htypos1
	neg	r20
	neg	r20
.htypos1:
	move	r21,r16
	add	r6,r16
	add	r7,r17
	add	r8,r18
	add	r9,r19
	jump	t,(r29)
	add	r10,r20
.hcalc2:
	move	r6,r16
	move	r7,r17
	move	r8,r18
	move	r9,r19
	move	r10,r20
	sub	r11,r16
	sub	r12,r17
	sub	r13,r18
	sub	r14,r19
	sub	r15,r20
	sub	r11,r21
	imult	r21,r17
	imult	r21,r18
	imult	r21,r19
	imult	r21,r20
	abs	r17
	div	r16,r17
	jr	cs,.hypos2
	neg	r17
	neg	r17
.hypos2:
	abs	r18
	div	r16,r18
	jr	cs,.hzpos2
	neg	r18
	neg	r18
.hzpos2:
	abs	r19
	div	r16,r19
	jr	cs,.htxpos2
	neg	r19
	neg	r19
.htxpos2:
	abs	r20
	div	r16,r20
	jr	cs,.htypos2
	neg	r20
	neg	r20
.htypos2:
	move	r21,r16
	add	r11,r16
	add	r12,r17
	add	r13,r18
	add	r14,r19
	jump	t,(r29)
	add	r15,r20

.vcalc:
	cmp	r7,r12				;calculate the point
	movei	#.vcalc2,r28			;at the intersection
	jump	mi,(r28)			;of line r6,7,8,9,10
	move	r11,r16				;to r11,12,13,14,15
	move	r12,r17				;with y at r21
	move	r13,r18
	move	r14,r19
	move	r15,r20
	sub	r6,r16
	sub	r7,r17
	sub	r8,r18
	sub	r9,r19
	sub	r10,r20
	sub	r7,r21
	imult	r21,r16
	imult	r21,r18
	imult	r21,r19
	imult	r21,r20
	abs	r16
	div	r17,r16
	jr	cs,.vypos1
	neg	r16
	neg	r16
.vypos1:
	abs	r18
	div	r17,r18
	jr	cs,.vzpos1
	neg	r18
	neg	r18
.vzpos1:
	abs	r19
	div	r17,r19
	jr	cs,.vtxpos1
	neg	r19
	neg	r19
.vtxpos1:
	abs	r20
	div	r17,r20
	jr	cs,.vtypos1
	neg	r20
	neg	r20
.vtypos1:
	move	r21,r17
	add	r6,r16
	add	r7,r17
	add	r8,r18
	add	r9,r19
	jump	t,(r29)
	add	r10,r20
.vcalc2:
	move	r6,r16
	move	r7,r17
	move	r8,r18
	move	r9,r19
	move	r10,r20
	sub	r11,r16
	sub	r12,r17
	sub	r13,r18
	sub	r14,r19
	sub	r15,r20
	sub	r12,r21
	imult	r21,r16
	imult	r21,r18
	imult	r21,r19
	imult	r21,r20
	abs	r16
	div	r17,r16
	jr	cs,.vypos2
	neg	r16
	neg	r16
.vypos2:
	abs	r18
	div	r17,r18
	jr	cs,.vzpos2
	neg	r18
	neg	r18
.vzpos2:
	abs	r19
	div	r17,r19
	jr	cs,.vtxpos2
	neg	r19
	neg	r19
.vtxpos2:
	abs	r20
	div	r17,r20
	jr	cs,.vtypos2
	neg	r20
	neg	r20
.vtypos2:
	move	r21,r17
	add	r11,r16
	add	r12,r17
	add	r13,r18
	add	r14,r19
	jump	t,(r29)
	add	r15,r20

	.68000

endtextured:

******************************* Data Section *********************************

		data

******************* Textured Polygon List Routine Definition *****************

		even

gputextured:	dc.l	textured,gpuprog,endtextured-textured

******************************* BSS Section **********************************

		bss

************************** Textured Polygon Buffer ***************************

		phrase
texturedbuffer:	ds.b	maxtextured*4*20	;4 points each, 20 bytes per point




